/* config.c generated by valac 0.34.9, the Vala compiler
 * generated from config.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <dioriteglib4.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>


#define NUVOLA_TYPE_CONFIG (nuvola_config_get_type ())
#define NUVOLA_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_CONFIG, NuvolaConfig))
#define NUVOLA_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_CONFIG, NuvolaConfigClass))
#define NUVOLA_IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_CONFIG))
#define NUVOLA_IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_CONFIG))
#define NUVOLA_CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_CONFIG, NuvolaConfigClass))

typedef struct _NuvolaConfig NuvolaConfig;
typedef struct _NuvolaConfigClass NuvolaConfigClass;
typedef struct _NuvolaConfigPrivate NuvolaConfigPrivate;
#define _drt_lst_unref0(var) ((var == NULL) ? NULL : (var = (drt_lst_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _NuvolaConfig {
	GObject parent_instance;
	NuvolaConfigPrivate * priv;
};

struct _NuvolaConfigClass {
	GObjectClass parent_class;
};

struct _NuvolaConfigPrivate {
	DrtLst* _property_bindings;
	GFile* _file;
	GHashTable* _defaults;
	JsonNode* root;
	guint save_cb_id;
};


static gpointer nuvola_config_parent_class = NULL;
static DrtKeyValueStorageIface* nuvola_config_drt_key_value_storage_parent_iface = NULL;

GType nuvola_config_get_type (void) G_GNUC_CONST;
#define NUVOLA_CONFIG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_CONFIG, NuvolaConfigPrivate))
enum  {
	NUVOLA_CONFIG_DUMMY_PROPERTY,
	NUVOLA_CONFIG_PROPERTY_BINDINGS,
	NUVOLA_CONFIG_FILE,
	NUVOLA_CONFIG_DEFAULTS
};
static void _vala_JsonNode_free (JsonNode* self);
NuvolaConfig* nuvola_config_new (GFile* file, GHashTable* defaults);
NuvolaConfig* nuvola_config_construct (GType object_type, GFile* file, GHashTable* defaults);
static void nuvola_config_set_file (NuvolaConfig* self, GFile* value);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
static void nuvola_config_set_defaults (NuvolaConfig* self, GHashTable* value);
static gboolean nuvola_config_load (NuvolaConfig* self);
static void nuvola_config_on_changed (NuvolaConfig* self, const gchar* key, GVariant* old_value);
static void _nuvola_config_on_changed_drt_key_value_storage_changed (DrtKeyValueStorage* _sender, const gchar* key, GVariant* old_value, gpointer self);
gboolean nuvola_config_reload (NuvolaConfig* self);
gboolean nuvola_config_owerwrite (NuvolaConfig* self, const gchar* data);
gchar* nuvola_config_to_string (NuvolaConfig* self);
static gboolean nuvola_config_real_has_key (DrtKeyValueStorage* base, const gchar* key);
static JsonObject* nuvola_config_get_parent_object (NuvolaConfig* self, const gchar* key, gchar** member_name);
static GVariant* nuvola_config_real_get_value (DrtKeyValueStorage* base, const gchar* key);
GHashTable* nuvola_config_get_defaults (NuvolaConfig* self);
static void nuvola_config_real_set_value_unboxed (DrtKeyValueStorage* base, const gchar* key, GVariant* value);
static JsonObject* nuvola_config_create_parent_object (NuvolaConfig* self, const gchar* key, gchar** member_name);
static void nuvola_config_real_set_default_value_unboxed (DrtKeyValueStorage* base, const gchar* key, GVariant* value);
static void nuvola_config_real_unset (DrtKeyValueStorage* base, const gchar* key);
GFile* nuvola_config_get_file (NuvolaConfig* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static gboolean nuvola_config_save_cb (NuvolaConfig* self);
static gboolean _nuvola_config_save_cb_gsource_func (gpointer self);
static void nuvola_config_finalize (GObject* obj);
static void _vala_nuvola_config_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_config_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void _vala_JsonNode_free (JsonNode* self) {
	g_boxed_free (json_node_get_type (), self);
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_variant_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
}


static void _nuvola_config_on_changed_drt_key_value_storage_changed (DrtKeyValueStorage* _sender, const gchar* key, GVariant* old_value, gpointer self) {
	nuvola_config_on_changed ((NuvolaConfig*) self, key, old_value);
}


NuvolaConfig* nuvola_config_construct (GType object_type, GFile* file, GHashTable* defaults) {
	NuvolaConfig * self = NULL;
	DrtLst* _tmp0_ = NULL;
	DrtLst* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GHashTable* _tmp3_ = NULL;
	GHashTable* _tmp4_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	self = (NuvolaConfig*) g_object_new (object_type, NULL);
	_tmp0_ = drt_lst_new (DRT_TYPE_PROPERTY_BINDING, (GBoxedCopyFunc) drt_property_binding_ref, (GDestroyNotify) drt_property_binding_unref, NULL);
	_tmp1_ = _tmp0_;
	drt_key_value_storage_set_property_bindings ((DrtKeyValueStorage*) self, _tmp1_);
	_drt_lst_unref0 (_tmp1_);
	_tmp2_ = file;
	nuvola_config_set_file (self, _tmp2_);
	_tmp4_ = defaults;
	if (_tmp4_ != NULL) {
		GHashTable* _tmp5_ = NULL;
		GHashTable* _tmp6_ = NULL;
		_tmp5_ = defaults;
		_tmp6_ = _g_hash_table_ref0 (_tmp5_);
		_g_hash_table_unref0 (_tmp3_);
		_tmp3_ = _tmp6_;
	} else {
		GHashFunc _tmp7_ = NULL;
		GEqualFunc _tmp8_ = NULL;
		GHashTable* _tmp9_ = NULL;
		_tmp7_ = g_str_hash;
		_tmp8_ = g_str_equal;
		_tmp9_ = g_hash_table_new_full (_tmp7_, _tmp8_, _g_free0_, _g_variant_unref0_);
		_g_hash_table_unref0 (_tmp3_);
		_tmp3_ = _tmp9_;
	}
	nuvola_config_set_defaults (self, _tmp3_);
	nuvola_config_load (self);
	g_signal_connect_object ((DrtKeyValueStorage*) self, "changed", (GCallback) _nuvola_config_on_changed_drt_key_value_storage_changed, self, 0);
	_g_hash_table_unref0 (_tmp3_);
	return self;
}


NuvolaConfig* nuvola_config_new (GFile* file, GHashTable* defaults) {
	return nuvola_config_construct (NUVOLA_TYPE_CONFIG, file, defaults);
}


gboolean nuvola_config_reload (NuvolaConfig* self) {
	gboolean result = FALSE;
	gboolean _result_ = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = nuvola_config_load (self);
	_result_ = _tmp0_;
	g_signal_emit_by_name (self, "reloaded");
	result = _result_;
	return result;
}


gboolean nuvola_config_owerwrite (NuvolaConfig* self, const gchar* data) {
	gboolean result = FALSE;
	JsonParser* parser = NULL;
	JsonParser* _tmp0_ = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp6_ = NULL;
	JsonNode* _tmp11_ = NULL;
	JsonNode* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (data != NULL, FALSE);
	_tmp0_ = json_parser_new ();
	parser = _tmp0_;
	{
		const gchar* _tmp1_ = NULL;
		JsonNode* _tmp2_ = NULL;
		_tmp1_ = data;
		json_parser_load_from_data (parser, _tmp1_, (gssize) -1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch2_g_error;
		}
		_tmp2_ = json_parser_get_root (parser);
		root = _tmp2_;
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		root = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_debug ("config.vala:66: Json Error: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp5_ = FALSE;
		_g_object_unref0 (parser);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp5_;
	}
	_tmp6_ = root;
	if (_tmp6_ == NULL) {
		JsonNode* _tmp7_ = NULL;
		JsonNode* _tmp8_ = NULL;
		JsonObject* _tmp9_ = NULL;
		JsonObject* _tmp10_ = NULL;
		_tmp7_ = json_node_new (JSON_NODE_OBJECT);
		__vala_JsonNode_free0 (self->priv->root);
		self->priv->root = _tmp7_;
		_tmp8_ = self->priv->root;
		_tmp9_ = json_object_new ();
		_tmp10_ = _tmp9_;
		json_node_set_object (_tmp8_, _tmp10_);
		_json_object_unref0 (_tmp10_);
		result = FALSE;
		_g_object_unref0 (parser);
		return result;
	}
	_tmp11_ = root;
	_tmp12_ = json_node_copy (_tmp11_);
	__vala_JsonNode_free0 (self->priv->root);
	self->priv->root = _tmp12_;
	result = TRUE;
	_g_object_unref0 (parser);
	return result;
}


gchar* nuvola_config_to_string (NuvolaConfig* self) {
	gchar* result = NULL;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp0_ = NULL;
	JsonNode* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = json_generator_new ();
	generator = _tmp0_;
	_tmp1_ = self->priv->root;
	json_generator_set_root (generator, _tmp1_);
	json_generator_set_pretty (generator, TRUE);
	_tmp2_ = json_generator_to_data (generator, NULL);
	result = _tmp2_;
	_g_object_unref0 (generator);
	return result;
}


static gboolean nuvola_config_real_has_key (DrtKeyValueStorage* base, const gchar* key) {
	NuvolaConfig * self;
	gboolean result = FALSE;
	gchar* member_name = NULL;
	JsonObject* object = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	JsonObject* _tmp4_ = NULL;
	self = (NuvolaConfig*) base;
	g_return_val_if_fail (key != NULL, FALSE);
	_tmp0_ = key;
	_tmp2_ = nuvola_config_get_parent_object (self, _tmp0_, &_tmp1_);
	_g_free0 (member_name);
	member_name = _tmp1_;
	object = _tmp2_;
	_tmp4_ = object;
	if (_tmp4_ != NULL) {
		JsonObject* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		_tmp5_ = object;
		_tmp6_ = member_name;
		_tmp7_ = json_object_has_member (_tmp5_, _tmp6_);
		_tmp3_ = _tmp7_;
	} else {
		_tmp3_ = FALSE;
	}
	result = _tmp3_;
	_g_free0 (member_name);
	return result;
}


static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


static GVariant* nuvola_config_real_get_value (DrtKeyValueStorage* base, const gchar* key) {
	NuvolaConfig * self;
	GVariant* result = NULL;
	gchar* member_name = NULL;
	JsonObject* object = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	JsonObject* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
	self = (NuvolaConfig*) base;
	g_return_val_if_fail (key != NULL, NULL);
	_tmp0_ = key;
	_tmp2_ = nuvola_config_get_parent_object (self, _tmp0_, &_tmp1_);
	_g_free0 (member_name);
	member_name = _tmp1_;
	object = _tmp2_;
	_tmp4_ = object;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		JsonObject* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		_tmp5_ = object;
		_tmp6_ = member_name;
		_tmp7_ = json_object_has_member (_tmp5_, _tmp6_);
		_tmp3_ = !_tmp7_;
	}
	if (_tmp3_) {
		GHashTable* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gconstpointer _tmp10_ = NULL;
		GVariant* _tmp11_ = NULL;
		_tmp8_ = self->priv->_defaults;
		_tmp9_ = key;
		_tmp10_ = g_hash_table_lookup (_tmp8_, _tmp9_);
		_tmp11_ = _g_variant_ref0 ((GVariant*) _tmp10_);
		result = _tmp11_;
		_g_free0 (member_name);
		return result;
	}
	{
		GVariant* _tmp12_ = NULL;
		JsonObject* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		JsonNode* _tmp15_ = NULL;
		GVariant* _tmp16_ = NULL;
		GVariant* _tmp17_ = NULL;
		_tmp13_ = object;
		_tmp14_ = member_name;
		_tmp15_ = json_object_get_member (_tmp13_, _tmp14_);
		_tmp16_ = json_gvariant_deserialize (_tmp15_, NULL, &_inner_error_);
		g_variant_ref_sink (_tmp16_);
		_tmp12_ = _tmp16_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch3_g_error;
		}
		_tmp17_ = _tmp12_;
		_tmp12_ = NULL;
		g_variant_ref_sink (_tmp17_);
		result = _tmp17_;
		_g_variant_unref0 (_tmp12_);
		_g_free0 (member_name);
		return result;
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp18_ = NULL;
		GError* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		GHashTable* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
		gconstpointer _tmp23_ = NULL;
		GVariant* _tmp24_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp18_ = key;
		_tmp19_ = e;
		_tmp20_ = _tmp19_->message;
		g_warning ("config.vala:108: Failed to deserialize key '%s'. %s", _tmp18_, _tmp20_);
		_tmp21_ = self->priv->_defaults;
		_tmp22_ = key;
		_tmp23_ = g_hash_table_lookup (_tmp21_, _tmp22_);
		_tmp24_ = _g_variant_ref0 ((GVariant*) _tmp23_);
		result = _tmp24_;
		_g_error_free0 (e);
		_g_free0 (member_name);
		return result;
	}
	__finally3:
	_g_free0 (member_name);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


static void nuvola_config_real_set_value_unboxed (DrtKeyValueStorage* base, const gchar* key, GVariant* value) {
	NuvolaConfig * self;
	gchar* member_name = NULL;
	JsonObject* object = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonObject* _tmp3_ = NULL;
	GVariant* old_value = NULL;
	JsonObject* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GVariant* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
	self = (NuvolaConfig*) base;
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	_tmp2_ = nuvola_config_create_parent_object (self, _tmp0_, &_tmp1_);
	_g_free0 (member_name);
	member_name = _tmp1_;
	object = _tmp2_;
	_tmp3_ = object;
	g_return_if_fail (_tmp3_ != NULL);
	old_value = NULL;
	_tmp4_ = object;
	_tmp5_ = member_name;
	_tmp6_ = json_object_has_member (_tmp4_, _tmp5_);
	if (_tmp6_) {
		{
			GVariant* _tmp7_ = NULL;
			JsonObject* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
			JsonNode* _tmp10_ = NULL;
			GVariant* _tmp11_ = NULL;
			GVariant* _tmp12_ = NULL;
			_tmp8_ = object;
			_tmp9_ = member_name;
			_tmp10_ = json_object_get_member (_tmp8_, _tmp9_);
			_tmp11_ = json_gvariant_deserialize (_tmp10_, NULL, &_inner_error_);
			g_variant_ref_sink (_tmp11_);
			_tmp7_ = _tmp11_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch4_g_error;
			}
			_tmp12_ = _tmp7_;
			_tmp7_ = NULL;
			g_variant_ref_sink (_tmp12_);
			_g_variant_unref0 (old_value);
			old_value = _tmp12_;
			_g_variant_unref0 (_tmp7_);
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			g_assert_not_reached ();
			_g_error_free0 (e);
		}
		__finally4:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_variant_unref0 (old_value);
			_g_free0 (member_name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp13_ = value;
	if (_tmp13_ == NULL) {
		JsonObject* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
		_tmp14_ = object;
		_tmp15_ = member_name;
		_tmp16_ = json_object_has_member (_tmp14_, _tmp15_);
		if (_tmp16_) {
			JsonObject* _tmp17_ = NULL;
			const gchar* _tmp18_ = NULL;
			const gchar* _tmp19_ = NULL;
			GVariant* _tmp20_ = NULL;
			_tmp17_ = object;
			_tmp18_ = member_name;
			json_object_remove_member (_tmp17_, _tmp18_);
			_tmp19_ = key;
			_tmp20_ = old_value;
			g_signal_emit_by_name ((DrtKeyValueStorage*) self, "changed", _tmp19_, _tmp20_);
		}
	} else {
		gboolean _tmp21_ = FALSE;
		GVariant* _tmp22_ = NULL;
		_tmp22_ = old_value;
		if (_tmp22_ == NULL) {
			_tmp21_ = TRUE;
		} else {
			GVariant* _tmp23_ = NULL;
			GVariant* _tmp24_ = NULL;
			gboolean _tmp25_ = FALSE;
			_tmp23_ = old_value;
			_tmp24_ = value;
			_tmp25_ = g_variant_equal (_tmp23_, _tmp24_);
			_tmp21_ = !_tmp25_;
		}
		if (_tmp21_) {
			JsonNode* node = NULL;
			GVariant* _tmp26_ = NULL;
			JsonNode* _tmp27_ = NULL;
			JsonObject* _tmp28_ = NULL;
			const gchar* _tmp29_ = NULL;
			JsonNode* _tmp30_ = NULL;
			const gchar* _tmp31_ = NULL;
			GVariant* _tmp32_ = NULL;
			_tmp26_ = value;
			_tmp27_ = json_gvariant_serialize (_tmp26_);
			node = _tmp27_;
			_tmp28_ = object;
			_tmp29_ = member_name;
			_tmp30_ = node;
			node = NULL;
			json_object_set_member (_tmp28_, _tmp29_, _tmp30_);
			_tmp31_ = key;
			_tmp32_ = old_value;
			g_signal_emit_by_name ((DrtKeyValueStorage*) self, "changed", _tmp31_, _tmp32_);
			__vala_JsonNode_free0 (node);
		}
	}
	_g_variant_unref0 (old_value);
	_g_free0 (member_name);
}


static void nuvola_config_real_set_default_value_unboxed (DrtKeyValueStorage* base, const gchar* key, GVariant* value) {
	NuvolaConfig * self;
	GVariant* _tmp0_ = NULL;
	self = (NuvolaConfig*) base;
	g_return_if_fail (key != NULL);
	_tmp0_ = value;
	if (_tmp0_ == NULL) {
		GHashTable* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		_tmp1_ = self->priv->_defaults;
		_tmp2_ = key;
		g_hash_table_remove (_tmp1_, _tmp2_);
	} else {
		GHashTable* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GVariant* _tmp6_ = NULL;
		GVariant* _tmp7_ = NULL;
		_tmp3_ = self->priv->_defaults;
		_tmp4_ = key;
		_tmp5_ = g_strdup (_tmp4_);
		_tmp6_ = value;
		_tmp7_ = _g_variant_ref0 (_tmp6_);
		g_hash_table_insert (_tmp3_, _tmp5_, _tmp7_);
	}
}


static void nuvola_config_real_unset (DrtKeyValueStorage* base, const gchar* key) {
	NuvolaConfig * self;
	const gchar* _tmp0_ = NULL;
	self = (NuvolaConfig*) base;
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	drt_key_value_storage_set_value ((DrtKeyValueStorage*) self, _tmp0_, NULL);
}


static gboolean nuvola_config_load (NuvolaConfig* self) {
	gboolean result = FALSE;
	JsonParser* parser = NULL;
	JsonParser* _tmp0_ = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp8_ = NULL;
	JsonNode* _tmp13_ = NULL;
	JsonNode* _tmp14_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = json_parser_new ();
	parser = _tmp0_;
	{
		GFile* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		JsonNode* _tmp4_ = NULL;
		_tmp1_ = self->priv->_file;
		_tmp2_ = g_file_get_path (_tmp1_);
		_tmp3_ = _tmp2_;
		json_parser_load_from_file (parser, _tmp3_, &_inner_error_);
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch5_g_error;
		}
		_tmp4_ = json_parser_get_root (parser);
		root = _tmp4_;
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		root = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_debug ("config.vala:174: Json Error: %s", _tmp6_);
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp7_ = FALSE;
		_g_object_unref0 (parser);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp7_;
	}
	_tmp8_ = root;
	if (_tmp8_ == NULL) {
		JsonNode* _tmp9_ = NULL;
		JsonNode* _tmp10_ = NULL;
		JsonObject* _tmp11_ = NULL;
		JsonObject* _tmp12_ = NULL;
		_tmp9_ = json_node_new (JSON_NODE_OBJECT);
		__vala_JsonNode_free0 (self->priv->root);
		self->priv->root = _tmp9_;
		_tmp10_ = self->priv->root;
		_tmp11_ = json_object_new ();
		_tmp12_ = _tmp11_;
		json_node_set_object (_tmp10_, _tmp12_);
		_json_object_unref0 (_tmp12_);
		result = FALSE;
		_g_object_unref0 (parser);
		return result;
	}
	_tmp13_ = root;
	_tmp14_ = json_node_copy (_tmp13_);
	__vala_JsonNode_free0 (self->priv->root);
	self->priv->root = _tmp14_;
	result = TRUE;
	_g_object_unref0 (parser);
	return result;
}


static gpointer _json_object_ref0 (gpointer self) {
	return self ? json_object_ref (self) : NULL;
}


static JsonObject* nuvola_config_get_parent_object (NuvolaConfig* self, const gchar* key, gchar** member_name) {
	gchar* _vala_member_name = NULL;
	JsonObject* result = NULL;
	gchar** keys = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	JsonNode* node = NULL;
	JsonNode* _tmp3_ = NULL;
	JsonNode* _tmp23_ = NULL;
	JsonNodeType _tmp24_ = 0;
	gchar** _tmp25_ = NULL;
	gint _tmp25__length1 = 0;
	gchar** _tmp26_ = NULL;
	gint _tmp26__length1 = 0;
	const gchar* _tmp27_ = NULL;
	gchar* _tmp28_ = NULL;
	JsonNode* _tmp29_ = NULL;
	JsonObject* _tmp30_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_g_free0 (_vala_member_name);
	_vala_member_name = NULL;
	_tmp0_ = key;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ".", 0);
	keys = _tmp2_;
	keys_length1 = _vala_array_length (_tmp1_);
	_keys_size_ = keys_length1;
	_tmp3_ = self->priv->root;
	node = _tmp3_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gint _tmp6_ = 0;
				gchar** _tmp7_ = NULL;
				gint _tmp7__length1 = 0;
				JsonNode* _tmp8_ = NULL;
				JsonNodeType _tmp9_ = 0;
				JsonObject* object = NULL;
				JsonNode* _tmp10_ = NULL;
				JsonObject* _tmp11_ = NULL;
				JsonObject* _tmp12_ = NULL;
				gchar* name = NULL;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp14_ = 0;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				JsonObject* _tmp17_ = NULL;
				const gchar* _tmp18_ = NULL;
				gboolean _tmp19_ = FALSE;
				JsonObject* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				JsonNode* _tmp22_ = NULL;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = i;
				_tmp7_ = keys;
				_tmp7__length1 = keys_length1;
				if (!(_tmp6_ < (_tmp7__length1 - 1))) {
					break;
				}
				_tmp8_ = node;
				_tmp9_ = json_node_get_node_type (_tmp8_);
				if (_tmp9_ != JSON_NODE_OBJECT) {
					result = NULL;
					keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
					if (member_name) {
						*member_name = _vala_member_name;
					} else {
						_g_free0 (_vala_member_name);
					}
					return result;
				}
				_tmp10_ = node;
				_tmp11_ = json_node_get_object (_tmp10_);
				_tmp12_ = _json_object_ref0 (_tmp11_);
				object = _tmp12_;
				_tmp13_ = keys;
				_tmp13__length1 = keys_length1;
				_tmp14_ = i;
				_tmp15_ = _tmp13_[_tmp14_];
				_tmp16_ = g_strdup (_tmp15_);
				name = _tmp16_;
				_tmp17_ = object;
				_tmp18_ = name;
				_tmp19_ = json_object_has_member (_tmp17_, _tmp18_);
				if (!_tmp19_) {
					result = NULL;
					_g_free0 (name);
					_json_object_unref0 (object);
					keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
					if (member_name) {
						*member_name = _vala_member_name;
					} else {
						_g_free0 (_vala_member_name);
					}
					return result;
				}
				_tmp20_ = object;
				_tmp21_ = name;
				_tmp22_ = json_object_get_member (_tmp20_, _tmp21_);
				node = _tmp22_;
				_g_free0 (name);
				_json_object_unref0 (object);
			}
		}
	}
	_tmp23_ = node;
	_tmp24_ = json_node_get_node_type (_tmp23_);
	if (_tmp24_ != JSON_NODE_OBJECT) {
		result = NULL;
		keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
		if (member_name) {
			*member_name = _vala_member_name;
		} else {
			_g_free0 (_vala_member_name);
		}
		return result;
	}
	_tmp25_ = keys;
	_tmp25__length1 = keys_length1;
	_tmp26_ = keys;
	_tmp26__length1 = keys_length1;
	_tmp27_ = _tmp25_[_tmp26__length1 - 1];
	_tmp28_ = g_strdup (_tmp27_);
	_g_free0 (_vala_member_name);
	_vala_member_name = _tmp28_;
	_tmp29_ = node;
	_tmp30_ = json_node_get_object (_tmp29_);
	result = _tmp30_;
	keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
	if (member_name) {
		*member_name = _vala_member_name;
	} else {
		_g_free0 (_vala_member_name);
	}
	return result;
}


static JsonNode* _vala_JsonNode_copy (JsonNode* self) {
	return g_boxed_copy (json_node_get_type (), self);
}


static gpointer __vala_JsonNode_copy0 (gpointer self) {
	return self ? _vala_JsonNode_copy (self) : NULL;
}


static JsonObject* nuvola_config_create_parent_object (NuvolaConfig* self, const gchar* key, gchar** member_name) {
	gchar* _vala_member_name = NULL;
	JsonObject* result = NULL;
	gchar** keys = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	JsonNode* node = NULL;
	JsonNode* _tmp3_ = NULL;
	JsonNode* _tmp31_ = NULL;
	JsonNodeType _tmp32_ = 0;
	gchar** _tmp33_ = NULL;
	gint _tmp33__length1 = 0;
	gchar** _tmp34_ = NULL;
	gint _tmp34__length1 = 0;
	const gchar* _tmp35_ = NULL;
	gchar* _tmp36_ = NULL;
	JsonNode* _tmp37_ = NULL;
	JsonObject* _tmp38_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_g_free0 (_vala_member_name);
	_vala_member_name = NULL;
	_tmp0_ = key;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ".", 0);
	keys = _tmp2_;
	keys_length1 = _vala_array_length (_tmp1_);
	_keys_size_ = keys_length1;
	_tmp3_ = self->priv->root;
	node = _tmp3_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gint _tmp6_ = 0;
				gchar** _tmp7_ = NULL;
				gint _tmp7__length1 = 0;
				JsonNode* _tmp8_ = NULL;
				JsonNodeType _tmp9_ = 0;
				JsonObject* object = NULL;
				JsonNode* _tmp10_ = NULL;
				JsonObject* _tmp11_ = NULL;
				JsonObject* _tmp12_ = NULL;
				gchar* name = NULL;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp14_ = 0;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				JsonObject* _tmp17_ = NULL;
				const gchar* _tmp18_ = NULL;
				gboolean _tmp19_ = FALSE;
				JsonObject* _tmp28_ = NULL;
				const gchar* _tmp29_ = NULL;
				JsonNode* _tmp30_ = NULL;
				if (!_tmp4_) {
					gint _tmp5_ = 0;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = i;
				_tmp7_ = keys;
				_tmp7__length1 = keys_length1;
				if (!(_tmp6_ < (_tmp7__length1 - 1))) {
					break;
				}
				_tmp8_ = node;
				_tmp9_ = json_node_get_node_type (_tmp8_);
				if (_tmp9_ != JSON_NODE_OBJECT) {
					result = NULL;
					keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
					if (member_name) {
						*member_name = _vala_member_name;
					} else {
						_g_free0 (_vala_member_name);
					}
					return result;
				}
				_tmp10_ = node;
				_tmp11_ = json_node_get_object (_tmp10_);
				_tmp12_ = _json_object_ref0 (_tmp11_);
				object = _tmp12_;
				_tmp13_ = keys;
				_tmp13__length1 = keys_length1;
				_tmp14_ = i;
				_tmp15_ = _tmp13_[_tmp14_];
				_tmp16_ = g_strdup (_tmp15_);
				name = _tmp16_;
				_tmp17_ = object;
				_tmp18_ = name;
				_tmp19_ = json_object_has_member (_tmp17_, _tmp18_);
				if (!_tmp19_) {
					JsonNode* new_node = NULL;
					JsonNode* _tmp20_ = NULL;
					JsonNode* _tmp21_ = NULL;
					JsonObject* _tmp22_ = NULL;
					JsonObject* _tmp23_ = NULL;
					JsonObject* _tmp24_ = NULL;
					const gchar* _tmp25_ = NULL;
					JsonNode* _tmp26_ = NULL;
					JsonNode* _tmp27_ = NULL;
					_tmp20_ = json_node_new (JSON_NODE_OBJECT);
					new_node = _tmp20_;
					_tmp21_ = new_node;
					_tmp22_ = json_object_new ();
					_tmp23_ = _tmp22_;
					json_node_set_object (_tmp21_, _tmp23_);
					_json_object_unref0 (_tmp23_);
					_tmp24_ = object;
					_tmp25_ = name;
					_tmp26_ = new_node;
					_tmp27_ = __vala_JsonNode_copy0 (_tmp26_);
					json_object_set_member (_tmp24_, _tmp25_, _tmp27_);
					__vala_JsonNode_free0 (new_node);
				}
				_tmp28_ = object;
				_tmp29_ = name;
				_tmp30_ = json_object_get_member (_tmp28_, _tmp29_);
				node = _tmp30_;
				_g_free0 (name);
				_json_object_unref0 (object);
			}
		}
	}
	_tmp31_ = node;
	_tmp32_ = json_node_get_node_type (_tmp31_);
	if (_tmp32_ != JSON_NODE_OBJECT) {
		result = NULL;
		keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
		if (member_name) {
			*member_name = _vala_member_name;
		} else {
			_g_free0 (_vala_member_name);
		}
		return result;
	}
	_tmp33_ = keys;
	_tmp33__length1 = keys_length1;
	_tmp34_ = keys;
	_tmp34__length1 = keys_length1;
	_tmp35_ = _tmp33_[_tmp34__length1 - 1];
	_tmp36_ = g_strdup (_tmp35_);
	_g_free0 (_vala_member_name);
	_vala_member_name = _tmp36_;
	_tmp37_ = node;
	_tmp38_ = json_node_get_object (_tmp37_);
	result = _tmp38_;
	keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
	if (member_name) {
		*member_name = _vala_member_name;
	} else {
		_g_free0 (_vala_member_name);
	}
	return result;
}


static gboolean _nuvola_config_save_cb_gsource_func (gpointer self) {
	gboolean result;
	result = nuvola_config_save_cb ((NuvolaConfig*) self);
	return result;
}


static void nuvola_config_on_changed (NuvolaConfig* self, const gchar* key, GVariant* old_value) {
	guint _tmp0_ = 0U;
	guint _tmp2_ = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->save_cb_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->save_cb_id;
		g_source_remove (_tmp1_);
	}
	_tmp2_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, _nuvola_config_save_cb_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->save_cb_id = _tmp2_;
}


static gboolean nuvola_config_save_cb (NuvolaConfig* self) {
	gboolean result = FALSE;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp0_ = NULL;
	JsonNode* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->save_cb_id = (guint) 0;
	_tmp0_ = json_generator_new ();
	generator = _tmp0_;
	_tmp1_ = self->priv->root;
	json_generator_set_root (generator, _tmp1_);
	json_generator_set_pretty (generator, TRUE);
	{
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
		_tmp2_ = self->priv->_file;
		_tmp3_ = g_file_get_parent (_tmp2_);
		_tmp4_ = _tmp3_;
		g_file_make_directory_with_parents (_tmp4_, NULL, &_inner_error_);
		_g_object_unref0 (_tmp4_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp5_ = FALSE;
		_g_object_unref0 (generator);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp5_;
	}
	{
		GFile* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		GFile* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		_tmp6_ = self->priv->_file;
		_tmp7_ = g_file_get_path (_tmp6_);
		_tmp8_ = _tmp7_;
		json_generator_to_file (generator, _tmp8_, &_inner_error_);
		_g_free0 (_tmp8_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch7_g_error;
		}
		_tmp9_ = self->priv->_file;
		_tmp10_ = g_file_get_path (_tmp9_);
		_tmp11_ = _tmp10_;
		g_message ("config.vala:260: Config saved to %s", _tmp11_);
		_g_free0 (_tmp11_);
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		GFile* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		GError* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp12_ = self->priv->_file;
		_tmp13_ = g_file_get_path (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = e;
		_tmp16_ = _tmp15_->message;
		g_warning ("config.vala:264: Failed to save file %s. %s", _tmp14_, _tmp16_);
		_g_free0 (_tmp14_);
		_g_error_free0 (e);
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp17_ = FALSE;
		_g_object_unref0 (generator);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp17_;
	}
	result = FALSE;
	_g_object_unref0 (generator);
	return result;
}


static DrtLst* nuvola_config_real_get_property_bindings (DrtKeyValueStorage* base) {
	DrtLst* result;
	NuvolaConfig* self;
	DrtLst* _tmp0_ = NULL;
	self = (NuvolaConfig*) base;
	_tmp0_ = self->priv->_property_bindings;
	result = _tmp0_;
	return result;
}


static gpointer _drt_lst_ref0 (gpointer self) {
	return self ? drt_lst_ref (self) : NULL;
}


static void nuvola_config_real_set_property_bindings (DrtKeyValueStorage* base, DrtLst* value) {
	NuvolaConfig* self;
	DrtLst* _tmp0_ = NULL;
	DrtLst* _tmp1_ = NULL;
	self = (NuvolaConfig*) base;
	_tmp0_ = value;
	_tmp1_ = _drt_lst_ref0 (_tmp0_);
	_drt_lst_unref0 (self->priv->_property_bindings);
	self->priv->_property_bindings = _tmp1_;
	g_object_notify ((GObject *) self, "property-bindings");
}


GFile* nuvola_config_get_file (NuvolaConfig* self) {
	GFile* result;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_file;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void nuvola_config_set_file (NuvolaConfig* self, GFile* value) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_file);
	self->priv->_file = _tmp1_;
	g_object_notify ((GObject *) self, "file");
}


GHashTable* nuvola_config_get_defaults (NuvolaConfig* self) {
	GHashTable* result;
	GHashTable* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_defaults;
	result = _tmp0_;
	return result;
}


static void nuvola_config_set_defaults (NuvolaConfig* self, GHashTable* value) {
	GHashTable* _tmp0_ = NULL;
	GHashTable* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_hash_table_ref0 (_tmp0_);
	_g_hash_table_unref0 (self->priv->_defaults);
	self->priv->_defaults = _tmp1_;
	g_object_notify ((GObject *) self, "defaults");
}


static void nuvola_config_class_init (NuvolaConfigClass * klass) {
	nuvola_config_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaConfigPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_config_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_config_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_config_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_CONFIG_PROPERTY_BINDINGS, drt_param_spec_lst ("property-bindings", "property-bindings", "property-bindings", DRT_TYPE_LST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_CONFIG_FILE, g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_CONFIG_DEFAULTS, g_param_spec_boxed ("defaults", "defaults", "defaults", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("reloaded", NUVOLA_TYPE_CONFIG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void nuvola_config_drt_key_value_storage_interface_init (DrtKeyValueStorageIface * iface) {
	nuvola_config_drt_key_value_storage_parent_iface = g_type_interface_peek_parent (iface);
	iface->has_key = (gboolean (*)(DrtKeyValueStorage*, const gchar*)) nuvola_config_real_has_key;
	iface->get_value = (GVariant* (*)(DrtKeyValueStorage*, const gchar*)) nuvola_config_real_get_value;
	iface->set_value_unboxed = (void (*)(DrtKeyValueStorage*, const gchar*, GVariant*)) nuvola_config_real_set_value_unboxed;
	iface->set_default_value_unboxed = (void (*)(DrtKeyValueStorage*, const gchar*, GVariant*)) nuvola_config_real_set_default_value_unboxed;
	iface->unset = (void (*)(DrtKeyValueStorage*, const gchar*)) nuvola_config_real_unset;
	iface->get_property_bindings = nuvola_config_real_get_property_bindings;
	iface->set_property_bindings = nuvola_config_real_set_property_bindings;
}


static void nuvola_config_instance_init (NuvolaConfig * self) {
	self->priv = NUVOLA_CONFIG_GET_PRIVATE (self);
	self->priv->save_cb_id = (guint) 0;
}


static void nuvola_config_finalize (GObject* obj) {
	NuvolaConfig * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_CONFIG, NuvolaConfig);
	_drt_lst_unref0 (self->priv->_property_bindings);
	_g_object_unref0 (self->priv->_file);
	_g_hash_table_unref0 (self->priv->_defaults);
	__vala_JsonNode_free0 (self->priv->root);
	G_OBJECT_CLASS (nuvola_config_parent_class)->finalize (obj);
}


GType nuvola_config_get_type (void) {
	static volatile gsize nuvola_config_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_config_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaConfigClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_config_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaConfig), 0, (GInstanceInitFunc) nuvola_config_instance_init, NULL };
		static const GInterfaceInfo drt_key_value_storage_info = { (GInterfaceInitFunc) nuvola_config_drt_key_value_storage_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType nuvola_config_type_id;
		nuvola_config_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaConfig", &g_define_type_info, 0);
		g_type_add_interface_static (nuvola_config_type_id, DRT_TYPE_KEY_VALUE_STORAGE, &drt_key_value_storage_info);
		g_once_init_leave (&nuvola_config_type_id__volatile, nuvola_config_type_id);
	}
	return nuvola_config_type_id__volatile;
}


static void _vala_nuvola_config_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaConfig * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_CONFIG, NuvolaConfig);
	switch (property_id) {
		case NUVOLA_CONFIG_PROPERTY_BINDINGS:
		drt_value_set_lst (value, drt_key_value_storage_get_property_bindings ((DrtKeyValueStorage*) self));
		break;
		case NUVOLA_CONFIG_FILE:
		g_value_set_object (value, nuvola_config_get_file (self));
		break;
		case NUVOLA_CONFIG_DEFAULTS:
		g_value_set_boxed (value, nuvola_config_get_defaults (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_config_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaConfig * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_CONFIG, NuvolaConfig);
	switch (property_id) {
		case NUVOLA_CONFIG_PROPERTY_BINDINGS:
		drt_key_value_storage_set_property_bindings ((DrtKeyValueStorage*) self, drt_value_get_lst (value));
		break;
		case NUVOLA_CONFIG_FILE:
		nuvola_config_set_file (self, g_value_get_object (value));
		break;
		case NUVOLA_CONFIG_DEFAULTS:
		nuvola_config_set_defaults (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



