/* jsapi.c generated by valac 0.34.9, the Vala compiler
 * generated from jsapi.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <dioriteglib4.h>
#include <gio/gio.h>
#include <JavaScriptCore/JavaScript.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define NUVOLA_TYPE_JS_API (nuvola_js_api_get_type ())
#define NUVOLA_JS_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_JS_API, NuvolaJSApi))
#define NUVOLA_JS_API_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_JS_API, NuvolaJSApiClass))
#define NUVOLA_IS_JS_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_JS_API))
#define NUVOLA_IS_JS_API_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_JS_API))
#define NUVOLA_JS_API_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_JS_API, NuvolaJSApiClass))

typedef struct _NuvolaJSApi NuvolaJSApi;
typedef struct _NuvolaJSApiClass NuvolaJSApiClass;
typedef struct _NuvolaJSApiPrivate NuvolaJSApiPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NUVOLA_TYPE_JS_ENVIRONMENT (nuvola_js_environment_get_type ())
#define NUVOLA_JS_ENVIRONMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironment))
#define NUVOLA_JS_ENVIRONMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironmentClass))
#define NUVOLA_IS_JS_ENVIRONMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_JS_ENVIRONMENT))
#define NUVOLA_IS_JS_ENVIRONMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_JS_ENVIRONMENT))
#define NUVOLA_JS_ENVIRONMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironmentClass))

typedef struct _NuvolaJsEnvironment NuvolaJsEnvironment;
typedef struct _NuvolaJsEnvironmentClass NuvolaJsEnvironmentClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _JSClassRelease0(var) ((var == NULL) ? NULL : (var = (JSClassRelease (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

/**
 * Errors thrown from Nuvola Palyer JavaScript API
 */
typedef enum  {
	NUVOLA_JS_ERROR_NOT_FOUND,
	NUVOLA_JS_ERROR_WRONG_TYPE,
	NUVOLA_JS_ERROR_FUNC_FAILED,
	NUVOLA_JS_ERROR_READ_ERROR,
	NUVOLA_JS_ERROR_NO_CONTEXT,
	NUVOLA_JS_ERROR_EXCEPTION,
	NUVOLA_JS_ERROR_INITIALIZATION_FAILED
} NuvolaJSError;
#define NUVOLA_JS_ERROR nuvola_js_error_quark ()
struct _NuvolaJSApi {
	GObject parent_instance;
	NuvolaJSApiPrivate * priv;
};

struct _NuvolaJSApiClass {
	GObjectClass parent_class;
};

struct _NuvolaJSApiPrivate {
	DrtStorage* storage;
	GFile* data_dir;
	GFile* config_dir;
	DrtKeyValueStorage** key_value_storages;
	gint key_value_storages_length1;
	gint _key_value_storages_size_;
	guint* webkit_version;
	gint webkit_version_length1;
	gint _webkit_version_size_;
	guint* libsoup_version;
	gint libsoup_version_length1;
	gint _libsoup_version_size_;
};

struct _Block1Data {
	int _ref_count_;
	gchar* name;
	NuvolaJSApi* js_api;
	GVariant* data;
};


static gpointer nuvola_js_api_parent_class = NULL;
static void* nuvola_js_api_klass;
static void* nuvola_js_api_klass = NULL;

GQuark nuvola_js_error_quark (void);
GType nuvola_js_api_get_type (void) G_GNUC_CONST;
#define NUVOLA_JS_API_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_JS_API, NuvolaJSApiPrivate))
enum  {
	NUVOLA_JS_API_DUMMY_PROPERTY
};
#define NUVOLA_JS_API_MAIN_JS "main.js"
#define NUVOLA_JS_API_META_JSON "metadata.json"
#define NUVOLA_JS_API_META_PROPERTY "meta"
#define NUVOLA_JS_API_JS_DIR "js"
#define NUVOLA_JS_API_INTEGRATE_JS "integrate.js"
#define NUVOLA_JS_API_SETTINGS_SCRIPT "settings.js"
#define NUVOLA_JS_API_API_VERSION_MAJOR NUVOLA_VERSION_MAJOR
#define NUVOLA_JS_API_API_VERSION_MINOR NUVOLA_VERSION_MINOR
#define NUVOLA_JS_API_API_VERSION ((NUVOLA_JS_API_API_VERSION_MAJOR * 100) + NUVOLA_JS_API_API_VERSION_MINOR)
#define NUVOLA_JS_API_MAIN_FRAME_ID "__main__"
#define NUVOLA_JS_API_PREFERENCES_FRAME_ID "__preferences__"
static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_async_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_call_ipc_method_async_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_sync_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_call_ipc_method_sync_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_with_dict_async_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_call_ipc_method_with_dict_async_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_with_dict_sync_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_call_ipc_method_with_dict_sync_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* nuvola_js_api_key_value_storage_has_key_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_key_value_storage_has_key_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* nuvola_js_api_key_value_storage_get_value_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_key_value_storage_get_value_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* nuvola_js_api_key_value_storage_set_value_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_key_value_storage_set_value_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* nuvola_js_api_key_value_storage_set_default_value_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_key_value_storage_set_default_value_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* nuvola_js_api_log_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_log_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* nuvola_js_api_warn_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception);
static const struct OpaqueJSValue* _nuvola_js_api_warn_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception);
NuvolaJSApi* nuvola_js_api_new (DrtStorage* storage, GFile* data_dir, GFile* config_dir, DrtKeyValueStorage* config, DrtKeyValueStorage* session, guint* webkit_version, int webkit_version_length1, guint* libsoup_version, int libsoup_version_length1);
NuvolaJSApi* nuvola_js_api_construct (GType object_type, DrtStorage* storage, GFile* data_dir, GFile* config_dir, DrtKeyValueStorage* config, DrtKeyValueStorage* session, guint* webkit_version, int webkit_version_length1, guint* libsoup_version, int libsoup_version_length1);
static guint* _vala_array_dup1 (guint* self, int length);
static guint* _vala_array_dup2 (guint* self, int length);
gboolean nuvola_js_api_is_supported (gint api_major, gint api_minor);
guint nuvola_js_api_get_webkit_version (NuvolaJSApi* self);
guint nuvola_js_api_get_libsoup_version (NuvolaJSApi* self);
GType nuvola_js_environment_get_type (void) G_GNUC_CONST;
void nuvola_js_api_inject (NuvolaJSApi* self, NuvolaJsEnvironment* env, GError** error);
struct OpaqueJSContext* nuvola_js_environment_get_context (NuvolaJsEnvironment* self);
static void nuvola_js_api_create_class (void);
void nuvola_js_tools_o_set_number (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, gdouble value);
void nuvola_js_tools_o_set_string (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, const gchar* value);
gint nuvola_get_encoded_version (void);
void nuvola_js_environment_set_main_object (NuvolaJsEnvironment* self, struct OpaqueJSValue* value);
void nuvola_js_environment_execute_script_from_file (NuvolaJsEnvironment* self, GFile* file, GValue* result, GError** error);
const struct OpaqueJSValue* nuvola_js_tools_object_from_JSON (const struct OpaqueJSContext* ctx, const gchar* json);
struct OpaqueJSValue* nuvola_js_environment_get_main_object (NuvolaJsEnvironment* self);
void nuvola_js_api_initialize (NuvolaJSApi* self, NuvolaJsEnvironment* env, GError** error);
void nuvola_js_api_integrate (NuvolaJSApi* self, NuvolaJsEnvironment* env, GError** error);
static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception, gboolean async, gint type);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
const struct OpaqueJSValue* nuvola_js_tools_create_exception (const struct OpaqueJSContext* ctx, const gchar* message);
gchar* nuvola_js_tools_string_or_null (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, gboolean allow_empty);
GVariant* nuvola_js_tools_variant_from_value (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, GError** error);
static gboolean ____lambda4_ (Block1Data* _data1_);
static gboolean _____lambda4__gsource_func (gpointer self);
static gboolean ____lambda5_ (Block1Data* _data1_);
static gboolean _____lambda5__gsource_func (gpointer self);
const struct OpaqueJSValue* nuvola_js_tools_value_from_variant (const struct OpaqueJSContext* ctx, GVariant* variant, GError** error);
static void g_cclosure_user_marshal_VOID__STRING_VARIANT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_VARIANT_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void nuvola_js_api_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const JSStaticFunction NUVOLA_JS_API_static_functions[11] = {{"_callIpcMethodAsync", _nuvola_js_api_call_ipc_method_async_func_js_object_call_as_function_callback, 0}, {"_callIpcMethodSync", _nuvola_js_api_call_ipc_method_sync_func_js_object_call_as_function_callback, 0}, {"_callIpcMethodWithDictAsync", _nuvola_js_api_call_ipc_method_with_dict_async_func_js_object_call_as_function_callback, 0}, {"_callIpcMethodWithDictSync", _nuvola_js_api_call_ipc_method_with_dict_sync_func_js_object_call_as_function_callback, 0}, {"_keyValueStorageHasKey", _nuvola_js_api_key_value_storage_has_key_func_js_object_call_as_function_callback, 0}, {"_keyValueStorageGetValue", _nuvola_js_api_key_value_storage_get_value_func_js_object_call_as_function_callback, 0}, {"_keyValueStorageSetValue", _nuvola_js_api_key_value_storage_set_value_func_js_object_call_as_function_callback, 0}, {"_keyValueStorageSetDefaultValue", _nuvola_js_api_key_value_storage_set_default_value_func_js_object_call_as_function_callback, 0}, {"_log", _nuvola_js_api_log_func_js_object_call_as_function_callback, 0}, {"_warn", _nuvola_js_api_warn_func_js_object_call_as_function_callback, 0}, {NULL, NULL, 0}};

GQuark nuvola_js_error_quark (void) {
	return g_quark_from_static_string ("nuvola_js_error-quark");
}


static const struct OpaqueJSValue* _nuvola_js_api_call_ipc_method_async_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_call_ipc_method_async_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static const struct OpaqueJSValue* _nuvola_js_api_call_ipc_method_sync_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_call_ipc_method_sync_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static const struct OpaqueJSValue* _nuvola_js_api_call_ipc_method_with_dict_async_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_call_ipc_method_with_dict_async_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static const struct OpaqueJSValue* _nuvola_js_api_call_ipc_method_with_dict_sync_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_call_ipc_method_with_dict_sync_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static const struct OpaqueJSValue* _nuvola_js_api_key_value_storage_has_key_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_key_value_storage_has_key_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static const struct OpaqueJSValue* _nuvola_js_api_key_value_storage_get_value_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_key_value_storage_get_value_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static const struct OpaqueJSValue* _nuvola_js_api_key_value_storage_set_value_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_key_value_storage_set_value_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static const struct OpaqueJSValue* _nuvola_js_api_key_value_storage_set_default_value_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_key_value_storage_set_default_value_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static const struct OpaqueJSValue* _nuvola_js_api_log_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_log_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static const struct OpaqueJSValue* _nuvola_js_api_warn_func_js_object_call_as_function_callback (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* thisObject, size_t arguments_length1, const struct OpaqueJSValue** arguments, struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* result;
	result = nuvola_js_api_warn_func (ctx, function, thisObject, arguments, arguments_length1, exception);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static guint* _vala_array_dup1 (guint* self, int length) {
	return g_memdup (self, length * sizeof (guint));
}


static guint* _vala_array_dup2 (guint* self, int length) {
	return g_memdup (self, length * sizeof (guint));
}


NuvolaJSApi* nuvola_js_api_construct (GType object_type, DrtStorage* storage, GFile* data_dir, GFile* config_dir, DrtKeyValueStorage* config, DrtKeyValueStorage* session, guint* webkit_version, int webkit_version_length1, guint* libsoup_version, int libsoup_version_length1) {
	NuvolaJSApi * self = NULL;
	DrtStorage* _tmp0_ = NULL;
	DrtStorage* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	GFile* _tmp5_ = NULL;
	DrtKeyValueStorage* _tmp6_ = NULL;
	DrtKeyValueStorage* _tmp7_ = NULL;
	DrtKeyValueStorage* _tmp8_ = NULL;
	DrtKeyValueStorage* _tmp9_ = NULL;
	DrtKeyValueStorage** _tmp10_ = NULL;
	guint* _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	guint* _tmp12_ = NULL;
	gint _tmp12__length1 = 0;
	guint* _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	guint* _tmp14_ = NULL;
	gint _tmp14__length1 = 0;
	guint* _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	g_return_val_if_fail (storage != NULL, NULL);
	g_return_val_if_fail (data_dir != NULL, NULL);
	g_return_val_if_fail (config_dir != NULL, NULL);
	g_return_val_if_fail (config != NULL, NULL);
	g_return_val_if_fail (session != NULL, NULL);
	self = (NuvolaJSApi*) g_object_new (object_type, NULL);
	_tmp0_ = storage;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->storage);
	self->priv->storage = _tmp1_;
	_tmp2_ = data_dir;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->data_dir);
	self->priv->data_dir = _tmp3_;
	_tmp4_ = config_dir;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (self->priv->config_dir);
	self->priv->config_dir = _tmp5_;
	_tmp6_ = config;
	_tmp7_ = _g_object_ref0 (_tmp6_);
	_tmp8_ = session;
	_tmp9_ = _g_object_ref0 (_tmp8_);
	_tmp10_ = g_new0 (DrtKeyValueStorage*, 2 + 1);
	_tmp10_[0] = _tmp7_;
	_tmp10_[1] = _tmp9_;
	self->priv->key_value_storages = (_vala_array_free (self->priv->key_value_storages, self->priv->key_value_storages_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->key_value_storages = _tmp10_;
	self->priv->key_value_storages_length1 = 2;
	self->priv->_key_value_storages_size_ = self->priv->key_value_storages_length1;
	_tmp11_ = webkit_version;
	_tmp11__length1 = webkit_version_length1;
	_vala_assert (_tmp11__length1 >= 3, "webkit_version.length >= 3");
	_tmp12_ = webkit_version;
	_tmp12__length1 = webkit_version_length1;
	_tmp13_ = (_tmp12_ != NULL) ? _vala_array_dup1 (_tmp12_, _tmp12__length1) : ((gpointer) _tmp12_);
	_tmp13__length1 = _tmp12__length1;
	self->priv->webkit_version = (g_free (self->priv->webkit_version), NULL);
	self->priv->webkit_version = _tmp13_;
	self->priv->webkit_version_length1 = _tmp13__length1;
	self->priv->_webkit_version_size_ = self->priv->webkit_version_length1;
	_tmp14_ = libsoup_version;
	_tmp14__length1 = libsoup_version_length1;
	_tmp15_ = (_tmp14_ != NULL) ? _vala_array_dup2 (_tmp14_, _tmp14__length1) : ((gpointer) _tmp14_);
	_tmp15__length1 = _tmp14__length1;
	self->priv->libsoup_version = (g_free (self->priv->libsoup_version), NULL);
	self->priv->libsoup_version = _tmp15_;
	self->priv->libsoup_version_length1 = _tmp15__length1;
	self->priv->_libsoup_version_size_ = self->priv->libsoup_version_length1;
	return self;
}


NuvolaJSApi* nuvola_js_api_new (DrtStorage* storage, GFile* data_dir, GFile* config_dir, DrtKeyValueStorage* config, DrtKeyValueStorage* session, guint* webkit_version, int webkit_version_length1, guint* libsoup_version, int libsoup_version_length1) {
	return nuvola_js_api_construct (NUVOLA_TYPE_JS_API, storage, data_dir, config_dir, config, session, webkit_version, webkit_version_length1, libsoup_version, libsoup_version_length1);
}


gboolean nuvola_js_api_is_supported (gint api_major, gint api_minor) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	_tmp1_ = api_major;
	if (_tmp1_ >= 3) {
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		_tmp2_ = api_major;
		_tmp3_ = api_minor;
		_tmp0_ = ((_tmp2_ * 100) + _tmp3_) <= NUVOLA_JS_API_API_VERSION;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


guint nuvola_js_api_get_webkit_version (NuvolaJSApi* self) {
	guint result = 0U;
	guint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	guint _tmp1_ = 0U;
	guint* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	guint _tmp3_ = 0U;
	guint* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	guint _tmp5_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->webkit_version;
	_tmp0__length1 = self->priv->webkit_version_length1;
	_tmp1_ = _tmp0_[0];
	_tmp2_ = self->priv->webkit_version;
	_tmp2__length1 = self->priv->webkit_version_length1;
	_tmp3_ = _tmp2_[1];
	_tmp4_ = self->priv->webkit_version;
	_tmp4__length1 = self->priv->webkit_version_length1;
	_tmp5_ = _tmp4_[2];
	result = ((_tmp1_ * 10000) + (_tmp3_ * 100)) + _tmp5_;
	return result;
}


guint nuvola_js_api_get_libsoup_version (NuvolaJSApi* self) {
	guint result = 0U;
	guint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	guint _tmp1_ = 0U;
	guint* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	guint _tmp3_ = 0U;
	guint* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	guint _tmp5_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->libsoup_version;
	_tmp0__length1 = self->priv->libsoup_version_length1;
	_tmp1_ = _tmp0_[0];
	_tmp2_ = self->priv->libsoup_version;
	_tmp2__length1 = self->priv->libsoup_version_length1;
	_tmp3_ = _tmp2_[1];
	_tmp4_ = self->priv->libsoup_version;
	_tmp4__length1 = self->priv->libsoup_version_length1;
	_tmp5_ = _tmp4_[2];
	result = ((_tmp1_ * 10000) + (_tmp3_ * 100)) + _tmp5_;
	return result;
}


/**
 * Creates the main object and injects it to the JavaScript context
 * 
 * @param env    JavaScript environment to use for injection
 */
void nuvola_js_api_inject (NuvolaJSApi* self, NuvolaJsEnvironment* env, GError** error) {
	const struct OpaqueJSContext* ctx = NULL;
	NuvolaJsEnvironment* _tmp0_ = NULL;
	struct OpaqueJSContext* _tmp1_ = NULL;
	struct OpaqueJSContext* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	struct OpaqueJSValue* main_object = NULL;
	const struct OpaqueJSContext* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	struct OpaqueJSValue* _tmp6_ = NULL;
	struct OpaqueJSValue* _tmp7_ = NULL;
	const struct OpaqueJSContext* _tmp8_ = NULL;
	const struct OpaqueJSContext* _tmp9_ = NULL;
	struct OpaqueJSValue* _tmp10_ = NULL;
	const struct OpaqueJSContext* _tmp11_ = NULL;
	struct OpaqueJSValue* _tmp12_ = NULL;
	const struct OpaqueJSContext* _tmp13_ = NULL;
	struct OpaqueJSValue* _tmp14_ = NULL;
	const struct OpaqueJSContext* _tmp15_ = NULL;
	struct OpaqueJSValue* _tmp16_ = NULL;
	const struct OpaqueJSContext* _tmp17_ = NULL;
	struct OpaqueJSValue* _tmp18_ = NULL;
	const struct OpaqueJSContext* _tmp19_ = NULL;
	struct OpaqueJSValue* _tmp20_ = NULL;
	const struct OpaqueJSContext* _tmp21_ = NULL;
	struct OpaqueJSValue* _tmp22_ = NULL;
	const struct OpaqueJSContext* _tmp23_ = NULL;
	struct OpaqueJSValue* _tmp24_ = NULL;
	const struct OpaqueJSContext* _tmp25_ = NULL;
	struct OpaqueJSValue* _tmp26_ = NULL;
	gint _tmp27_ = 0;
	const struct OpaqueJSContext* _tmp28_ = NULL;
	struct OpaqueJSValue* _tmp29_ = NULL;
	guint _tmp30_ = 0U;
	const struct OpaqueJSContext* _tmp31_ = NULL;
	struct OpaqueJSValue* _tmp32_ = NULL;
	guint* _tmp33_ = NULL;
	gint _tmp33__length1 = 0;
	guint _tmp34_ = 0U;
	const struct OpaqueJSContext* _tmp35_ = NULL;
	struct OpaqueJSValue* _tmp36_ = NULL;
	guint* _tmp37_ = NULL;
	gint _tmp37__length1 = 0;
	guint _tmp38_ = 0U;
	const struct OpaqueJSContext* _tmp39_ = NULL;
	struct OpaqueJSValue* _tmp40_ = NULL;
	guint* _tmp41_ = NULL;
	gint _tmp41__length1 = 0;
	guint _tmp42_ = 0U;
	const struct OpaqueJSContext* _tmp43_ = NULL;
	struct OpaqueJSValue* _tmp44_ = NULL;
	guint _tmp45_ = 0U;
	const struct OpaqueJSContext* _tmp46_ = NULL;
	struct OpaqueJSValue* _tmp47_ = NULL;
	guint* _tmp48_ = NULL;
	gint _tmp48__length1 = 0;
	guint _tmp49_ = 0U;
	const struct OpaqueJSContext* _tmp50_ = NULL;
	struct OpaqueJSValue* _tmp51_ = NULL;
	guint* _tmp52_ = NULL;
	gint _tmp52__length1 = 0;
	guint _tmp53_ = 0U;
	const struct OpaqueJSContext* _tmp54_ = NULL;
	struct OpaqueJSValue* _tmp55_ = NULL;
	guint* _tmp56_ = NULL;
	gint _tmp56__length1 = 0;
	guint _tmp57_ = 0U;
	NuvolaJsEnvironment* _tmp58_ = NULL;
	struct OpaqueJSValue* _tmp59_ = NULL;
	struct OpaqueJSValue* _tmp60_ = NULL;
	const struct OpaqueJSContext* _tmp61_ = NULL;
	GFile* main_js = NULL;
	DrtStorage* _tmp62_ = NULL;
	GFile* _tmp63_ = NULL;
	GFile* _tmp64_ = NULL;
	GFile* _tmp65_ = NULL;
	GFile* _tmp66_ = NULL;
	GFile* _tmp67_ = NULL;
	GFile* _tmp68_ = NULL;
	GFile* _tmp69_ = NULL;
	gboolean _tmp70_ = FALSE;
	GFile* _tmp81_ = NULL;
	GFile* meta_json = NULL;
	GFile* _tmp93_ = NULL;
	GFile* _tmp94_ = NULL;
	GFile* _tmp95_ = NULL;
	gboolean _tmp96_ = FALSE;
	gchar* meta_json_data = NULL;
	const struct OpaqueJSValue* meta = NULL;
	const struct OpaqueJSContext* _tmp105_ = NULL;
	const gchar* _tmp106_ = NULL;
	const struct OpaqueJSValue* _tmp107_ = NULL;
	NuvolaJsEnvironment* _tmp108_ = NULL;
	struct OpaqueJSValue* _tmp109_ = NULL;
	struct OpaqueJSValue* _tmp110_ = NULL;
	const struct OpaqueJSContext* _tmp111_ = NULL;
	struct OpaqueJSString* _tmp112_ = NULL;
	struct OpaqueJSString* _tmp113_ = NULL;
	const struct OpaqueJSValue* _tmp114_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (env != NULL);
	_tmp0_ = env;
	_tmp1_ = nuvola_js_environment_get_context (_tmp0_);
	_tmp2_ = _tmp1_;
	ctx = (const struct OpaqueJSContext*) _tmp2_;
	_tmp3_ = nuvola_js_api_klass;
	if (_tmp3_ == NULL) {
		nuvola_js_api_create_class ();
	}
	_tmp4_ = ctx;
	_tmp5_ = nuvola_js_api_klass;
	_tmp6_ = JSObjectMake (_tmp4_, _tmp5_, self);
	main_object = _tmp6_;
	_tmp7_ = main_object;
	_tmp8_ = ctx;
	JSValueProtect (_tmp8_, (const struct OpaqueJSValue*) _tmp7_);
	_tmp9_ = ctx;
	_tmp10_ = main_object;
	nuvola_js_tools_o_set_number (_tmp9_, _tmp10_, "API_VERSION_MAJOR", (gdouble) NUVOLA_JS_API_API_VERSION_MAJOR);
	_tmp11_ = ctx;
	_tmp12_ = main_object;
	nuvola_js_tools_o_set_number (_tmp11_, _tmp12_, "API_VERSION_MINOR", (gdouble) NUVOLA_JS_API_API_VERSION_MINOR);
	_tmp13_ = ctx;
	_tmp14_ = main_object;
	nuvola_js_tools_o_set_number (_tmp13_, _tmp14_, "API_VERSION", (gdouble) NUVOLA_JS_API_API_VERSION);
	_tmp15_ = ctx;
	_tmp16_ = main_object;
	nuvola_js_tools_o_set_number (_tmp15_, _tmp16_, "VERSION_MAJOR", (gdouble) NUVOLA_VERSION_MAJOR);
	_tmp17_ = ctx;
	_tmp18_ = main_object;
	nuvola_js_tools_o_set_number (_tmp17_, _tmp18_, "VERSION_MINOR", (gdouble) NUVOLA_VERSION_MINOR);
	_tmp19_ = ctx;
	_tmp20_ = main_object;
	nuvola_js_tools_o_set_number (_tmp19_, _tmp20_, "VERSION_MICRO", (gdouble) NUVOLA_VERSION_BUGFIX);
	_tmp21_ = ctx;
	_tmp22_ = main_object;
	nuvola_js_tools_o_set_number (_tmp21_, _tmp22_, "VERSION_BUGFIX", (gdouble) NUVOLA_VERSION_BUGFIX);
	_tmp23_ = ctx;
	_tmp24_ = main_object;
	nuvola_js_tools_o_set_string (_tmp23_, _tmp24_, "VERSION_SUFFIX", NUVOLA_VERSION_SUFFIX);
	_tmp25_ = ctx;
	_tmp26_ = main_object;
	_tmp27_ = nuvola_get_encoded_version ();
	nuvola_js_tools_o_set_number (_tmp25_, _tmp26_, "VERSION", (gdouble) _tmp27_);
	_tmp28_ = ctx;
	_tmp29_ = main_object;
	_tmp30_ = nuvola_js_api_get_webkit_version (self);
	nuvola_js_tools_o_set_number (_tmp28_, _tmp29_, "WEBKITGTK_VERSION", (gdouble) _tmp30_);
	_tmp31_ = ctx;
	_tmp32_ = main_object;
	_tmp33_ = self->priv->webkit_version;
	_tmp33__length1 = self->priv->webkit_version_length1;
	_tmp34_ = _tmp33_[0];
	nuvola_js_tools_o_set_number (_tmp31_, _tmp32_, "WEBKITGTK_MAJOR", (gdouble) _tmp34_);
	_tmp35_ = ctx;
	_tmp36_ = main_object;
	_tmp37_ = self->priv->webkit_version;
	_tmp37__length1 = self->priv->webkit_version_length1;
	_tmp38_ = _tmp37_[1];
	nuvola_js_tools_o_set_number (_tmp35_, _tmp36_, "WEBKITGTK_MINOR", (gdouble) _tmp38_);
	_tmp39_ = ctx;
	_tmp40_ = main_object;
	_tmp41_ = self->priv->webkit_version;
	_tmp41__length1 = self->priv->webkit_version_length1;
	_tmp42_ = _tmp41_[2];
	nuvola_js_tools_o_set_number (_tmp39_, _tmp40_, "WEBKITGTK_MICRO", (gdouble) _tmp42_);
	_tmp43_ = ctx;
	_tmp44_ = main_object;
	_tmp45_ = nuvola_js_api_get_libsoup_version (self);
	nuvola_js_tools_o_set_number (_tmp43_, _tmp44_, "LIBSOUP_VERSION", (gdouble) _tmp45_);
	_tmp46_ = ctx;
	_tmp47_ = main_object;
	_tmp48_ = self->priv->libsoup_version;
	_tmp48__length1 = self->priv->libsoup_version_length1;
	_tmp49_ = _tmp48_[0];
	nuvola_js_tools_o_set_number (_tmp46_, _tmp47_, "LIBSOUP_MAJOR", (gdouble) _tmp49_);
	_tmp50_ = ctx;
	_tmp51_ = main_object;
	_tmp52_ = self->priv->libsoup_version;
	_tmp52__length1 = self->priv->libsoup_version_length1;
	_tmp53_ = _tmp52_[1];
	nuvola_js_tools_o_set_number (_tmp50_, _tmp51_, "LIBSOUP_MINOR", (gdouble) _tmp53_);
	_tmp54_ = ctx;
	_tmp55_ = main_object;
	_tmp56_ = self->priv->libsoup_version;
	_tmp56__length1 = self->priv->libsoup_version_length1;
	_tmp57_ = _tmp56_[2];
	nuvola_js_tools_o_set_number (_tmp54_, _tmp55_, "LIBSOUP_MICRO", (gdouble) _tmp57_);
	_tmp58_ = env;
	_tmp59_ = main_object;
	nuvola_js_environment_set_main_object (_tmp58_, _tmp59_);
	_tmp60_ = main_object;
	_tmp61_ = ctx;
	JSValueUnprotect (_tmp61_, (const struct OpaqueJSValue*) _tmp60_);
	_tmp62_ = self->priv->storage;
	_tmp63_ = drt_storage_get_user_data_dir (_tmp62_);
	_tmp64_ = _tmp63_;
	_tmp65_ = g_file_get_child (_tmp64_, NUVOLA_JS_API_JS_DIR);
	_tmp66_ = _tmp65_;
	_tmp67_ = g_file_get_child (_tmp66_, NUVOLA_JS_API_MAIN_JS);
	_tmp68_ = _tmp67_;
	_g_object_unref0 (_tmp66_);
	main_js = _tmp68_;
	_tmp69_ = main_js;
	_tmp70_ = g_file_query_exists (_tmp69_, NULL);
	if (!_tmp70_) {
		DrtStorage* _tmp71_ = NULL;
		GFile** _tmp72_ = NULL;
		gint _tmp72__length1 = 0;
		GFile** _tmp73_ = NULL;
		gint _tmp73__length1 = 0;
		_g_object_unref0 (main_js);
		main_js = NULL;
		_tmp71_ = self->priv->storage;
		_tmp72_ = drt_storage_get_data_dirs (_tmp71_, &_tmp72__length1);
		_tmp73_ = _tmp72_;
		_tmp73__length1 = _tmp72__length1;
		{
			GFile** dir_collection = NULL;
			gint dir_collection_length1 = 0;
			gint _dir_collection_size_ = 0;
			gint dir_it = 0;
			dir_collection = _tmp73_;
			dir_collection_length1 = _tmp73__length1;
			for (dir_it = 0; dir_it < _tmp73__length1; dir_it = dir_it + 1) {
				GFile* _tmp74_ = NULL;
				GFile* dir = NULL;
				_tmp74_ = _g_object_ref0 (dir_collection[dir_it]);
				dir = _tmp74_;
				{
					GFile* _tmp75_ = NULL;
					GFile* _tmp76_ = NULL;
					GFile* _tmp77_ = NULL;
					GFile* _tmp78_ = NULL;
					GFile* _tmp79_ = NULL;
					gboolean _tmp80_ = FALSE;
					_tmp75_ = dir;
					_tmp76_ = g_file_get_child (_tmp75_, NUVOLA_JS_API_JS_DIR);
					_tmp77_ = _tmp76_;
					_tmp78_ = g_file_get_child (_tmp77_, NUVOLA_JS_API_MAIN_JS);
					_g_object_unref0 (main_js);
					main_js = _tmp78_;
					_g_object_unref0 (_tmp77_);
					_tmp79_ = main_js;
					_tmp80_ = g_file_query_exists (_tmp79_, NULL);
					if (_tmp80_) {
						_g_object_unref0 (dir);
						break;
					}
					_g_object_unref0 (main_js);
					main_js = NULL;
					_g_object_unref0 (dir);
				}
			}
			dir_collection = (_vala_array_free (dir_collection, dir_collection_length1, (GDestroyNotify) g_object_unref), NULL);
		}
	}
	_tmp81_ = main_js;
	if (_tmp81_ == NULL) {
		GError* _tmp82_ = NULL;
		_tmp82_ = g_error_new_literal (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_INITIALIZATION_FAILED, "Failed to find a core component main.js. This probably means the appli" \
"cation has not been installed correctly or that component has been acc" \
"identally deleted.");
		_inner_error_ = _tmp82_;
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (main_js);
			return;
		} else {
			_g_object_unref0 (main_js);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		NuvolaJsEnvironment* _tmp83_ = NULL;
		GFile* _tmp84_ = NULL;
		GValue _tmp85_ = {0};
		_tmp83_ = env;
		_tmp84_ = main_js;
		nuvola_js_environment_execute_script_from_file (_tmp83_, _tmp84_, &_tmp85_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				goto __catch8_nuvola_js_error;
			}
			_g_object_unref0 (main_js);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally8;
	__catch8_nuvola_js_error:
	{
		GError* e = NULL;
		GFile* _tmp86_ = NULL;
		gchar* _tmp87_ = NULL;
		gchar* _tmp88_ = NULL;
		GError* _tmp89_ = NULL;
		const gchar* _tmp90_ = NULL;
		GError* _tmp91_ = NULL;
		GError* _tmp92_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp86_ = main_js;
		_tmp87_ = g_file_get_path (_tmp86_);
		_tmp88_ = _tmp87_;
		_tmp89_ = e;
		_tmp90_ = _tmp89_->message;
		_tmp91_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_INITIALIZATION_FAILED, "Failed to initialize a core component main.js located at '%s'. Initial" \
"ization exited with error:\n" \
"\n" \
"%s", _tmp88_, _tmp90_);
		_tmp92_ = _tmp91_;
		_g_free0 (_tmp88_);
		_inner_error_ = _tmp92_;
		_g_error_free0 (e);
		goto __finally8;
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (main_js);
			return;
		} else {
			_g_object_unref0 (main_js);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp93_ = self->priv->data_dir;
	_tmp94_ = g_file_get_child (_tmp93_, NUVOLA_JS_API_META_JSON);
	meta_json = _tmp94_;
	_tmp95_ = meta_json;
	_tmp96_ = g_file_query_exists (_tmp95_, NULL);
	if (!_tmp96_) {
		GError* _tmp97_ = NULL;
		_tmp97_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_INITIALIZATION_FAILED, "Failed to find a web app component %s. This probably means the web app" \
" integration has not been installed correctly or that component has be" \
"en accidentally deleted.", NUVOLA_JS_API_META_JSON);
		_inner_error_ = _tmp97_;
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (meta_json);
			_g_object_unref0 (main_js);
			return;
		} else {
			_g_object_unref0 (meta_json);
			_g_object_unref0 (main_js);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		gchar* _tmp98_ = NULL;
		GFile* _tmp99_ = NULL;
		gchar* _tmp100_ = NULL;
		gchar* _tmp101_ = NULL;
		_tmp99_ = meta_json;
		_tmp100_ = drt_system_read_file (_tmp99_, &_inner_error_);
		_tmp98_ = _tmp100_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch9_g_error;
		}
		_tmp101_ = _tmp98_;
		_tmp98_ = NULL;
		_g_free0 (meta_json_data);
		meta_json_data = _tmp101_;
		_g_free0 (_tmp98_);
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		GError* _tmp102_ = NULL;
		const gchar* _tmp103_ = NULL;
		GError* _tmp104_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp102_ = e;
		_tmp103_ = _tmp102_->message;
		_tmp104_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_INITIALIZATION_FAILED, "Failed load a web app component %s. This probably means the web app in" \
"tegration has not been installed correctly or that component has been " \
"accidentally deleted.\n" \
"\n" \
"%s", NUVOLA_JS_API_META_JSON, _tmp103_);
		_inner_error_ = _tmp104_;
		_g_error_free0 (e);
		goto __finally9;
	}
	__finally9:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (meta_json_data);
			_g_object_unref0 (meta_json);
			_g_object_unref0 (main_js);
			return;
		} else {
			_g_free0 (meta_json_data);
			_g_object_unref0 (meta_json);
			_g_object_unref0 (main_js);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp105_ = ctx;
	_tmp106_ = meta_json_data;
	_tmp107_ = nuvola_js_tools_object_from_JSON (_tmp105_, _tmp106_);
	meta = _tmp107_;
	_tmp108_ = env;
	_tmp109_ = nuvola_js_environment_get_main_object (_tmp108_);
	_tmp110_ = _tmp109_;
	_tmp111_ = ctx;
	_tmp112_ = JSStringCreateWithUTF8CString (NUVOLA_JS_API_META_PROPERTY);
	_tmp113_ = _tmp112_;
	_tmp114_ = meta;
	JSObjectSetProperty (_tmp111_, _tmp110_, _tmp113_, _tmp114_, 0, NULL);
	_JSStringRelease0 (_tmp113_);
	_g_free0 (meta_json_data);
	_g_object_unref0 (meta_json);
	_g_object_unref0 (main_js);
}


void nuvola_js_api_initialize (NuvolaJSApi* self, NuvolaJsEnvironment* env, GError** error) {
	NuvolaJsEnvironment* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (env != NULL);
	_tmp0_ = env;
	nuvola_js_api_integrate (self, _tmp0_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void nuvola_js_api_integrate (NuvolaJSApi* self, NuvolaJsEnvironment* env, GError** error) {
	GFile* integrate_js = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (env != NULL);
	_tmp0_ = self->priv->data_dir;
	_tmp1_ = g_file_get_child (_tmp0_, NUVOLA_JS_API_INTEGRATE_JS);
	integrate_js = _tmp1_;
	_tmp2_ = integrate_js;
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
	if (!_tmp3_) {
		GError* _tmp4_ = NULL;
		_tmp4_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_INITIALIZATION_FAILED, "Failed to find a web app component %s. This probably means the web app" \
" integration has not been installed correctly or that component has be" \
"en accidentally deleted.", NUVOLA_JS_API_INTEGRATE_JS);
		_inner_error_ = _tmp4_;
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (integrate_js);
			return;
		} else {
			_g_object_unref0 (integrate_js);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		NuvolaJsEnvironment* _tmp5_ = NULL;
		GFile* _tmp6_ = NULL;
		GValue _tmp7_ = {0};
		_tmp5_ = env;
		_tmp6_ = integrate_js;
		nuvola_js_environment_execute_script_from_file (_tmp5_, _tmp6_, &_tmp7_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				goto __catch10_nuvola_js_error;
			}
			_g_object_unref0 (integrate_js);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally10;
	__catch10_nuvola_js_error:
	{
		GError* e = NULL;
		GFile* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		GError* _tmp13_ = NULL;
		GError* _tmp14_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = integrate_js;
		_tmp9_ = g_file_get_path (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		_tmp13_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_INITIALIZATION_FAILED, "Failed to initialize a web app component %s located at '%s'. Initializ" \
"ation exited with error:\n" \
"\n" \
"%s", NUVOLA_JS_API_INTEGRATE_JS, _tmp10_, _tmp12_);
		_tmp14_ = _tmp13_;
		_g_free0 (_tmp10_);
		_inner_error_ = _tmp14_;
		_g_error_free0 (e);
		goto __finally10;
	}
	__finally10:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (integrate_js);
			return;
		} else {
			_g_object_unref0 (integrate_js);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (integrate_js);
}


/**
 * Creates Nuvola Player main object class description
 */
static void nuvola_js_api_create_class (void) {
	JSClassDefinition class_def = {0};
	JSClassDefinition _tmp0_ = {0};
	JSClassDefinition _tmp1_ = {0};
	void* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	void* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	_tmp0_.version = 1;
	_tmp0_.attributes = kJSClassAttributeNone;
	_g_free0 (_tmp0_.className);
	_tmp0_.className = "Nuvola JavaScript API";
	_JSClassRelease0 (_tmp0_.parentClass);
	_tmp0_.parentClass = NULL;
	_tmp0_.staticValues = NULL;
	_tmp0_.staticFunctions = NUVOLA_JS_API_static_functions;
	_tmp0_.initialize = NULL;
	_tmp0_.finalize = NULL;
	_tmp0_.hasProperty = NULL;
	_tmp0_.getProperty = NULL;
	_tmp0_.setProperty = NULL;
	_tmp0_.deleteProperty = NULL;
	_tmp0_.getPropertyNames = NULL;
	_tmp0_.callAsFunction = NULL;
	_tmp0_.callAsConstructor = NULL;
	_tmp0_.hasInstance = NULL;
	_tmp0_.convertToType = NULL;
	class_def = _tmp0_;
	_tmp1_ = class_def;
	_tmp2_ = JSClassCreate (&_tmp1_);
	nuvola_js_api_klass = _tmp2_;
	_tmp3_ = nuvola_js_api_klass;
	_tmp4_ = JSClassRetain (_tmp3_);
	_tmp5_ = _tmp4_;
	_JSClassRelease0 (_tmp5_);
}


static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_async_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSContext* _tmp0_ = NULL;
	struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSValue* _tmp2_ = NULL;
	const struct OpaqueJSValue** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	const struct OpaqueJSValue* _tmp4_ = NULL;
	const struct OpaqueJSValue* _tmp5_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_tmp0_ = ctx;
	_tmp1_ = function;
	_tmp2_ = _self_;
	_tmp3_ = args;
	_tmp3__length1 = args_length1;
	_tmp5_ = nuvola_js_api_call_ipc_method_func (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp3__length1, &_tmp4_, TRUE, 0);
	_vala_exception = _tmp4_;
	result = _tmp5_;
	if (exception) {
		*exception = _vala_exception;
	}
	return result;
}


static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_sync_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSContext* _tmp0_ = NULL;
	struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSValue* _tmp2_ = NULL;
	const struct OpaqueJSValue** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	const struct OpaqueJSValue* _tmp4_ = NULL;
	const struct OpaqueJSValue* _tmp5_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_tmp0_ = ctx;
	_tmp1_ = function;
	_tmp2_ = _self_;
	_tmp3_ = args;
	_tmp3__length1 = args_length1;
	_tmp5_ = nuvola_js_api_call_ipc_method_func (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp3__length1, &_tmp4_, FALSE, 0);
	_vala_exception = _tmp4_;
	result = _tmp5_;
	if (exception) {
		*exception = _vala_exception;
	}
	return result;
}


static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_with_dict_async_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSContext* _tmp0_ = NULL;
	struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSValue* _tmp2_ = NULL;
	const struct OpaqueJSValue** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	const struct OpaqueJSValue* _tmp4_ = NULL;
	const struct OpaqueJSValue* _tmp5_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_tmp0_ = ctx;
	_tmp1_ = function;
	_tmp2_ = _self_;
	_tmp3_ = args;
	_tmp3__length1 = args_length1;
	_tmp5_ = nuvola_js_api_call_ipc_method_func (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp3__length1, &_tmp4_, TRUE, 1);
	_vala_exception = _tmp4_;
	result = _tmp5_;
	if (exception) {
		*exception = _vala_exception;
	}
	return result;
}


static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_with_dict_sync_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSContext* _tmp0_ = NULL;
	struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSValue* _tmp2_ = NULL;
	const struct OpaqueJSValue** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	const struct OpaqueJSValue* _tmp4_ = NULL;
	const struct OpaqueJSValue* _tmp5_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_tmp0_ = ctx;
	_tmp1_ = function;
	_tmp2_ = _self_;
	_tmp3_ = args;
	_tmp3__length1 = args_length1;
	_tmp5_ = nuvola_js_api_call_ipc_method_func (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp3__length1, &_tmp4_, FALSE, 1);
	_vala_exception = _tmp4_;
	result = _tmp5_;
	if (exception) {
		*exception = _vala_exception;
	}
	return result;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_variant_unref0 (_data1_->data);
		_g_object_unref0 (_data1_->js_api);
		_g_free0 (_data1_->name);
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean ____lambda4_ (Block1Data* _data1_) {
	gboolean result = FALSE;
	NuvolaJSApi* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	_tmp0_ = _data1_->js_api;
	_tmp1_ = _data1_->name;
	_tmp2_ = _data1_->data;
	g_signal_emit_by_name (_tmp0_, "call-ipc-method-async", _tmp1_, _tmp2_);
	result = FALSE;
	return result;
}


static gboolean _____lambda4__gsource_func (gpointer self) {
	gboolean result;
	result = ____lambda4_ (self);
	return result;
}


static gboolean ____lambda5_ (Block1Data* _data1_) {
	gboolean result = FALSE;
	NuvolaJSApi* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	_tmp0_ = _data1_->js_api;
	_tmp1_ = _data1_->name;
	_tmp2_ = _data1_->data;
	g_signal_emit_by_name (_tmp0_, "call-ipc-method-with-dict-async", _tmp1_, _tmp2_);
	result = FALSE;
	return result;
}


static gboolean _____lambda5__gsource_func (gpointer self) {
	gboolean result;
	result = ____lambda5_ (self);
	return result;
}


static const struct OpaqueJSValue* nuvola_js_api_call_ipc_method_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception, gboolean async, gint type) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	Block1Data* _data1_;
	const struct OpaqueJSValue* undefined = NULL;
	const struct OpaqueJSContext* _tmp0_ = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	const struct OpaqueJSValue** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	const struct OpaqueJSContext* _tmp6_ = NULL;
	const struct OpaqueJSValue** _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	const struct OpaqueJSValue* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	struct OpaqueJSValue* _tmp14_ = NULL;
	void* _tmp15_ = NULL;
	NuvolaJSApi* _tmp16_ = NULL;
	NuvolaJSApi* _tmp17_ = NULL;
	const struct OpaqueJSValue** _tmp21_ = NULL;
	gint _tmp21__length1 = 0;
	gboolean _tmp48_ = FALSE;
	GVariant* _result_ = NULL;
	gint _tmp51_ = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = ctx;
	_tmp1_ = JSValueMakeUndefined (_tmp0_);
	undefined = _tmp1_;
	_vala_exception = NULL;
	_tmp2_ = args;
	_tmp2__length1 = args_length1;
	if (_tmp2__length1 == 0) {
		const struct OpaqueJSContext* _tmp3_ = NULL;
		const struct OpaqueJSValue* _tmp4_ = NULL;
		const struct OpaqueJSValue* _tmp5_ = NULL;
		_tmp3_ = ctx;
		_tmp4_ = nuvola_js_tools_create_exception (_tmp3_, "At least one argument required.");
		_vala_exception = _tmp4_;
		_tmp5_ = undefined;
		result = _tmp5_;
		block1_data_unref (_data1_);
		_data1_ = NULL;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp6_ = ctx;
	_tmp7_ = args;
	_tmp7__length1 = args_length1;
	_tmp8_ = _tmp7_[0];
	_tmp9_ = nuvola_js_tools_string_or_null (_tmp6_, _tmp8_, FALSE);
	_data1_->name = _tmp9_;
	_tmp10_ = _data1_->name;
	if (_tmp10_ == NULL) {
		const struct OpaqueJSContext* _tmp11_ = NULL;
		const struct OpaqueJSValue* _tmp12_ = NULL;
		const struct OpaqueJSValue* _tmp13_ = NULL;
		_tmp11_ = ctx;
		_tmp12_ = nuvola_js_tools_create_exception (_tmp11_, "The first argument must be a non-null string");
		_vala_exception = _tmp12_;
		_tmp13_ = undefined;
		result = _tmp13_;
		block1_data_unref (_data1_);
		_data1_ = NULL;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp14_ = _self_;
	_tmp15_ = JSObjectGetPrivate (_tmp14_);
	_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, NUVOLA_TYPE_JS_API) ? ((NuvolaJSApi*) _tmp15_) : NULL);
	_data1_->js_api = _tmp16_;
	_tmp17_ = _data1_->js_api;
	if (_tmp17_ == NULL) {
		const struct OpaqueJSContext* _tmp18_ = NULL;
		const struct OpaqueJSValue* _tmp19_ = NULL;
		const struct OpaqueJSValue* _tmp20_ = NULL;
		_tmp18_ = ctx;
		_tmp19_ = nuvola_js_tools_create_exception (_tmp18_, "JSApi is null");
		_vala_exception = _tmp19_;
		_tmp20_ = undefined;
		result = _tmp20_;
		block1_data_unref (_data1_);
		_data1_ = NULL;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_data1_->data = NULL;
	_tmp21_ = args;
	_tmp21__length1 = args_length1;
	if (_tmp21__length1 > 1) {
		GVariant** tuple = NULL;
		const struct OpaqueJSValue** _tmp22_ = NULL;
		gint _tmp22__length1 = 0;
		GVariant** _tmp23_ = NULL;
		gint tuple_length1 = 0;
		gint _tuple_size_ = 0;
		GVariant** _tmp46_ = NULL;
		gint _tmp46__length1 = 0;
		GVariant* _tmp47_ = NULL;
		_tmp22_ = args;
		_tmp22__length1 = args_length1;
		_tmp23_ = g_new0 (GVariant*, (_tmp22__length1 - 1) + 1);
		tuple = _tmp23_;
		tuple_length1 = _tmp22__length1 - 1;
		_tuple_size_ = tuple_length1;
		{
			gint i = 0;
			i = 1;
			{
				gboolean _tmp24_ = FALSE;
				_tmp24_ = TRUE;
				while (TRUE) {
					gint _tmp26_ = 0;
					const struct OpaqueJSValue** _tmp27_ = NULL;
					gint _tmp27__length1 = 0;
					if (!_tmp24_) {
						gint _tmp25_ = 0;
						_tmp25_ = i;
						i = _tmp25_ + 1;
					}
					_tmp24_ = FALSE;
					_tmp26_ = i;
					_tmp27_ = args;
					_tmp27__length1 = args_length1;
					if (!(_tmp26_ < _tmp27__length1)) {
						break;
					}
					{
						GVariant* _tmp28_ = NULL;
						const struct OpaqueJSContext* _tmp29_ = NULL;
						const struct OpaqueJSValue** _tmp30_ = NULL;
						gint _tmp30__length1 = 0;
						gint _tmp31_ = 0;
						const struct OpaqueJSValue* _tmp32_ = NULL;
						GVariant* _tmp33_ = NULL;
						GVariant** _tmp34_ = NULL;
						gint _tmp34__length1 = 0;
						gint _tmp35_ = 0;
						GVariant* _tmp36_ = NULL;
						GVariant* _tmp37_ = NULL;
						_tmp29_ = ctx;
						_tmp30_ = args;
						_tmp30__length1 = args_length1;
						_tmp31_ = i;
						_tmp32_ = _tmp30_[_tmp31_];
						_tmp33_ = nuvola_js_tools_variant_from_value (_tmp29_, _tmp32_, &_inner_error_);
						_tmp28_ = _tmp33_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							if (_inner_error_->domain == NUVOLA_JS_ERROR) {
								goto __catch11_nuvola_js_error;
							}
							tuple = (_vala_array_free (tuple, tuple_length1, (GDestroyNotify) g_variant_unref), NULL);
							block1_data_unref (_data1_);
							_data1_ = NULL;
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
						_tmp34_ = tuple;
						_tmp34__length1 = tuple_length1;
						_tmp35_ = i;
						_tmp36_ = _tmp28_;
						_tmp28_ = NULL;
						_g_variant_unref0 (_tmp34_[_tmp35_ - 1]);
						_tmp34_[_tmp35_ - 1] = _tmp36_;
						_tmp37_ = _tmp34_[_tmp35_ - 1];
						_g_variant_unref0 (_tmp28_);
					}
					goto __finally11;
					__catch11_nuvola_js_error:
					{
						GError* e = NULL;
						const struct OpaqueJSContext* _tmp38_ = NULL;
						gint _tmp39_ = 0;
						GError* _tmp40_ = NULL;
						const gchar* _tmp41_ = NULL;
						gchar* _tmp42_ = NULL;
						gchar* _tmp43_ = NULL;
						const struct OpaqueJSValue* _tmp44_ = NULL;
						const struct OpaqueJSValue* _tmp45_ = NULL;
						e = _inner_error_;
						_inner_error_ = NULL;
						_tmp38_ = ctx;
						_tmp39_ = i;
						_tmp40_ = e;
						_tmp41_ = _tmp40_->message;
						_tmp42_ = g_strdup_printf ("Argument %d: %s", _tmp39_, _tmp41_);
						_tmp43_ = _tmp42_;
						_tmp44_ = nuvola_js_tools_create_exception (_tmp38_, _tmp43_);
						_vala_exception = _tmp44_;
						_g_free0 (_tmp43_);
						_tmp45_ = undefined;
						result = _tmp45_;
						_g_error_free0 (e);
						tuple = (_vala_array_free (tuple, tuple_length1, (GDestroyNotify) g_variant_unref), NULL);
						block1_data_unref (_data1_);
						_data1_ = NULL;
						if (exception) {
							*exception = _vala_exception;
						}
						return result;
					}
					__finally11:
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						tuple = (_vala_array_free (tuple, tuple_length1, (GDestroyNotify) g_variant_unref), NULL);
						block1_data_unref (_data1_);
						_data1_ = NULL;
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
			}
		}
		_tmp46_ = tuple;
		_tmp46__length1 = tuple_length1;
		_tmp47_ = g_variant_new_tuple (_tmp46_, _tmp46__length1);
		g_variant_ref_sink (_tmp47_);
		_g_variant_unref0 (_data1_->data);
		_data1_->data = _tmp47_;
		tuple = (_vala_array_free (tuple, tuple_length1, (GDestroyNotify) g_variant_unref), NULL);
	}
	_tmp48_ = async;
	if (_tmp48_) {
		gint _tmp49_ = 0;
		const struct OpaqueJSValue* _tmp50_ = NULL;
		_tmp49_ = type;
		switch (_tmp49_) {
			case 0:
			{
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda4__gsource_func, block1_data_ref (_data1_), block1_data_unref);
				break;
			}
			case 1:
			{
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda5__gsource_func, block1_data_ref (_data1_), block1_data_unref);
				break;
			}
			default:
			break;
		}
		_tmp50_ = undefined;
		result = _tmp50_;
		block1_data_unref (_data1_);
		_data1_ = NULL;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_result_ = NULL;
	_tmp51_ = type;
	switch (_tmp51_) {
		case 0:
		{
			NuvolaJSApi* _tmp52_ = NULL;
			const gchar* _tmp53_ = NULL;
			GVariant* _tmp54_ = NULL;
			_tmp52_ = _data1_->js_api;
			_tmp53_ = _data1_->name;
			_tmp54_ = _data1_->data;
			g_signal_emit_by_name (_tmp52_, "call-ipc-method-sync", _tmp53_, _tmp54_, &_result_);
			break;
		}
		case 1:
		{
			NuvolaJSApi* _tmp55_ = NULL;
			const gchar* _tmp56_ = NULL;
			GVariant* _tmp57_ = NULL;
			_tmp55_ = _data1_->js_api;
			_tmp56_ = _data1_->name;
			_tmp57_ = _data1_->data;
			g_signal_emit_by_name (_tmp55_, "call-ipc-method-with-dict-sync", _tmp56_, _tmp57_, &_result_);
			break;
		}
		default:
		break;
	}
	{
		const struct OpaqueJSValue* _tmp58_ = NULL;
		const struct OpaqueJSContext* _tmp59_ = NULL;
		GVariant* _tmp60_ = NULL;
		const struct OpaqueJSValue* _tmp61_ = NULL;
		_tmp59_ = ctx;
		_tmp60_ = _result_;
		_tmp61_ = nuvola_js_tools_value_from_variant (_tmp59_, _tmp60_, &_inner_error_);
		_tmp58_ = _tmp61_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				goto __catch12_nuvola_js_error;
			}
			_g_variant_unref0 (_result_);
			block1_data_unref (_data1_);
			_data1_ = NULL;
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp58_;
		_g_variant_unref0 (_result_);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	goto __finally12;
	__catch12_nuvola_js_error:
	{
		GError* e = NULL;
		const struct OpaqueJSContext* _tmp62_ = NULL;
		GError* _tmp63_ = NULL;
		const gchar* _tmp64_ = NULL;
		gchar* _tmp65_ = NULL;
		gchar* _tmp66_ = NULL;
		const struct OpaqueJSValue* _tmp67_ = NULL;
		const struct OpaqueJSValue* _tmp68_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp62_ = ctx;
		_tmp63_ = e;
		_tmp64_ = _tmp63_->message;
		_tmp65_ = g_strdup_printf ("Failed to parse response. %s", _tmp64_);
		_tmp66_ = _tmp65_;
		_tmp67_ = nuvola_js_tools_create_exception (_tmp62_, _tmp66_);
		_vala_exception = _tmp67_;
		_g_free0 (_tmp66_);
		_tmp68_ = undefined;
		result = _tmp68_;
		_g_error_free0 (e);
		_g_variant_unref0 (_result_);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	__finally12:
	_g_variant_unref0 (_result_);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


static const struct OpaqueJSValue* nuvola_js_api_key_value_storage_has_key_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* _false = NULL;
	const struct OpaqueJSContext* _tmp0_ = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	const struct OpaqueJSValue** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	const struct OpaqueJSValue** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	const struct OpaqueJSContext* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gint index = 0;
	const struct OpaqueJSValue** _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	const struct OpaqueJSValue* _tmp14_ = NULL;
	const struct OpaqueJSContext* _tmp15_ = NULL;
	gdouble _tmp16_ = 0.0;
	gchar* key = NULL;
	const struct OpaqueJSContext* _tmp17_ = NULL;
	const struct OpaqueJSValue** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	const struct OpaqueJSValue* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	NuvolaJSApi* js_api = NULL;
	struct OpaqueJSValue* _tmp25_ = NULL;
	void* _tmp26_ = NULL;
	NuvolaJSApi* _tmp27_ = NULL;
	NuvolaJSApi* _tmp28_ = NULL;
	NuvolaJSApi* _tmp32_ = NULL;
	DrtKeyValueStorage** _tmp33_ = NULL;
	gint _tmp33__length1 = 0;
	gint _tmp34_ = 0;
	const struct OpaqueJSContext* _tmp36_ = NULL;
	NuvolaJSApi* _tmp37_ = NULL;
	DrtKeyValueStorage** _tmp38_ = NULL;
	gint _tmp38__length1 = 0;
	gint _tmp39_ = 0;
	DrtKeyValueStorage* _tmp40_ = NULL;
	const gchar* _tmp41_ = NULL;
	gboolean _tmp42_ = FALSE;
	const struct OpaqueJSValue* _tmp43_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_tmp0_ = ctx;
	_tmp1_ = JSValueMakeBoolean (_tmp0_, FALSE);
	_false = _tmp1_;
	_vala_exception = NULL;
	_tmp2_ = args;
	_tmp2__length1 = args_length1;
	if (_tmp2__length1 != 2) {
		const struct OpaqueJSContext* _tmp3_ = NULL;
		const struct OpaqueJSValue* _tmp4_ = NULL;
		const struct OpaqueJSValue* _tmp5_ = NULL;
		_tmp3_ = ctx;
		_tmp4_ = nuvola_js_tools_create_exception (_tmp3_, "Two arguments required.");
		_vala_exception = _tmp4_;
		_tmp5_ = _false;
		result = _tmp5_;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp6_ = args;
	_tmp6__length1 = args_length1;
	_tmp7_ = _tmp6_[0];
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsNumber (_tmp8_, _tmp7_);
	if (!_tmp9_) {
		const struct OpaqueJSContext* _tmp10_ = NULL;
		const struct OpaqueJSValue* _tmp11_ = NULL;
		const struct OpaqueJSValue* _tmp12_ = NULL;
		_tmp10_ = ctx;
		_tmp11_ = nuvola_js_tools_create_exception (_tmp10_, "Argument 0 must be a number.");
		_vala_exception = _tmp11_;
		_tmp12_ = _false;
		result = _tmp12_;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp13_ = args;
	_tmp13__length1 = args_length1;
	_tmp14_ = _tmp13_[0];
	_tmp15_ = ctx;
	_tmp16_ = JSValueToNumber (_tmp15_, _tmp14_, NULL);
	index = (gint) _tmp16_;
	_tmp17_ = ctx;
	_tmp18_ = args;
	_tmp18__length1 = args_length1;
	_tmp19_ = _tmp18_[1];
	_tmp20_ = nuvola_js_tools_string_or_null (_tmp17_, _tmp19_, FALSE);
	key = _tmp20_;
	_tmp21_ = key;
	if (_tmp21_ == NULL) {
		const struct OpaqueJSContext* _tmp22_ = NULL;
		const struct OpaqueJSValue* _tmp23_ = NULL;
		const struct OpaqueJSValue* _tmp24_ = NULL;
		_tmp22_ = ctx;
		_tmp23_ = nuvola_js_tools_create_exception (_tmp22_, "The first argument must be a non-null string");
		_vala_exception = _tmp23_;
		_tmp24_ = _false;
		result = _tmp24_;
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp25_ = _self_;
	_tmp26_ = JSObjectGetPrivate (_tmp25_);
	_tmp27_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp26_, NUVOLA_TYPE_JS_API) ? ((NuvolaJSApi*) _tmp26_) : NULL);
	js_api = _tmp27_;
	_tmp28_ = js_api;
	if (_tmp28_ == NULL) {
		const struct OpaqueJSContext* _tmp29_ = NULL;
		const struct OpaqueJSValue* _tmp30_ = NULL;
		const struct OpaqueJSValue* _tmp31_ = NULL;
		_tmp29_ = ctx;
		_tmp30_ = nuvola_js_tools_create_exception (_tmp29_, "JSApi is null");
		_vala_exception = _tmp30_;
		_tmp31_ = _false;
		result = _tmp31_;
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp32_ = js_api;
	_tmp33_ = _tmp32_->priv->key_value_storages;
	_tmp33__length1 = _tmp32_->priv->key_value_storages_length1;
	_tmp34_ = index;
	if (_tmp33__length1 <= _tmp34_) {
		const struct OpaqueJSValue* _tmp35_ = NULL;
		_tmp35_ = _false;
		result = _tmp35_;
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp36_ = ctx;
	_tmp37_ = js_api;
	_tmp38_ = _tmp37_->priv->key_value_storages;
	_tmp38__length1 = _tmp37_->priv->key_value_storages_length1;
	_tmp39_ = index;
	_tmp40_ = _tmp38_[_tmp39_];
	_tmp41_ = key;
	_tmp42_ = drt_key_value_storage_has_key (_tmp40_, _tmp41_);
	_tmp43_ = JSValueMakeBoolean (_tmp36_, _tmp42_);
	result = _tmp43_;
	_g_object_unref0 (js_api);
	_g_free0 (key);
	if (exception) {
		*exception = _vala_exception;
	}
	return result;
}


static const struct OpaqueJSValue* nuvola_js_api_key_value_storage_get_value_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* undefined = NULL;
	const struct OpaqueJSContext* _tmp0_ = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	const struct OpaqueJSValue** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	const struct OpaqueJSValue** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	const struct OpaqueJSContext* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gint index = 0;
	const struct OpaqueJSValue** _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	const struct OpaqueJSValue* _tmp14_ = NULL;
	const struct OpaqueJSContext* _tmp15_ = NULL;
	gdouble _tmp16_ = 0.0;
	gchar* key = NULL;
	const struct OpaqueJSContext* _tmp17_ = NULL;
	const struct OpaqueJSValue** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	const struct OpaqueJSValue* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	NuvolaJSApi* js_api = NULL;
	struct OpaqueJSValue* _tmp25_ = NULL;
	void* _tmp26_ = NULL;
	NuvolaJSApi* _tmp27_ = NULL;
	NuvolaJSApi* _tmp28_ = NULL;
	NuvolaJSApi* _tmp32_ = NULL;
	DrtKeyValueStorage** _tmp33_ = NULL;
	gint _tmp33__length1 = 0;
	gint _tmp34_ = 0;
	GVariant* value = NULL;
	NuvolaJSApi* _tmp36_ = NULL;
	DrtKeyValueStorage** _tmp37_ = NULL;
	gint _tmp37__length1 = 0;
	gint _tmp38_ = 0;
	DrtKeyValueStorage* _tmp39_ = NULL;
	const gchar* _tmp40_ = NULL;
	GVariant* _tmp41_ = NULL;
	GVariant* _tmp42_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_tmp0_ = ctx;
	_tmp1_ = JSValueMakeUndefined (_tmp0_);
	undefined = _tmp1_;
	_vala_exception = NULL;
	_tmp2_ = args;
	_tmp2__length1 = args_length1;
	if (_tmp2__length1 != 2) {
		const struct OpaqueJSContext* _tmp3_ = NULL;
		const struct OpaqueJSValue* _tmp4_ = NULL;
		const struct OpaqueJSValue* _tmp5_ = NULL;
		_tmp3_ = ctx;
		_tmp4_ = nuvola_js_tools_create_exception (_tmp3_, "Two arguments required.");
		_vala_exception = _tmp4_;
		_tmp5_ = undefined;
		result = _tmp5_;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp6_ = args;
	_tmp6__length1 = args_length1;
	_tmp7_ = _tmp6_[0];
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsNumber (_tmp8_, _tmp7_);
	if (!_tmp9_) {
		const struct OpaqueJSContext* _tmp10_ = NULL;
		const struct OpaqueJSValue* _tmp11_ = NULL;
		const struct OpaqueJSValue* _tmp12_ = NULL;
		_tmp10_ = ctx;
		_tmp11_ = nuvola_js_tools_create_exception (_tmp10_, "Argument 0 must be a number.");
		_vala_exception = _tmp11_;
		_tmp12_ = undefined;
		result = _tmp12_;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp13_ = args;
	_tmp13__length1 = args_length1;
	_tmp14_ = _tmp13_[0];
	_tmp15_ = ctx;
	_tmp16_ = JSValueToNumber (_tmp15_, _tmp14_, NULL);
	index = (gint) _tmp16_;
	_tmp17_ = ctx;
	_tmp18_ = args;
	_tmp18__length1 = args_length1;
	_tmp19_ = _tmp18_[1];
	_tmp20_ = nuvola_js_tools_string_or_null (_tmp17_, _tmp19_, FALSE);
	key = _tmp20_;
	_tmp21_ = key;
	if (_tmp21_ == NULL) {
		const struct OpaqueJSContext* _tmp22_ = NULL;
		const struct OpaqueJSValue* _tmp23_ = NULL;
		const struct OpaqueJSValue* _tmp24_ = NULL;
		_tmp22_ = ctx;
		_tmp23_ = nuvola_js_tools_create_exception (_tmp22_, "Argument 1 must be a non-null string");
		_vala_exception = _tmp23_;
		_tmp24_ = undefined;
		result = _tmp24_;
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp25_ = _self_;
	_tmp26_ = JSObjectGetPrivate (_tmp25_);
	_tmp27_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp26_, NUVOLA_TYPE_JS_API) ? ((NuvolaJSApi*) _tmp26_) : NULL);
	js_api = _tmp27_;
	_tmp28_ = js_api;
	if (_tmp28_ == NULL) {
		const struct OpaqueJSContext* _tmp29_ = NULL;
		const struct OpaqueJSValue* _tmp30_ = NULL;
		const struct OpaqueJSValue* _tmp31_ = NULL;
		_tmp29_ = ctx;
		_tmp30_ = nuvola_js_tools_create_exception (_tmp29_, "JSApi is null");
		_vala_exception = _tmp30_;
		_tmp31_ = undefined;
		result = _tmp31_;
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp32_ = js_api;
	_tmp33_ = _tmp32_->priv->key_value_storages;
	_tmp33__length1 = _tmp32_->priv->key_value_storages_length1;
	_tmp34_ = index;
	if (_tmp33__length1 <= _tmp34_) {
		const struct OpaqueJSValue* _tmp35_ = NULL;
		_tmp35_ = undefined;
		result = _tmp35_;
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp36_ = js_api;
	_tmp37_ = _tmp36_->priv->key_value_storages;
	_tmp37__length1 = _tmp36_->priv->key_value_storages_length1;
	_tmp38_ = index;
	_tmp39_ = _tmp37_[_tmp38_];
	_tmp40_ = key;
	_tmp41_ = drt_key_value_storage_get_value (_tmp39_, _tmp40_);
	value = _tmp41_;
	_tmp42_ = value;
	if (_tmp42_ == NULL) {
		const struct OpaqueJSValue* _tmp43_ = NULL;
		_tmp43_ = undefined;
		result = _tmp43_;
		_g_variant_unref0 (value);
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	{
		const struct OpaqueJSValue* _tmp44_ = NULL;
		const struct OpaqueJSContext* _tmp45_ = NULL;
		GVariant* _tmp46_ = NULL;
		const struct OpaqueJSValue* _tmp47_ = NULL;
		_tmp45_ = ctx;
		_tmp46_ = value;
		_tmp47_ = nuvola_js_tools_value_from_variant (_tmp45_, _tmp46_, &_inner_error_);
		_tmp44_ = _tmp47_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				goto __catch13_nuvola_js_error;
			}
			_g_variant_unref0 (value);
			_g_object_unref0 (js_api);
			_g_free0 (key);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp44_;
		_g_variant_unref0 (value);
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	goto __finally13;
	__catch13_nuvola_js_error:
	{
		GError* e = NULL;
		const struct OpaqueJSContext* _tmp48_ = NULL;
		GError* _tmp49_ = NULL;
		const gchar* _tmp50_ = NULL;
		gchar* _tmp51_ = NULL;
		gchar* _tmp52_ = NULL;
		const struct OpaqueJSValue* _tmp53_ = NULL;
		const struct OpaqueJSValue* _tmp54_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp48_ = ctx;
		_tmp49_ = e;
		_tmp50_ = _tmp49_->message;
		_tmp51_ = g_strdup_printf ("Failed to convert Variant to JavaScript value. %s", _tmp50_);
		_tmp52_ = _tmp51_;
		_tmp53_ = nuvola_js_tools_create_exception (_tmp48_, _tmp52_);
		_vala_exception = _tmp53_;
		_g_free0 (_tmp52_);
		_tmp54_ = undefined;
		result = _tmp54_;
		_g_error_free0 (e);
		_g_variant_unref0 (value);
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	__finally13:
	_g_variant_unref0 (value);
	_g_object_unref0 (js_api);
	_g_free0 (key);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


static const struct OpaqueJSValue* nuvola_js_api_key_value_storage_set_value_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* undefined = NULL;
	const struct OpaqueJSContext* _tmp0_ = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	const struct OpaqueJSValue** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	const struct OpaqueJSValue** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	const struct OpaqueJSContext* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gint index = 0;
	const struct OpaqueJSValue** _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	const struct OpaqueJSValue* _tmp14_ = NULL;
	const struct OpaqueJSContext* _tmp15_ = NULL;
	gdouble _tmp16_ = 0.0;
	gchar* key = NULL;
	const struct OpaqueJSContext* _tmp17_ = NULL;
	const struct OpaqueJSValue** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	const struct OpaqueJSValue* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	NuvolaJSApi* js_api = NULL;
	struct OpaqueJSValue* _tmp25_ = NULL;
	void* _tmp26_ = NULL;
	NuvolaJSApi* _tmp27_ = NULL;
	NuvolaJSApi* _tmp28_ = NULL;
	NuvolaJSApi* _tmp32_ = NULL;
	DrtKeyValueStorage** _tmp33_ = NULL;
	gint _tmp33__length1 = 0;
	gint _tmp34_ = 0;
	const struct OpaqueJSValue* _tmp58_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_tmp0_ = ctx;
	_tmp1_ = JSValueMakeUndefined (_tmp0_);
	undefined = _tmp1_;
	_vala_exception = NULL;
	_tmp2_ = args;
	_tmp2__length1 = args_length1;
	if (_tmp2__length1 != 3) {
		const struct OpaqueJSContext* _tmp3_ = NULL;
		const struct OpaqueJSValue* _tmp4_ = NULL;
		const struct OpaqueJSValue* _tmp5_ = NULL;
		_tmp3_ = ctx;
		_tmp4_ = nuvola_js_tools_create_exception (_tmp3_, "Three arguments required.");
		_vala_exception = _tmp4_;
		_tmp5_ = undefined;
		result = _tmp5_;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp6_ = args;
	_tmp6__length1 = args_length1;
	_tmp7_ = _tmp6_[0];
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsNumber (_tmp8_, _tmp7_);
	if (!_tmp9_) {
		const struct OpaqueJSContext* _tmp10_ = NULL;
		const struct OpaqueJSValue* _tmp11_ = NULL;
		const struct OpaqueJSValue* _tmp12_ = NULL;
		_tmp10_ = ctx;
		_tmp11_ = nuvola_js_tools_create_exception (_tmp10_, "Argument 0 must be a number.");
		_vala_exception = _tmp11_;
		_tmp12_ = undefined;
		result = _tmp12_;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp13_ = args;
	_tmp13__length1 = args_length1;
	_tmp14_ = _tmp13_[0];
	_tmp15_ = ctx;
	_tmp16_ = JSValueToNumber (_tmp15_, _tmp14_, NULL);
	index = (gint) _tmp16_;
	_tmp17_ = ctx;
	_tmp18_ = args;
	_tmp18__length1 = args_length1;
	_tmp19_ = _tmp18_[1];
	_tmp20_ = nuvola_js_tools_string_or_null (_tmp17_, _tmp19_, FALSE);
	key = _tmp20_;
	_tmp21_ = key;
	if (_tmp21_ == NULL) {
		const struct OpaqueJSContext* _tmp22_ = NULL;
		const struct OpaqueJSValue* _tmp23_ = NULL;
		const struct OpaqueJSValue* _tmp24_ = NULL;
		_tmp22_ = ctx;
		_tmp23_ = nuvola_js_tools_create_exception (_tmp22_, "Argument 1 must be a non-null string");
		_vala_exception = _tmp23_;
		_tmp24_ = undefined;
		result = _tmp24_;
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp25_ = _self_;
	_tmp26_ = JSObjectGetPrivate (_tmp25_);
	_tmp27_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp26_, NUVOLA_TYPE_JS_API) ? ((NuvolaJSApi*) _tmp26_) : NULL);
	js_api = _tmp27_;
	_tmp28_ = js_api;
	if (_tmp28_ == NULL) {
		const struct OpaqueJSContext* _tmp29_ = NULL;
		const struct OpaqueJSValue* _tmp30_ = NULL;
		const struct OpaqueJSValue* _tmp31_ = NULL;
		_tmp29_ = ctx;
		_tmp30_ = nuvola_js_tools_create_exception (_tmp29_, "JSApi is null");
		_vala_exception = _tmp30_;
		_tmp31_ = undefined;
		result = _tmp31_;
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp32_ = js_api;
	_tmp33_ = _tmp32_->priv->key_value_storages;
	_tmp33__length1 = _tmp32_->priv->key_value_storages_length1;
	_tmp34_ = index;
	if (_tmp33__length1 <= _tmp34_) {
		const struct OpaqueJSValue* _tmp35_ = NULL;
		_tmp35_ = undefined;
		result = _tmp35_;
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	{
		GVariant* _tmp36_ = NULL;
		const struct OpaqueJSValue** _tmp37_ = NULL;
		gint _tmp37__length1 = 0;
		const struct OpaqueJSValue* _tmp38_ = NULL;
		const struct OpaqueJSContext* _tmp39_ = NULL;
		gboolean _tmp40_ = FALSE;
		GVariant* value = NULL;
		GVariant* _tmp45_ = NULL;
		NuvolaJSApi* _tmp46_ = NULL;
		DrtKeyValueStorage** _tmp47_ = NULL;
		gint _tmp47__length1 = 0;
		gint _tmp48_ = 0;
		DrtKeyValueStorage* _tmp49_ = NULL;
		const gchar* _tmp50_ = NULL;
		GVariant* _tmp51_ = NULL;
		_tmp37_ = args;
		_tmp37__length1 = args_length1;
		_tmp38_ = _tmp37_[2];
		_tmp39_ = ctx;
		_tmp40_ = JSValueIsUndefined (_tmp39_, _tmp38_);
		if (_tmp40_) {
			_g_variant_unref0 (_tmp36_);
			_tmp36_ = NULL;
		} else {
			const struct OpaqueJSContext* _tmp41_ = NULL;
			const struct OpaqueJSValue** _tmp42_ = NULL;
			gint _tmp42__length1 = 0;
			const struct OpaqueJSValue* _tmp43_ = NULL;
			GVariant* _tmp44_ = NULL;
			_tmp41_ = ctx;
			_tmp42_ = args;
			_tmp42__length1 = args_length1;
			_tmp43_ = _tmp42_[2];
			_tmp44_ = nuvola_js_tools_variant_from_value (_tmp41_, _tmp43_, &_inner_error_);
			_g_variant_unref0 (_tmp36_);
			_tmp36_ = _tmp44_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_variant_unref0 (_tmp36_);
				if (_inner_error_->domain == NUVOLA_JS_ERROR) {
					goto __catch14_nuvola_js_error;
				}
				_g_variant_unref0 (_tmp36_);
				_g_object_unref0 (js_api);
				_g_free0 (key);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp45_ = _g_variant_ref0 (_tmp36_);
		value = _tmp45_;
		_tmp46_ = js_api;
		_tmp47_ = _tmp46_->priv->key_value_storages;
		_tmp47__length1 = _tmp46_->priv->key_value_storages_length1;
		_tmp48_ = index;
		_tmp49_ = _tmp47_[_tmp48_];
		_tmp50_ = key;
		_tmp51_ = value;
		drt_key_value_storage_set_value (_tmp49_, _tmp50_, _tmp51_);
		_g_variant_unref0 (value);
		_g_variant_unref0 (_tmp36_);
	}
	goto __finally14;
	__catch14_nuvola_js_error:
	{
		GError* e = NULL;
		const struct OpaqueJSContext* _tmp52_ = NULL;
		GError* _tmp53_ = NULL;
		const gchar* _tmp54_ = NULL;
		gchar* _tmp55_ = NULL;
		gchar* _tmp56_ = NULL;
		const struct OpaqueJSValue* _tmp57_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp52_ = ctx;
		_tmp53_ = e;
		_tmp54_ = _tmp53_->message;
		_tmp55_ = g_strdup_printf ("Failed to convert JavaScript value to Variant. %s", _tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = nuvola_js_tools_create_exception (_tmp52_, _tmp56_);
		_vala_exception = _tmp57_;
		_g_free0 (_tmp56_);
		_g_error_free0 (e);
	}
	__finally14:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (js_api);
		_g_free0 (key);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp58_ = undefined;
	result = _tmp58_;
	_g_object_unref0 (js_api);
	_g_free0 (key);
	if (exception) {
		*exception = _vala_exception;
	}
	return result;
}


static const struct OpaqueJSValue* nuvola_js_api_key_value_storage_set_default_value_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* undefined = NULL;
	const struct OpaqueJSContext* _tmp0_ = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	const struct OpaqueJSValue** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	const struct OpaqueJSValue** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	const struct OpaqueJSContext* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gint index = 0;
	const struct OpaqueJSValue** _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	const struct OpaqueJSValue* _tmp14_ = NULL;
	const struct OpaqueJSContext* _tmp15_ = NULL;
	gdouble _tmp16_ = 0.0;
	gchar* key = NULL;
	const struct OpaqueJSContext* _tmp17_ = NULL;
	const struct OpaqueJSValue** _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	const struct OpaqueJSValue* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	NuvolaJSApi* js_api = NULL;
	struct OpaqueJSValue* _tmp25_ = NULL;
	void* _tmp26_ = NULL;
	NuvolaJSApi* _tmp27_ = NULL;
	NuvolaJSApi* _tmp28_ = NULL;
	NuvolaJSApi* _tmp32_ = NULL;
	DrtKeyValueStorage** _tmp33_ = NULL;
	gint _tmp33__length1 = 0;
	gint _tmp34_ = 0;
	const struct OpaqueJSValue* _tmp58_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_tmp0_ = ctx;
	_tmp1_ = JSValueMakeUndefined (_tmp0_);
	undefined = _tmp1_;
	_vala_exception = NULL;
	_tmp2_ = args;
	_tmp2__length1 = args_length1;
	if (_tmp2__length1 != 3) {
		const struct OpaqueJSContext* _tmp3_ = NULL;
		const struct OpaqueJSValue* _tmp4_ = NULL;
		const struct OpaqueJSValue* _tmp5_ = NULL;
		_tmp3_ = ctx;
		_tmp4_ = nuvola_js_tools_create_exception (_tmp3_, "Three arguments required.");
		_vala_exception = _tmp4_;
		_tmp5_ = undefined;
		result = _tmp5_;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp6_ = args;
	_tmp6__length1 = args_length1;
	_tmp7_ = _tmp6_[0];
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsNumber (_tmp8_, _tmp7_);
	if (!_tmp9_) {
		const struct OpaqueJSContext* _tmp10_ = NULL;
		const struct OpaqueJSValue* _tmp11_ = NULL;
		const struct OpaqueJSValue* _tmp12_ = NULL;
		_tmp10_ = ctx;
		_tmp11_ = nuvola_js_tools_create_exception (_tmp10_, "Argument 0 must be a number.");
		_vala_exception = _tmp11_;
		_tmp12_ = undefined;
		result = _tmp12_;
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp13_ = args;
	_tmp13__length1 = args_length1;
	_tmp14_ = _tmp13_[0];
	_tmp15_ = ctx;
	_tmp16_ = JSValueToNumber (_tmp15_, _tmp14_, NULL);
	index = (gint) _tmp16_;
	_tmp17_ = ctx;
	_tmp18_ = args;
	_tmp18__length1 = args_length1;
	_tmp19_ = _tmp18_[1];
	_tmp20_ = nuvola_js_tools_string_or_null (_tmp17_, _tmp19_, FALSE);
	key = _tmp20_;
	_tmp21_ = key;
	if (_tmp21_ == NULL) {
		const struct OpaqueJSContext* _tmp22_ = NULL;
		const struct OpaqueJSValue* _tmp23_ = NULL;
		const struct OpaqueJSValue* _tmp24_ = NULL;
		_tmp22_ = ctx;
		_tmp23_ = nuvola_js_tools_create_exception (_tmp22_, "Argument 1 must be a non-null string");
		_vala_exception = _tmp23_;
		_tmp24_ = undefined;
		result = _tmp24_;
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp25_ = _self_;
	_tmp26_ = JSObjectGetPrivate (_tmp25_);
	_tmp27_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp26_, NUVOLA_TYPE_JS_API) ? ((NuvolaJSApi*) _tmp26_) : NULL);
	js_api = _tmp27_;
	_tmp28_ = js_api;
	if (_tmp28_ == NULL) {
		const struct OpaqueJSContext* _tmp29_ = NULL;
		const struct OpaqueJSValue* _tmp30_ = NULL;
		const struct OpaqueJSValue* _tmp31_ = NULL;
		_tmp29_ = ctx;
		_tmp30_ = nuvola_js_tools_create_exception (_tmp29_, "JSApi is null");
		_vala_exception = _tmp30_;
		_tmp31_ = undefined;
		result = _tmp31_;
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	_tmp32_ = js_api;
	_tmp33_ = _tmp32_->priv->key_value_storages;
	_tmp33__length1 = _tmp32_->priv->key_value_storages_length1;
	_tmp34_ = index;
	if (_tmp33__length1 <= _tmp34_) {
		const struct OpaqueJSValue* _tmp35_ = NULL;
		_tmp35_ = undefined;
		result = _tmp35_;
		_g_object_unref0 (js_api);
		_g_free0 (key);
		if (exception) {
			*exception = _vala_exception;
		}
		return result;
	}
	{
		GVariant* _tmp36_ = NULL;
		const struct OpaqueJSValue** _tmp37_ = NULL;
		gint _tmp37__length1 = 0;
		const struct OpaqueJSValue* _tmp38_ = NULL;
		const struct OpaqueJSContext* _tmp39_ = NULL;
		gboolean _tmp40_ = FALSE;
		GVariant* value = NULL;
		GVariant* _tmp45_ = NULL;
		NuvolaJSApi* _tmp46_ = NULL;
		DrtKeyValueStorage** _tmp47_ = NULL;
		gint _tmp47__length1 = 0;
		gint _tmp48_ = 0;
		DrtKeyValueStorage* _tmp49_ = NULL;
		const gchar* _tmp50_ = NULL;
		GVariant* _tmp51_ = NULL;
		_tmp37_ = args;
		_tmp37__length1 = args_length1;
		_tmp38_ = _tmp37_[2];
		_tmp39_ = ctx;
		_tmp40_ = JSValueIsUndefined (_tmp39_, _tmp38_);
		if (_tmp40_) {
			_g_variant_unref0 (_tmp36_);
			_tmp36_ = NULL;
		} else {
			const struct OpaqueJSContext* _tmp41_ = NULL;
			const struct OpaqueJSValue** _tmp42_ = NULL;
			gint _tmp42__length1 = 0;
			const struct OpaqueJSValue* _tmp43_ = NULL;
			GVariant* _tmp44_ = NULL;
			_tmp41_ = ctx;
			_tmp42_ = args;
			_tmp42__length1 = args_length1;
			_tmp43_ = _tmp42_[2];
			_tmp44_ = nuvola_js_tools_variant_from_value (_tmp41_, _tmp43_, &_inner_error_);
			_g_variant_unref0 (_tmp36_);
			_tmp36_ = _tmp44_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_variant_unref0 (_tmp36_);
				if (_inner_error_->domain == NUVOLA_JS_ERROR) {
					goto __catch15_nuvola_js_error;
				}
				_g_variant_unref0 (_tmp36_);
				_g_object_unref0 (js_api);
				_g_free0 (key);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp45_ = _g_variant_ref0 (_tmp36_);
		value = _tmp45_;
		_tmp46_ = js_api;
		_tmp47_ = _tmp46_->priv->key_value_storages;
		_tmp47__length1 = _tmp46_->priv->key_value_storages_length1;
		_tmp48_ = index;
		_tmp49_ = _tmp47_[_tmp48_];
		_tmp50_ = key;
		_tmp51_ = value;
		drt_key_value_storage_set_default_value (_tmp49_, _tmp50_, _tmp51_);
		_g_variant_unref0 (value);
		_g_variant_unref0 (_tmp36_);
	}
	goto __finally15;
	__catch15_nuvola_js_error:
	{
		GError* e = NULL;
		const struct OpaqueJSContext* _tmp52_ = NULL;
		GError* _tmp53_ = NULL;
		const gchar* _tmp54_ = NULL;
		gchar* _tmp55_ = NULL;
		gchar* _tmp56_ = NULL;
		const struct OpaqueJSValue* _tmp57_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp52_ = ctx;
		_tmp53_ = e;
		_tmp54_ = _tmp53_->message;
		_tmp55_ = g_strdup_printf ("Failed to convert JavaScript value to Variant. %s", _tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = nuvola_js_tools_create_exception (_tmp52_, _tmp56_);
		_vala_exception = _tmp57_;
		_g_free0 (_tmp56_);
		_g_error_free0 (e);
	}
	__finally15:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (js_api);
		_g_free0 (key);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp58_ = undefined;
	result = _tmp58_;
	_g_object_unref0 (js_api);
	_g_free0 (key);
	if (exception) {
		*exception = _vala_exception;
	}
	return result;
}


static const struct OpaqueJSValue* nuvola_js_api_log_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSContext* _tmp21_ = NULL;
	const struct OpaqueJSValue* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_vala_exception = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_ = 0;
				const struct OpaqueJSValue** _tmp3_ = NULL;
				gint _tmp3__length1 = 0;
				const struct OpaqueJSValue** _tmp4_ = NULL;
				gint _tmp4__length1 = 0;
				gint _tmp5_ = 0;
				const struct OpaqueJSValue* _tmp6_ = NULL;
				const struct OpaqueJSContext* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_ = 0;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = args;
				_tmp3__length1 = args_length1;
				if (!(_tmp2_ < _tmp3__length1)) {
					break;
				}
				_tmp4_ = args;
				_tmp4__length1 = args_length1;
				_tmp5_ = i;
				_tmp6_ = _tmp4_[_tmp5_];
				_tmp7_ = ctx;
				_tmp8_ = JSValueIsUndefined (_tmp7_, _tmp6_);
				if (_tmp8_) {
					g_debug ("jsapi.vala:574: Nuvola.log: undefined");
				} else {
					{
						GVariant* _tmp9_ = NULL;
						const struct OpaqueJSContext* _tmp10_ = NULL;
						const struct OpaqueJSValue** _tmp11_ = NULL;
						gint _tmp11__length1 = 0;
						gint _tmp12_ = 0;
						const struct OpaqueJSValue* _tmp13_ = NULL;
						GVariant* _tmp14_ = NULL;
						GVariant* _tmp15_ = NULL;
						GVariant* _tmp16_ = NULL;
						gchar* _tmp17_ = NULL;
						gchar* _tmp18_ = NULL;
						_tmp10_ = ctx;
						_tmp11_ = args;
						_tmp11__length1 = args_length1;
						_tmp12_ = i;
						_tmp13_ = _tmp11_[_tmp12_];
						_tmp14_ = nuvola_js_tools_variant_from_value (_tmp10_, _tmp13_, &_inner_error_);
						_tmp9_ = _tmp14_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							if (_inner_error_->domain == NUVOLA_JS_ERROR) {
								goto __catch16_nuvola_js_error;
							}
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
						_tmp15_ = _tmp9_;
						_tmp9_ = NULL;
						_tmp16_ = _tmp15_;
						_tmp17_ = g_variant_print (_tmp16_, FALSE);
						_tmp18_ = _tmp17_;
						g_debug ("jsapi.vala:580: Nuvola.log: %s", _tmp18_);
						_g_free0 (_tmp18_);
						_g_variant_unref0 (_tmp16_);
						_g_variant_unref0 (_tmp9_);
					}
					goto __finally16;
					__catch16_nuvola_js_error:
					{
						GError* e = NULL;
						GError* _tmp19_ = NULL;
						const gchar* _tmp20_ = NULL;
						e = _inner_error_;
						_inner_error_ = NULL;
						_tmp19_ = e;
						_tmp20_ = _tmp19_->message;
						g_warning ("jsapi.vala:584: Nuvola.log (JSError): %s", _tmp20_);
						_g_error_free0 (e);
					}
					__finally16:
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
			}
		}
	}
	_tmp21_ = ctx;
	_tmp22_ = JSValueMakeUndefined (_tmp21_);
	result = _tmp22_;
	if (exception) {
		*exception = _vala_exception;
	}
	return result;
}


static const struct OpaqueJSValue* nuvola_js_api_warn_func (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* function, struct OpaqueJSValue* _self_, const struct OpaqueJSValue** args, int args_length1, const struct OpaqueJSValue** exception) {
	const struct OpaqueJSValue* _vala_exception = NULL;
	const struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSContext* _tmp21_ = NULL;
	const struct OpaqueJSValue* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (function != NULL, NULL);
	g_return_val_if_fail (_self_ != NULL, NULL);
	_vala_exception = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_ = 0;
				const struct OpaqueJSValue** _tmp3_ = NULL;
				gint _tmp3__length1 = 0;
				const struct OpaqueJSValue** _tmp4_ = NULL;
				gint _tmp4__length1 = 0;
				gint _tmp5_ = 0;
				const struct OpaqueJSValue* _tmp6_ = NULL;
				const struct OpaqueJSContext* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_ = 0;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = args;
				_tmp3__length1 = args_length1;
				if (!(_tmp2_ < _tmp3__length1)) {
					break;
				}
				_tmp4_ = args;
				_tmp4__length1 = args_length1;
				_tmp5_ = i;
				_tmp6_ = _tmp4_[_tmp5_];
				_tmp7_ = ctx;
				_tmp8_ = JSValueIsUndefined (_tmp7_, _tmp6_);
				if (_tmp8_) {
					g_warning ("jsapi.vala:598: Nuvola.warn: undefined");
				} else {
					{
						GVariant* _tmp9_ = NULL;
						const struct OpaqueJSContext* _tmp10_ = NULL;
						const struct OpaqueJSValue** _tmp11_ = NULL;
						gint _tmp11__length1 = 0;
						gint _tmp12_ = 0;
						const struct OpaqueJSValue* _tmp13_ = NULL;
						GVariant* _tmp14_ = NULL;
						GVariant* _tmp15_ = NULL;
						GVariant* _tmp16_ = NULL;
						gchar* _tmp17_ = NULL;
						gchar* _tmp18_ = NULL;
						_tmp10_ = ctx;
						_tmp11_ = args;
						_tmp11__length1 = args_length1;
						_tmp12_ = i;
						_tmp13_ = _tmp11_[_tmp12_];
						_tmp14_ = nuvola_js_tools_variant_from_value (_tmp10_, _tmp13_, &_inner_error_);
						_tmp9_ = _tmp14_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							if (_inner_error_->domain == NUVOLA_JS_ERROR) {
								goto __catch17_nuvola_js_error;
							}
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
						_tmp15_ = _tmp9_;
						_tmp9_ = NULL;
						_tmp16_ = _tmp15_;
						_tmp17_ = g_variant_print (_tmp16_, FALSE);
						_tmp18_ = _tmp17_;
						g_warning ("jsapi.vala:604: Nuvola.warn: %s", _tmp18_);
						_g_free0 (_tmp18_);
						_g_variant_unref0 (_tmp16_);
						_g_variant_unref0 (_tmp9_);
					}
					goto __finally17;
					__catch17_nuvola_js_error:
					{
						GError* e = NULL;
						GError* _tmp19_ = NULL;
						const gchar* _tmp20_ = NULL;
						e = _inner_error_;
						_inner_error_ = NULL;
						_tmp19_ = e;
						_tmp20_ = _tmp19_->message;
						g_warning ("jsapi.vala:608: Nuvola.warn (JSError): %s", _tmp20_);
						_g_error_free0 (e);
					}
					__finally17:
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
			}
		}
	}
	_tmp21_ = ctx;
	_tmp22_ = JSValueMakeUndefined (_tmp21_);
	result = _tmp22_;
	if (exception) {
		*exception = _vala_exception;
	}
	return result;
}


static void g_cclosure_user_marshal_VOID__STRING_VARIANT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_VARIANT) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_VARIANT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_VARIANT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_variant (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__STRING_VARIANT_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_VARIANT_POINTER) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_VARIANT_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_VARIANT_POINTER) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_variant (param_values + 2), g_value_get_pointer (param_values + 3), data2);
}


static void nuvola_js_api_class_init (NuvolaJSApiClass * klass) {
	nuvola_js_api_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaJSApiPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_js_api_finalize;
	g_signal_new ("call_ipc_method_async", NUVOLA_TYPE_JS_API, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_VARIANT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_VARIANT);
	g_signal_new ("call_ipc_method_sync", NUVOLA_TYPE_JS_API, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_VARIANT_POINTER, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_VARIANT, G_TYPE_POINTER);
	g_signal_new ("call_ipc_method_with_dict_async", NUVOLA_TYPE_JS_API, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_VARIANT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_VARIANT);
	g_signal_new ("call_ipc_method_with_dict_sync", NUVOLA_TYPE_JS_API, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_VARIANT_POINTER, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_VARIANT, G_TYPE_POINTER);
}


static void nuvola_js_api_instance_init (NuvolaJSApi * self) {
	self->priv = NUVOLA_JS_API_GET_PRIVATE (self);
}


static void nuvola_js_api_finalize (GObject* obj) {
	NuvolaJSApi * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_JS_API, NuvolaJSApi);
	_g_object_unref0 (self->priv->storage);
	_g_object_unref0 (self->priv->data_dir);
	_g_object_unref0 (self->priv->config_dir);
	self->priv->key_value_storages = (_vala_array_free (self->priv->key_value_storages, self->priv->key_value_storages_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->webkit_version = (g_free (self->priv->webkit_version), NULL);
	self->priv->libsoup_version = (g_free (self->priv->libsoup_version), NULL);
	G_OBJECT_CLASS (nuvola_js_api_parent_class)->finalize (obj);
}


/**
 * Nuvola JavaScript API provides interface for service integrations to communicate
 * with Nuvola Player runtime. Practically, it is a bridge between Service object
 * and JavaScript environment of WebKit WebView.
 * 
 * Main method of the main Nuvola Player JavaScript object are implemented here,
 * other helper functions and tools are loaded from a JavaScript file.
 */
GType nuvola_js_api_get_type (void) {
	static volatile gsize nuvola_js_api_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_js_api_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaJSApiClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_js_api_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaJSApi), 0, (GInstanceInitFunc) nuvola_js_api_instance_init, NULL };
		GType nuvola_js_api_type_id;
		nuvola_js_api_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaJSApi", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_js_api_type_id__volatile, nuvola_js_api_type_id);
	}
	return nuvola_js_api_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



