/* jsenvironment.c generated by valac 0.34.9, the Vala compiler
 * generated from jsenvironment.vala, do not modify */

/*
 * Copyright 2011-2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <JavaScriptCore/JavaScript.h>
#include <gio/gio.h>
#include <dioriteglib4.h>


#define NUVOLA_TYPE_VALUE_TYPE (nuvola_value_type_get_type ())

#define NUVOLA_TYPE_JS_EXECUTOR (nuvola_js_executor_get_type ())
#define NUVOLA_JS_EXECUTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_JS_EXECUTOR, NuvolaJSExecutor))
#define NUVOLA_IS_JS_EXECUTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_JS_EXECUTOR))
#define NUVOLA_JS_EXECUTOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_JS_EXECUTOR, NuvolaJSExecutorIface))

typedef struct _NuvolaJSExecutor NuvolaJSExecutor;
typedef struct _NuvolaJSExecutorIface NuvolaJSExecutorIface;

#define NUVOLA_TYPE_JS_ENVIRONMENT (nuvola_js_environment_get_type ())
#define NUVOLA_JS_ENVIRONMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironment))
#define NUVOLA_JS_ENVIRONMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironmentClass))
#define NUVOLA_IS_JS_ENVIRONMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_JS_ENVIRONMENT))
#define NUVOLA_IS_JS_ENVIRONMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_JS_ENVIRONMENT))
#define NUVOLA_JS_ENVIRONMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironmentClass))

typedef struct _NuvolaJsEnvironment NuvolaJsEnvironment;
typedef struct _NuvolaJsEnvironmentClass NuvolaJsEnvironmentClass;
typedef struct _NuvolaJsEnvironmentPrivate NuvolaJsEnvironmentPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	NUVOLA_VALUE_TYPE_STRING,
	NUVOLA_VALUE_TYPE_INT,
	NUVOLA_VALUE_TYPE_DOUBLE,
	NUVOLA_VALUE_TYPE_NULL,
	NUVOLA_VALUE_TYPE_JS_VALUE
} NuvolaValueType;

struct _NuvolaJSExecutorIface {
	GTypeInterface parent_iface;
	void (*call_function) (NuvolaJSExecutor* self, const gchar* name, GVariant** params, GError** error);
};

struct _NuvolaJsEnvironment {
	GObject parent_instance;
	NuvolaJsEnvironmentPrivate * priv;
};

struct _NuvolaJsEnvironmentClass {
	GObjectClass parent_class;
};

struct _NuvolaJsEnvironmentPrivate {
	struct OpaqueJSContext* _context;
	struct OpaqueJSValue* _main_object;
};

typedef enum  {
	NUVOLA_JS_ERROR_NOT_FOUND,
	NUVOLA_JS_ERROR_WRONG_TYPE,
	NUVOLA_JS_ERROR_FUNC_FAILED,
	NUVOLA_JS_ERROR_READ_ERROR,
	NUVOLA_JS_ERROR_NO_CONTEXT,
	NUVOLA_JS_ERROR_EXCEPTION,
	NUVOLA_JS_ERROR_INITIALIZATION_FAILED
} NuvolaJSError;
#define NUVOLA_JS_ERROR nuvola_js_error_quark ()

static gpointer nuvola_js_environment_parent_class = NULL;
static NuvolaJSExecutorIface* nuvola_js_environment_nuvola_js_executor_parent_iface = NULL;

#define NUVOLA_WEB_ENGINE_LOADING_URI "about:loading"
GType nuvola_value_type_get_type (void) G_GNUC_CONST;
GType nuvola_js_executor_get_type (void) G_GNUC_CONST;
GType nuvola_js_environment_get_type (void) G_GNUC_CONST;
#define NUVOLA_JS_ENVIRONMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironmentPrivate))
enum  {
	NUVOLA_JS_ENVIRONMENT_DUMMY_PROPERTY,
	NUVOLA_JS_ENVIRONMENT_CONTEXT,
	NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT
};
void nuvola_js_environment_set_main_object (NuvolaJsEnvironment* self, struct OpaqueJSValue* value);
NuvolaJsEnvironment* nuvola_js_environment_new (struct OpaqueJSContext* context, struct OpaqueJSValue* main_object);
NuvolaJsEnvironment* nuvola_js_environment_construct (GType object_type, struct OpaqueJSContext* context, struct OpaqueJSValue* main_object);
static void nuvola_js_environment_set_context (NuvolaJsEnvironment* self, struct OpaqueJSContext* value);
GQuark nuvola_js_error_quark (void);
void nuvola_js_environment_execute_script_from_file (NuvolaJsEnvironment* self, GFile* file, GValue* result, GError** error);
void nuvola_js_environment_execute_script (NuvolaJsEnvironment* self, const gchar* script, const gchar* path, gint line, GValue* result, GError** error);
struct OpaqueJSContext* nuvola_js_environment_get_context (NuvolaJsEnvironment* self);
struct OpaqueJSValue* nuvola_js_environment_get_main_object (NuvolaJsEnvironment* self);
gchar* nuvola_js_tools_exception_to_string (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* value);
static void nuvola_js_environment_real_call_function (NuvolaJSExecutor* base, const gchar* name, GVariant** args, GError** error);
struct OpaqueJSValue* nuvola_js_tools_o_get_object (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property);
const struct OpaqueJSValue* nuvola_js_tools_value_from_variant (const struct OpaqueJSContext* ctx, GVariant* variant, GError** error);
GVariant* nuvola_js_tools_variant_from_value (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, GError** error);
static void nuvola_js_environment_finalize (GObject* obj);
static void _vala_nuvola_js_environment_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_js_environment_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType nuvola_value_type_get_type (void) {
	static volatile gsize nuvola_value_type_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_value_type_type_id__volatile)) {
		static const GEnumValue values[] = {{NUVOLA_VALUE_TYPE_STRING, "NUVOLA_VALUE_TYPE_STRING", "string"}, {NUVOLA_VALUE_TYPE_INT, "NUVOLA_VALUE_TYPE_INT", "int"}, {NUVOLA_VALUE_TYPE_DOUBLE, "NUVOLA_VALUE_TYPE_DOUBLE", "double"}, {NUVOLA_VALUE_TYPE_NULL, "NUVOLA_VALUE_TYPE_NULL", "null"}, {NUVOLA_VALUE_TYPE_JS_VALUE, "NUVOLA_VALUE_TYPE_JS_VALUE", "js-value"}, {0, NULL, NULL}};
		GType nuvola_value_type_type_id;
		nuvola_value_type_type_id = g_enum_register_static ("NuvolaValueType", values);
		g_once_init_leave (&nuvola_value_type_type_id__volatile, nuvola_value_type_type_id);
	}
	return nuvola_value_type_type_id__volatile;
}


NuvolaJsEnvironment* nuvola_js_environment_construct (GType object_type, struct OpaqueJSContext* context, struct OpaqueJSValue* main_object) {
	NuvolaJsEnvironment * self = NULL;
	struct OpaqueJSContext* _tmp0_ = NULL;
	struct OpaqueJSValue* _tmp1_ = NULL;
	g_return_val_if_fail (context != NULL, NULL);
	self = (NuvolaJsEnvironment*) g_object_new (object_type, NULL);
	_tmp0_ = context;
	nuvola_js_environment_set_context (self, _tmp0_);
	_tmp1_ = main_object;
	nuvola_js_environment_set_main_object (self, _tmp1_);
	return self;
}


NuvolaJsEnvironment* nuvola_js_environment_new (struct OpaqueJSContext* context, struct OpaqueJSValue* main_object) {
	return nuvola_js_environment_construct (NUVOLA_TYPE_JS_ENVIRONMENT, context, main_object);
}


/**
 * Executes script from file.
 * 
 * The script will be executed in a context returned by {@link get_context().
 * The "this" keyword will refer to {@link object_this} if provided.
 * 
 * @param file    script to execute
 * @return        return value of the script
 * @throw         JSError on failure
 */
void nuvola_js_environment_execute_script_from_file (NuvolaJsEnvironment* self, GFile* file, GValue* result, GError** error) {
	gchar* code = NULL;
	GValue _tmp11_ = {0};
	GFile* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	GValue _tmp15_ = {0};
	GValue _tmp16_ = {0};
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	{
		gchar* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		_tmp1_ = file;
		_tmp2_ = drt_system_read_file (_tmp1_, &_inner_error_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch18_g_error;
		}
		_tmp3_ = _tmp0_;
		_tmp0_ = NULL;
		_g_free0 (code);
		code = _tmp3_;
		_g_free0 (_tmp0_);
	}
	goto __finally18;
	__catch18_g_error:
	{
		GError* e = NULL;
		GFile* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = file;
		_tmp5_ = g_file_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		_tmp9_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_READ_ERROR, "Unable to read script %s: %s", _tmp6_, _tmp8_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp6_);
		_inner_error_ = _tmp10_;
		_g_error_free0 (e);
		goto __finally18;
	}
	__finally18:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (code);
			return;
		} else {
			_g_free0 (code);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp12_ = file;
	_tmp13_ = g_file_get_uri (_tmp12_);
	_tmp14_ = _tmp13_;
	nuvola_js_environment_execute_script (self, code, _tmp14_, 1, &_tmp15_, &_inner_error_);
	_tmp16_ = _tmp15_;
	_g_free0 (_tmp14_);
	_tmp11_ = _tmp16_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (code);
			return;
		} else {
			_g_free0 (code);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	*result = _tmp11_;
	_g_free0 (code);
	return;
}


/**
 * Executes script.
 * 
 * The script will be executed in a context returned by {@link get_context()}.
 * The "this" keyword will refer to {@link object_this} if provided.
 * 
 * @param script    script to execute
 * @return          return value of the script
 * @throw           JSError on failure
 */
void nuvola_js_environment_execute_script (NuvolaJsEnvironment* self, const gchar* script, const gchar* path, gint line, GValue* result, GError** error) {
	const struct OpaqueJSValue* exception = NULL;
	GValue value = {0};
	struct OpaqueJSContext* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	struct OpaqueJSString* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_ = NULL;
	struct OpaqueJSValue* _tmp4_ = NULL;
	struct OpaqueJSValue* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	struct OpaqueJSString* _tmp7_ = NULL;
	struct OpaqueJSString* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	const struct OpaqueJSValue* _tmp10_ = NULL;
	const struct OpaqueJSValue* _tmp11_ = NULL;
	GValue _tmp12_ = {0};
	GValue _tmp13_ = {0};
	const struct OpaqueJSValue* _tmp14_ = NULL;
	GValue _tmp21_ = {0};
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (script != NULL);
	g_return_if_fail (path != NULL);
	exception = NULL;
	_tmp0_ = self->priv->_context;
	_tmp1_ = script;
	_tmp2_ = JSStringCreateWithUTF8CString (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = nuvola_js_environment_get_main_object (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = path;
	_tmp7_ = JSStringCreateWithUTF8CString (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = line;
	_tmp11_ = JSEvaluateScript ((const struct OpaqueJSContext*) _tmp0_, _tmp3_, _tmp5_, _tmp8_, _tmp9_, &_tmp10_);
	_0 (exception);
	exception = _tmp10_;
	g_value_init (&_tmp12_, G_TYPE_POINTER);
	g_value_set_pointer (&_tmp12_, _tmp11_);
	_tmp13_ = _tmp12_;
	G_IS_VALUE (&_tmp12_) ? (g_value_unset (&_tmp12_), NULL) : NULL;
	_JSStringRelease0 (_tmp8_);
	_JSStringRelease0 (_tmp3_);
	value = _tmp13_;
	_tmp14_ = exception;
	if (_tmp14_ != NULL) {
		struct OpaqueJSContext* _tmp15_ = NULL;
		const struct OpaqueJSValue* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		GError* _tmp19_ = NULL;
		GError* _tmp20_ = NULL;
		_tmp15_ = self->priv->_context;
		_tmp16_ = exception;
		_tmp17_ = nuvola_js_tools_exception_to_string ((const struct OpaqueJSContext*) _tmp15_, _tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_error_new_literal (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_EXCEPTION, _tmp18_);
		_tmp20_ = _tmp19_;
		_g_free0 (_tmp18_);
		_inner_error_ = _tmp20_;
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_0 (exception);
			return;
		} else {
			_0 (exception);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp21_ = value;
	*result = _tmp21_;
	_0 (exception);
	return;
}


static void nuvola_js_environment_real_call_function (NuvolaJSExecutor* base, const gchar* name, GVariant** args, GError** error) {
	NuvolaJsEnvironment * self;
	const struct OpaqueJSContext* ctx = NULL;
	struct OpaqueJSContext* _tmp0_ = NULL;
	gchar** names = NULL;
	const gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint names_length1 = 0;
	gint _names_size_ = 0;
	struct OpaqueJSValue* object = NULL;
	struct OpaqueJSValue* _tmp4_ = NULL;
	struct OpaqueJSValue* _tmp5_ = NULL;
	struct OpaqueJSValue* _tmp6_ = NULL;
	struct OpaqueJSValue* func = NULL;
	const struct OpaqueJSContext* _tmp23_ = NULL;
	struct OpaqueJSValue* _tmp24_ = NULL;
	gchar** _tmp25_ = NULL;
	gint _tmp25__length1 = 0;
	gchar** _tmp26_ = NULL;
	gint _tmp26__length1 = 0;
	const gchar* _tmp27_ = NULL;
	struct OpaqueJSValue* _tmp28_ = NULL;
	struct OpaqueJSValue* _tmp29_ = NULL;
	struct OpaqueJSValue* _tmp34_ = NULL;
	const struct OpaqueJSContext* _tmp35_ = NULL;
	gboolean _tmp36_ = FALSE;
	const struct OpaqueJSValue** params = NULL;
	gint params_length1 = 0;
	gint _params_size_ = 0;
	gint size = 0;
	GVariant* _tmp39_ = NULL;
	const struct OpaqueJSValue* exception = NULL;
	struct OpaqueJSValue* _tmp59_ = NULL;
	const struct OpaqueJSContext* _tmp60_ = NULL;
	struct OpaqueJSValue* _tmp61_ = NULL;
	const struct OpaqueJSValue** _tmp62_ = NULL;
	gint _tmp62__length1 = 0;
	const struct OpaqueJSValue* _tmp63_ = NULL;
	const struct OpaqueJSValue* _tmp64_ = NULL;
	GVariant* _tmp75_ = NULL;
	GError * _inner_error_ = NULL;
	self = (NuvolaJsEnvironment*) base;
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->_context;
	ctx = (const struct OpaqueJSContext*) _tmp0_;
	_tmp1_ = name;
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ".", 0);
	names = _tmp3_;
	names_length1 = _vala_array_length (_tmp2_);
	_names_size_ = names_length1;
	_tmp4_ = nuvola_js_environment_get_main_object (self);
	_tmp5_ = _tmp4_;
	object = _tmp5_;
	_tmp6_ = object;
	if (_tmp6_ == NULL) {
		GError* _tmp7_ = NULL;
		_tmp7_ = g_error_new_literal (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_NOT_FOUND, "Main object not found.'");
		_inner_error_ = _tmp7_;
		g_propagate_error (error, _inner_error_);
		names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				gint _tmp10_ = 0;
				gchar** _tmp11_ = NULL;
				gint _tmp11__length1 = 0;
				const struct OpaqueJSContext* _tmp12_ = NULL;
				struct OpaqueJSValue* _tmp13_ = NULL;
				gchar** _tmp14_ = NULL;
				gint _tmp14__length1 = 0;
				gint _tmp15_ = 0;
				const gchar* _tmp16_ = NULL;
				struct OpaqueJSValue* _tmp17_ = NULL;
				struct OpaqueJSValue* _tmp18_ = NULL;
				if (!_tmp8_) {
					gint _tmp9_ = 0;
					_tmp9_ = i;
					i = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp10_ = i;
				_tmp11_ = names;
				_tmp11__length1 = names_length1;
				if (!(_tmp10_ < (_tmp11__length1 - 1))) {
					break;
				}
				_tmp12_ = ctx;
				_tmp13_ = object;
				_tmp14_ = names;
				_tmp14__length1 = names_length1;
				_tmp15_ = i;
				_tmp16_ = _tmp14_[_tmp15_];
				_tmp17_ = nuvola_js_tools_o_get_object (_tmp12_, _tmp13_, _tmp16_);
				object = _tmp17_;
				_tmp18_ = object;
				if (_tmp18_ == NULL) {
					gchar** _tmp19_ = NULL;
					gint _tmp19__length1 = 0;
					gint _tmp20_ = 0;
					const gchar* _tmp21_ = NULL;
					GError* _tmp22_ = NULL;
					_tmp19_ = names;
					_tmp19__length1 = names_length1;
					_tmp20_ = i;
					_tmp21_ = _tmp19_[_tmp20_];
					_tmp22_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_NOT_FOUND, "Attribute '%s' not found.'", _tmp21_);
					_inner_error_ = _tmp22_;
					g_propagate_error (error, _inner_error_);
					names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
					return;
				}
			}
		}
	}
	_tmp23_ = ctx;
	_tmp24_ = object;
	_tmp25_ = names;
	_tmp25__length1 = names_length1;
	_tmp26_ = names;
	_tmp26__length1 = names_length1;
	_tmp27_ = _tmp25_[_tmp26__length1 - 1];
	_tmp28_ = nuvola_js_tools_o_get_object (_tmp23_, _tmp24_, _tmp27_);
	func = _tmp28_;
	_tmp29_ = func;
	if (_tmp29_ == NULL) {
		gchar** _tmp30_ = NULL;
		gint _tmp30__length1 = 0;
		gchar** _tmp31_ = NULL;
		gint _tmp31__length1 = 0;
		const gchar* _tmp32_ = NULL;
		GError* _tmp33_ = NULL;
		_tmp30_ = names;
		_tmp30__length1 = names_length1;
		_tmp31_ = names;
		_tmp31__length1 = names_length1;
		_tmp32_ = _tmp30_[_tmp31__length1 - 1];
		_tmp33_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_NOT_FOUND, "Attribute '%s' not found.'", _tmp32_);
		_inner_error_ = _tmp33_;
		g_propagate_error (error, _inner_error_);
		names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	_tmp34_ = func;
	_tmp35_ = ctx;
	_tmp36_ = JSObjectIsFunction (_tmp35_, _tmp34_);
	if (!_tmp36_) {
		const gchar* _tmp37_ = NULL;
		GError* _tmp38_ = NULL;
		_tmp37_ = name;
		_tmp38_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_WRONG_TYPE, "'%s' is not a function.'", _tmp37_);
		_inner_error_ = _tmp38_;
		g_propagate_error (error, _inner_error_);
		names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	size = 0;
	_tmp39_ = *args;
	if (_tmp39_ != NULL) {
		GVariant* _tmp40_ = NULL;
		gboolean _tmp41_ = FALSE;
		GVariant* _tmp42_ = NULL;
		gsize _tmp43_ = 0UL;
		gint _tmp44_ = 0;
		const struct OpaqueJSValue** _tmp45_ = NULL;
		gint i = 0;
		_tmp40_ = *args;
		_tmp41_ = g_variant_is_container (_tmp40_);
		_vala_assert (_tmp41_, "args.is_container()");
		_tmp42_ = *args;
		_tmp43_ = g_variant_n_children (_tmp42_);
		size = (gint) _tmp43_;
		_tmp44_ = size;
		_tmp45_ = g_new0 (const struct OpaqueJSValue*, _tmp44_ + 1);
		params = (g_free (params), NULL);
		params = _tmp45_;
		params_length1 = _tmp44_;
		_params_size_ = params_length1;
		i = 0;
		{
			GVariantIter* _item_it = NULL;
			GVariant* _tmp46_ = NULL;
			GVariantIter* _tmp47_ = NULL;
			GVariant* item = NULL;
			_tmp46_ = *args;
			_tmp47_ = g_variant_iter_new (_tmp46_);
			_item_it = _tmp47_;
			while (TRUE) {
				GVariantIter* _tmp48_ = NULL;
				GVariant* _tmp49_ = NULL;
				GVariant* _tmp50_ = NULL;
				const struct OpaqueJSValue* _tmp51_ = NULL;
				const struct OpaqueJSContext* _tmp52_ = NULL;
				GVariant* _tmp53_ = NULL;
				const struct OpaqueJSValue* _tmp54_ = NULL;
				const struct OpaqueJSValue** _tmp55_ = NULL;
				gint _tmp55__length1 = 0;
				gint _tmp56_ = 0;
				const struct OpaqueJSValue* _tmp57_ = NULL;
				_tmp48_ = _item_it;
				_tmp49_ = g_variant_iter_next_value (_tmp48_);
				_g_variant_unref0 (item);
				item = _tmp49_;
				_tmp50_ = item;
				if (!(_tmp50_ != NULL)) {
					break;
				}
				_tmp52_ = ctx;
				_tmp53_ = item;
				_tmp54_ = nuvola_js_tools_value_from_variant (_tmp52_, _tmp53_, &_inner_error_);
				_tmp51_ = _tmp54_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_variant_unref0 (item);
					_g_variant_iter_free0 (_item_it);
					params = (g_free (params), NULL);
					names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
					return;
				}
				_tmp55_ = params;
				_tmp55__length1 = params_length1;
				_tmp56_ = i;
				i = _tmp56_ + 1;
				_tmp55_[_tmp56_] = _tmp51_;
				_tmp57_ = _tmp55_[_tmp56_];
			}
			_g_variant_unref0 (item);
			_g_variant_iter_free0 (_item_it);
		}
	} else {
		const struct OpaqueJSValue** _tmp58_ = NULL;
		_tmp58_ = g_new0 (const struct OpaqueJSValue*, 0 + 1);
		params = (g_free (params), NULL);
		params = _tmp58_;
		params_length1 = 0;
		_params_size_ = params_length1;
	}
	_tmp59_ = func;
	_tmp60_ = ctx;
	_tmp61_ = object;
	_tmp62_ = params;
	_tmp62__length1 = params_length1;
	JSObjectCallAsFunction (_tmp60_, _tmp59_, _tmp61_, (size_t) _tmp62__length1, _tmp62_, &_tmp63_);
	_0 (exception);
	exception = _tmp63_;
	_tmp64_ = exception;
	if (_tmp64_ != NULL) {
		gchar* _tmp65_ = NULL;
		const struct OpaqueJSContext* _tmp66_ = NULL;
		const struct OpaqueJSValue* _tmp67_ = NULL;
		gchar* _tmp68_ = NULL;
		const gchar* _tmp70_ = NULL;
		gchar* _tmp71_ = NULL;
		gchar* _tmp72_ = NULL;
		GError* _tmp73_ = NULL;
		GError* _tmp74_ = NULL;
		_tmp66_ = ctx;
		_tmp67_ = exception;
		_tmp68_ = nuvola_js_tools_exception_to_string (_tmp66_, _tmp67_);
		_tmp65_ = _tmp68_;
		if (_tmp65_ == NULL) {
			gchar* _tmp69_ = NULL;
			_tmp69_ = g_strdup ("(null)");
			_g_free0 (_tmp65_);
			_tmp65_ = _tmp69_;
		}
		_tmp70_ = name;
		_tmp71_ = _tmp65_;
		_tmp65_ = NULL;
		_tmp72_ = _tmp71_;
		_tmp73_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_FUNC_FAILED, "Function '%s' failed. %s", _tmp70_, _tmp72_);
		_tmp74_ = _tmp73_;
		_g_free0 (_tmp72_);
		_inner_error_ = _tmp74_;
		g_propagate_error (error, _inner_error_);
		_g_free0 (_tmp65_);
		_0 (exception);
		params = (g_free (params), NULL);
		names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	_tmp75_ = *args;
	if (_tmp75_ != NULL) {
		GVariant** items = NULL;
		gint _tmp76_ = 0;
		GVariant** _tmp77_ = NULL;
		gint items_length1 = 0;
		gint _items_size_ = 0;
		GVariant** _tmp92_ = NULL;
		gint _tmp92__length1 = 0;
		GVariant* _tmp93_ = NULL;
		_tmp76_ = size;
		_tmp77_ = g_new0 (GVariant*, _tmp76_ + 1);
		items = _tmp77_;
		items_length1 = _tmp76_;
		_items_size_ = items_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp78_ = FALSE;
				_tmp78_ = TRUE;
				while (TRUE) {
					gint _tmp80_ = 0;
					gint _tmp81_ = 0;
					GVariant* _tmp82_ = NULL;
					const struct OpaqueJSContext* _tmp83_ = NULL;
					const struct OpaqueJSValue** _tmp84_ = NULL;
					gint _tmp84__length1 = 0;
					gint _tmp85_ = 0;
					const struct OpaqueJSValue* _tmp86_ = NULL;
					GVariant* _tmp87_ = NULL;
					GVariant** _tmp88_ = NULL;
					gint _tmp88__length1 = 0;
					gint _tmp89_ = 0;
					GVariant* _tmp90_ = NULL;
					GVariant* _tmp91_ = NULL;
					if (!_tmp78_) {
						gint _tmp79_ = 0;
						_tmp79_ = i;
						i = _tmp79_ + 1;
					}
					_tmp78_ = FALSE;
					_tmp80_ = i;
					_tmp81_ = size;
					if (!(_tmp80_ < _tmp81_)) {
						break;
					}
					_tmp83_ = ctx;
					_tmp84_ = params;
					_tmp84__length1 = params_length1;
					_tmp85_ = i;
					_tmp86_ = _tmp84_[_tmp85_];
					_tmp87_ = nuvola_js_tools_variant_from_value (_tmp83_, (const struct OpaqueJSValue*) _tmp86_, &_inner_error_);
					_tmp82_ = _tmp87_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						g_propagate_error (error, _inner_error_);
						items = (_vala_array_free (items, items_length1, (GDestroyNotify) g_variant_unref), NULL);
						_0 (exception);
						params = (g_free (params), NULL);
						names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
						return;
					}
					_tmp88_ = items;
					_tmp88__length1 = items_length1;
					_tmp89_ = i;
					_tmp90_ = _tmp82_;
					_tmp82_ = NULL;
					_g_variant_unref0 (_tmp88_[_tmp89_]);
					_tmp88_[_tmp89_] = _tmp90_;
					_tmp91_ = _tmp88_[_tmp89_];
					_g_variant_unref0 (_tmp82_);
				}
			}
		}
		_tmp92_ = items;
		_tmp92__length1 = items_length1;
		_tmp93_ = g_variant_new_tuple (_tmp92_, _tmp92__length1);
		g_variant_ref_sink (_tmp93_);
		_g_variant_unref0 (*args);
		*args = _tmp93_;
		items = (_vala_array_free (items, items_length1, (GDestroyNotify) g_variant_unref), NULL);
	}
	_0 (exception);
	params = (g_free (params), NULL);
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
}


struct OpaqueJSContext* nuvola_js_environment_get_context (NuvolaJsEnvironment* self) {
	struct OpaqueJSContext* result;
	struct OpaqueJSContext* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_context;
	result = _tmp0_;
	return result;
}


static void nuvola_js_environment_set_context (NuvolaJsEnvironment* self, struct OpaqueJSContext* value) {
	struct OpaqueJSContext* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_context = _tmp0_;
	g_object_notify ((GObject *) self, "context");
}


struct OpaqueJSValue* nuvola_js_environment_get_main_object (NuvolaJsEnvironment* self) {
	struct OpaqueJSValue* result;
	struct OpaqueJSValue* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_main_object;
	result = _tmp0_;
	return result;
}


void nuvola_js_environment_set_main_object (NuvolaJsEnvironment* self, struct OpaqueJSValue* value) {
	struct OpaqueJSValue* _tmp0_ = NULL;
	struct OpaqueJSValue* _tmp3_ = NULL;
	struct OpaqueJSValue* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_main_object;
	if (_tmp0_ != NULL) {
		struct OpaqueJSValue* _tmp1_ = NULL;
		struct OpaqueJSContext* _tmp2_ = NULL;
		_tmp1_ = self->priv->_main_object;
		_tmp2_ = self->priv->_context;
		JSValueUnprotect ((const struct OpaqueJSContext*) _tmp2_, (const struct OpaqueJSValue*) _tmp1_);
	}
	_tmp3_ = value;
	self->priv->_main_object = _tmp3_;
	_tmp4_ = self->priv->_main_object;
	if (_tmp4_ != NULL) {
		struct OpaqueJSValue* _tmp5_ = NULL;
		struct OpaqueJSContext* _tmp6_ = NULL;
		_tmp5_ = self->priv->_main_object;
		_tmp6_ = self->priv->_context;
		JSValueProtect ((const struct OpaqueJSContext*) _tmp6_, (const struct OpaqueJSValue*) _tmp5_);
	}
	g_object_notify ((GObject *) self, "main-object");
}


static void nuvola_js_environment_class_init (NuvolaJsEnvironmentClass * klass) {
	nuvola_js_environment_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaJsEnvironmentPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_js_environment_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_js_environment_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_js_environment_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_JS_ENVIRONMENT_CONTEXT, g_param_spec_pointer ("context", "context", "context", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT, g_param_spec_pointer ("main-object", "main-object", "main-object", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void nuvola_js_environment_nuvola_js_executor_interface_init (NuvolaJSExecutorIface * iface) {
	nuvola_js_environment_nuvola_js_executor_parent_iface = g_type_interface_peek_parent (iface);
	iface->call_function = (void (*)(NuvolaJSExecutor*, const gchar*, GVariant**, GError**)) nuvola_js_environment_real_call_function;
}


static void nuvola_js_environment_instance_init (NuvolaJsEnvironment * self) {
	self->priv = NUVOLA_JS_ENVIRONMENT_GET_PRIVATE (self);
	self->priv->_main_object = NULL;
}


static void nuvola_js_environment_finalize (GObject* obj) {
	NuvolaJsEnvironment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironment);
	nuvola_js_environment_set_main_object (self, NULL);
	g_debug ("jsenvironment.vala:67: ~JsEnvironment %p", self);
	G_OBJECT_CLASS (nuvola_js_environment_parent_class)->finalize (obj);
}


GType nuvola_js_environment_get_type (void) {
	static volatile gsize nuvola_js_environment_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_js_environment_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaJsEnvironmentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_js_environment_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaJsEnvironment), 0, (GInstanceInitFunc) nuvola_js_environment_instance_init, NULL };
		static const GInterfaceInfo nuvola_js_executor_info = { (GInterfaceInitFunc) nuvola_js_environment_nuvola_js_executor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType nuvola_js_environment_type_id;
		nuvola_js_environment_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaJsEnvironment", &g_define_type_info, 0);
		g_type_add_interface_static (nuvola_js_environment_type_id, NUVOLA_TYPE_JS_EXECUTOR, &nuvola_js_executor_info);
		g_once_init_leave (&nuvola_js_environment_type_id__volatile, nuvola_js_environment_type_id);
	}
	return nuvola_js_environment_type_id__volatile;
}


static void _vala_nuvola_js_environment_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaJsEnvironment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironment);
	switch (property_id) {
		case NUVOLA_JS_ENVIRONMENT_CONTEXT:
		g_value_set_pointer (value, nuvola_js_environment_get_context (self));
		break;
		case NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT:
		g_value_set_pointer (value, nuvola_js_environment_get_main_object (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_js_environment_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaJsEnvironment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_JS_ENVIRONMENT, NuvolaJsEnvironment);
	switch (property_id) {
		case NUVOLA_JS_ENVIRONMENT_CONTEXT:
		nuvola_js_environment_set_context (self, g_value_get_pointer (value));
		break;
		case NUVOLA_JS_ENVIRONMENT_MAIN_OBJECT:
		nuvola_js_environment_set_main_object (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



