/* jstools.c generated by valac 0.34.9, the Vala compiler
 * generated from jstools.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <JavaScriptCore/JavaScript.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _JSPropertyNameArrayRelease0(var) ((var == NULL) ? NULL : (var = (JSPropertyNameArrayRelease (var), NULL)))

typedef enum  {
	NUVOLA_JS_ERROR_NOT_FOUND,
	NUVOLA_JS_ERROR_WRONG_TYPE,
	NUVOLA_JS_ERROR_FUNC_FAILED,
	NUVOLA_JS_ERROR_READ_ERROR,
	NUVOLA_JS_ERROR_NO_CONTEXT,
	NUVOLA_JS_ERROR_EXCEPTION,
	NUVOLA_JS_ERROR_INITIALIZATION_FAILED
} NuvolaJSError;
#define NUVOLA_JS_ERROR nuvola_js_error_quark ()


gchar* nuvola_js_tools_utf8_string (struct OpaqueJSString* jsstring);
const struct OpaqueJSValue* nuvola_js_tools_object_from_JSON (const struct OpaqueJSContext* ctx, const gchar* json);
const struct OpaqueJSValue* nuvola_js_tools_create_exception (const struct OpaqueJSContext* ctx, const gchar* message);
gchar* nuvola_js_tools_o_get_string (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property);
gdouble nuvola_js_tools_o_get_number (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property);
void nuvola_js_tools_o_set_string (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, const gchar* value);
void nuvola_js_tools_o_set_number (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, gdouble value);
void nuvola_js_tools_o_set_null (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property);
void nuvola_js_tools_o_set_bool (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, gboolean value);
struct OpaqueJSValue* nuvola_js_tools_o_get_object (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property);
gchar* nuvola_js_tools_string_or_null (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, gboolean allow_empty);
gchar* nuvola_js_tools_value_to_string (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* value);
gchar* nuvola_js_tools_exception_to_string (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* value);
const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property_named (const struct OpaqueJSContext* ctx, GObject* o, const gchar* name);
const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property (const struct OpaqueJSContext* ctx, GObject* o, GParamSpec* p);
GQuark nuvola_js_error_quark (void);
const struct OpaqueJSValue* nuvola_js_tools_value_from_variant (const struct OpaqueJSContext* ctx, GVariant* variant, GError** error);
GVariant* nuvola_js_tools_variant_from_value (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, GError** error);


/**
 * Converts JavaScriptCore string to Vala UTF-8 string
 *
 * @param jsstring JavaScriptCore string
 * @return Vala UTF-8 string
 */
gchar* nuvola_js_tools_utf8_string (struct OpaqueJSString* jsstring) {
	gchar* result = NULL;
	gsize max_size = 0UL;
	struct OpaqueJSString* _tmp0_ = NULL;
	gsize _tmp1_ = 0UL;
	guint8* buffer = NULL;
	guint8* _tmp2_ = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	struct OpaqueJSString* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	g_return_val_if_fail (jsstring != NULL, NULL);
	_tmp0_ = jsstring;
	_tmp1_ = JSStringGetMaximumUTF8CStringSize (_tmp0_);
	max_size = _tmp1_;
	_tmp2_ = g_new0 (guint8, max_size);
	buffer = _tmp2_;
	buffer_length1 = max_size;
	_buffer_size_ = buffer_length1;
	_tmp3_ = jsstring;
	JSStringGetUTF8CString (_tmp3_, buffer, buffer_length1);
	_tmp4_ = g_strdup ((const gchar*) buffer);
	result = _tmp4_;
	buffer = (g_free (buffer), NULL);
	return result;
}


/**
 * Creates JavaScript object from JSON.
 * 
 * @param ctx	JavaScript context
 * @param json	object in JSON notation
 * @return	JavaScript object
 */
const struct OpaqueJSValue* nuvola_js_tools_object_from_JSON (const struct OpaqueJSContext* ctx, const gchar* json) {
	const struct OpaqueJSValue* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const struct OpaqueJSValue* _result_ = NULL;
	const struct OpaqueJSContext* _tmp3_ = NULL;
	struct OpaqueJSString* _tmp4_ = NULL;
	struct OpaqueJSString* _tmp5_ = NULL;
	const struct OpaqueJSValue* _tmp6_ = NULL;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	const struct OpaqueJSValue* _tmp9_ = NULL;
	const struct OpaqueJSValue* _tmp15_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (json != NULL, NULL);
	_tmp1_ = json;
	if (g_strcmp0 (_tmp1_, "") == 0) {
		_tmp0_ = "{}";
	} else {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = json;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = ctx;
	_tmp4_ = JSStringCreateWithUTF8CString (_tmp0_);
	_tmp5_ = _tmp4_;
	_tmp6_ = JSValueMakeFromJSONString (_tmp3_, _tmp5_);
	_tmp7_ = _tmp6_;
	_JSStringRelease0 (_tmp5_);
	_result_ = _tmp7_;
	_tmp9_ = _result_;
	if (_tmp9_ == NULL) {
		_tmp8_ = TRUE;
	} else {
		const struct OpaqueJSValue* _tmp10_ = NULL;
		const struct OpaqueJSContext* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		_tmp10_ = _result_;
		_tmp11_ = ctx;
		_tmp12_ = JSValueIsObject (_tmp11_, _tmp10_);
		_tmp8_ = !_tmp12_;
	}
	if (_tmp8_) {
		const struct OpaqueJSContext* _tmp13_ = NULL;
		struct OpaqueJSValue* _tmp14_ = NULL;
		_tmp13_ = ctx;
		_tmp14_ = JSObjectMake (_tmp13_, NULL, NULL);
		_result_ = (const struct OpaqueJSValue*) _tmp14_;
	}
	_tmp15_ = _result_;
	result = _tmp15_;
	return result;
}


/**
 * Creates JavaScript Exception object.
 * 
 * @param ctx	JavaScript context
 * @param message	Error message (single line);
 * @return	JavaScript object
 */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch19_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch19_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally19;
	__catch19_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally19:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


const struct OpaqueJSValue* nuvola_js_tools_create_exception (const struct OpaqueJSContext* ctx, const gchar* message) {
	const struct OpaqueJSValue* result = NULL;
	gchar* exception = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const struct OpaqueJSContext* _tmp5_ = NULL;
	const struct OpaqueJSValue* _tmp6_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (message != NULL, NULL);
	_tmp0_ = message;
	_tmp1_ = string_replace (_tmp0_, "\"", "\\\"");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf ("{\"type\":\"NuvolaError\", \"message\":\"%s\"}", _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	exception = _tmp4_;
	g_debug ("jstools.vala:66: %s", exception);
	_tmp5_ = ctx;
	_tmp6_ = nuvola_js_tools_object_from_JSON (_tmp5_, exception);
	result = _tmp6_;
	_g_free0 (exception);
	return result;
}


/**
 * Obtains string property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return string value or null if property is not a string
 */
gchar* nuvola_js_tools_o_get_string (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property) {
	gchar* result = NULL;
	const struct OpaqueJSValue* value = NULL;
	struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_ = NULL;
	struct OpaqueJSString* _tmp4_ = NULL;
	const struct OpaqueJSValue* _tmp5_ = NULL;
	const struct OpaqueJSValue* _tmp6_ = NULL;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	const struct OpaqueJSContext* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (obj != NULL, NULL);
	g_return_val_if_fail (property != NULL, NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = JSObjectGetProperty (_tmp1_, _tmp0_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_JSStringRelease0 (_tmp4_);
	value = _tmp6_;
	_tmp7_ = value;
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsString (_tmp8_, _tmp7_);
	if (_tmp9_) {
		const struct OpaqueJSValue* _tmp10_ = NULL;
		const struct OpaqueJSContext* _tmp11_ = NULL;
		struct OpaqueJSString* _tmp12_ = NULL;
		struct OpaqueJSString* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		_tmp10_ = value;
		_tmp11_ = ctx;
		_tmp12_ = JSValueToStringCopy (_tmp11_, _tmp10_, NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = nuvola_js_tools_utf8_string (_tmp13_);
		_tmp15_ = _tmp14_;
		_JSStringRelease0 (_tmp13_);
		result = _tmp15_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Obtains number property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return double value or 0.0 if property is not a number
 */
gdouble nuvola_js_tools_o_get_number (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property) {
	gdouble result = 0.0;
	const struct OpaqueJSValue* value = NULL;
	struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_ = NULL;
	struct OpaqueJSString* _tmp4_ = NULL;
	const struct OpaqueJSValue* _tmp5_ = NULL;
	const struct OpaqueJSValue* _tmp6_ = NULL;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	const struct OpaqueJSContext* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	g_return_val_if_fail (ctx != NULL, 0.0);
	g_return_val_if_fail (obj != NULL, 0.0);
	g_return_val_if_fail (property != NULL, 0.0);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = JSObjectGetProperty (_tmp1_, _tmp0_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_JSStringRelease0 (_tmp4_);
	value = _tmp6_;
	_tmp7_ = value;
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsNumber (_tmp8_, _tmp7_);
	if (_tmp9_) {
		const struct OpaqueJSValue* _tmp10_ = NULL;
		const struct OpaqueJSContext* _tmp11_ = NULL;
		gdouble _tmp12_ = 0.0;
		_tmp10_ = value;
		_tmp11_ = ctx;
		_tmp12_ = JSValueToNumber (_tmp11_, _tmp10_, NULL);
		result = _tmp12_;
		return result;
	}
	result = 0.0;
	return result;
}


/**
 * Sets string property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void nuvola_js_tools_o_set_string (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, const gchar* value) {
	struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_ = NULL;
	struct OpaqueJSString* _tmp4_ = NULL;
	const struct OpaqueJSContext* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	struct OpaqueJSString* _tmp7_ = NULL;
	struct OpaqueJSString* _tmp8_ = NULL;
	const struct OpaqueJSValue* _tmp9_ = NULL;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = ctx;
	_tmp6_ = value;
	_tmp7_ = JSStringCreateWithUTF8CString (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = JSValueMakeString (_tmp5_, _tmp8_);
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp9_, 0, NULL);
	_JSStringRelease0 (_tmp8_);
	_JSStringRelease0 (_tmp4_);
}


/**
 * Sets string property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void nuvola_js_tools_o_set_number (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, gdouble value) {
	struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_ = NULL;
	struct OpaqueJSString* _tmp4_ = NULL;
	const struct OpaqueJSContext* _tmp5_ = NULL;
	gdouble _tmp6_ = 0.0;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = ctx;
	_tmp6_ = value;
	_tmp7_ = JSValueMakeNumber (_tmp5_, _tmp6_);
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp7_, 0, NULL);
	_JSStringRelease0 (_tmp4_);
}


/**
 * Sets null property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 */
void nuvola_js_tools_o_set_null (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property) {
	struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_ = NULL;
	struct OpaqueJSString* _tmp4_ = NULL;
	const struct OpaqueJSContext* _tmp5_ = NULL;
	const struct OpaqueJSValue* _tmp6_ = NULL;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = ctx;
	_tmp6_ = JSValueMakeNull (_tmp5_);
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp6_, 0, NULL);
	_JSStringRelease0 (_tmp4_);
}


/**
 * Sets boolean property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void nuvola_js_tools_o_set_bool (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property, gboolean value) {
	struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_ = NULL;
	struct OpaqueJSString* _tmp4_ = NULL;
	const struct OpaqueJSContext* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (obj != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = ctx;
	_tmp6_ = value;
	_tmp7_ = JSValueMakeBoolean (_tmp5_, _tmp6_);
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp7_, 0, NULL);
	_JSStringRelease0 (_tmp4_);
}


/**
 * Obtains object property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return object or null if property is not a object
 */
struct OpaqueJSValue* nuvola_js_tools_o_get_object (const struct OpaqueJSContext* ctx, struct OpaqueJSValue* obj, const gchar* property) {
	struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* value = NULL;
	struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_ = NULL;
	struct OpaqueJSString* _tmp4_ = NULL;
	const struct OpaqueJSValue* _tmp5_ = NULL;
	const struct OpaqueJSValue* _tmp6_ = NULL;
	const struct OpaqueJSValue* _tmp7_ = NULL;
	const struct OpaqueJSContext* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (obj != NULL, NULL);
	g_return_val_if_fail (property != NULL, NULL);
	_tmp0_ = obj;
	_tmp1_ = ctx;
	_tmp2_ = property;
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = JSObjectGetProperty (_tmp1_, _tmp0_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_JSStringRelease0 (_tmp4_);
	value = _tmp6_;
	_tmp7_ = value;
	_tmp8_ = ctx;
	_tmp9_ = JSValueIsObject (_tmp8_, _tmp7_);
	if (_tmp9_) {
		const struct OpaqueJSValue* _tmp10_ = NULL;
		const struct OpaqueJSContext* _tmp11_ = NULL;
		struct OpaqueJSValue* _tmp12_ = NULL;
		_tmp10_ = value;
		_tmp11_ = ctx;
		_tmp12_ = JSValueToObject (_tmp11_, _tmp10_, NULL);
		result = _tmp12_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Converts JavaScript value to string
 * 
 * @param ctx            JavaScript context
 * @param val            JavaScript value
 * @param allow_empty    if false null will be returned for empty string
 * @return string value or null if value is not a string
 */
gchar* nuvola_js_tools_string_or_null (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, gboolean allow_empty) {
	gchar* result = NULL;
	const struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (val != NULL, NULL);
	_tmp0_ = val;
	_tmp1_ = ctx;
	_tmp2_ = JSValueIsString (_tmp1_, _tmp0_);
	if (_tmp2_) {
		gchar* str = NULL;
		const struct OpaqueJSValue* _tmp3_ = NULL;
		const struct OpaqueJSContext* _tmp4_ = NULL;
		struct OpaqueJSString* _tmp5_ = NULL;
		struct OpaqueJSString* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp14_ = NULL;
		_tmp3_ = val;
		_tmp4_ = ctx;
		_tmp5_ = JSValueToStringCopy (_tmp4_, _tmp3_, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = nuvola_js_tools_utf8_string (_tmp6_);
		_tmp8_ = _tmp7_;
		_JSStringRelease0 (_tmp6_);
		str = _tmp8_;
		_tmp11_ = str;
		if (g_strcmp0 (_tmp11_, "") == 0) {
			gboolean _tmp12_ = FALSE;
			_tmp12_ = allow_empty;
			_tmp10_ = !_tmp12_;
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			_tmp9_ = NULL;
		} else {
			const gchar* _tmp13_ = NULL;
			_tmp13_ = str;
			_tmp9_ = _tmp13_;
		}
		_tmp14_ = g_strdup (_tmp9_);
		result = _tmp14_;
		_g_free0 (str);
		return result;
	}
	result = NULL;
	return result;
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


gchar* nuvola_js_tools_value_to_string (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* value) {
	gchar* result = NULL;
	const struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const struct OpaqueJSValue* _tmp9_ = NULL;
	const struct OpaqueJSContext* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	const struct OpaqueJSValue* _tmp16_ = NULL;
	const struct OpaqueJSContext* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = value;
	_tmp1_ = ctx;
	_tmp2_ = JSValueIsString (_tmp1_, _tmp0_);
	if (_tmp2_) {
		const struct OpaqueJSValue* _tmp3_ = NULL;
		const struct OpaqueJSContext* _tmp4_ = NULL;
		struct OpaqueJSString* _tmp5_ = NULL;
		struct OpaqueJSString* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		_tmp3_ = value;
		_tmp4_ = ctx;
		_tmp5_ = JSValueToStringCopy (_tmp4_, _tmp3_, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = nuvola_js_tools_utf8_string (_tmp6_);
		_tmp8_ = _tmp7_;
		_JSStringRelease0 (_tmp6_);
		result = _tmp8_;
		return result;
	}
	_tmp9_ = value;
	_tmp10_ = ctx;
	_tmp11_ = JSValueIsNumber (_tmp10_, _tmp9_);
	if (_tmp11_) {
		const struct OpaqueJSValue* _tmp12_ = NULL;
		const struct OpaqueJSContext* _tmp13_ = NULL;
		gdouble _tmp14_ = 0.0;
		gchar* _tmp15_ = NULL;
		_tmp12_ = value;
		_tmp13_ = ctx;
		_tmp14_ = JSValueToNumber (_tmp13_, _tmp12_, NULL);
		_tmp15_ = double_to_string (_tmp14_);
		result = _tmp15_;
		return result;
	}
	_tmp16_ = value;
	_tmp17_ = ctx;
	_tmp18_ = JSValueIsObject (_tmp17_, _tmp16_);
	if (_tmp18_) {
		const struct OpaqueJSValue* _tmp19_ = NULL;
		const struct OpaqueJSContext* _tmp20_ = NULL;
		struct OpaqueJSValue* _tmp21_ = NULL;
		const struct OpaqueJSContext* _tmp22_ = NULL;
		struct OpaqueJSString* _tmp23_ = NULL;
		struct OpaqueJSString* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
		_tmp19_ = value;
		_tmp20_ = ctx;
		_tmp21_ = JSValueToObject (_tmp20_, _tmp19_, NULL);
		_tmp22_ = ctx;
		_tmp23_ = JSValueCreateJSONString (_tmp22_, (const struct OpaqueJSValue*) _tmp21_, (guint) 0, NULL);
		_tmp24_ = _tmp23_;
		_tmp25_ = nuvola_js_tools_utf8_string (_tmp24_);
		_tmp26_ = _tmp25_;
		_JSStringRelease0 (_tmp24_);
		result = _tmp26_;
		return result;
	}
	result = NULL;
	return result;
}


gchar* nuvola_js_tools_exception_to_string (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* value) {
	gchar* result = NULL;
	const struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const struct OpaqueJSContext* _tmp33_ = NULL;
	const struct OpaqueJSValue* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = value;
	_tmp1_ = ctx;
	_tmp2_ = JSValueIsObject (_tmp1_, _tmp0_);
	if (_tmp2_) {
		struct OpaqueJSValue* obj = NULL;
		const struct OpaqueJSValue* _tmp3_ = NULL;
		const struct OpaqueJSContext* _tmp4_ = NULL;
		struct OpaqueJSValue* _tmp5_ = NULL;
		gchar* message = NULL;
		const struct OpaqueJSContext* _tmp6_ = NULL;
		struct OpaqueJSValue* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		_tmp3_ = value;
		_tmp4_ = ctx;
		_tmp5_ = JSValueToObject (_tmp4_, _tmp3_, NULL);
		obj = _tmp5_;
		_tmp6_ = ctx;
		_tmp7_ = obj;
		_tmp8_ = nuvola_js_tools_o_get_string (_tmp6_, _tmp7_, "message");
		message = _tmp8_;
		_tmp9_ = message;
		if (_tmp9_ != NULL) {
			gchar* name = NULL;
			const struct OpaqueJSContext* _tmp10_ = NULL;
			struct OpaqueJSValue* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			gint line = 0;
			const struct OpaqueJSContext* _tmp13_ = NULL;
			struct OpaqueJSValue* _tmp14_ = NULL;
			gdouble _tmp15_ = 0.0;
			gchar* file = NULL;
			const struct OpaqueJSContext* _tmp16_ = NULL;
			struct OpaqueJSValue* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_ = 0;
			const gchar* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
			const gchar* _tmp28_ = NULL;
			const gchar* _tmp29_ = NULL;
			gint _tmp30_ = 0;
			const gchar* _tmp31_ = NULL;
			gchar* _tmp32_ = NULL;
			_tmp10_ = ctx;
			_tmp11_ = obj;
			_tmp12_ = nuvola_js_tools_o_get_string (_tmp10_, _tmp11_, "name");
			name = _tmp12_;
			_tmp13_ = ctx;
			_tmp14_ = obj;
			_tmp15_ = nuvola_js_tools_o_get_number (_tmp13_, _tmp14_, "line");
			line = (gint) _tmp15_;
			_tmp16_ = ctx;
			_tmp17_ = obj;
			_tmp18_ = nuvola_js_tools_o_get_string (_tmp16_, _tmp17_, "sourceURL");
			file = _tmp18_;
			_tmp20_ = line;
			if (_tmp20_ == 0) {
				const gchar* _tmp21_ = NULL;
				_tmp21_ = file;
				_tmp19_ = _tmp21_ == NULL;
			} else {
				_tmp19_ = FALSE;
			}
			if (_tmp19_) {
				const gchar* _tmp22_ = NULL;
				const gchar* _tmp23_ = NULL;
				const gchar* _tmp24_ = NULL;
				gchar* _tmp25_ = NULL;
				_tmp23_ = name;
				_tmp22_ = _tmp23_;
				if (_tmp22_ == NULL) {
					_tmp22_ = "null";
				}
				_tmp24_ = message;
				_tmp25_ = g_strdup_printf ("%s: %s. Enable JS debugging for more details.", _tmp22_, _tmp24_);
				result = _tmp25_;
				_g_free0 (file);
				_g_free0 (name);
				_g_free0 (message);
				return result;
			}
			_tmp27_ = file;
			_tmp26_ = _tmp27_;
			if (_tmp26_ == NULL) {
				_tmp26_ = "(null)";
			}
			_tmp29_ = name;
			_tmp28_ = _tmp29_;
			if (_tmp28_ == NULL) {
				_tmp28_ = "null";
			}
			_tmp30_ = line;
			_tmp31_ = message;
			_tmp32_ = g_strdup_printf ("%s:%d: %s: %s", _tmp26_, _tmp30_, _tmp28_, _tmp31_);
			result = _tmp32_;
			_g_free0 (file);
			_g_free0 (name);
			_g_free0 (message);
			return result;
		}
		_g_free0 (message);
	}
	_tmp33_ = ctx;
	_tmp34_ = value;
	_tmp35_ = nuvola_js_tools_value_to_string (_tmp33_, _tmp34_);
	result = _tmp35_;
	return result;
}


const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property_named (const struct OpaqueJSContext* ctx, GObject* o, const gchar* name) {
	const struct OpaqueJSValue* result = NULL;
	GObjectClass* klass = NULL;
	GObject* _tmp0_ = NULL;
	GType _tmp1_ = 0UL;
	GTypeClass* _tmp2_ = NULL;
	GParamSpec* p = NULL;
	GObjectClass* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GParamSpec* _tmp5_ = NULL;
	GParamSpec* _tmp6_ = NULL;
	const struct OpaqueJSContext* _tmp9_ = NULL;
	GObject* _tmp10_ = NULL;
	GParamSpec* _tmp11_ = NULL;
	const struct OpaqueJSValue* _tmp12_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (o != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = o;
	_tmp1_ = G_TYPE_FROM_INSTANCE (_tmp0_);
	_tmp2_ = g_type_class_ref (_tmp1_);
	klass = (GObjectClass*) _tmp2_;
	_tmp3_ = klass;
	_tmp4_ = name;
	_tmp5_ = g_object_class_find_property (_tmp3_, _tmp4_);
	p = _tmp5_;
	_tmp6_ = p;
	if (_tmp6_ == NULL) {
		const struct OpaqueJSContext* _tmp7_ = NULL;
		const struct OpaqueJSValue* _tmp8_ = NULL;
		_tmp7_ = ctx;
		_tmp8_ = JSValueMakeUndefined (_tmp7_);
		result = _tmp8_;
		_g_type_class_unref0 (klass);
		return result;
	}
	_tmp9_ = ctx;
	_tmp10_ = o;
	_tmp11_ = p;
	_tmp12_ = nuvola_js_tools_get_gobject_property (_tmp9_, _tmp10_, _tmp11_);
	result = _tmp12_;
	_g_type_class_unref0 (klass);
	return result;
}


const struct OpaqueJSValue* nuvola_js_tools_get_gobject_property (const struct OpaqueJSContext* ctx, GObject* o, GParamSpec* p) {
	const struct OpaqueJSValue* result = NULL;
	GType type = 0UL;
	GParamSpec* _tmp0_ = NULL;
	GType _tmp1_ = 0UL;
	GType _tmp2_ = 0UL;
	GType _tmp12_ = 0UL;
	GType _tmp19_ = 0UL;
	GType _tmp26_ = 0UL;
	GType _tmp33_ = 0UL;
	const struct OpaqueJSContext* _tmp40_ = NULL;
	const struct OpaqueJSValue* _tmp41_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (o != NULL, NULL);
	g_return_val_if_fail (p != NULL, NULL);
	_tmp0_ = p;
	_tmp1_ = _tmp0_->value_type;
	type = _tmp1_;
	_tmp2_ = type;
	if (_tmp2_ == G_TYPE_STRING) {
		gchar* str_val = NULL;
		GObject* _tmp3_ = NULL;
		GParamSpec* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const struct OpaqueJSContext* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		struct OpaqueJSString* _tmp8_ = NULL;
		struct OpaqueJSString* _tmp9_ = NULL;
		const struct OpaqueJSValue* _tmp10_ = NULL;
		const struct OpaqueJSValue* _tmp11_ = NULL;
		_tmp3_ = o;
		_tmp4_ = p;
		_tmp5_ = _tmp4_->name;
		g_object_get (_tmp3_, _tmp5_, &str_val, NULL);
		_tmp6_ = ctx;
		_tmp7_ = str_val;
		_tmp8_ = JSStringCreateWithUTF8CString (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = JSValueMakeString (_tmp6_, _tmp9_);
		_tmp11_ = _tmp10_;
		_JSStringRelease0 (_tmp9_);
		result = _tmp11_;
		_g_free0 (str_val);
		return result;
	}
	_tmp12_ = type;
	if (_tmp12_ == G_TYPE_INT) {
		gint int_val = 0;
		GObject* _tmp13_ = NULL;
		GParamSpec* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		const struct OpaqueJSContext* _tmp16_ = NULL;
		gint _tmp17_ = 0;
		const struct OpaqueJSValue* _tmp18_ = NULL;
		_tmp13_ = o;
		_tmp14_ = p;
		_tmp15_ = _tmp14_->name;
		g_object_get (_tmp13_, _tmp15_, &int_val, NULL);
		_tmp16_ = ctx;
		_tmp17_ = int_val;
		_tmp18_ = JSValueMakeNumber (_tmp16_, (gdouble) _tmp17_);
		result = _tmp18_;
		return result;
	}
	_tmp19_ = type;
	if (_tmp19_ == G_TYPE_FLOAT) {
		gfloat float_val = 0.0F;
		GObject* _tmp20_ = NULL;
		GParamSpec* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
		const struct OpaqueJSContext* _tmp23_ = NULL;
		gfloat _tmp24_ = 0.0F;
		const struct OpaqueJSValue* _tmp25_ = NULL;
		_tmp20_ = o;
		_tmp21_ = p;
		_tmp22_ = _tmp21_->name;
		g_object_get (_tmp20_, _tmp22_, &float_val, NULL);
		_tmp23_ = ctx;
		_tmp24_ = float_val;
		_tmp25_ = JSValueMakeNumber (_tmp23_, (gdouble) _tmp24_);
		result = _tmp25_;
		return result;
	}
	_tmp26_ = type;
	if (_tmp26_ == G_TYPE_DOUBLE) {
		gdouble double_val = 0.0;
		GObject* _tmp27_ = NULL;
		GParamSpec* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		const struct OpaqueJSContext* _tmp30_ = NULL;
		gdouble _tmp31_ = 0.0;
		const struct OpaqueJSValue* _tmp32_ = NULL;
		_tmp27_ = o;
		_tmp28_ = p;
		_tmp29_ = _tmp28_->name;
		g_object_get (_tmp27_, _tmp29_, &double_val, NULL);
		_tmp30_ = ctx;
		_tmp31_ = double_val;
		_tmp32_ = JSValueMakeNumber (_tmp30_, (gdouble) _tmp31_);
		result = _tmp32_;
		return result;
	}
	_tmp33_ = type;
	if (_tmp33_ == G_TYPE_BOOLEAN) {
		gboolean bool_val = FALSE;
		GObject* _tmp34_ = NULL;
		GParamSpec* _tmp35_ = NULL;
		const gchar* _tmp36_ = NULL;
		const struct OpaqueJSContext* _tmp37_ = NULL;
		gboolean _tmp38_ = FALSE;
		const struct OpaqueJSValue* _tmp39_ = NULL;
		_tmp34_ = o;
		_tmp35_ = p;
		_tmp36_ = _tmp35_->name;
		g_object_get (_tmp34_, _tmp36_, &bool_val, NULL);
		_tmp37_ = ctx;
		_tmp38_ = bool_val;
		_tmp39_ = JSValueMakeBoolean (_tmp37_, _tmp38_);
		result = _tmp39_;
		return result;
	}
	_tmp40_ = ctx;
	_tmp41_ = JSValueMakeUndefined (_tmp40_);
	result = _tmp41_;
	return result;
}


static gpointer _g_variant_type_copy0 (gpointer self) {
	return self ? g_variant_type_copy (self) : NULL;
}


const struct OpaqueJSValue* nuvola_js_tools_value_from_variant (const struct OpaqueJSContext* ctx, GVariant* variant, GError** error) {
	const struct OpaqueJSValue* result = NULL;
	GVariant* _tmp0_ = NULL;
	GVariantType* type = NULL;
	GVariant* _tmp3_ = NULL;
	const GVariantType* _tmp4_ = NULL;
	GVariantType* _tmp5_ = NULL;
	GVariant* _tmp6_ = NULL;
	const GVariantType* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	const GVariantType* _tmp16_ = NULL;
	const GVariantType* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	GVariantType* object_type = NULL;
	GVariantType* _tmp27_ = NULL;
	const GVariantType* _tmp28_ = NULL;
	const GVariantType* _tmp29_ = NULL;
	gboolean _tmp30_ = FALSE;
	GVariant* _tmp46_ = NULL;
	const GVariantType* _tmp47_ = NULL;
	gboolean _tmp48_ = FALSE;
	GVariant* _tmp56_ = NULL;
	const GVariantType* _tmp57_ = NULL;
	gboolean _tmp58_ = FALSE;
	GVariant* _tmp63_ = NULL;
	const GVariantType* _tmp64_ = NULL;
	gboolean _tmp65_ = FALSE;
	GVariant* _tmp70_ = NULL;
	const GVariantType* _tmp71_ = NULL;
	gboolean _tmp72_ = FALSE;
	GVariant* _tmp77_ = NULL;
	const GVariantType* _tmp78_ = NULL;
	gboolean _tmp79_ = FALSE;
	GVariant* _tmp84_ = NULL;
	const GVariantType* _tmp85_ = NULL;
	gboolean _tmp86_ = FALSE;
	GVariant* _tmp91_ = NULL;
	const GVariantType* _tmp92_ = NULL;
	gboolean _tmp93_ = FALSE;
	GVariant* _tmp98_ = NULL;
	gboolean _tmp99_ = FALSE;
	GVariant* _tmp122_ = NULL;
	const gchar* _tmp123_ = NULL;
	GVariant* _tmp124_ = NULL;
	gchar* _tmp125_ = NULL;
	gchar* _tmp126_ = NULL;
	GError* _tmp127_ = NULL;
	GError* _tmp128_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	_tmp0_ = variant;
	if (_tmp0_ == NULL) {
		const struct OpaqueJSContext* _tmp1_ = NULL;
		const struct OpaqueJSValue* _tmp2_ = NULL;
		_tmp1_ = ctx;
		_tmp2_ = JSValueMakeNull (_tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = variant;
	_tmp4_ = g_variant_get_type (_tmp3_);
	_tmp5_ = _g_variant_type_copy0 (_tmp4_);
	type = _tmp5_;
	_tmp6_ = variant;
	_tmp7_ = G_VARIANT_TYPE_VARIANT;
	_tmp8_ = g_variant_is_of_type (_tmp6_, _tmp7_);
	if (_tmp8_) {
		const struct OpaqueJSValue* _tmp9_ = NULL;
		const struct OpaqueJSContext* _tmp10_ = NULL;
		GVariant* _tmp11_ = NULL;
		GVariant* _tmp12_ = NULL;
		GVariant* _tmp13_ = NULL;
		const struct OpaqueJSValue* _tmp14_ = NULL;
		const struct OpaqueJSValue* _tmp15_ = NULL;
		_tmp10_ = ctx;
		_tmp11_ = variant;
		_tmp12_ = g_variant_get_variant (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = nuvola_js_tools_value_from_variant (_tmp10_, _tmp13_, &_inner_error_);
		_tmp15_ = _tmp14_;
		_g_variant_unref0 (_tmp13_);
		_tmp9_ = _tmp15_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_variant_type_free0 (type);
				return NULL;
			} else {
				_g_variant_type_free0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		result = _tmp9_;
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp16_ = type;
	_tmp17_ = G_VARIANT_TYPE_MAYBE;
	_tmp18_ = g_variant_type_is_subtype_of (_tmp16_, _tmp17_);
	if (_tmp18_) {
		GVariant* maybe_variant = NULL;
		GVariant* _tmp19_ = NULL;
		GVariant* _tmp20_ = NULL;
		const struct OpaqueJSValue* _tmp23_ = NULL;
		const struct OpaqueJSContext* _tmp24_ = NULL;
		GVariant* _tmp25_ = NULL;
		const struct OpaqueJSValue* _tmp26_ = NULL;
		maybe_variant = NULL;
		_tmp19_ = variant;
		g_variant_get (_tmp19_, "m*", &maybe_variant, NULL);
		_tmp20_ = maybe_variant;
		if (_tmp20_ == NULL) {
			const struct OpaqueJSContext* _tmp21_ = NULL;
			const struct OpaqueJSValue* _tmp22_ = NULL;
			_tmp21_ = ctx;
			_tmp22_ = JSValueMakeNull (_tmp21_);
			result = _tmp22_;
			_g_variant_unref0 (maybe_variant);
			_g_variant_type_free0 (type);
			return result;
		}
		_tmp24_ = ctx;
		_tmp25_ = maybe_variant;
		_tmp26_ = nuvola_js_tools_value_from_variant (_tmp24_, _tmp25_, &_inner_error_);
		_tmp23_ = _tmp26_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == NUVOLA_JS_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_variant_unref0 (maybe_variant);
				_g_variant_type_free0 (type);
				return NULL;
			} else {
				_g_variant_unref0 (maybe_variant);
				_g_variant_type_free0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		result = _tmp23_;
		_g_variant_unref0 (maybe_variant);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp27_ = g_variant_type_new ("a{s*}");
	object_type = _tmp27_;
	_tmp28_ = type;
	_tmp29_ = object_type;
	_tmp30_ = g_variant_type_is_subtype_of (_tmp28_, _tmp29_);
	if (_tmp30_) {
		struct OpaqueJSValue* object = NULL;
		const struct OpaqueJSContext* _tmp31_ = NULL;
		struct OpaqueJSValue* _tmp32_ = NULL;
		GVariantIter* iter = NULL;
		GVariant* _tmp33_ = NULL;
		gchar* key = NULL;
		GVariant* value = NULL;
		struct OpaqueJSValue* _tmp45_ = NULL;
		_tmp31_ = ctx;
		_tmp32_ = JSObjectMake (_tmp31_, NULL, NULL);
		object = _tmp32_;
		iter = NULL;
		_tmp33_ = variant;
		g_variant_get (_tmp33_, "a{s*}", &iter, NULL);
		key = NULL;
		value = NULL;
		while (TRUE) {
			GVariantIter* _tmp34_ = NULL;
			gboolean _tmp35_ = FALSE;
			const struct OpaqueJSValue* _tmp36_ = NULL;
			const struct OpaqueJSContext* _tmp37_ = NULL;
			GVariant* _tmp38_ = NULL;
			const struct OpaqueJSValue* _tmp39_ = NULL;
			struct OpaqueJSValue* _tmp40_ = NULL;
			const struct OpaqueJSContext* _tmp41_ = NULL;
			const gchar* _tmp42_ = NULL;
			struct OpaqueJSString* _tmp43_ = NULL;
			struct OpaqueJSString* _tmp44_ = NULL;
			_tmp34_ = iter;
			_tmp35_ = g_variant_iter_next (_tmp34_, "{s*}", &key, &value, NULL);
			if (!_tmp35_) {
				break;
			}
			_tmp37_ = ctx;
			_tmp38_ = value;
			_tmp39_ = nuvola_js_tools_value_from_variant (_tmp37_, _tmp38_, &_inner_error_);
			_tmp36_ = _tmp39_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == NUVOLA_JS_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_variant_unref0 (value);
					_g_free0 (key);
					_g_variant_iter_free0 (iter);
					_g_variant_type_free0 (object_type);
					_g_variant_type_free0 (type);
					return NULL;
				} else {
					_g_variant_unref0 (value);
					_g_free0 (key);
					_g_variant_iter_free0 (iter);
					_g_variant_type_free0 (object_type);
					_g_variant_type_free0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp40_ = object;
			_tmp41_ = ctx;
			_tmp42_ = key;
			_tmp43_ = JSStringCreateWithUTF8CString (_tmp42_);
			_tmp44_ = _tmp43_;
			JSObjectSetProperty (_tmp41_, _tmp40_, _tmp44_, _tmp36_, 0, NULL);
			_JSStringRelease0 (_tmp44_);
		}
		_tmp45_ = object;
		result = (const struct OpaqueJSValue*) _tmp45_;
		_g_variant_unref0 (value);
		_g_free0 (key);
		_g_variant_iter_free0 (iter);
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp46_ = variant;
	_tmp47_ = G_VARIANT_TYPE_STRING;
	_tmp48_ = g_variant_is_of_type (_tmp46_, _tmp47_);
	if (_tmp48_) {
		const struct OpaqueJSContext* _tmp49_ = NULL;
		GVariant* _tmp50_ = NULL;
		const gchar* _tmp51_ = NULL;
		struct OpaqueJSString* _tmp52_ = NULL;
		struct OpaqueJSString* _tmp53_ = NULL;
		const struct OpaqueJSValue* _tmp54_ = NULL;
		const struct OpaqueJSValue* _tmp55_ = NULL;
		_tmp49_ = ctx;
		_tmp50_ = variant;
		_tmp51_ = g_variant_get_string (_tmp50_, NULL);
		_tmp52_ = JSStringCreateWithUTF8CString (_tmp51_);
		_tmp53_ = _tmp52_;
		_tmp54_ = JSValueMakeString (_tmp49_, _tmp53_);
		_tmp55_ = _tmp54_;
		_JSStringRelease0 (_tmp53_);
		result = _tmp55_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp56_ = variant;
	_tmp57_ = G_VARIANT_TYPE_BOOLEAN;
	_tmp58_ = g_variant_is_of_type (_tmp56_, _tmp57_);
	if (_tmp58_) {
		const struct OpaqueJSContext* _tmp59_ = NULL;
		GVariant* _tmp60_ = NULL;
		gboolean _tmp61_ = FALSE;
		const struct OpaqueJSValue* _tmp62_ = NULL;
		_tmp59_ = ctx;
		_tmp60_ = variant;
		_tmp61_ = g_variant_get_boolean (_tmp60_);
		_tmp62_ = JSValueMakeBoolean (_tmp59_, _tmp61_);
		result = _tmp62_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp63_ = variant;
	_tmp64_ = G_VARIANT_TYPE_DOUBLE;
	_tmp65_ = g_variant_is_of_type (_tmp63_, _tmp64_);
	if (_tmp65_) {
		const struct OpaqueJSContext* _tmp66_ = NULL;
		GVariant* _tmp67_ = NULL;
		gdouble _tmp68_ = 0.0;
		const struct OpaqueJSValue* _tmp69_ = NULL;
		_tmp66_ = ctx;
		_tmp67_ = variant;
		_tmp68_ = g_variant_get_double (_tmp67_);
		_tmp69_ = JSValueMakeNumber (_tmp66_, _tmp68_);
		result = _tmp69_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp70_ = variant;
	_tmp71_ = G_VARIANT_TYPE_INT32;
	_tmp72_ = g_variant_is_of_type (_tmp70_, _tmp71_);
	if (_tmp72_) {
		const struct OpaqueJSContext* _tmp73_ = NULL;
		GVariant* _tmp74_ = NULL;
		gint32 _tmp75_ = 0;
		const struct OpaqueJSValue* _tmp76_ = NULL;
		_tmp73_ = ctx;
		_tmp74_ = variant;
		_tmp75_ = g_variant_get_int32 (_tmp74_);
		_tmp76_ = JSValueMakeNumber (_tmp73_, (gdouble) _tmp75_);
		result = _tmp76_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp77_ = variant;
	_tmp78_ = G_VARIANT_TYPE_UINT32;
	_tmp79_ = g_variant_is_of_type (_tmp77_, _tmp78_);
	if (_tmp79_) {
		const struct OpaqueJSContext* _tmp80_ = NULL;
		GVariant* _tmp81_ = NULL;
		guint32 _tmp82_ = 0U;
		const struct OpaqueJSValue* _tmp83_ = NULL;
		_tmp80_ = ctx;
		_tmp81_ = variant;
		_tmp82_ = g_variant_get_uint32 (_tmp81_);
		_tmp83_ = JSValueMakeNumber (_tmp80_, (gdouble) _tmp82_);
		result = _tmp83_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp84_ = variant;
	_tmp85_ = G_VARIANT_TYPE_INT64;
	_tmp86_ = g_variant_is_of_type (_tmp84_, _tmp85_);
	if (_tmp86_) {
		const struct OpaqueJSContext* _tmp87_ = NULL;
		GVariant* _tmp88_ = NULL;
		gint64 _tmp89_ = 0LL;
		const struct OpaqueJSValue* _tmp90_ = NULL;
		_tmp87_ = ctx;
		_tmp88_ = variant;
		_tmp89_ = g_variant_get_int64 (_tmp88_);
		_tmp90_ = JSValueMakeNumber (_tmp87_, (gdouble) _tmp89_);
		result = _tmp90_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp91_ = variant;
	_tmp92_ = G_VARIANT_TYPE_UINT64;
	_tmp93_ = g_variant_is_of_type (_tmp91_, _tmp92_);
	if (_tmp93_) {
		const struct OpaqueJSContext* _tmp94_ = NULL;
		GVariant* _tmp95_ = NULL;
		guint64 _tmp96_ = 0ULL;
		const struct OpaqueJSValue* _tmp97_ = NULL;
		_tmp94_ = ctx;
		_tmp95_ = variant;
		_tmp96_ = g_variant_get_uint64 (_tmp95_);
		_tmp97_ = JSValueMakeNumber (_tmp94_, (gdouble) _tmp96_);
		result = _tmp97_;
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp98_ = variant;
	_tmp99_ = g_variant_is_container (_tmp98_);
	if (_tmp99_) {
		gsize size = 0UL;
		GVariant* _tmp100_ = NULL;
		gsize _tmp101_ = 0UL;
		void** args = NULL;
		gsize _tmp102_ = 0UL;
		void** _tmp103_ = NULL;
		gint args_length1 = 0;
		gint _args_size_ = 0;
		const struct OpaqueJSContext* _tmp119_ = NULL;
		void** _tmp120_ = NULL;
		gint _tmp120__length1 = 0;
		struct OpaqueJSValue* _tmp121_ = NULL;
		_tmp100_ = variant;
		_tmp101_ = g_variant_n_children (_tmp100_);
		size = _tmp101_;
		_tmp102_ = size;
		_tmp103_ = g_new0 (void*, _tmp102_);
		args = _tmp103_;
		args_length1 = _tmp102_;
		_args_size_ = args_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp104_ = FALSE;
				_tmp104_ = TRUE;
				while (TRUE) {
					gint _tmp106_ = 0;
					gsize _tmp107_ = 0UL;
					const struct OpaqueJSValue* _tmp108_ = NULL;
					const struct OpaqueJSContext* _tmp109_ = NULL;
					GVariant* _tmp110_ = NULL;
					gint _tmp111_ = 0;
					GVariant* _tmp112_ = NULL;
					GVariant* _tmp113_ = NULL;
					const struct OpaqueJSValue* _tmp114_ = NULL;
					const struct OpaqueJSValue* _tmp115_ = NULL;
					void** _tmp116_ = NULL;
					gint _tmp116__length1 = 0;
					gint _tmp117_ = 0;
					void* _tmp118_ = NULL;
					if (!_tmp104_) {
						gint _tmp105_ = 0;
						_tmp105_ = i;
						i = _tmp105_ + 1;
					}
					_tmp104_ = FALSE;
					_tmp106_ = i;
					_tmp107_ = size;
					if (!(((gsize) _tmp106_) < _tmp107_)) {
						break;
					}
					_tmp109_ = ctx;
					_tmp110_ = variant;
					_tmp111_ = i;
					_tmp112_ = g_variant_get_child_value (_tmp110_, (gsize) _tmp111_);
					_tmp113_ = _tmp112_;
					_tmp114_ = nuvola_js_tools_value_from_variant (_tmp109_, _tmp113_, &_inner_error_);
					_tmp115_ = _tmp114_;
					_g_variant_unref0 (_tmp113_);
					_tmp108_ = _tmp115_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_JS_ERROR) {
							g_propagate_error (error, _inner_error_);
							args = (g_free (args), NULL);
							_g_variant_type_free0 (object_type);
							_g_variant_type_free0 (type);
							return NULL;
						} else {
							args = (g_free (args), NULL);
							_g_variant_type_free0 (object_type);
							_g_variant_type_free0 (type);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp116_ = args;
					_tmp116__length1 = args_length1;
					_tmp117_ = i;
					_tmp116_[_tmp117_] = (void*) _tmp108_;
					_tmp118_ = _tmp116_[_tmp117_];
				}
			}
		}
		_tmp119_ = ctx;
		_tmp120_ = args;
		_tmp120__length1 = args_length1;
		_tmp121_ = JSObjectMakeArray (_tmp119_, (size_t) ((_tmp120__length1 * sizeof (void*)) / sizeof (const struct OpaqueJSValue*)), (const struct OpaqueJSValue**) _tmp120_, NULL);
		result = (const struct OpaqueJSValue*) _tmp121_;
		args = (g_free (args), NULL);
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp122_ = variant;
	_tmp123_ = g_variant_get_type_string (_tmp122_);
	_tmp124_ = variant;
	_tmp125_ = g_variant_print (_tmp124_, TRUE);
	_tmp126_ = _tmp125_;
	_tmp127_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_WRONG_TYPE, "Unsupported type '%s'. Content: %s", _tmp123_, _tmp126_);
	_tmp128_ = _tmp127_;
	_g_free0 (_tmp126_);
	_inner_error_ = _tmp128_;
	if (_inner_error_->domain == NUVOLA_JS_ERROR) {
		g_propagate_error (error, _inner_error_);
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		return NULL;
	} else {
		_g_variant_type_free0 (object_type);
		_g_variant_type_free0 (type);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_variant_type_free0 (object_type);
	_g_variant_type_free0 (type);
}


GVariant* nuvola_js_tools_variant_from_value (const struct OpaqueJSContext* ctx, const struct OpaqueJSValue* val, GError** error) {
	GVariant* result = NULL;
	const struct OpaqueJSValue* _tmp0_ = NULL;
	const struct OpaqueJSContext* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const struct OpaqueJSValue* _tmp4_ = NULL;
	const struct OpaqueJSContext* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	const struct OpaqueJSValue* _tmp15_ = NULL;
	const struct OpaqueJSContext* _tmp16_ = NULL;
	gboolean _tmp17_ = FALSE;
	const struct OpaqueJSValue* _tmp22_ = NULL;
	const struct OpaqueJSContext* _tmp23_ = NULL;
	gboolean _tmp24_ = FALSE;
	struct OpaqueJSValue* glob_object = NULL;
	const struct OpaqueJSContext* _tmp29_ = NULL;
	struct OpaqueJSValue* _tmp30_ = NULL;
	struct OpaqueJSValue* object = NULL;
	const struct OpaqueJSContext* _tmp31_ = NULL;
	struct OpaqueJSValue* _tmp32_ = NULL;
	struct OpaqueJSValue* _tmp33_ = NULL;
	const struct OpaqueJSContext* _tmp34_ = NULL;
	struct OpaqueJSValue* _tmp35_ = NULL;
	struct OpaqueJSValue* _tmp36_ = NULL;
	void** params = NULL;
	void** _tmp37_ = NULL;
	gint params_length1 = 0;
	gint _params_size_ = 0;
	void** _tmp38_ = NULL;
	gint _tmp38__length1 = 0;
	const struct OpaqueJSValue* _tmp39_ = NULL;
	void* _tmp40_ = NULL;
	const struct OpaqueJSValue* exception = NULL;
	const struct OpaqueJSValue* _result_ = NULL;
	struct OpaqueJSValue* _tmp41_ = NULL;
	const struct OpaqueJSContext* _tmp42_ = NULL;
	struct OpaqueJSValue* _tmp43_ = NULL;
	void** _tmp44_ = NULL;
	gint _tmp44__length1 = 0;
	const struct OpaqueJSValue* _tmp45_ = NULL;
	const struct OpaqueJSValue* _tmp46_ = NULL;
	const struct OpaqueJSValue* _tmp47_ = NULL;
	const struct OpaqueJSValue* _tmp57_ = NULL;
	const struct OpaqueJSContext* _tmp58_ = NULL;
	gboolean _tmp59_ = FALSE;
	const struct OpaqueJSValue* _tmp83_ = NULL;
	const struct OpaqueJSContext* _tmp84_ = NULL;
	gboolean _tmp85_ = FALSE;
	GVariant* _tmp116_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ctx != NULL, NULL);
	g_return_val_if_fail (val != NULL, NULL);
	_tmp0_ = val;
	_tmp1_ = ctx;
	_tmp2_ = JSValueIsNull (_tmp1_, _tmp0_);
	if (_tmp2_) {
		GVariant* _tmp3_ = NULL;
		_tmp3_ = g_variant_new ("mv", NULL, NULL);
		g_variant_ref_sink (_tmp3_);
		result = _tmp3_;
		return result;
	}
	_tmp4_ = val;
	_tmp5_ = ctx;
	_tmp6_ = JSValueIsString (_tmp5_, _tmp4_);
	if (_tmp6_) {
		const struct OpaqueJSValue* _tmp7_ = NULL;
		const struct OpaqueJSContext* _tmp8_ = NULL;
		struct OpaqueJSString* _tmp9_ = NULL;
		struct OpaqueJSString* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		GVariant* _tmp13_ = NULL;
		GVariant* _tmp14_ = NULL;
		_tmp7_ = val;
		_tmp8_ = ctx;
		_tmp9_ = JSValueToStringCopy (_tmp8_, _tmp7_, NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = nuvola_js_tools_utf8_string (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_variant_new_string (_tmp12_);
		g_variant_ref_sink (_tmp13_);
		_tmp14_ = _tmp13_;
		_g_free0 (_tmp12_);
		_JSStringRelease0 (_tmp10_);
		result = _tmp14_;
		return result;
	}
	_tmp15_ = val;
	_tmp16_ = ctx;
	_tmp17_ = JSValueIsNumber (_tmp16_, _tmp15_);
	if (_tmp17_) {
		const struct OpaqueJSValue* _tmp18_ = NULL;
		const struct OpaqueJSContext* _tmp19_ = NULL;
		gdouble _tmp20_ = 0.0;
		GVariant* _tmp21_ = NULL;
		_tmp18_ = val;
		_tmp19_ = ctx;
		_tmp20_ = JSValueToNumber (_tmp19_, _tmp18_, NULL);
		_tmp21_ = g_variant_new_double (_tmp20_);
		g_variant_ref_sink (_tmp21_);
		result = _tmp21_;
		return result;
	}
	_tmp22_ = val;
	_tmp23_ = ctx;
	_tmp24_ = JSValueIsBoolean (_tmp23_, _tmp22_);
	if (_tmp24_) {
		const struct OpaqueJSValue* _tmp25_ = NULL;
		const struct OpaqueJSContext* _tmp26_ = NULL;
		gboolean _tmp27_ = FALSE;
		GVariant* _tmp28_ = NULL;
		_tmp25_ = val;
		_tmp26_ = ctx;
		_tmp27_ = JSValueToBoolean (_tmp26_, _tmp25_);
		_tmp28_ = g_variant_new_boolean (_tmp27_);
		g_variant_ref_sink (_tmp28_);
		result = _tmp28_;
		return result;
	}
	_tmp29_ = ctx;
	_tmp30_ = JSContextGetGlobalObject (_tmp29_);
	glob_object = _tmp30_;
	_tmp31_ = ctx;
	_tmp32_ = glob_object;
	_tmp33_ = nuvola_js_tools_o_get_object (_tmp31_, _tmp32_, "Array");
	object = _tmp33_;
	_tmp34_ = ctx;
	_tmp35_ = object;
	_tmp36_ = nuvola_js_tools_o_get_object (_tmp34_, _tmp35_, "isArray");
	object = _tmp36_;
	_tmp37_ = g_new0 (void*, 1);
	params = _tmp37_;
	params_length1 = 1;
	_params_size_ = params_length1;
	_tmp38_ = params;
	_tmp38__length1 = params_length1;
	_tmp39_ = val;
	_tmp38_[0] = (void*) _tmp39_;
	_tmp40_ = _tmp38_[0];
	_tmp41_ = object;
	_tmp42_ = ctx;
	_tmp43_ = glob_object;
	_tmp44_ = params;
	_tmp44__length1 = params_length1;
	_tmp46_ = JSObjectCallAsFunction (_tmp42_, _tmp41_, _tmp43_, (size_t) ((_tmp44__length1 * sizeof (void*)) / sizeof (const struct OpaqueJSValue*)), (const struct OpaqueJSValue**) _tmp44_, &_tmp45_);
	_0 (exception);
	exception = _tmp45_;
	_result_ = _tmp46_;
	_tmp47_ = exception;
	if (_tmp47_ != NULL) {
		gchar* _tmp48_ = NULL;
		const struct OpaqueJSContext* _tmp49_ = NULL;
		const struct OpaqueJSValue* _tmp50_ = NULL;
		gchar* _tmp51_ = NULL;
		gchar* _tmp53_ = NULL;
		gchar* _tmp54_ = NULL;
		GError* _tmp55_ = NULL;
		GError* _tmp56_ = NULL;
		_tmp49_ = ctx;
		_tmp50_ = exception;
		_tmp51_ = nuvola_js_tools_exception_to_string (_tmp49_, _tmp50_);
		_tmp48_ = _tmp51_;
		if (_tmp48_ == NULL) {
			gchar* _tmp52_ = NULL;
			_tmp52_ = g_strdup ("(null)");
			_g_free0 (_tmp48_);
			_tmp48_ = _tmp52_;
		}
		_tmp53_ = _tmp48_;
		_tmp48_ = NULL;
		_tmp54_ = _tmp53_;
		_tmp55_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_WRONG_TYPE, "Unsupported type. %s", _tmp54_);
		_tmp56_ = _tmp55_;
		_g_free0 (_tmp54_);
		_inner_error_ = _tmp56_;
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (_tmp48_);
			_0 (exception);
			params = (g_free (params), NULL);
			return NULL;
		} else {
			_g_free0 (_tmp48_);
			_0 (exception);
			params = (g_free (params), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (_tmp48_);
	}
	_tmp57_ = _result_;
	_tmp58_ = ctx;
	_tmp59_ = JSValueToBoolean (_tmp58_, _tmp57_);
	if (_tmp59_) {
		GVariantBuilder* builder = NULL;
		GVariantType* _tmp60_ = NULL;
		GVariantType* _tmp61_ = NULL;
		GVariantBuilder* _tmp62_ = NULL;
		GVariantBuilder* _tmp63_ = NULL;
		const struct OpaqueJSValue* _tmp64_ = NULL;
		gint size = 0;
		const struct OpaqueJSContext* _tmp65_ = NULL;
		struct OpaqueJSValue* _tmp66_ = NULL;
		gdouble _tmp67_ = 0.0;
		GVariantBuilder* _tmp81_ = NULL;
		GVariant* _tmp82_ = NULL;
		_tmp60_ = g_variant_type_new ("av");
		_tmp61_ = _tmp60_;
		_tmp62_ = g_variant_builder_new (_tmp61_);
		_tmp63_ = _tmp62_;
		_g_variant_type_free0 (_tmp61_);
		builder = _tmp63_;
		_tmp64_ = val;
		object = (struct OpaqueJSValue*) _tmp64_;
		_tmp65_ = ctx;
		_tmp66_ = object;
		_tmp67_ = nuvola_js_tools_o_get_number (_tmp65_, _tmp66_, "length");
		size = (gint) _tmp67_;
		{
			guint i = 0U;
			i = (guint) 0;
			{
				gboolean _tmp68_ = FALSE;
				_tmp68_ = TRUE;
				while (TRUE) {
					guint _tmp70_ = 0U;
					gint _tmp71_ = 0;
					GVariant* _tmp72_ = NULL;
					const struct OpaqueJSContext* _tmp73_ = NULL;
					struct OpaqueJSValue* _tmp74_ = NULL;
					const struct OpaqueJSContext* _tmp75_ = NULL;
					guint _tmp76_ = 0U;
					const struct OpaqueJSValue* _tmp77_ = NULL;
					GVariant* _tmp78_ = NULL;
					GVariantBuilder* _tmp79_ = NULL;
					GVariant* _tmp80_ = NULL;
					if (!_tmp68_) {
						guint _tmp69_ = 0U;
						_tmp69_ = i;
						i = _tmp69_ + 1;
					}
					_tmp68_ = FALSE;
					_tmp70_ = i;
					_tmp71_ = size;
					if (!(_tmp70_ < ((guint) _tmp71_))) {
						break;
					}
					_tmp73_ = ctx;
					_tmp74_ = object;
					_tmp75_ = ctx;
					_tmp76_ = i;
					_tmp77_ = JSObjectGetPropertyAtIndex (_tmp75_, _tmp74_, _tmp76_, NULL);
					_tmp78_ = nuvola_js_tools_variant_from_value (_tmp73_, _tmp77_, &_inner_error_);
					_tmp72_ = _tmp78_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_JS_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_variant_builder_unref0 (builder);
							_0 (exception);
							params = (g_free (params), NULL);
							return NULL;
						} else {
							_g_variant_builder_unref0 (builder);
							_0 (exception);
							params = (g_free (params), NULL);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp79_ = builder;
					_tmp80_ = _tmp72_;
					_tmp72_ = NULL;
					g_variant_builder_add (_tmp79_, "v", _tmp80_, NULL);
					_g_variant_unref0 (_tmp72_);
				}
			}
		}
		_tmp81_ = builder;
		_tmp82_ = g_variant_builder_end (_tmp81_);
		g_variant_ref_sink (_tmp82_);
		result = _tmp82_;
		_g_variant_builder_unref0 (builder);
		_0 (exception);
		params = (g_free (params), NULL);
		return result;
	}
	_tmp83_ = val;
	_tmp84_ = ctx;
	_tmp85_ = JSValueIsObject (_tmp84_, _tmp83_);
	if (_tmp85_) {
		const struct OpaqueJSValue* _tmp86_ = NULL;
		struct OpaqueJSPropertyNameArray* properties = NULL;
		struct OpaqueJSValue* _tmp87_ = NULL;
		const struct OpaqueJSContext* _tmp88_ = NULL;
		struct OpaqueJSPropertyNameArray* _tmp89_ = NULL;
		gsize size = 0UL;
		struct OpaqueJSPropertyNameArray* _tmp90_ = NULL;
		gsize _tmp91_ = 0UL;
		GVariantBuilder* builder = NULL;
		GVariantType* _tmp92_ = NULL;
		GVariantType* _tmp93_ = NULL;
		GVariantBuilder* _tmp94_ = NULL;
		GVariantBuilder* _tmp95_ = NULL;
		GVariantBuilder* _tmp114_ = NULL;
		GVariant* _tmp115_ = NULL;
		_tmp86_ = val;
		object = (struct OpaqueJSValue*) _tmp86_;
		_tmp87_ = object;
		_tmp88_ = ctx;
		_tmp89_ = JSObjectCopyPropertyNames (_tmp88_, _tmp87_);
		properties = _tmp89_;
		_tmp90_ = properties;
		_tmp91_ = JSPropertyNameArrayGetCount (_tmp90_);
		size = _tmp91_;
		_tmp92_ = g_variant_type_new ("a{smv}");
		_tmp93_ = _tmp92_;
		_tmp94_ = g_variant_builder_new (_tmp93_);
		_tmp95_ = _tmp94_;
		_g_variant_type_free0 (_tmp93_);
		builder = _tmp95_;
		{
			gsize i = 0UL;
			i = (gsize) 0;
			{
				gboolean _tmp96_ = FALSE;
				_tmp96_ = TRUE;
				while (TRUE) {
					gsize _tmp98_ = 0UL;
					gsize _tmp99_ = 0UL;
					struct OpaqueJSString* js_property = NULL;
					struct OpaqueJSPropertyNameArray* _tmp100_ = NULL;
					gsize _tmp101_ = 0UL;
					struct OpaqueJSString* _tmp102_ = NULL;
					GVariant* value = NULL;
					const struct OpaqueJSContext* _tmp103_ = NULL;
					struct OpaqueJSValue* _tmp104_ = NULL;
					const struct OpaqueJSContext* _tmp105_ = NULL;
					struct OpaqueJSString* _tmp106_ = NULL;
					const struct OpaqueJSValue* _tmp107_ = NULL;
					GVariant* _tmp108_ = NULL;
					GVariantBuilder* _tmp109_ = NULL;
					struct OpaqueJSString* _tmp110_ = NULL;
					gchar* _tmp111_ = NULL;
					gchar* _tmp112_ = NULL;
					GVariant* _tmp113_ = NULL;
					if (!_tmp96_) {
						gsize _tmp97_ = 0UL;
						_tmp97_ = i;
						i = _tmp97_ + 1;
					}
					_tmp96_ = FALSE;
					_tmp98_ = i;
					_tmp99_ = size;
					if (!(_tmp98_ < _tmp99_)) {
						break;
					}
					_tmp100_ = properties;
					_tmp101_ = i;
					_tmp102_ = JSPropertyNameArrayGetNameAtIndex (_tmp100_, _tmp101_);
					js_property = _tmp102_;
					_tmp103_ = ctx;
					_tmp104_ = object;
					_tmp105_ = ctx;
					_tmp106_ = js_property;
					_tmp107_ = JSObjectGetProperty (_tmp105_, _tmp104_, _tmp106_, NULL);
					_tmp108_ = nuvola_js_tools_variant_from_value (_tmp103_, _tmp107_, &_inner_error_);
					value = _tmp108_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_JS_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_variant_builder_unref0 (builder);
							_JSPropertyNameArrayRelease0 (properties);
							_0 (exception);
							params = (g_free (params), NULL);
							return NULL;
						} else {
							_g_variant_builder_unref0 (builder);
							_JSPropertyNameArrayRelease0 (properties);
							_0 (exception);
							params = (g_free (params), NULL);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp109_ = builder;
					_tmp110_ = js_property;
					_tmp111_ = nuvola_js_tools_utf8_string (_tmp110_);
					_tmp112_ = _tmp111_;
					_tmp113_ = value;
					g_variant_builder_add (_tmp109_, "{smv}", _tmp112_, _tmp113_, NULL);
					_g_free0 (_tmp112_);
					_g_variant_unref0 (value);
				}
			}
		}
		_tmp114_ = builder;
		_tmp115_ = g_variant_builder_end (_tmp114_);
		g_variant_ref_sink (_tmp115_);
		result = _tmp115_;
		_g_variant_builder_unref0 (builder);
		_JSPropertyNameArrayRelease0 (properties);
		_0 (exception);
		params = (g_free (params), NULL);
		return result;
	}
	g_warning ("jstools.vala:381: Attempt to convert `undefined` JavaScript type. This" \
" might be a programmer error!");
	_tmp116_ = g_variant_new_string ("<ERROR: UNDEFINED VALUE TYPE>");
	g_variant_ref_sink (_tmp116_);
	result = _tmp116_;
	_0 (exception);
	params = (g_free (params), NULL);
	return result;
}



