/* ActionsInterface.c generated by valac 0.34.9, the Vala compiler
 * generated from ActionsInterface.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <dioritegtk4.h>


#define NUVOLA_TYPE_ACTIONS_INTERFACE (nuvola_actions_interface_get_type ())
#define NUVOLA_ACTIONS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_ACTIONS_INTERFACE, NuvolaActionsInterface))
#define NUVOLA_IS_ACTIONS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_ACTIONS_INTERFACE))
#define NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_ACTIONS_INTERFACE, NuvolaActionsInterfaceIface))

typedef struct _NuvolaActionsInterface NuvolaActionsInterface;
typedef struct _NuvolaActionsInterfaceIface NuvolaActionsInterfaceIface;

struct _NuvolaActionsInterfaceIface {
	GTypeInterface parent_iface;
	gboolean (*activate) (NuvolaActionsInterface* self, const gchar* name, GVariant* parameter);
	gboolean (*set_state) (NuvolaActionsInterface* self, const gchar* name, GVariant* state);
	gboolean (*get_state) (NuvolaActionsInterface* self, const gchar* name, GVariant** state);
	gboolean (*is_enabled) (NuvolaActionsInterface* self, const gchar* action_name, gboolean* enabled);
	gboolean (*set_enabled) (NuvolaActionsInterface* self, const gchar* action_name, gboolean enabled);
	gboolean (*add_action) (NuvolaActionsInterface* self, const gchar* group, const gchar* scope, const gchar* action_name, const gchar* label, const gchar* mnemo_label, const gchar* icon, const gchar* keybinding, GVariant* state);
	gboolean (*add_radio_action) (NuvolaActionsInterface* self, const gchar* group, const gchar* scope, const gchar* name, GVariant* state, DrtRadioOption** options, int options_length1);
	gboolean (*list_groups) (NuvolaActionsInterface* self, GList** groups);
	gboolean (*list_group_actions) (NuvolaActionsInterface* self, const gchar* group, GSList** actions);
};



GType nuvola_actions_interface_get_type (void) G_GNUC_CONST;
gboolean nuvola_actions_interface_activate (NuvolaActionsInterface* self, const gchar* name, GVariant* parameter);
gboolean nuvola_actions_interface_set_state (NuvolaActionsInterface* self, const gchar* name, GVariant* state);
gboolean nuvola_actions_interface_get_state (NuvolaActionsInterface* self, const gchar* name, GVariant** state);
gboolean nuvola_actions_interface_is_enabled (NuvolaActionsInterface* self, const gchar* action_name, gboolean* enabled);
gboolean nuvola_actions_interface_set_enabled (NuvolaActionsInterface* self, const gchar* action_name, gboolean enabled);
gboolean nuvola_actions_interface_add_action (NuvolaActionsInterface* self, const gchar* group, const gchar* scope, const gchar* action_name, const gchar* label, const gchar* mnemo_label, const gchar* icon, const gchar* keybinding, GVariant* state);
gboolean nuvola_actions_interface_add_radio_action (NuvolaActionsInterface* self, const gchar* group, const gchar* scope, const gchar* name, GVariant* state, DrtRadioOption** options, int options_length1);
gboolean nuvola_actions_interface_list_groups (NuvolaActionsInterface* self, GList** groups);
gboolean nuvola_actions_interface_list_group_actions (NuvolaActionsInterface* self, const gchar* group, GSList** actions);
static void g_cclosure_user_marshal_VOID__STRING_VARIANT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);


gboolean nuvola_actions_interface_activate (NuvolaActionsInterface* self, const gchar* name, GVariant* parameter) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE (self)->activate (self, name, parameter);
}


gboolean nuvola_actions_interface_set_state (NuvolaActionsInterface* self, const gchar* name, GVariant* state) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE (self)->set_state (self, name, state);
}


gboolean nuvola_actions_interface_get_state (NuvolaActionsInterface* self, const gchar* name, GVariant** state) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE (self)->get_state (self, name, state);
}


gboolean nuvola_actions_interface_is_enabled (NuvolaActionsInterface* self, const gchar* action_name, gboolean* enabled) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE (self)->is_enabled (self, action_name, enabled);
}


gboolean nuvola_actions_interface_set_enabled (NuvolaActionsInterface* self, const gchar* action_name, gboolean enabled) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE (self)->set_enabled (self, action_name, enabled);
}


gboolean nuvola_actions_interface_add_action (NuvolaActionsInterface* self, const gchar* group, const gchar* scope, const gchar* action_name, const gchar* label, const gchar* mnemo_label, const gchar* icon, const gchar* keybinding, GVariant* state) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE (self)->add_action (self, group, scope, action_name, label, mnemo_label, icon, keybinding, state);
}


gboolean nuvola_actions_interface_add_radio_action (NuvolaActionsInterface* self, const gchar* group, const gchar* scope, const gchar* name, GVariant* state, DrtRadioOption** options, int options_length1) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE (self)->add_radio_action (self, group, scope, name, state, options, options_length1);
}


gboolean nuvola_actions_interface_list_groups (NuvolaActionsInterface* self, GList** groups) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE (self)->list_groups (self, groups);
}


gboolean nuvola_actions_interface_list_group_actions (NuvolaActionsInterface* self, const gchar* group, GSList** actions) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_ACTIONS_INTERFACE_GET_INTERFACE (self)->list_group_actions (self, group, actions);
}


static void g_cclosure_user_marshal_VOID__STRING_VARIANT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_VARIANT) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_VARIANT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_VARIANT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_variant (param_values + 2), data2);
}


static void nuvola_actions_interface_base_init (NuvolaActionsInterfaceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("custom_action_activated", NUVOLA_TYPE_ACTIONS_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_VARIANT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_VARIANT);
	}
}


GType nuvola_actions_interface_get_type (void) {
	static volatile gsize nuvola_actions_interface_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_actions_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaActionsInterfaceIface), (GBaseInitFunc) nuvola_actions_interface_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType nuvola_actions_interface_type_id;
		nuvola_actions_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "NuvolaActionsInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (nuvola_actions_interface_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&nuvola_actions_interface_type_id__volatile, nuvola_actions_interface_type_id);
	}
	return nuvola_actions_interface_type_id__volatile;
}



