/* AudioScrobbler.c generated by valac 0.34.9, the Vala compiler
 * generated from AudioScrobbler.vala, do not modify */

/*
 * Copyright 2014-2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <dioritegtk4.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_AUDIO_SCROBBLER (nuvola_audio_scrobbler_get_type ())
#define NUVOLA_AUDIO_SCROBBLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_AUDIO_SCROBBLER, NuvolaAudioScrobbler))
#define NUVOLA_AUDIO_SCROBBLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_AUDIO_SCROBBLER, NuvolaAudioScrobblerClass))
#define NUVOLA_IS_AUDIO_SCROBBLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_AUDIO_SCROBBLER))
#define NUVOLA_IS_AUDIO_SCROBBLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_AUDIO_SCROBBLER))
#define NUVOLA_AUDIO_SCROBBLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_AUDIO_SCROBBLER, NuvolaAudioScrobblerClass))

typedef struct _NuvolaAudioScrobbler NuvolaAudioScrobbler;
typedef struct _NuvolaAudioScrobblerClass NuvolaAudioScrobblerClass;
typedef struct _NuvolaAudioScrobblerPrivate NuvolaAudioScrobblerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _NuvolaAudioScrobblerScrobbleTrackData NuvolaAudioScrobblerScrobbleTrackData;
typedef struct _NuvolaAudioScrobblerUpdateNowPlayingData NuvolaAudioScrobblerUpdateNowPlayingData;

typedef enum  {
	NUVOLA_AUDIO_SCROBBLER_ERROR_NOT_IMPLEMENTED,
	NUVOLA_AUDIO_SCROBBLER_ERROR_CONNECTION_ERROR,
	NUVOLA_AUDIO_SCROBBLER_ERROR_NOT_AUTHENTICATED,
	NUVOLA_AUDIO_SCROBBLER_ERROR_JSON_PARSE_ERROR,
	NUVOLA_AUDIO_SCROBBLER_ERROR_LASTFM_ERROR,
	NUVOLA_AUDIO_SCROBBLER_ERROR_WRONG_RESPONSE,
	NUVOLA_AUDIO_SCROBBLER_ERROR_NO_SESSION,
	NUVOLA_AUDIO_SCROBBLER_ERROR_RETRY
} NuvolaAudioScrobblerError;
#define NUVOLA_AUDIO_SCROBBLER_ERROR nuvola_audio_scrobbler_error_quark ()
struct _NuvolaAudioScrobbler {
	GObject parent_instance;
	NuvolaAudioScrobblerPrivate * priv;
};

struct _NuvolaAudioScrobblerClass {
	GObjectClass parent_class;
	GtkWidget* (*get_settings) (NuvolaAudioScrobbler* self, DrtApplication* app);
	void (*scrobble_track) (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, const gchar* album, gint64 timestamp, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*scrobble_track_finish) (NuvolaAudioScrobbler* self, GAsyncResult* _res_, GError** error);
	void (*update_now_playing) (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*update_now_playing_finish) (NuvolaAudioScrobbler* self, GAsyncResult* _res_, GError** error);
};

struct _NuvolaAudioScrobblerPrivate {
	gchar* _id;
	gchar* _name;
	gboolean _has_settings;
	gboolean _scrobbling_enabled;
	gboolean _can_scrobble;
	gboolean _can_update_now_playing;
};

struct _NuvolaAudioScrobblerScrobbleTrackData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaAudioScrobbler* self;
	gchar* song;
	gchar* artist;
	gchar* album;
	gint64 timestamp;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _tmp2_;
	GError * _inner_error_;
};

struct _NuvolaAudioScrobblerUpdateNowPlayingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaAudioScrobbler* self;
	gchar* song;
	gchar* artist;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _tmp2_;
	GError * _inner_error_;
};


static gpointer nuvola_audio_scrobbler_parent_class = NULL;

GQuark nuvola_audio_scrobbler_error_quark (void);
GType nuvola_audio_scrobbler_get_type (void) G_GNUC_CONST;
#define NUVOLA_AUDIO_SCROBBLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_AUDIO_SCROBBLER, NuvolaAudioScrobblerPrivate))
enum  {
	NUVOLA_AUDIO_SCROBBLER_DUMMY_PROPERTY,
	NUVOLA_AUDIO_SCROBBLER_ID,
	NUVOLA_AUDIO_SCROBBLER_NAME,
	NUVOLA_AUDIO_SCROBBLER_HAS_SETTINGS,
	NUVOLA_AUDIO_SCROBBLER_SCROBBLING_ENABLED,
	NUVOLA_AUDIO_SCROBBLER_CAN_SCROBBLE,
	NUVOLA_AUDIO_SCROBBLER_CAN_UPDATE_NOW_PLAYING
};
GtkWidget* nuvola_audio_scrobbler_get_settings (NuvolaAudioScrobbler* self, DrtApplication* app);
static GtkWidget* nuvola_audio_scrobbler_real_get_settings (NuvolaAudioScrobbler* self, DrtApplication* app);
static void nuvola_audio_scrobbler_real_scrobble_track_data_free (gpointer _data);
static void nuvola_audio_scrobbler_real_scrobble_track (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, const gchar* album, gint64 timestamp, GAsyncReadyCallback _callback_, gpointer _user_data_);
void nuvola_audio_scrobbler_scrobble_track (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, const gchar* album, gint64 timestamp, GAsyncReadyCallback _callback_, gpointer _user_data_);
void nuvola_audio_scrobbler_scrobble_track_finish (NuvolaAudioScrobbler* self, GAsyncResult* _res_, GError** error);
static gboolean nuvola_audio_scrobbler_real_scrobble_track_co (NuvolaAudioScrobblerScrobbleTrackData* _data_);
const gchar* nuvola_audio_scrobbler_get_name (NuvolaAudioScrobbler* self);
const gchar* nuvola_audio_scrobbler_get_id (NuvolaAudioScrobbler* self);
static void nuvola_audio_scrobbler_real_update_now_playing_data_free (gpointer _data);
static void nuvola_audio_scrobbler_real_update_now_playing (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, GAsyncReadyCallback _callback_, gpointer _user_data_);
void nuvola_audio_scrobbler_update_now_playing (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, GAsyncReadyCallback _callback_, gpointer _user_data_);
void nuvola_audio_scrobbler_update_now_playing_finish (NuvolaAudioScrobbler* self, GAsyncResult* _res_, GError** error);
static gboolean nuvola_audio_scrobbler_real_update_now_playing_co (NuvolaAudioScrobblerUpdateNowPlayingData* _data_);
NuvolaAudioScrobbler* nuvola_audio_scrobbler_construct (GType object_type);
static void nuvola_audio_scrobbler_set_id (NuvolaAudioScrobbler* self, const gchar* value);
static void nuvola_audio_scrobbler_set_name (NuvolaAudioScrobbler* self, const gchar* value);
gboolean nuvola_audio_scrobbler_get_has_settings (NuvolaAudioScrobbler* self);
void nuvola_audio_scrobbler_set_has_settings (NuvolaAudioScrobbler* self, gboolean value);
gboolean nuvola_audio_scrobbler_get_scrobbling_enabled (NuvolaAudioScrobbler* self);
void nuvola_audio_scrobbler_set_scrobbling_enabled (NuvolaAudioScrobbler* self, gboolean value);
gboolean nuvola_audio_scrobbler_get_can_scrobble (NuvolaAudioScrobbler* self);
void nuvola_audio_scrobbler_set_can_scrobble (NuvolaAudioScrobbler* self, gboolean value);
gboolean nuvola_audio_scrobbler_get_can_update_now_playing (NuvolaAudioScrobbler* self);
void nuvola_audio_scrobbler_set_can_update_now_playing (NuvolaAudioScrobbler* self, gboolean value);
static void nuvola_audio_scrobbler_finalize (GObject* obj);
static void _vala_nuvola_audio_scrobbler_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_audio_scrobbler_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GQuark nuvola_audio_scrobbler_error_quark (void) {
	return g_quark_from_static_string ("nuvola_audio_scrobbler_error-quark");
}


static GtkWidget* nuvola_audio_scrobbler_real_get_settings (NuvolaAudioScrobbler* self, DrtApplication* app) {
	GtkWidget* result = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	result = NULL;
	return result;
}


GtkWidget* nuvola_audio_scrobbler_get_settings (NuvolaAudioScrobbler* self, DrtApplication* app) {
	g_return_val_if_fail (self != NULL, NULL);
	return NUVOLA_AUDIO_SCROBBLER_GET_CLASS (self)->get_settings (self, app);
}


static void nuvola_audio_scrobbler_real_scrobble_track_data_free (gpointer _data) {
	NuvolaAudioScrobblerScrobbleTrackData* _data_;
	_data_ = _data;
	_g_free0 (_data_->song);
	_g_free0 (_data_->artist);
	_g_free0 (_data_->album);
	_g_object_unref0 (_data_->self);
	g_slice_free (NuvolaAudioScrobblerScrobbleTrackData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void nuvola_audio_scrobbler_real_scrobble_track (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, const gchar* album, gint64 timestamp, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaAudioScrobblerScrobbleTrackData* _data_;
	NuvolaAudioScrobbler* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint64 _tmp7_ = 0LL;
	_data_ = g_slice_new0 (NuvolaAudioScrobblerScrobbleTrackData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, nuvola_audio_scrobbler_real_scrobble_track);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_audio_scrobbler_real_scrobble_track_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = song;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->song);
	_data_->song = _tmp2_;
	_tmp3_ = artist;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_data_->artist);
	_data_->artist = _tmp4_;
	_tmp5_ = album;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (_data_->album);
	_data_->album = _tmp6_;
	_tmp7_ = timestamp;
	_data_->timestamp = _tmp7_;
	nuvola_audio_scrobbler_real_scrobble_track_co (_data_);
}


static void nuvola_audio_scrobbler_real_scrobble_track_finish (NuvolaAudioScrobbler* self, GAsyncResult* _res_, GError** error) {
	NuvolaAudioScrobblerScrobbleTrackData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static gboolean nuvola_audio_scrobbler_real_scrobble_track_co (NuvolaAudioScrobblerScrobbleTrackData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->self->priv->_name;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = _data_->self->priv->_id;
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = g_error_new (NUVOLA_AUDIO_SCROBBLER_ERROR, NUVOLA_AUDIO_SCROBBLER_ERROR_NOT_IMPLEMENTED, "Scrobble track call is not implemented in %s (%s).", _data_->_tmp0_, _data_->_tmp1_);
	_data_->_inner_error_ = _data_->_tmp2_;
	if (_data_->_inner_error_->domain == NUVOLA_AUDIO_SCROBBLER_ERROR) {
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
		g_error_free (_data_->_inner_error_);
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void nuvola_audio_scrobbler_scrobble_track (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, const gchar* album, gint64 timestamp, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NUVOLA_AUDIO_SCROBBLER_GET_CLASS (self)->scrobble_track (self, song, artist, album, timestamp, _callback_, _user_data_);
}


void nuvola_audio_scrobbler_scrobble_track_finish (NuvolaAudioScrobbler* self, GAsyncResult* _res_, GError** error) {
	NUVOLA_AUDIO_SCROBBLER_GET_CLASS (self)->scrobble_track_finish (self, _res_, error);
}


static void nuvola_audio_scrobbler_real_update_now_playing_data_free (gpointer _data) {
	NuvolaAudioScrobblerUpdateNowPlayingData* _data_;
	_data_ = _data;
	_g_free0 (_data_->song);
	_g_free0 (_data_->artist);
	_g_object_unref0 (_data_->self);
	g_slice_free (NuvolaAudioScrobblerUpdateNowPlayingData, _data_);
}


static void nuvola_audio_scrobbler_real_update_now_playing (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaAudioScrobblerUpdateNowPlayingData* _data_;
	NuvolaAudioScrobbler* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	_data_ = g_slice_new0 (NuvolaAudioScrobblerUpdateNowPlayingData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, nuvola_audio_scrobbler_real_update_now_playing);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_audio_scrobbler_real_update_now_playing_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = song;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->song);
	_data_->song = _tmp2_;
	_tmp3_ = artist;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_data_->artist);
	_data_->artist = _tmp4_;
	nuvola_audio_scrobbler_real_update_now_playing_co (_data_);
}


static void nuvola_audio_scrobbler_real_update_now_playing_finish (NuvolaAudioScrobbler* self, GAsyncResult* _res_, GError** error) {
	NuvolaAudioScrobblerUpdateNowPlayingData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static gboolean nuvola_audio_scrobbler_real_update_now_playing_co (NuvolaAudioScrobblerUpdateNowPlayingData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->self->priv->_name;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = _data_->self->priv->_id;
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = g_error_new (NUVOLA_AUDIO_SCROBBLER_ERROR, NUVOLA_AUDIO_SCROBBLER_ERROR_NOT_IMPLEMENTED, "Update now playing call is not implemented in %s (%s).", _data_->_tmp0_, _data_->_tmp1_);
	_data_->_inner_error_ = _data_->_tmp2_;
	if (_data_->_inner_error_->domain == NUVOLA_AUDIO_SCROBBLER_ERROR) {
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
		g_error_free (_data_->_inner_error_);
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void nuvola_audio_scrobbler_update_now_playing (NuvolaAudioScrobbler* self, const gchar* song, const gchar* artist, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NUVOLA_AUDIO_SCROBBLER_GET_CLASS (self)->update_now_playing (self, song, artist, _callback_, _user_data_);
}


void nuvola_audio_scrobbler_update_now_playing_finish (NuvolaAudioScrobbler* self, GAsyncResult* _res_, GError** error) {
	NUVOLA_AUDIO_SCROBBLER_GET_CLASS (self)->update_now_playing_finish (self, _res_, error);
}


NuvolaAudioScrobbler* nuvola_audio_scrobbler_construct (GType object_type) {
	NuvolaAudioScrobbler * self = NULL;
	self = (NuvolaAudioScrobbler*) g_object_new (object_type, NULL);
	return self;
}


const gchar* nuvola_audio_scrobbler_get_id (NuvolaAudioScrobbler* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_id;
	result = _tmp0_;
	return result;
}


static void nuvola_audio_scrobbler_set_id (NuvolaAudioScrobbler* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_id);
	self->priv->_id = _tmp1_;
	g_object_notify ((GObject *) self, "id");
}


const gchar* nuvola_audio_scrobbler_get_name (NuvolaAudioScrobbler* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


static void nuvola_audio_scrobbler_set_name (NuvolaAudioScrobbler* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


gboolean nuvola_audio_scrobbler_get_has_settings (NuvolaAudioScrobbler* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_has_settings;
	result = _tmp0_;
	return result;
}


void nuvola_audio_scrobbler_set_has_settings (NuvolaAudioScrobbler* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_has_settings = _tmp0_;
	g_object_notify ((GObject *) self, "has-settings");
}


gboolean nuvola_audio_scrobbler_get_scrobbling_enabled (NuvolaAudioScrobbler* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_scrobbling_enabled;
	result = _tmp0_;
	return result;
}


void nuvola_audio_scrobbler_set_scrobbling_enabled (NuvolaAudioScrobbler* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_scrobbling_enabled = _tmp0_;
	g_object_notify ((GObject *) self, "scrobbling-enabled");
}


gboolean nuvola_audio_scrobbler_get_can_scrobble (NuvolaAudioScrobbler* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_scrobble;
	result = _tmp0_;
	return result;
}


void nuvola_audio_scrobbler_set_can_scrobble (NuvolaAudioScrobbler* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_scrobble = _tmp0_;
	g_object_notify ((GObject *) self, "can-scrobble");
}


gboolean nuvola_audio_scrobbler_get_can_update_now_playing (NuvolaAudioScrobbler* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_update_now_playing;
	result = _tmp0_;
	return result;
}


void nuvola_audio_scrobbler_set_can_update_now_playing (NuvolaAudioScrobbler* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_update_now_playing = _tmp0_;
	g_object_notify ((GObject *) self, "can-update-now-playing");
}


static void nuvola_audio_scrobbler_class_init (NuvolaAudioScrobblerClass * klass) {
	nuvola_audio_scrobbler_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaAudioScrobblerPrivate));
	((NuvolaAudioScrobblerClass *) klass)->get_settings = (GtkWidget* (*)(NuvolaAudioScrobbler*, DrtApplication*)) nuvola_audio_scrobbler_real_get_settings;
	((NuvolaAudioScrobblerClass *) klass)->scrobble_track = (void (*)(NuvolaAudioScrobbler*, const gchar*, const gchar*, const gchar*, gint64, GAsyncReadyCallback, gpointer)) nuvola_audio_scrobbler_real_scrobble_track;
	((NuvolaAudioScrobblerClass *) klass)->scrobble_track_finish = (void (*)(NuvolaAudioScrobbler*, GAsyncResult*, GError**)) nuvola_audio_scrobbler_real_scrobble_track_finish;
	((NuvolaAudioScrobblerClass *) klass)->update_now_playing = (void (*)(NuvolaAudioScrobbler*, const gchar*, const gchar*, GAsyncReadyCallback, gpointer)) nuvola_audio_scrobbler_real_update_now_playing;
	((NuvolaAudioScrobblerClass *) klass)->update_now_playing_finish = (void (*)(NuvolaAudioScrobbler*, GAsyncResult*, GError**)) nuvola_audio_scrobbler_real_update_now_playing_finish;
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_audio_scrobbler_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_audio_scrobbler_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_audio_scrobbler_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_AUDIO_SCROBBLER_ID, g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_AUDIO_SCROBBLER_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_AUDIO_SCROBBLER_HAS_SETTINGS, g_param_spec_boolean ("has-settings", "has-settings", "has-settings", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_AUDIO_SCROBBLER_SCROBBLING_ENABLED, g_param_spec_boolean ("scrobbling-enabled", "scrobbling-enabled", "scrobbling-enabled", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_AUDIO_SCROBBLER_CAN_SCROBBLE, g_param_spec_boolean ("can-scrobble", "can-scrobble", "can-scrobble", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_AUDIO_SCROBBLER_CAN_UPDATE_NOW_PLAYING, g_param_spec_boolean ("can-update-now-playing", "can-update-now-playing", "can-update-now-playing", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void nuvola_audio_scrobbler_instance_init (NuvolaAudioScrobbler * self) {
	self->priv = NUVOLA_AUDIO_SCROBBLER_GET_PRIVATE (self);
	self->priv->_has_settings = FALSE;
	self->priv->_scrobbling_enabled = FALSE;
	self->priv->_can_scrobble = FALSE;
	self->priv->_can_update_now_playing = FALSE;
}


static void nuvola_audio_scrobbler_finalize (GObject* obj) {
	NuvolaAudioScrobbler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_AUDIO_SCROBBLER, NuvolaAudioScrobbler);
	_g_free0 (self->priv->_id);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (nuvola_audio_scrobbler_parent_class)->finalize (obj);
}


GType nuvola_audio_scrobbler_get_type (void) {
	static volatile gsize nuvola_audio_scrobbler_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_audio_scrobbler_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaAudioScrobblerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_audio_scrobbler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaAudioScrobbler), 0, (GInstanceInitFunc) nuvola_audio_scrobbler_instance_init, NULL };
		GType nuvola_audio_scrobbler_type_id;
		nuvola_audio_scrobbler_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaAudioScrobbler", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&nuvola_audio_scrobbler_type_id__volatile, nuvola_audio_scrobbler_type_id);
	}
	return nuvola_audio_scrobbler_type_id__volatile;
}


static void _vala_nuvola_audio_scrobbler_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaAudioScrobbler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_AUDIO_SCROBBLER, NuvolaAudioScrobbler);
	switch (property_id) {
		case NUVOLA_AUDIO_SCROBBLER_ID:
		g_value_set_string (value, nuvola_audio_scrobbler_get_id (self));
		break;
		case NUVOLA_AUDIO_SCROBBLER_NAME:
		g_value_set_string (value, nuvola_audio_scrobbler_get_name (self));
		break;
		case NUVOLA_AUDIO_SCROBBLER_HAS_SETTINGS:
		g_value_set_boolean (value, nuvola_audio_scrobbler_get_has_settings (self));
		break;
		case NUVOLA_AUDIO_SCROBBLER_SCROBBLING_ENABLED:
		g_value_set_boolean (value, nuvola_audio_scrobbler_get_scrobbling_enabled (self));
		break;
		case NUVOLA_AUDIO_SCROBBLER_CAN_SCROBBLE:
		g_value_set_boolean (value, nuvola_audio_scrobbler_get_can_scrobble (self));
		break;
		case NUVOLA_AUDIO_SCROBBLER_CAN_UPDATE_NOW_PLAYING:
		g_value_set_boolean (value, nuvola_audio_scrobbler_get_can_update_now_playing (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_audio_scrobbler_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaAudioScrobbler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_AUDIO_SCROBBLER, NuvolaAudioScrobbler);
	switch (property_id) {
		case NUVOLA_AUDIO_SCROBBLER_ID:
		nuvola_audio_scrobbler_set_id (self, g_value_get_string (value));
		break;
		case NUVOLA_AUDIO_SCROBBLER_NAME:
		nuvola_audio_scrobbler_set_name (self, g_value_get_string (value));
		break;
		case NUVOLA_AUDIO_SCROBBLER_HAS_SETTINGS:
		nuvola_audio_scrobbler_set_has_settings (self, g_value_get_boolean (value));
		break;
		case NUVOLA_AUDIO_SCROBBLER_SCROBBLING_ENABLED:
		nuvola_audio_scrobbler_set_scrobbling_enabled (self, g_value_get_boolean (value));
		break;
		case NUVOLA_AUDIO_SCROBBLER_CAN_SCROBBLE:
		nuvola_audio_scrobbler_set_can_scrobble (self, g_value_get_boolean (value));
		break;
		case NUVOLA_AUDIO_SCROBBLER_CAN_UPDATE_NOW_PLAYING:
		nuvola_audio_scrobbler_set_can_update_now_playing (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



