/* Component.c generated by valac 0.34.9, the Vala compiler
 * generated from Component.vala, do not modify */

/*
 * Copyright 2014-2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_COMPONENT (nuvola_component_get_type ())
#define NUVOLA_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_COMPONENT, NuvolaComponent))
#define NUVOLA_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_COMPONENT, NuvolaComponentClass))
#define NUVOLA_IS_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_COMPONENT))
#define NUVOLA_IS_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_COMPONENT))
#define NUVOLA_COMPONENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_COMPONENT, NuvolaComponentClass))

typedef struct _NuvolaComponent NuvolaComponent;
typedef struct _NuvolaComponentClass NuvolaComponentClass;
typedef struct _NuvolaComponentPrivate NuvolaComponentPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NuvolaComponent {
	GObject parent_instance;
	NuvolaComponentPrivate * priv;
};

struct _NuvolaComponentClass {
	GObjectClass parent_class;
	void (*toggle) (NuvolaComponent* self, gboolean enabled);
	GtkWidget* (*get_settings) (NuvolaComponent* self);
	void (*load) (NuvolaComponent* self);
	void (*unload) (NuvolaComponent* self);
	gboolean (*activate) (NuvolaComponent* self);
	gboolean (*deactivate) (NuvolaComponent* self);
};

struct _NuvolaComponentPrivate {
	gchar* _id;
	gchar* _name;
	gchar* _description;
	gboolean _hidden;
	gboolean _enabled;
	gboolean _enabled_set;
	gboolean _active;
	gboolean _auto_activate;
	gboolean _has_settings;
};


static gpointer nuvola_component_parent_class = NULL;

GType nuvola_component_get_type (void) G_GNUC_CONST;
#define NUVOLA_COMPONENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_COMPONENT, NuvolaComponentPrivate))
enum  {
	NUVOLA_COMPONENT_DUMMY_PROPERTY,
	NUVOLA_COMPONENT_ID,
	NUVOLA_COMPONENT_NAME,
	NUVOLA_COMPONENT_DESCRIPTION,
	NUVOLA_COMPONENT_HIDDEN,
	NUVOLA_COMPONENT_ENABLED,
	NUVOLA_COMPONENT_ENABLED_SET,
	NUVOLA_COMPONENT_ACTIVE,
	NUVOLA_COMPONENT_AUTO_ACTIVATE,
	NUVOLA_COMPONENT_HAS_SETTINGS
};
NuvolaComponent* nuvola_component_construct (GType object_type, const gchar* id, const gchar* name, const gchar* description);
void nuvola_component_toggle (NuvolaComponent* self, gboolean enabled);
static void nuvola_component_real_toggle (NuvolaComponent* self, gboolean enabled);
gboolean nuvola_component_get_enabled (NuvolaComponent* self);
const gchar* nuvola_component_get_id (NuvolaComponent* self);
const gchar* nuvola_component_get_name (NuvolaComponent* self);
void nuvola_component_set_enabled (NuvolaComponent* self, gboolean value);
void nuvola_component_load (NuvolaComponent* self);
void nuvola_component_unload (NuvolaComponent* self);
void nuvola_component_set_active (NuvolaComponent* self, gboolean value);
GtkWidget* nuvola_component_get_settings (NuvolaComponent* self);
static GtkWidget* nuvola_component_real_get_settings (NuvolaComponent* self);
static void nuvola_component_real_load (NuvolaComponent* self);
gboolean nuvola_component_get_auto_activate (NuvolaComponent* self);
gboolean nuvola_component_toggle_active (NuvolaComponent* self, gboolean active);
static void nuvola_component_real_unload (NuvolaComponent* self);
gboolean nuvola_component_get_active (NuvolaComponent* self);
gboolean nuvola_component_activate (NuvolaComponent* self);
gboolean nuvola_component_deactivate (NuvolaComponent* self);
static gboolean nuvola_component_real_activate (NuvolaComponent* self);
static gboolean nuvola_component_real_deactivate (NuvolaComponent* self);
static void nuvola_component_set_id (NuvolaComponent* self, const gchar* value);
static void nuvola_component_set_name (NuvolaComponent* self, const gchar* value);
const gchar* nuvola_component_get_description (NuvolaComponent* self);
static void nuvola_component_set_description (NuvolaComponent* self, const gchar* value);
gboolean nuvola_component_get_hidden (NuvolaComponent* self);
void nuvola_component_set_hidden (NuvolaComponent* self, gboolean value);
gboolean nuvola_component_get_enabled_set (NuvolaComponent* self);
void nuvola_component_set_enabled_set (NuvolaComponent* self, gboolean value);
void nuvola_component_set_auto_activate (NuvolaComponent* self, gboolean value);
gboolean nuvola_component_get_has_settings (NuvolaComponent* self);
void nuvola_component_set_has_settings (NuvolaComponent* self, gboolean value);
static void nuvola_component_finalize (GObject* obj);
static void _vala_nuvola_component_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_component_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


NuvolaComponent* nuvola_component_construct (GType object_type, const gchar* id, const gchar* name, const gchar* description) {
	NuvolaComponent * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (description != NULL, NULL);
	_tmp0_ = id;
	_tmp1_ = name;
	_tmp2_ = description;
	self = (NuvolaComponent*) g_object_new (object_type, "id", _tmp0_, "name", _tmp1_, "description", _tmp2_, NULL);
	return self;
}


static void nuvola_component_real_toggle (NuvolaComponent* self, gboolean enabled) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	_tmp0_ = self->priv->_enabled;
	_tmp1_ = enabled;
	if (_tmp0_ != _tmp1_) {
		gboolean _tmp2_ = FALSE;
		_tmp2_ = enabled;
		if (_tmp2_) {
			const gchar* _tmp3_ = NULL;
			const gchar* _tmp4_ = NULL;
			_tmp3_ = self->priv->_id;
			_tmp4_ = self->priv->_name;
			g_message ("Component.vala:54: Load %s %s", _tmp3_, _tmp4_);
			nuvola_component_set_enabled (self, TRUE);
			nuvola_component_load (self);
		} else {
			const gchar* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			_tmp5_ = self->priv->_id;
			_tmp6_ = self->priv->_name;
			g_message ("Component.vala:60: Unload %s %s", _tmp5_, _tmp6_);
			nuvola_component_unload (self);
			nuvola_component_set_enabled (self, FALSE);
			nuvola_component_set_active (self, FALSE);
		}
	}
}


void nuvola_component_toggle (NuvolaComponent* self, gboolean enabled) {
	g_return_if_fail (self != NULL);
	NUVOLA_COMPONENT_GET_CLASS (self)->toggle (self, enabled);
}


static GtkWidget* nuvola_component_real_get_settings (NuvolaComponent* self) {
	GtkWidget* result = NULL;
	result = NULL;
	return result;
}


GtkWidget* nuvola_component_get_settings (NuvolaComponent* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return NUVOLA_COMPONENT_GET_CLASS (self)->get_settings (self);
}


static void nuvola_component_real_load (NuvolaComponent* self) {
	gboolean _tmp0_ = FALSE;
	_tmp0_ = self->priv->_auto_activate;
	if (_tmp0_) {
		nuvola_component_toggle_active (self, TRUE);
	}
}


void nuvola_component_load (NuvolaComponent* self) {
	g_return_if_fail (self != NULL);
	NUVOLA_COMPONENT_GET_CLASS (self)->load (self);
}


static void nuvola_component_real_unload (NuvolaComponent* self) {
	nuvola_component_toggle_active (self, FALSE);
}


void nuvola_component_unload (NuvolaComponent* self) {
	g_return_if_fail (self != NULL);
	NUVOLA_COMPONENT_GET_CLASS (self)->unload (self);
}


gboolean nuvola_component_toggle_active (NuvolaComponent* self, gboolean active) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _result_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp16_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_enabled;
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	_result_ = FALSE;
	_tmp1_ = self->priv->_active;
	_tmp2_ = active;
	if (_tmp1_ != _tmp2_) {
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp11_ = FALSE;
		_tmp4_ = active;
		if (_tmp4_) {
			_tmp3_ = "Activate";
		} else {
			_tmp3_ = "Deactivate";
		}
		_tmp5_ = self->priv->_id;
		_tmp6_ = self->priv->_name;
		g_message ("Component.vala:91: %s: %s %s", _tmp3_, _tmp5_, _tmp6_);
		_tmp8_ = active;
		if (_tmp8_) {
			gboolean _tmp9_ = FALSE;
			_tmp9_ = nuvola_component_activate (self);
			_tmp7_ = _tmp9_;
		} else {
			gboolean _tmp10_ = FALSE;
			_tmp10_ = nuvola_component_deactivate (self);
			_tmp7_ = _tmp10_;
		}
		_result_ = _tmp7_;
		_tmp11_ = _result_;
		if (!_tmp11_) {
			const gchar* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			const gchar* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			_tmp13_ = active;
			if (_tmp13_) {
				_tmp12_ = "activate";
			} else {
				_tmp12_ = "deactivate";
			}
			_tmp14_ = self->priv->_id;
			_tmp15_ = self->priv->_name;
			g_warning ("Component.vala:94: Failed to %s: %s %s", _tmp12_, _tmp14_, _tmp15_);
		}
	}
	_tmp16_ = _result_;
	if (_tmp16_) {
		gboolean _tmp17_ = FALSE;
		_tmp17_ = active;
		nuvola_component_set_active (self, _tmp17_);
	}
	result = _result_;
	return result;
}


static gboolean nuvola_component_real_activate (NuvolaComponent* self) {
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `nuvola_component_activate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}


gboolean nuvola_component_activate (NuvolaComponent* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_COMPONENT_GET_CLASS (self)->activate (self);
}


static gboolean nuvola_component_real_deactivate (NuvolaComponent* self) {
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `nuvola_component_deactivate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}


gboolean nuvola_component_deactivate (NuvolaComponent* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_COMPONENT_GET_CLASS (self)->deactivate (self);
}


const gchar* nuvola_component_get_id (NuvolaComponent* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_id;
	result = _tmp0_;
	return result;
}


static void nuvola_component_set_id (NuvolaComponent* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_id);
	self->priv->_id = _tmp1_;
	g_object_notify ((GObject *) self, "id");
}


const gchar* nuvola_component_get_name (NuvolaComponent* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


static void nuvola_component_set_name (NuvolaComponent* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


const gchar* nuvola_component_get_description (NuvolaComponent* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_description;
	result = _tmp0_;
	return result;
}


static void nuvola_component_set_description (NuvolaComponent* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_description);
	self->priv->_description = _tmp1_;
	g_object_notify ((GObject *) self, "description");
}


gboolean nuvola_component_get_hidden (NuvolaComponent* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_hidden;
	result = _tmp0_;
	return result;
}


void nuvola_component_set_hidden (NuvolaComponent* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_hidden = _tmp0_;
	g_object_notify ((GObject *) self, "hidden");
}


gboolean nuvola_component_get_enabled (NuvolaComponent* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_enabled;
	result = _tmp0_;
	return result;
}


void nuvola_component_set_enabled (NuvolaComponent* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_enabled = _tmp0_;
	g_object_notify ((GObject *) self, "enabled");
}


gboolean nuvola_component_get_enabled_set (NuvolaComponent* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_enabled_set;
	result = _tmp0_;
	return result;
}


void nuvola_component_set_enabled_set (NuvolaComponent* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_enabled_set = _tmp0_;
	g_object_notify ((GObject *) self, "enabled-set");
}


gboolean nuvola_component_get_active (NuvolaComponent* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_active;
	result = _tmp0_;
	return result;
}


void nuvola_component_set_active (NuvolaComponent* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_active = _tmp0_;
	g_object_notify ((GObject *) self, "active");
}


gboolean nuvola_component_get_auto_activate (NuvolaComponent* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_auto_activate;
	result = _tmp0_;
	return result;
}


void nuvola_component_set_auto_activate (NuvolaComponent* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_auto_activate = _tmp0_;
	g_object_notify ((GObject *) self, "auto-activate");
}


gboolean nuvola_component_get_has_settings (NuvolaComponent* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_has_settings;
	result = _tmp0_;
	return result;
}


void nuvola_component_set_has_settings (NuvolaComponent* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_has_settings = _tmp0_;
	g_object_notify ((GObject *) self, "has-settings");
}


static void nuvola_component_class_init (NuvolaComponentClass * klass) {
	nuvola_component_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaComponentPrivate));
	((NuvolaComponentClass *) klass)->toggle = (void (*)(NuvolaComponent*, gboolean)) nuvola_component_real_toggle;
	((NuvolaComponentClass *) klass)->get_settings = (GtkWidget* (*)(NuvolaComponent*)) nuvola_component_real_get_settings;
	((NuvolaComponentClass *) klass)->load = (void (*)(NuvolaComponent*)) nuvola_component_real_load;
	((NuvolaComponentClass *) klass)->unload = (void (*)(NuvolaComponent*)) nuvola_component_real_unload;
	((NuvolaComponentClass *) klass)->activate = (gboolean (*)(NuvolaComponent*)) nuvola_component_real_activate;
	((NuvolaComponentClass *) klass)->deactivate = (gboolean (*)(NuvolaComponent*)) nuvola_component_real_deactivate;
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_component_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_component_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_component_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_COMPONENT_ID, g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_COMPONENT_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_COMPONENT_DESCRIPTION, g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_COMPONENT_HIDDEN, g_param_spec_boolean ("hidden", "hidden", "hidden", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_COMPONENT_ENABLED, g_param_spec_boolean ("enabled", "enabled", "enabled", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_COMPONENT_ENABLED_SET, g_param_spec_boolean ("enabled-set", "enabled-set", "enabled-set", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_COMPONENT_ACTIVE, g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_COMPONENT_AUTO_ACTIVATE, g_param_spec_boolean ("auto-activate", "auto-activate", "auto-activate", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_COMPONENT_HAS_SETTINGS, g_param_spec_boolean ("has-settings", "has-settings", "has-settings", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void nuvola_component_instance_init (NuvolaComponent * self) {
	self->priv = NUVOLA_COMPONENT_GET_PRIVATE (self);
	self->priv->_hidden = FALSE;
	self->priv->_enabled = FALSE;
	self->priv->_enabled_set = FALSE;
	self->priv->_active = FALSE;
	self->priv->_auto_activate = TRUE;
	self->priv->_has_settings = FALSE;
}


static void nuvola_component_finalize (GObject* obj) {
	NuvolaComponent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_COMPONENT, NuvolaComponent);
	_g_free0 (self->priv->_id);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_description);
	G_OBJECT_CLASS (nuvola_component_parent_class)->finalize (obj);
}


/**
 * Component classes represent a particular component/feature.
 */
GType nuvola_component_get_type (void) {
	static volatile gsize nuvola_component_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_component_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaComponentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_component_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaComponent), 0, (GInstanceInitFunc) nuvola_component_instance_init, NULL };
		GType nuvola_component_type_id;
		nuvola_component_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaComponent", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&nuvola_component_type_id__volatile, nuvola_component_type_id);
	}
	return nuvola_component_type_id__volatile;
}


static void _vala_nuvola_component_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaComponent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_COMPONENT, NuvolaComponent);
	switch (property_id) {
		case NUVOLA_COMPONENT_ID:
		g_value_set_string (value, nuvola_component_get_id (self));
		break;
		case NUVOLA_COMPONENT_NAME:
		g_value_set_string (value, nuvola_component_get_name (self));
		break;
		case NUVOLA_COMPONENT_DESCRIPTION:
		g_value_set_string (value, nuvola_component_get_description (self));
		break;
		case NUVOLA_COMPONENT_HIDDEN:
		g_value_set_boolean (value, nuvola_component_get_hidden (self));
		break;
		case NUVOLA_COMPONENT_ENABLED:
		g_value_set_boolean (value, nuvola_component_get_enabled (self));
		break;
		case NUVOLA_COMPONENT_ENABLED_SET:
		g_value_set_boolean (value, nuvola_component_get_enabled_set (self));
		break;
		case NUVOLA_COMPONENT_ACTIVE:
		g_value_set_boolean (value, nuvola_component_get_active (self));
		break;
		case NUVOLA_COMPONENT_AUTO_ACTIVATE:
		g_value_set_boolean (value, nuvola_component_get_auto_activate (self));
		break;
		case NUVOLA_COMPONENT_HAS_SETTINGS:
		g_value_set_boolean (value, nuvola_component_get_has_settings (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_component_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaComponent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_COMPONENT, NuvolaComponent);
	switch (property_id) {
		case NUVOLA_COMPONENT_ID:
		nuvola_component_set_id (self, g_value_get_string (value));
		break;
		case NUVOLA_COMPONENT_NAME:
		nuvola_component_set_name (self, g_value_get_string (value));
		break;
		case NUVOLA_COMPONENT_DESCRIPTION:
		nuvola_component_set_description (self, g_value_get_string (value));
		break;
		case NUVOLA_COMPONENT_HIDDEN:
		nuvola_component_set_hidden (self, g_value_get_boolean (value));
		break;
		case NUVOLA_COMPONENT_ENABLED:
		nuvola_component_set_enabled (self, g_value_get_boolean (value));
		break;
		case NUVOLA_COMPONENT_ENABLED_SET:
		nuvola_component_set_enabled_set (self, g_value_get_boolean (value));
		break;
		case NUVOLA_COMPONENT_ACTIVE:
		nuvola_component_set_active (self, g_value_get_boolean (value));
		break;
		case NUVOLA_COMPONENT_AUTO_ACTIVATE:
		nuvola_component_set_auto_activate (self, g_value_get_boolean (value));
		break;
		case NUVOLA_COMPONENT_HAS_SETTINGS:
		nuvola_component_set_has_settings (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



