/* Connection.c generated by valac 0.34.9, the Vala compiler
 * generated from Connection.vala, do not modify */

/*
 * Copyright 2011-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <nuvolaruntime-base.h>
#include <dioriteglib4.h>


#define NUVOLA_TYPE_CONNECTION (nuvola_connection_get_type ())
#define NUVOLA_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_CONNECTION, NuvolaConnection))
#define NUVOLA_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_CONNECTION, NuvolaConnectionClass))
#define NUVOLA_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_CONNECTION))
#define NUVOLA_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_CONNECTION))
#define NUVOLA_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_CONNECTION, NuvolaConnectionClass))

typedef struct _NuvolaConnection NuvolaConnection;
typedef struct _NuvolaConnectionClass NuvolaConnectionClass;
typedef struct _NuvolaConnectionPrivate NuvolaConnectionPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define NUVOLA_TYPE_NETWORK_PROXY_TYPE (nuvola_network_proxy_type_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block9Data Block9Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NuvolaConnectionDownloadFileData NuvolaConnectionDownloadFileData;
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))

struct _NuvolaConnection {
	GObject parent_instance;
	NuvolaConnectionPrivate * priv;
};

struct _NuvolaConnectionClass {
	GObjectClass parent_class;
};

struct _NuvolaConnectionPrivate {
	SoupSession* _session;
	GFile* _cache_dir;
	gchar* _proxy_uri;
	NuvolaConfig* config;
};

typedef enum  {
	NUVOLA_NETWORK_PROXY_TYPE_SYSTEM,
	NUVOLA_NETWORK_PROXY_TYPE_DIRECT,
	NUVOLA_NETWORK_PROXY_TYPE_HTTP,
	NUVOLA_NETWORK_PROXY_TYPE_SOCKS
} NuvolaNetworkProxyType;

struct _Block9Data {
	int _ref_count_;
	NuvolaConnection* self;
	GSourceFunc resume;
	gpointer resume_target;
	GDestroyNotify resume_target_destroy_notify;
	gpointer _async_data_;
};

struct _NuvolaConnectionDownloadFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaConnection* self;
	gchar* uri;
	GFile* local_file;
	SoupMessage* msg;
	gboolean result;
	Block9Data* _data9_;
	const gchar* _tmp0_;
	SoupMessage* _tmp1_;
	SoupSession* _tmp2_;
	SoupMessage* _tmp3_;
	SoupMessage* _tmp4_;
	gboolean _tmp5_;
	SoupMessage* _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	SoupMessage* _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	SoupMessageBody* body;
	SoupMessage* _tmp12_;
	SoupMessageBody* _tmp13_;
	GFile* dir;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	gboolean _tmp17_;
	GFile* _tmp18_;
	GError* e;
	GError* _tmp19_;
	const gchar* _tmp20_;
	GFileOutputStream* stream;
	GFileOutputStream* _tmp21_;
	GFile* _tmp22_;
	GFileOutputStream* _tmp23_;
	GFileOutputStream* _tmp24_;
	GError* _vala1_e;
	GError* _tmp25_;
	const gchar* _tmp26_;
	GFileOutputStream* _tmp27_;
	SoupMessageBody* _tmp28_;
	guint8* _tmp29_;
	gint _tmp29__length1;
	GError* _vala2_e;
	GError* _tmp30_;
	const gchar* _tmp31_;
	GFileOutputStream* _tmp32_;
	GError* _vala3_e;
	GError* _tmp33_;
	const gchar* _tmp34_;
	GError * _inner_error_;
};


static gpointer nuvola_connection_parent_class = NULL;

GType nuvola_connection_get_type (void) G_GNUC_CONST;
#define NUVOLA_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_CONNECTION, NuvolaConnectionPrivate))
enum  {
	NUVOLA_CONNECTION_DUMMY_PROPERTY,
	NUVOLA_CONNECTION_SESSION,
	NUVOLA_CONNECTION_CACHE_DIR,
	NUVOLA_CONNECTION_PROXY_URI
};
#define NUVOLA_CONNECTION_PROXY_DIRECT "direct://"
#define NUVOLA_CONNECTION_PROXY_TYPE_CONF "webview.proxy.type"
#define NUVOLA_CONNECTION_PROXY_HOST_CONF "webview.proxy.host"
#define NUVOLA_CONNECTION_PROXY_PORT_CONF "webview.proxy.port"
NuvolaConnection* nuvola_connection_new (SoupSession* session, GFile* cache_dir, NuvolaConfig* config);
NuvolaConnection* nuvola_connection_construct (GType object_type, SoupSession* session, GFile* cache_dir, NuvolaConfig* config);
GType nuvola_network_proxy_type_get_type (void) G_GNUC_CONST;
gchar* nuvola_network_proxy_type_to_string (NuvolaNetworkProxyType self);
static GVariant* _variant_new44 (gchar* value);
static GVariant* _variant_new45 (const gchar* value);
static GVariant* _variant_new46 (gint value);
static void nuvola_connection_apply_network_proxy (NuvolaConnection* self);
static void nuvola_connection_download_file_data_free (gpointer _data);
void nuvola_connection_download_file (NuvolaConnection* self, const gchar* uri, GFile* local_file, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean nuvola_connection_download_file_finish (NuvolaConnection* self, GAsyncResult* _res_, SoupMessage** msg);
static gboolean nuvola_connection_download_file_co (NuvolaConnectionDownloadFileData* _data_);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gboolean _nuvola_connection_download_file_co_gsource_func (gpointer self);
SoupSession* nuvola_connection_get_session (NuvolaConnection* self);
static void __lambda4_ (Block9Data* _data9_, SoupSession* session, SoupMessage* msg);
static void ___lambda4__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self);
NuvolaNetworkProxyType nuvola_connection_get_network_proxy (NuvolaConnection* self, gchar** host, gint* port);
static void nuvola_connection_set_proxy_uri (NuvolaConnection* self, const gchar* value);
const gchar* nuvola_connection_get_proxy_uri (NuvolaConnection* self);
static void _vala_SoupURI_free (SoupURI* self);
void nuvola_connection_set_network_proxy (NuvolaConnection* self, NuvolaNetworkProxyType type, const gchar* server, gint port);
NuvolaNetworkProxyType nuvola_network_proxy_type_from_string (const gchar* type);
void nuvola_connection_set_session (NuvolaConnection* self, SoupSession* value);
GFile* nuvola_connection_get_cache_dir (NuvolaConnection* self);
void nuvola_connection_set_cache_dir (NuvolaConnection* self, GFile* value);
static void nuvola_connection_finalize (GObject* obj);
static void _vala_nuvola_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GVariant* _variant_new44 (gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new45 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new46 (gint value) {
	return g_variant_ref_sink (g_variant_new_int32 (value));
}


NuvolaConnection* nuvola_connection_construct (GType object_type, SoupSession* session, GFile* cache_dir, NuvolaConfig* config) {
	NuvolaConnection * self = NULL;
	SoupSession* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	NuvolaConfig* _tmp2_ = NULL;
	NuvolaConfig* _tmp3_ = NULL;
	NuvolaConfig* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GVariant* _tmp7_ = NULL;
	NuvolaConfig* _tmp8_ = NULL;
	GVariant* _tmp9_ = NULL;
	NuvolaConfig* _tmp10_ = NULL;
	GVariant* _tmp11_ = NULL;
	g_return_val_if_fail (session != NULL, NULL);
	g_return_val_if_fail (cache_dir != NULL, NULL);
	g_return_val_if_fail (config != NULL, NULL);
	_tmp0_ = session;
	_tmp1_ = cache_dir;
	self = (NuvolaConnection*) g_object_new (object_type, "session", _tmp0_, "cache-dir", _tmp1_, NULL);
	_tmp2_ = config;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->config);
	self->priv->config = _tmp3_;
	_tmp4_ = config;
	_tmp5_ = nuvola_network_proxy_type_to_string (NUVOLA_NETWORK_PROXY_TYPE_SYSTEM);
	_tmp6_ = _tmp5_;
	_tmp7_ = _variant_new44 (_tmp6_);
	drt_key_value_storage_set_default_value ((DrtKeyValueStorage*) _tmp4_, NUVOLA_CONNECTION_PROXY_TYPE_CONF, _tmp7_);
	_g_variant_unref0 (_tmp7_);
	_g_free0 (_tmp6_);
	_tmp8_ = config;
	_tmp9_ = _variant_new45 ("");
	drt_key_value_storage_set_default_value ((DrtKeyValueStorage*) _tmp8_, NUVOLA_CONNECTION_PROXY_HOST_CONF, _tmp9_);
	_g_variant_unref0 (_tmp9_);
	_tmp10_ = config;
	_tmp11_ = _variant_new46 (0);
	drt_key_value_storage_set_default_value ((DrtKeyValueStorage*) _tmp10_, NUVOLA_CONNECTION_PROXY_PORT_CONF, _tmp11_);
	_g_variant_unref0 (_tmp11_);
	nuvola_connection_apply_network_proxy (self);
	return self;
}


NuvolaConnection* nuvola_connection_new (SoupSession* session, GFile* cache_dir, NuvolaConfig* config) {
	return nuvola_connection_construct (NUVOLA_TYPE_CONNECTION, session, cache_dir, config);
}


static void nuvola_connection_download_file_data_free (gpointer _data) {
	NuvolaConnectionDownloadFileData* _data_;
	_data_ = _data;
	_g_free0 (_data_->uri);
	_g_object_unref0 (_data_->local_file);
	_g_object_unref0 (_data_->self);
	g_slice_free (NuvolaConnectionDownloadFileData, _data_);
}


void nuvola_connection_download_file (NuvolaConnection* self, const gchar* uri, GFile* local_file, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaConnectionDownloadFileData* _data_;
	NuvolaConnection* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	_data_ = g_slice_new0 (NuvolaConnectionDownloadFileData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, nuvola_connection_download_file);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_connection_download_file_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = uri;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->uri);
	_data_->uri = _tmp2_;
	_tmp3_ = local_file;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (_data_->local_file);
	_data_->local_file = _tmp4_;
	nuvola_connection_download_file_co (_data_);
}


gboolean nuvola_connection_download_file_finish (NuvolaConnection* self, GAsyncResult* _res_, SoupMessage** msg) {
	gboolean result;
	NuvolaConnectionDownloadFileData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	if (msg) {
		*msg = _data_->msg;
	} else {
		_g_object_unref0 (_data_->msg);
	}
	_data_->msg = NULL;
	result = _data_->result;
	return result;
}


static Block9Data* block9_data_ref (Block9Data* _data9_) {
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}


static void block9_data_unref (void * _userdata_) {
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		NuvolaConnection* self;
		self = _data9_->self;
		(_data9_->resume_target_destroy_notify == NULL) ? NULL : (_data9_->resume_target_destroy_notify (_data9_->resume_target), NULL);
		_data9_->resume = NULL;
		_data9_->resume_target = NULL;
		_data9_->resume_target_destroy_notify = NULL;
		_g_object_unref0 (self);
		g_slice_free (Block9Data, _data9_);
	}
}


static gboolean _nuvola_connection_download_file_co_gsource_func (gpointer self) {
	gboolean result;
	result = nuvola_connection_download_file_co (self);
	return result;
}


static void __lambda4_ (Block9Data* _data9_, SoupSession* session, SoupMessage* msg) {
	NuvolaConnection* self;
	GSourceFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	self = _data9_->self;
	g_return_if_fail (session != NULL);
	g_return_if_fail (msg != NULL);
	_tmp0_ = _data9_->resume;
	_tmp0__target = _data9_->resume_target;
	_tmp0_ (_tmp0__target);
}


static void ___lambda4__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self) {
	__lambda4_ (self, session, msg);
	block9_data_unref (self);
}


static gboolean nuvola_connection_download_file_co (NuvolaConnectionDownloadFileData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data9_ = g_slice_new0 (Block9Data);
	_data_->_data9_->_ref_count_ = 1;
	_data_->_data9_->self = g_object_ref (_data_->self);
	_data_->_data9_->_async_data_ = _data_;
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->uri;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = soup_message_new ("GET", _data_->_tmp0_);
	_g_object_unref0 (_data_->msg);
	_data_->msg = _data_->_tmp1_;
	_data_->_data9_->resume = _nuvola_connection_download_file_co_gsource_func;
	_data_->_data9_->resume_target = _data_;
	_data_->_data9_->resume_target_destroy_notify = NULL;
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = _data_->self->priv->_session;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = _data_->msg;
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _g_object_ref0 (_data_->_tmp3_);
	soup_session_queue_message (_data_->_tmp2_, _data_->_tmp4_, ___lambda4__soup_session_callback, block9_data_ref (_data_->_data9_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp6_ = NULL;
	_data_->_tmp6_ = _data_->msg;
	_data_->_tmp7_ = 0U;
	g_object_get (_data_->_tmp6_, "status-code", &_data_->_tmp7_, NULL);
	_data_->_tmp8_ = 0U;
	_data_->_tmp8_ = _data_->_tmp7_;
	if (_data_->_tmp8_ < ((guint) 200)) {
		_data_->_tmp9_ = NULL;
		_data_->_tmp9_ = _data_->msg;
		_data_->_tmp10_ = 0U;
		g_object_get (_data_->_tmp9_, "status-code", &_data_->_tmp10_, NULL);
		_data_->_tmp11_ = 0U;
		_data_->_tmp11_ = _data_->_tmp10_;
		_data_->_tmp5_ = _data_->_tmp11_ >= ((guint) 300);
	} else {
		_data_->_tmp5_ = FALSE;
	}
	if (_data_->_tmp5_) {
		_data_->result = FALSE;
		block9_data_unref (_data_->_data9_);
		_data_->_data9_ = NULL;
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp12_ = NULL;
	_data_->_tmp12_ = _data_->msg;
	_data_->_tmp13_ = NULL;
	_data_->_tmp13_ = _data_->_tmp12_->response_body;
	_data_->body = _data_->_tmp13_;
	_data_->_tmp14_ = NULL;
	_data_->_tmp14_ = _data_->local_file;
	_data_->_tmp15_ = NULL;
	_data_->_tmp15_ = g_file_get_parent (_data_->_tmp14_);
	_data_->dir = _data_->_tmp15_;
	_data_->_tmp16_ = NULL;
	_data_->_tmp16_ = _data_->dir;
	_data_->_tmp17_ = FALSE;
	_data_->_tmp17_ = g_file_query_exists (_data_->_tmp16_, NULL);
	if (!_data_->_tmp17_) {
		{
			_data_->_tmp18_ = NULL;
			_data_->_tmp18_ = _data_->dir;
			g_file_make_directory_with_parents (_data_->_tmp18_, NULL, &_data_->_inner_error_);
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
				goto __catch86_g_error;
			}
		}
		goto __finally86;
		__catch86_g_error:
		{
			_data_->e = _data_->_inner_error_;
			_data_->_inner_error_ = NULL;
			_data_->_tmp19_ = NULL;
			_data_->_tmp19_ = _data_->e;
			_data_->_tmp20_ = NULL;
			_data_->_tmp20_ = _data_->_tmp19_->message;
			g_critical ("Connection.vala:70: Unable to create directory: %s", _data_->_tmp20_);
			_g_error_free0 (_data_->e);
		}
		__finally86:
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			_g_object_unref0 (_data_->dir);
			block9_data_unref (_data_->_data9_);
			_data_->_data9_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	{
		_data_->_tmp22_ = NULL;
		_data_->_tmp22_ = _data_->local_file;
		_data_->_tmp23_ = NULL;
		_data_->_tmp23_ = g_file_replace (_data_->_tmp22_, NULL, FALSE, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_data_->_inner_error_);
		_data_->_tmp21_ = _data_->_tmp23_;
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			goto __catch87_g_error;
		}
		_data_->_tmp24_ = NULL;
		_data_->_tmp24_ = _data_->_tmp21_;
		_data_->_tmp21_ = NULL;
		_g_object_unref0 (_data_->stream);
		_data_->stream = _data_->_tmp24_;
		_g_object_unref0 (_data_->_tmp21_);
	}
	goto __finally87;
	__catch87_g_error:
	{
		_data_->_vala1_e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp25_ = NULL;
		_data_->_tmp25_ = _data_->_vala1_e;
		_data_->_tmp26_ = NULL;
		_data_->_tmp26_ = _data_->_tmp25_->message;
		g_critical ("Connection.vala:81: Unable to create local file: %s", _data_->_tmp26_);
		_data_->result = FALSE;
		_g_error_free0 (_data_->_vala1_e);
		_g_object_unref0 (_data_->stream);
		_g_object_unref0 (_data_->dir);
		block9_data_unref (_data_->_data9_);
		_data_->_data9_ = NULL;
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally87:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		_g_object_unref0 (_data_->stream);
		_g_object_unref0 (_data_->dir);
		block9_data_unref (_data_->_data9_);
		_data_->_data9_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	{
		_data_->_tmp27_ = NULL;
		_data_->_tmp27_ = _data_->stream;
		_data_->_tmp28_ = NULL;
		_data_->_tmp28_ = _data_->body;
		_data_->_tmp29_ = NULL;
		_data_->_tmp29__length1 = 0;
		_data_->_tmp29_ = _data_->_tmp28_->data;
		_data_->_tmp29__length1 = (gint) _data_->_tmp28_->length;
		g_output_stream_write_all ((GOutputStream*) _data_->_tmp27_, _data_->_tmp29_, (gsize) _data_->_tmp29__length1, NULL, NULL, &_data_->_inner_error_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			if (_data_->_inner_error_->domain == G_IO_ERROR) {
				goto __catch88_g_io_error;
			}
			_g_object_unref0 (_data_->stream);
			_g_object_unref0 (_data_->dir);
			block9_data_unref (_data_->_data9_);
			_data_->_data9_ = NULL;
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	goto __finally88;
	__catch88_g_io_error:
	{
		_data_->_vala2_e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp30_ = NULL;
		_data_->_tmp30_ = _data_->_vala2_e;
		_data_->_tmp31_ = NULL;
		_data_->_tmp31_ = _data_->_tmp30_->message;
		g_critical ("Connection.vala:91: Unable to store remote file: %s", _data_->_tmp31_);
		_data_->result = FALSE;
		_g_error_free0 (_data_->_vala2_e);
		_g_object_unref0 (_data_->stream);
		_g_object_unref0 (_data_->dir);
		block9_data_unref (_data_->_data9_);
		_data_->_data9_ = NULL;
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally88:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		_g_object_unref0 (_data_->stream);
		_g_object_unref0 (_data_->dir);
		block9_data_unref (_data_->_data9_);
		_data_->_data9_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	{
		_data_->_tmp32_ = NULL;
		_data_->_tmp32_ = _data_->stream;
		g_output_stream_close ((GOutputStream*) _data_->_tmp32_, NULL, &_data_->_inner_error_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			if (_data_->_inner_error_->domain == G_IO_ERROR) {
				goto __catch89_g_io_error;
			}
			_g_object_unref0 (_data_->stream);
			_g_object_unref0 (_data_->dir);
			block9_data_unref (_data_->_data9_);
			_data_->_data9_ = NULL;
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	goto __finally89;
	__catch89_g_io_error:
	{
		_data_->_vala3_e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp33_ = NULL;
		_data_->_tmp33_ = _data_->_vala3_e;
		_data_->_tmp34_ = NULL;
		_data_->_tmp34_ = _data_->_tmp33_->message;
		g_warning ("Connection.vala:100: Unable to close stream: %s", _data_->_tmp34_);
		_g_error_free0 (_data_->_vala3_e);
	}
	__finally89:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		_g_object_unref0 (_data_->stream);
		_g_object_unref0 (_data_->dir);
		block9_data_unref (_data_->_data9_);
		_data_->_data9_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = TRUE;
	_g_object_unref0 (_data_->stream);
	_g_object_unref0 (_data_->dir);
	block9_data_unref (_data_->_data9_);
	_data_->_data9_ = NULL;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
	_g_object_unref0 (_data_->stream);
	_g_object_unref0 (_data_->dir);
	block9_data_unref (_data_->_data9_);
	_data_->_data9_ = NULL;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void _vala_SoupURI_free (SoupURI* self) {
	g_boxed_free (soup_uri_get_type (), self);
}


static void nuvola_connection_apply_network_proxy (NuvolaConnection* self) {
	gchar* host = NULL;
	gint port = 0;
	NuvolaNetworkProxyType type = 0;
	gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	NuvolaNetworkProxyType _tmp2_ = 0;
	NuvolaNetworkProxyType _tmp3_ = 0;
	g_return_if_fail (self != NULL);
	_tmp2_ = nuvola_connection_get_network_proxy (self, &_tmp0_, &_tmp1_);
	_g_free0 (host);
	host = _tmp0_;
	port = _tmp1_;
	type = _tmp2_;
	_tmp3_ = type;
	if (_tmp3_ != NUVOLA_NETWORK_PROXY_TYPE_SYSTEM) {
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_ = NULL;
		NuvolaNetworkProxyType _tmp8_ = 0;
		const gchar* _tmp17_ = NULL;
		SoupSession* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		SoupURI* _tmp20_ = NULL;
		SoupURI* _tmp21_ = NULL;
		_tmp5_ = host;
		if (_tmp5_ == NULL) {
			_tmp4_ = TRUE;
		} else {
			const gchar* _tmp6_ = NULL;
			_tmp6_ = host;
			_tmp4_ = g_strcmp0 (_tmp6_, "") == 0;
		}
		if (_tmp4_) {
			gchar* _tmp7_ = NULL;
			_tmp7_ = g_strdup ("127.0.0.1");
			_g_free0 (host);
			host = _tmp7_;
		}
		_tmp8_ = type;
		switch (_tmp8_) {
			case NUVOLA_NETWORK_PROXY_TYPE_HTTP:
			{
				const gchar* _tmp9_ = NULL;
				gint _tmp10_ = 0;
				gchar* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
				_tmp9_ = host;
				_tmp10_ = port;
				_tmp11_ = g_strdup_printf ("http://%s:%d/", _tmp9_, _tmp10_);
				_tmp12_ = _tmp11_;
				nuvola_connection_set_proxy_uri (self, _tmp12_);
				_g_free0 (_tmp12_);
				break;
			}
			case NUVOLA_NETWORK_PROXY_TYPE_SOCKS:
			{
				const gchar* _tmp13_ = NULL;
				gint _tmp14_ = 0;
				gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				_tmp13_ = host;
				_tmp14_ = port;
				_tmp15_ = g_strdup_printf ("socks://%s:%d/", _tmp13_, _tmp14_);
				_tmp16_ = _tmp15_;
				nuvola_connection_set_proxy_uri (self, _tmp16_);
				_g_free0 (_tmp16_);
				break;
			}
			default:
			{
				nuvola_connection_set_proxy_uri (self, NUVOLA_CONNECTION_PROXY_DIRECT);
				break;
			}
		}
		_tmp17_ = self->priv->_proxy_uri;
		g_debug ("Connection.vala:126: Network Proxy: '%s'", _tmp17_);
		_tmp18_ = self->priv->_session;
		_tmp19_ = self->priv->_proxy_uri;
		_tmp20_ = soup_uri_new (_tmp19_);
		_tmp21_ = _tmp20_;
		g_object_set (_tmp18_, "proxy-uri", _tmp21_, NULL);
		__vala_SoupURI_free0 (_tmp21_);
	} else {
		SoupSession* _tmp22_ = NULL;
		g_debug ("Connection.vala:131: Network Proxy: system settings");
		nuvola_connection_set_proxy_uri (self, NULL);
		_tmp22_ = self->priv->_session;
		soup_session_add_feature_by_type (_tmp22_, soup_proxy_resolver_default_get_type ());
	}
	_g_free0 (host);
}


void nuvola_connection_set_network_proxy (NuvolaConnection* self, NuvolaNetworkProxyType type, const gchar* server, gint port) {
	NuvolaConfig* _tmp0_ = NULL;
	NuvolaNetworkProxyType _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	NuvolaConfig* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	NuvolaConfig* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->config;
	_tmp1_ = type;
	_tmp2_ = nuvola_network_proxy_type_to_string (_tmp1_);
	_tmp3_ = _tmp2_;
	drt_key_value_storage_set_string ((DrtKeyValueStorage*) _tmp0_, NUVOLA_CONNECTION_PROXY_TYPE_CONF, _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = self->priv->config;
	_tmp5_ = server;
	drt_key_value_storage_set_string ((DrtKeyValueStorage*) _tmp4_, NUVOLA_CONNECTION_PROXY_HOST_CONF, _tmp5_);
	_tmp6_ = self->priv->config;
	_tmp7_ = port;
	drt_key_value_storage_set_int64 ((DrtKeyValueStorage*) _tmp6_, NUVOLA_CONNECTION_PROXY_PORT_CONF, (gint64) _tmp7_);
	nuvola_connection_apply_network_proxy (self);
}


NuvolaNetworkProxyType nuvola_connection_get_network_proxy (NuvolaConnection* self, gchar** host, gint* port) {
	gchar* _vala_host = NULL;
	gint _vala_port = 0;
	NuvolaNetworkProxyType result = 0;
	NuvolaConfig* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	NuvolaConfig* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	NuvolaConfig* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	NuvolaNetworkProxyType _tmp7_ = 0;
	NuvolaNetworkProxyType _tmp8_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->config;
	_tmp1_ = drt_key_value_storage_get_string ((DrtKeyValueStorage*) _tmp0_, NUVOLA_CONNECTION_PROXY_HOST_CONF);
	_g_free0 (_vala_host);
	_vala_host = _tmp1_;
	_tmp2_ = self->priv->config;
	_tmp3_ = drt_key_value_storage_get_int64 ((DrtKeyValueStorage*) _tmp2_, NUVOLA_CONNECTION_PROXY_PORT_CONF);
	_vala_port = (gint) _tmp3_;
	_tmp4_ = self->priv->config;
	_tmp5_ = drt_key_value_storage_get_string ((DrtKeyValueStorage*) _tmp4_, NUVOLA_CONNECTION_PROXY_TYPE_CONF);
	_tmp6_ = _tmp5_;
	_tmp7_ = nuvola_network_proxy_type_from_string (_tmp6_);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	result = _tmp8_;
	if (host) {
		*host = _vala_host;
	} else {
		_g_free0 (_vala_host);
	}
	if (port) {
		*port = _vala_port;
	}
	return result;
}


SoupSession* nuvola_connection_get_session (NuvolaConnection* self) {
	SoupSession* result;
	SoupSession* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_session;
	result = _tmp0_;
	return result;
}


void nuvola_connection_set_session (NuvolaConnection* self, SoupSession* value) {
	SoupSession* _tmp0_ = NULL;
	SoupSession* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_session);
	self->priv->_session = _tmp1_;
	g_object_notify ((GObject *) self, "session");
}


GFile* nuvola_connection_get_cache_dir (NuvolaConnection* self) {
	GFile* result;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cache_dir;
	result = _tmp0_;
	return result;
}


void nuvola_connection_set_cache_dir (NuvolaConnection* self, GFile* value) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_cache_dir);
	self->priv->_cache_dir = _tmp1_;
	g_object_notify ((GObject *) self, "cache-dir");
}


const gchar* nuvola_connection_get_proxy_uri (NuvolaConnection* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_proxy_uri;
	result = _tmp0_;
	return result;
}


static void nuvola_connection_set_proxy_uri (NuvolaConnection* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_proxy_uri);
	self->priv->_proxy_uri = _tmp1_;
	g_object_notify ((GObject *) self, "proxy-uri");
}


static void nuvola_connection_class_init (NuvolaConnectionClass * klass) {
	nuvola_connection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaConnectionPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_connection_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_connection_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_connection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_CONNECTION_SESSION, g_param_spec_object ("session", "session", "session", soup_session_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_CONNECTION_CACHE_DIR, g_param_spec_object ("cache-dir", "cache-dir", "cache-dir", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_CONNECTION_PROXY_URI, g_param_spec_string ("proxy-uri", "proxy-uri", "proxy-uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void nuvola_connection_instance_init (NuvolaConnection * self) {
	self->priv = NUVOLA_CONNECTION_GET_PRIVATE (self);
	self->priv->_proxy_uri = NULL;
}


static void nuvola_connection_finalize (GObject* obj) {
	NuvolaConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_CONNECTION, NuvolaConnection);
	_g_object_unref0 (self->priv->_session);
	_g_object_unref0 (self->priv->_cache_dir);
	_g_free0 (self->priv->_proxy_uri);
	_g_object_unref0 (self->priv->config);
	G_OBJECT_CLASS (nuvola_connection_parent_class)->finalize (obj);
}


GType nuvola_connection_get_type (void) {
	static volatile gsize nuvola_connection_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaConnection), 0, (GInstanceInitFunc) nuvola_connection_instance_init, NULL };
		GType nuvola_connection_type_id;
		nuvola_connection_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaConnection", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_connection_type_id__volatile, nuvola_connection_type_id);
	}
	return nuvola_connection_type_id__volatile;
}


static void _vala_nuvola_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_CONNECTION, NuvolaConnection);
	switch (property_id) {
		case NUVOLA_CONNECTION_SESSION:
		g_value_set_object (value, nuvola_connection_get_session (self));
		break;
		case NUVOLA_CONNECTION_CACHE_DIR:
		g_value_set_object (value, nuvola_connection_get_cache_dir (self));
		break;
		case NUVOLA_CONNECTION_PROXY_URI:
		g_value_set_string (value, nuvola_connection_get_proxy_uri (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_CONNECTION, NuvolaConnection);
	switch (property_id) {
		case NUVOLA_CONNECTION_SESSION:
		nuvola_connection_set_session (self, g_value_get_object (value));
		break;
		case NUVOLA_CONNECTION_CACHE_DIR:
		nuvola_connection_set_cache_dir (self, g_value_get_object (value));
		break;
		case NUVOLA_CONNECTION_PROXY_URI:
		nuvola_connection_set_proxy_uri (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



