/* LyricsFetcher.c generated by valac 0.34.9, the Vala compiler
 * generated from LyricsFetcher.vala, do not modify */

/*
 * Copyright 2012-2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_LYRICS_FETCHER (nuvola_lyrics_fetcher_get_type ())
#define NUVOLA_LYRICS_FETCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_LYRICS_FETCHER, NuvolaLyricsFetcher))
#define NUVOLA_IS_LYRICS_FETCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_LYRICS_FETCHER))
#define NUVOLA_LYRICS_FETCHER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_LYRICS_FETCHER, NuvolaLyricsFetcherIface))

typedef struct _NuvolaLyricsFetcher NuvolaLyricsFetcher;
typedef struct _NuvolaLyricsFetcherIface NuvolaLyricsFetcherIface;

/**
 * Errors in lyrics fetching process
 */
typedef enum  {
	NUVOLA_LYRICS_ERROR_WRONG_ID,
	NUVOLA_LYRICS_ERROR_NOT_FOUND
} NuvolaLyricsError;
#define NUVOLA_LYRICS_ERROR nuvola_lyrics_error_quark ()
struct _NuvolaLyricsFetcherIface {
	GTypeInterface parent_iface;
	void (*fetch_lyrics) (NuvolaLyricsFetcher* self, const gchar* artist, const gchar* song, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gchar* (*fetch_lyrics_finish) (NuvolaLyricsFetcher* self, GAsyncResult* _res_, GError** error);
};



GQuark nuvola_lyrics_error_quark (void);
GType nuvola_lyrics_fetcher_get_type (void) G_GNUC_CONST;
void nuvola_lyrics_fetcher_fetch_lyrics (NuvolaLyricsFetcher* self, const gchar* artist, const gchar* song, GAsyncReadyCallback _callback_, gpointer _user_data_);
gchar* nuvola_lyrics_fetcher_fetch_lyrics_finish (NuvolaLyricsFetcher* self, GAsyncResult* _res_, GError** error);


GQuark nuvola_lyrics_error_quark (void) {
	return g_quark_from_static_string ("nuvola_lyrics_error-quark");
}


void nuvola_lyrics_fetcher_fetch_lyrics (NuvolaLyricsFetcher* self, const gchar* artist, const gchar* song, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NUVOLA_LYRICS_FETCHER_GET_INTERFACE (self)->fetch_lyrics (self, artist, song, _callback_, _user_data_);
}


gchar* nuvola_lyrics_fetcher_fetch_lyrics_finish (NuvolaLyricsFetcher* self, GAsyncResult* _res_, GError** error) {
	return NUVOLA_LYRICS_FETCHER_GET_INTERFACE (self)->fetch_lyrics_finish (self, _res_, error);
}


static void nuvola_lyrics_fetcher_base_init (NuvolaLyricsFetcherIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


/**
 * Interface for lyrics fetchers
 */
GType nuvola_lyrics_fetcher_get_type (void) {
	static volatile gsize nuvola_lyrics_fetcher_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_lyrics_fetcher_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaLyricsFetcherIface), (GBaseInitFunc) nuvola_lyrics_fetcher_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType nuvola_lyrics_fetcher_type_id;
		nuvola_lyrics_fetcher_type_id = g_type_register_static (G_TYPE_INTERFACE, "NuvolaLyricsFetcher", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (nuvola_lyrics_fetcher_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&nuvola_lyrics_fetcher_type_id__volatile, nuvola_lyrics_fetcher_type_id);
	}
	return nuvola_lyrics_fetcher_type_id__volatile;
}



