/* LyricsFetcherCache.c generated by valac 0.34.9, the Vala compiler
 * generated from LyricsFetcherCache.vala, do not modify */

/*
 * Copyright 2012-2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <dioriteglib4.h>


#define NUVOLA_TYPE_LYRICS_FETCHER (nuvola_lyrics_fetcher_get_type ())
#define NUVOLA_LYRICS_FETCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_LYRICS_FETCHER, NuvolaLyricsFetcher))
#define NUVOLA_IS_LYRICS_FETCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_LYRICS_FETCHER))
#define NUVOLA_LYRICS_FETCHER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_LYRICS_FETCHER, NuvolaLyricsFetcherIface))

typedef struct _NuvolaLyricsFetcher NuvolaLyricsFetcher;
typedef struct _NuvolaLyricsFetcherIface NuvolaLyricsFetcherIface;

#define NUVOLA_TYPE_LYRICS_FETCHER_CACHE (nuvola_lyrics_fetcher_cache_get_type ())
#define NUVOLA_LYRICS_FETCHER_CACHE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_LYRICS_FETCHER_CACHE, NuvolaLyricsFetcherCache))
#define NUVOLA_LYRICS_FETCHER_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_LYRICS_FETCHER_CACHE, NuvolaLyricsFetcherCacheClass))
#define NUVOLA_IS_LYRICS_FETCHER_CACHE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_LYRICS_FETCHER_CACHE))
#define NUVOLA_IS_LYRICS_FETCHER_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_LYRICS_FETCHER_CACHE))
#define NUVOLA_LYRICS_FETCHER_CACHE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_LYRICS_FETCHER_CACHE, NuvolaLyricsFetcherCacheClass))

typedef struct _NuvolaLyricsFetcherCache NuvolaLyricsFetcherCache;
typedef struct _NuvolaLyricsFetcherCacheClass NuvolaLyricsFetcherCacheClass;
typedef struct _NuvolaLyricsFetcherCachePrivate NuvolaLyricsFetcherCachePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NuvolaLyricsFetcherCacheFetchLyricsData NuvolaLyricsFetcherCacheFetchLyricsData;
typedef struct _NuvolaLyricsFetcherCacheStoreData NuvolaLyricsFetcherCacheStoreData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

typedef enum  {
	NUVOLA_LYRICS_ERROR_WRONG_ID,
	NUVOLA_LYRICS_ERROR_NOT_FOUND
} NuvolaLyricsError;
#define NUVOLA_LYRICS_ERROR nuvola_lyrics_error_quark ()
struct _NuvolaLyricsFetcherIface {
	GTypeInterface parent_iface;
	void (*fetch_lyrics) (NuvolaLyricsFetcher* self, const gchar* artist, const gchar* song, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gchar* (*fetch_lyrics_finish) (NuvolaLyricsFetcher* self, GAsyncResult* _res_, GError** error);
};

struct _NuvolaLyricsFetcherCache {
	GObject parent_instance;
	NuvolaLyricsFetcherCachePrivate * priv;
};

struct _NuvolaLyricsFetcherCacheClass {
	GObjectClass parent_class;
};

struct _NuvolaLyricsFetcherCachePrivate {
	GFile* _lyrics_cache;
};

struct _NuvolaLyricsFetcherCacheFetchLyricsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaLyricsFetcherCache* self;
	gchar* artist;
	gchar* song;
	gchar* result;
	gchar* fixed_artist;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* fixed_song;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gboolean _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GError* _tmp17_;
	GError* _tmp18_;
	GFile* cached;
	GFile* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GFile* _tmp24_;
	GFile* _tmp25_;
	guint8* contents;
	gint contents_length1;
	gint _contents_size_;
	GFile* _tmp26_;
	guint8* _tmp27_;
	gsize _tmp28_;
	gchar* lyrics;
	guint8* _tmp29_;
	gint _tmp29__length1;
	gboolean _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	GError* e;
	GError* _tmp33_;
	gint _tmp34_;
	GError* _tmp35_;
	gint _tmp36_;
	GError* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	GError* _tmp43_;
	GError* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	GError* _tmp49_;
	GError* _tmp50_;
	GError * _inner_error_;
};

struct _NuvolaLyricsFetcherCacheStoreData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaLyricsFetcherCache* self;
	gchar* artist;
	gchar* song;
	gchar* lyrics;
	gchar* fixed_artist;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* fixed_song;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gboolean _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GFile* cached_file;
	GFile* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	GFile* _tmp20_;
	const gchar* _tmp21_;
	GError* e;
	GError* _tmp22_;
	const gchar* _tmp23_;
	GError * _inner_error_;
};


static gpointer nuvola_lyrics_fetcher_cache_parent_class = NULL;
static NuvolaLyricsFetcherIface* nuvola_lyrics_fetcher_cache_nuvola_lyrics_fetcher_parent_iface = NULL;

GQuark nuvola_lyrics_error_quark (void);
GType nuvola_lyrics_fetcher_get_type (void) G_GNUC_CONST;
GType nuvola_lyrics_fetcher_cache_get_type (void) G_GNUC_CONST;
#define NUVOLA_LYRICS_FETCHER_CACHE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_LYRICS_FETCHER_CACHE, NuvolaLyricsFetcherCachePrivate))
enum  {
	NUVOLA_LYRICS_FETCHER_CACHE_DUMMY_PROPERTY,
	NUVOLA_LYRICS_FETCHER_CACHE_LYRICS_CACHE
};
#define NUVOLA_LYRICS_FETCHER_CACHE_FILE_FORMAT "%s/%s.txt"
NuvolaLyricsFetcherCache* nuvola_lyrics_fetcher_cache_new (GFile* lyrics_cache);
NuvolaLyricsFetcherCache* nuvola_lyrics_fetcher_cache_construct (GType object_type, GFile* lyrics_cache);
static void nuvola_lyrics_fetcher_cache_real_fetch_lyrics_data_free (gpointer _data);
static void nuvola_lyrics_fetcher_cache_real_fetch_lyrics (NuvolaLyricsFetcher* base, const gchar* artist, const gchar* song, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean nuvola_lyrics_fetcher_cache_real_fetch_lyrics_co (NuvolaLyricsFetcherCacheFetchLyricsData* _data_);
static gchar* nuvola_lyrics_fetcher_cache_escape_name (NuvolaLyricsFetcherCache* self, const gchar* name);
GFile* nuvola_lyrics_fetcher_cache_get_lyrics_cache (NuvolaLyricsFetcherCache* self);
static void nuvola_lyrics_fetcher_cache_fetch_lyrics_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void nuvola_lyrics_fetcher_cache_store_data_free (gpointer _data);
void nuvola_lyrics_fetcher_cache_store (NuvolaLyricsFetcherCache* self, const gchar* artist, const gchar* song, const gchar* lyrics, GAsyncReadyCallback _callback_, gpointer _user_data_);
void nuvola_lyrics_fetcher_cache_store_finish (NuvolaLyricsFetcherCache* self, GAsyncResult* _res_);
static gboolean nuvola_lyrics_fetcher_cache_store_co (NuvolaLyricsFetcherCacheStoreData* _data_);
static void nuvola_lyrics_fetcher_cache_store_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void nuvola_lyrics_fetcher_cache_set_lyrics_cache (NuvolaLyricsFetcherCache* self, GFile* value);
static void nuvola_lyrics_fetcher_cache_finalize (GObject* obj);
static void _vala_nuvola_lyrics_fetcher_cache_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_lyrics_fetcher_cache_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Creates new lyrics cache
 * 
 * @param storage    where to store lyrics
 */
NuvolaLyricsFetcherCache* nuvola_lyrics_fetcher_cache_construct (GType object_type, GFile* lyrics_cache) {
	NuvolaLyricsFetcherCache * self = NULL;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (lyrics_cache != NULL, NULL);
	_tmp0_ = lyrics_cache;
	self = (NuvolaLyricsFetcherCache*) g_object_new (object_type, "lyrics-cache", _tmp0_, NULL);
	return self;
}


NuvolaLyricsFetcherCache* nuvola_lyrics_fetcher_cache_new (GFile* lyrics_cache) {
	return nuvola_lyrics_fetcher_cache_construct (NUVOLA_TYPE_LYRICS_FETCHER_CACHE, lyrics_cache);
}


static void nuvola_lyrics_fetcher_cache_real_fetch_lyrics_data_free (gpointer _data) {
	NuvolaLyricsFetcherCacheFetchLyricsData* _data_;
	_data_ = _data;
	_g_free0 (_data_->artist);
	_g_free0 (_data_->song);
	_g_free0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (NuvolaLyricsFetcherCacheFetchLyricsData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void nuvola_lyrics_fetcher_cache_real_fetch_lyrics (NuvolaLyricsFetcher* base, const gchar* artist, const gchar* song, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaLyricsFetcherCache * self;
	NuvolaLyricsFetcherCacheFetchLyricsData* _data_;
	NuvolaLyricsFetcherCache* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	self = (NuvolaLyricsFetcherCache*) base;
	_data_ = g_slice_new0 (NuvolaLyricsFetcherCacheFetchLyricsData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, nuvola_lyrics_fetcher_cache_real_fetch_lyrics);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_lyrics_fetcher_cache_real_fetch_lyrics_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = artist;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->artist);
	_data_->artist = _tmp2_;
	_tmp3_ = song;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_data_->song);
	_data_->song = _tmp4_;
	nuvola_lyrics_fetcher_cache_real_fetch_lyrics_co (_data_);
}


static gchar* nuvola_lyrics_fetcher_cache_real_fetch_lyrics_finish (NuvolaLyricsFetcher* base, GAsyncResult* _res_, GError** error) {
	gchar* result;
	NuvolaLyricsFetcherCacheFetchLyricsData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return NULL;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	result = _data_->result;
	_data_->result = NULL;
	return result;
}


/**
 * {@inheritDoc}
 */
static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


static void nuvola_lyrics_fetcher_cache_fetch_lyrics_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NuvolaLyricsFetcherCacheFetchLyricsData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	nuvola_lyrics_fetcher_cache_real_fetch_lyrics_co (_data_);
}


static gboolean nuvola_lyrics_fetcher_cache_real_fetch_lyrics_co (NuvolaLyricsFetcherCacheFetchLyricsData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->artist;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = g_utf8_strdown (_data_->_tmp0_, (gssize) -1);
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = nuvola_lyrics_fetcher_cache_escape_name (_data_->self, _data_->_tmp2_);
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _data_->_tmp3_;
	_g_free0 (_data_->_tmp2_);
	_data_->fixed_artist = _data_->_tmp4_;
	_data_->_tmp5_ = NULL;
	_data_->_tmp5_ = _data_->song;
	_data_->_tmp6_ = NULL;
	_data_->_tmp6_ = g_utf8_strdown (_data_->_tmp5_, (gssize) -1);
	_data_->_tmp7_ = NULL;
	_data_->_tmp7_ = _data_->_tmp6_;
	_data_->_tmp8_ = NULL;
	_data_->_tmp8_ = nuvola_lyrics_fetcher_cache_escape_name (_data_->self, _data_->_tmp7_);
	_data_->_tmp9_ = NULL;
	_data_->_tmp9_ = _data_->_tmp8_;
	_g_free0 (_data_->_tmp7_);
	_data_->fixed_song = _data_->_tmp9_;
	_data_->_tmp11_ = NULL;
	_data_->_tmp11_ = _data_->fixed_artist;
	if (g_strcmp0 (_data_->_tmp11_, "") == 0) {
		_data_->_tmp10_ = TRUE;
	} else {
		_data_->_tmp12_ = NULL;
		_data_->_tmp12_ = _data_->fixed_song;
		_data_->_tmp10_ = g_strcmp0 (_data_->_tmp12_, "") == 0;
	}
	if (_data_->_tmp10_) {
		_data_->_tmp13_ = NULL;
		_data_->_tmp13_ = _data_->song;
		_data_->_tmp14_ = NULL;
		_data_->_tmp14_ = string_to_string (_data_->_tmp13_);
		_data_->_tmp15_ = NULL;
		_data_->_tmp15_ = g_strconcat ("Song ", _data_->_tmp14_, " was not found in cache", NULL);
		_data_->_tmp16_ = NULL;
		_data_->_tmp16_ = _data_->_tmp15_;
		_data_->_tmp17_ = NULL;
		_data_->_tmp17_ = g_error_new_literal (NUVOLA_LYRICS_ERROR, NUVOLA_LYRICS_ERROR_NOT_FOUND, _data_->_tmp16_);
		_data_->_tmp18_ = NULL;
		_data_->_tmp18_ = _data_->_tmp17_;
		_g_free0 (_data_->_tmp16_);
		_data_->_inner_error_ = _data_->_tmp18_;
		if (_data_->_inner_error_->domain == NUVOLA_LYRICS_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			_g_free0 (_data_->fixed_song);
			_g_free0 (_data_->fixed_artist);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_free0 (_data_->fixed_song);
			_g_free0 (_data_->fixed_artist);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp19_ = NULL;
	_data_->_tmp19_ = _data_->self->priv->_lyrics_cache;
	_data_->_tmp20_ = NULL;
	_data_->_tmp20_ = _data_->fixed_artist;
	_data_->_tmp21_ = NULL;
	_data_->_tmp21_ = _data_->fixed_song;
	_data_->_tmp22_ = NULL;
	_data_->_tmp22_ = g_strdup_printf (NUVOLA_LYRICS_FETCHER_CACHE_FILE_FORMAT, _data_->_tmp20_, _data_->_tmp21_);
	_data_->_tmp23_ = NULL;
	_data_->_tmp23_ = _data_->_tmp22_;
	_data_->_tmp24_ = NULL;
	_data_->_tmp24_ = g_file_get_child (_data_->_tmp19_, _data_->_tmp23_);
	_data_->_tmp25_ = NULL;
	_data_->_tmp25_ = _data_->_tmp24_;
	_g_free0 (_data_->_tmp23_);
	_data_->cached = _data_->_tmp25_;
	{
		_data_->contents_length1 = 0;
		_data_->_contents_size_ = 0;
		_data_->_tmp26_ = NULL;
		_data_->_tmp26_ = _data_->cached;
		_data_->_tmp27_ = NULL;
		memset (&_data_->_tmp28_, 0, sizeof (gsize));
		_data_->_state_ = 1;
		g_file_load_contents_async (_data_->_tmp26_, NULL, nuvola_lyrics_fetcher_cache_fetch_lyrics_ready, _data_);
		return FALSE;
		_state_1:
		g_file_load_contents_finish (_data_->_tmp26_, _data_->_res_, &_data_->_tmp27_, &_data_->_tmp28_, NULL, &_data_->_inner_error_);
		_data_->contents = (g_free (_data_->contents), NULL);
		_data_->contents = _data_->_tmp27_;
		_data_->contents_length1 = _data_->_tmp28_;
		_data_->_contents_size_ = _data_->contents_length1;
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			_data_->contents = (g_free (_data_->contents), NULL);
			goto __catch34_g_error;
		}
		_data_->_tmp29_ = NULL;
		_data_->_tmp29__length1 = 0;
		_data_->_tmp29_ = _data_->contents;
		_data_->_tmp29__length1 = _data_->contents_length1;
		_data_->contents = NULL;
		_data_->contents_length1 = 0;
		_data_->lyrics = (gchar*) _data_->_tmp29_;
		_data_->_tmp31_ = NULL;
		_data_->_tmp31_ = _data_->lyrics;
		if (_data_->_tmp31_ != NULL) {
			_data_->_tmp32_ = NULL;
			_data_->_tmp32_ = _data_->lyrics;
			_data_->_tmp30_ = g_strcmp0 (_data_->_tmp32_, "") != 0;
		} else {
			_data_->_tmp30_ = FALSE;
		}
		if (_data_->_tmp30_) {
			_data_->result = _data_->lyrics;
			_data_->contents = (g_free (_data_->contents), NULL);
			_g_object_unref0 (_data_->cached);
			_g_free0 (_data_->fixed_song);
			_g_free0 (_data_->fixed_artist);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_g_free0 (_data_->lyrics);
		_data_->contents = (g_free (_data_->contents), NULL);
	}
	goto __finally34;
	__catch34_g_error:
	{
		_data_->e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp33_ = NULL;
		_data_->_tmp33_ = _data_->e;
		_data_->_tmp34_ = 0;
		_data_->_tmp34_ = _data_->_tmp33_->code;
		if (_data_->_tmp34_ != 1) {
			_data_->_tmp35_ = NULL;
			_data_->_tmp35_ = _data_->e;
			_data_->_tmp36_ = 0;
			_data_->_tmp36_ = _data_->_tmp35_->code;
			_data_->_tmp37_ = NULL;
			_data_->_tmp37_ = _data_->e;
			_data_->_tmp38_ = NULL;
			_data_->_tmp38_ = _data_->_tmp37_->message;
			g_warning ("LyricsFetcherCache.vala:70: Unable to load cached lyrics: [%d] ]%s", _data_->_tmp36_, _data_->_tmp38_);
			_data_->_tmp39_ = NULL;
			_data_->_tmp39_ = _data_->song;
			_data_->_tmp40_ = NULL;
			_data_->_tmp40_ = string_to_string (_data_->_tmp39_);
			_data_->_tmp41_ = NULL;
			_data_->_tmp41_ = g_strconcat ("Unable to load song ", _data_->_tmp40_, " from cache", NULL);
			_data_->_tmp42_ = NULL;
			_data_->_tmp42_ = _data_->_tmp41_;
			_data_->_tmp43_ = NULL;
			_data_->_tmp43_ = g_error_new_literal (NUVOLA_LYRICS_ERROR, NUVOLA_LYRICS_ERROR_NOT_FOUND, _data_->_tmp42_);
			_data_->_tmp44_ = NULL;
			_data_->_tmp44_ = _data_->_tmp43_;
			_g_free0 (_data_->_tmp42_);
			_data_->_inner_error_ = _data_->_tmp44_;
			_g_error_free0 (_data_->e);
			goto __finally34;
		}
		_g_error_free0 (_data_->e);
	}
	__finally34:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == NUVOLA_LYRICS_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			_g_object_unref0 (_data_->cached);
			_g_free0 (_data_->fixed_song);
			_g_free0 (_data_->fixed_artist);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_object_unref0 (_data_->cached);
			_g_free0 (_data_->fixed_song);
			_g_free0 (_data_->fixed_artist);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp45_ = NULL;
	_data_->_tmp45_ = _data_->song;
	_data_->_tmp46_ = NULL;
	_data_->_tmp46_ = string_to_string (_data_->_tmp45_);
	_data_->_tmp47_ = NULL;
	_data_->_tmp47_ = g_strconcat ("Song ", _data_->_tmp46_, " was not found in cache", NULL);
	_data_->_tmp48_ = NULL;
	_data_->_tmp48_ = _data_->_tmp47_;
	_data_->_tmp49_ = NULL;
	_data_->_tmp49_ = g_error_new_literal (NUVOLA_LYRICS_ERROR, NUVOLA_LYRICS_ERROR_NOT_FOUND, _data_->_tmp48_);
	_data_->_tmp50_ = NULL;
	_data_->_tmp50_ = _data_->_tmp49_;
	_g_free0 (_data_->_tmp48_);
	_data_->_inner_error_ = _data_->_tmp50_;
	if (_data_->_inner_error_->domain == NUVOLA_LYRICS_ERROR) {
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
		g_error_free (_data_->_inner_error_);
		_g_object_unref0 (_data_->cached);
		_g_free0 (_data_->fixed_song);
		_g_free0 (_data_->fixed_artist);
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	} else {
		_g_object_unref0 (_data_->cached);
		_g_free0 (_data_->fixed_song);
		_g_free0 (_data_->fixed_artist);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_object_unref0 (_data_->cached);
	_g_free0 (_data_->fixed_song);
	_g_free0 (_data_->fixed_artist);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void nuvola_lyrics_fetcher_cache_store_data_free (gpointer _data) {
	NuvolaLyricsFetcherCacheStoreData* _data_;
	_data_ = _data;
	_g_free0 (_data_->artist);
	_g_free0 (_data_->song);
	_g_free0 (_data_->lyrics);
	_g_object_unref0 (_data_->self);
	g_slice_free (NuvolaLyricsFetcherCacheStoreData, _data_);
}


void nuvola_lyrics_fetcher_cache_store (NuvolaLyricsFetcherCache* self, const gchar* artist, const gchar* song, const gchar* lyrics, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaLyricsFetcherCacheStoreData* _data_;
	NuvolaLyricsFetcherCache* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	_data_ = g_slice_new0 (NuvolaLyricsFetcherCacheStoreData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, nuvola_lyrics_fetcher_cache_store);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_lyrics_fetcher_cache_store_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = artist;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->artist);
	_data_->artist = _tmp2_;
	_tmp3_ = song;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_data_->song);
	_data_->song = _tmp4_;
	_tmp5_ = lyrics;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (_data_->lyrics);
	_data_->lyrics = _tmp6_;
	nuvola_lyrics_fetcher_cache_store_co (_data_);
}


void nuvola_lyrics_fetcher_cache_store_finish (NuvolaLyricsFetcherCache* self, GAsyncResult* _res_) {
	NuvolaLyricsFetcherCacheStoreData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


/**
 * Store lyrics to cache.
 * 
 * @param artist    artist name
 * @param song      song name
 * @param lyrics    lyrics text
 */
static void nuvola_lyrics_fetcher_cache_store_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NuvolaLyricsFetcherCacheStoreData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	nuvola_lyrics_fetcher_cache_store_co (_data_);
}


static gboolean nuvola_lyrics_fetcher_cache_store_co (NuvolaLyricsFetcherCacheStoreData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->artist;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = g_utf8_strdown (_data_->_tmp0_, (gssize) -1);
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = nuvola_lyrics_fetcher_cache_escape_name (_data_->self, _data_->_tmp2_);
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _data_->_tmp3_;
	_g_free0 (_data_->_tmp2_);
	_data_->fixed_artist = _data_->_tmp4_;
	_data_->_tmp5_ = NULL;
	_data_->_tmp5_ = _data_->song;
	_data_->_tmp6_ = NULL;
	_data_->_tmp6_ = g_utf8_strdown (_data_->_tmp5_, (gssize) -1);
	_data_->_tmp7_ = NULL;
	_data_->_tmp7_ = _data_->_tmp6_;
	_data_->_tmp8_ = NULL;
	_data_->_tmp8_ = nuvola_lyrics_fetcher_cache_escape_name (_data_->self, _data_->_tmp7_);
	_data_->_tmp9_ = NULL;
	_data_->_tmp9_ = _data_->_tmp8_;
	_g_free0 (_data_->_tmp7_);
	_data_->fixed_song = _data_->_tmp9_;
	_data_->_tmp11_ = NULL;
	_data_->_tmp11_ = _data_->fixed_artist;
	if (g_strcmp0 (_data_->_tmp11_, "") == 0) {
		_data_->_tmp10_ = TRUE;
	} else {
		_data_->_tmp12_ = NULL;
		_data_->_tmp12_ = _data_->fixed_song;
		_data_->_tmp10_ = g_strcmp0 (_data_->_tmp12_, "") == 0;
	}
	if (_data_->_tmp10_) {
		_g_free0 (_data_->fixed_song);
		_g_free0 (_data_->fixed_artist);
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	{
		_data_->_tmp13_ = NULL;
		_data_->_tmp13_ = _data_->self->priv->_lyrics_cache;
		_data_->_tmp14_ = NULL;
		_data_->_tmp14_ = _data_->fixed_artist;
		_data_->_tmp15_ = NULL;
		_data_->_tmp15_ = _data_->fixed_song;
		_data_->_tmp16_ = NULL;
		_data_->_tmp16_ = g_strdup_printf (NUVOLA_LYRICS_FETCHER_CACHE_FILE_FORMAT, _data_->_tmp14_, _data_->_tmp15_);
		_data_->_tmp17_ = NULL;
		_data_->_tmp17_ = _data_->_tmp16_;
		_data_->_tmp18_ = NULL;
		_data_->_tmp18_ = g_file_get_child (_data_->_tmp13_, _data_->_tmp17_);
		_data_->_tmp19_ = NULL;
		_data_->_tmp19_ = _data_->_tmp18_;
		_g_free0 (_data_->_tmp17_);
		_data_->cached_file = _data_->_tmp19_;
		_data_->_tmp20_ = NULL;
		_data_->_tmp20_ = _data_->cached_file;
		_data_->_tmp21_ = NULL;
		_data_->_tmp21_ = _data_->lyrics;
		_data_->_state_ = 1;
		drt_system_overwrite_file_async (_data_->_tmp20_, _data_->_tmp21_, G_PRIORITY_DEFAULT, NULL, nuvola_lyrics_fetcher_cache_store_ready, _data_);
		return FALSE;
		_state_1:
		drt_system_overwrite_file_finish (_data_->_res_, &_data_->_inner_error_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			_g_object_unref0 (_data_->cached_file);
			goto __catch35_g_error;
		}
		_g_object_unref0 (_data_->cached_file);
	}
	goto __finally35;
	__catch35_g_error:
	{
		_data_->e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp22_ = NULL;
		_data_->_tmp22_ = _data_->e;
		_data_->_tmp23_ = NULL;
		_data_->_tmp23_ = _data_->_tmp22_->message;
		g_warning ("LyricsFetcherCache.vala:99: Unable to store lyrics: %s", _data_->_tmp23_);
		_g_error_free0 (_data_->e);
	}
	__finally35:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		_g_free0 (_data_->fixed_song);
		_g_free0 (_data_->fixed_artist);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_free0 (_data_->fixed_song);
	_g_free0 (_data_->fixed_artist);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


/**
 * Escapes name for safe usage in file names
 * 
 * @param name	string to escape
 * @return		escaped name
 */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch36_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch36_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally36;
	__catch36_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally36:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gchar* nuvola_lyrics_fetcher_cache_escape_name (NuvolaLyricsFetcherCache* self, const gchar* name) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	_tmp1_ = g_uri_escape_string (_tmp0_, " ", TRUE);
	_tmp2_ = _tmp1_;
	_tmp3_ = string_replace (_tmp2_, "%", ",");
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


GFile* nuvola_lyrics_fetcher_cache_get_lyrics_cache (NuvolaLyricsFetcherCache* self) {
	GFile* result;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_lyrics_cache;
	result = _tmp0_;
	return result;
}


void nuvola_lyrics_fetcher_cache_set_lyrics_cache (NuvolaLyricsFetcherCache* self, GFile* value) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_lyrics_cache);
	self->priv->_lyrics_cache = _tmp1_;
	g_object_notify ((GObject *) self, "lyrics-cache");
}


static void nuvola_lyrics_fetcher_cache_class_init (NuvolaLyricsFetcherCacheClass * klass) {
	nuvola_lyrics_fetcher_cache_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaLyricsFetcherCachePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_lyrics_fetcher_cache_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_lyrics_fetcher_cache_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_lyrics_fetcher_cache_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_LYRICS_FETCHER_CACHE_LYRICS_CACHE, g_param_spec_object ("lyrics-cache", "lyrics-cache", "lyrics-cache", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}


static void nuvola_lyrics_fetcher_cache_nuvola_lyrics_fetcher_interface_init (NuvolaLyricsFetcherIface * iface) {
	nuvola_lyrics_fetcher_cache_nuvola_lyrics_fetcher_parent_iface = g_type_interface_peek_parent (iface);
	iface->fetch_lyrics = (void (*)(NuvolaLyricsFetcher*, const gchar*, const gchar*, GAsyncReadyCallback, gpointer)) nuvola_lyrics_fetcher_cache_real_fetch_lyrics;
	iface->fetch_lyrics_finish = (gchar* (*)(NuvolaLyricsFetcher*, GAsyncResult*, GError**)) nuvola_lyrics_fetcher_cache_real_fetch_lyrics_finish;
}


static void nuvola_lyrics_fetcher_cache_instance_init (NuvolaLyricsFetcherCache * self) {
	self->priv = NUVOLA_LYRICS_FETCHER_CACHE_GET_PRIVATE (self);
}


static void nuvola_lyrics_fetcher_cache_finalize (GObject* obj) {
	NuvolaLyricsFetcherCache * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_LYRICS_FETCHER_CACHE, NuvolaLyricsFetcherCache);
	_g_object_unref0 (self->priv->_lyrics_cache);
	G_OBJECT_CLASS (nuvola_lyrics_fetcher_cache_parent_class)->finalize (obj);
}


/**
 * File-based cache for lyrics
 */
GType nuvola_lyrics_fetcher_cache_get_type (void) {
	static volatile gsize nuvola_lyrics_fetcher_cache_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_lyrics_fetcher_cache_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaLyricsFetcherCacheClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_lyrics_fetcher_cache_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaLyricsFetcherCache), 0, (GInstanceInitFunc) nuvola_lyrics_fetcher_cache_instance_init, NULL };
		static const GInterfaceInfo nuvola_lyrics_fetcher_info = { (GInterfaceInitFunc) nuvola_lyrics_fetcher_cache_nuvola_lyrics_fetcher_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType nuvola_lyrics_fetcher_cache_type_id;
		nuvola_lyrics_fetcher_cache_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaLyricsFetcherCache", &g_define_type_info, 0);
		g_type_add_interface_static (nuvola_lyrics_fetcher_cache_type_id, NUVOLA_TYPE_LYRICS_FETCHER, &nuvola_lyrics_fetcher_info);
		g_once_init_leave (&nuvola_lyrics_fetcher_cache_type_id__volatile, nuvola_lyrics_fetcher_cache_type_id);
	}
	return nuvola_lyrics_fetcher_cache_type_id__volatile;
}


static void _vala_nuvola_lyrics_fetcher_cache_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaLyricsFetcherCache * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_LYRICS_FETCHER_CACHE, NuvolaLyricsFetcherCache);
	switch (property_id) {
		case NUVOLA_LYRICS_FETCHER_CACHE_LYRICS_CACHE:
		g_value_set_object (value, nuvola_lyrics_fetcher_cache_get_lyrics_cache (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_lyrics_fetcher_cache_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaLyricsFetcherCache * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_LYRICS_FETCHER_CACHE, NuvolaLyricsFetcherCache);
	switch (property_id) {
		case NUVOLA_LYRICS_FETCHER_CACHE_LYRICS_CACHE:
		nuvola_lyrics_fetcher_cache_set_lyrics_cache (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



