/* MPRISPlayer.c generated by valac 0.34.9, the Vala compiler
 * generated from MPRISPlayer.vala, do not modify */

/*
 * Copyright 2014-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <nuvolaruntime-base.h>


#define NUVOLA_TYPE_MPRIS_PLAYER (nuvola_mpris_player_get_type ())
#define NUVOLA_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_MPRIS_PLAYER, NuvolaMPRISPlayer))
#define NUVOLA_MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_MPRIS_PLAYER, NuvolaMPRISPlayerClass))
#define NUVOLA_IS_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_MPRIS_PLAYER))
#define NUVOLA_IS_MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_MPRIS_PLAYER))
#define NUVOLA_MPRIS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_MPRIS_PLAYER, NuvolaMPRISPlayerClass))

typedef struct _NuvolaMPRISPlayer NuvolaMPRISPlayer;
typedef struct _NuvolaMPRISPlayerClass NuvolaMPRISPlayerClass;
typedef struct _NuvolaMPRISPlayerPrivate NuvolaMPRISPlayerPrivate;

#define NUVOLA_TYPE_MEDIA_PLAYER_MODEL (nuvola_media_player_model_get_type ())
#define NUVOLA_MEDIA_PLAYER_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_MEDIA_PLAYER_MODEL, NuvolaMediaPlayerModel))
#define NUVOLA_IS_MEDIA_PLAYER_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_MEDIA_PLAYER_MODEL))
#define NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_MEDIA_PLAYER_MODEL, NuvolaMediaPlayerModelIface))

typedef struct _NuvolaMediaPlayerModel NuvolaMediaPlayerModel;
typedef struct _NuvolaMediaPlayerModelIface NuvolaMediaPlayerModelIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

struct _NuvolaMPRISPlayer {
	GObject parent_instance;
	NuvolaMPRISPlayerPrivate * priv;
};

struct _NuvolaMPRISPlayerClass {
	GObjectClass parent_class;
};

struct _NuvolaMediaPlayerModelIface {
	GTypeInterface parent_iface;
	void (*handle_set_track_info) (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length);
	void (*play) (NuvolaMediaPlayerModel* self);
	void (*pause) (NuvolaMediaPlayerModel* self);
	void (*toggle_play) (NuvolaMediaPlayerModel* self);
	void (*stop) (NuvolaMediaPlayerModel* self);
	void (*prev_song) (NuvolaMediaPlayerModel* self);
	void (*next_song) (NuvolaMediaPlayerModel* self);
	void (*seek) (NuvolaMediaPlayerModel* self, gint64 position);
	void (*change_volume) (NuvolaMediaPlayerModel* self, gdouble volume);
	void (*set_track_info) (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length);
	const gchar* (*get_title) (NuvolaMediaPlayerModel* self);
	void (*set_title) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_artist) (NuvolaMediaPlayerModel* self);
	void (*set_artist) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_album) (NuvolaMediaPlayerModel* self);
	void (*set_album) (NuvolaMediaPlayerModel* self, const gchar* value);
	gdouble (*get_rating) (NuvolaMediaPlayerModel* self);
	void (*set_rating) (NuvolaMediaPlayerModel* self, gdouble value);
	const gchar* (*get_state) (NuvolaMediaPlayerModel* self);
	void (*set_state) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_artwork_location) (NuvolaMediaPlayerModel* self);
	void (*set_artwork_location) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_artwork_file) (NuvolaMediaPlayerModel* self);
	void (*set_artwork_file) (NuvolaMediaPlayerModel* self, const gchar* value);
	gint64 (*get_track_length) (NuvolaMediaPlayerModel* self);
	void (*set_track_length) (NuvolaMediaPlayerModel* self, gint64 value);
	gint64 (*get_track_position) (NuvolaMediaPlayerModel* self);
	void (*set_track_position) (NuvolaMediaPlayerModel* self, gint64 value);
	gdouble (*get_volume) (NuvolaMediaPlayerModel* self);
	void (*set_volume) (NuvolaMediaPlayerModel* self, gdouble value);
	gboolean (*get_can_go_next) (NuvolaMediaPlayerModel* self);
	void (*set_can_go_next) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_go_previous) (NuvolaMediaPlayerModel* self);
	void (*set_can_go_previous) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_play) (NuvolaMediaPlayerModel* self);
	void (*set_can_play) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_pause) (NuvolaMediaPlayerModel* self);
	void (*set_can_pause) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_stop) (NuvolaMediaPlayerModel* self);
	void (*set_can_stop) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_rate) (NuvolaMediaPlayerModel* self);
	void (*set_can_rate) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_seek) (NuvolaMediaPlayerModel* self);
	void (*set_can_seek) (NuvolaMediaPlayerModel* self, gboolean value);
	GSList* (*get_playback_actions) (NuvolaMediaPlayerModel* self);
	void (*set_playback_actions) (NuvolaMediaPlayerModel* self, GSList* value);
};

struct _NuvolaMPRISPlayerPrivate {
	GDBusConnection* conn;
	NuvolaMediaPlayerModel* player;
	GHashTable* pending_update;
	guint pending_update_id;
	gchar* _playback_status;
	gint64 _position;
	gboolean _can_go_next;
	gboolean _can_go_previous;
	gboolean _can_play;
	gboolean _can_pause;
	gboolean _can_seek;
	gboolean _nuvola_can_rate;
	GHashTable* _metadata;
	gdouble _volume;
};


static gpointer nuvola_mpris_player_parent_class = NULL;

GType nuvola_mpris_player_get_type (void) G_GNUC_CONST;
guint nuvola_mpris_player_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType nuvola_media_player_model_get_type (void) G_GNUC_CONST;
#define NUVOLA_MPRIS_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_MPRIS_PLAYER, NuvolaMPRISPlayerPrivate))
enum  {
	NUVOLA_MPRIS_PLAYER_DUMMY_PROPERTY,
	NUVOLA_MPRIS_PLAYER_PLAYBACK_STATUS,
	NUVOLA_MPRIS_PLAYER_RATE,
	NUVOLA_MPRIS_PLAYER_MINIMUM_RATE,
	NUVOLA_MPRIS_PLAYER_MAXIMUM_RATE,
	NUVOLA_MPRIS_PLAYER_POSITION,
	NUVOLA_MPRIS_PLAYER_CAN_GO_NEXT,
	NUVOLA_MPRIS_PLAYER_CAN_GO_PREVIOUS,
	NUVOLA_MPRIS_PLAYER_CAN_PLAY,
	NUVOLA_MPRIS_PLAYER_CAN_PAUSE,
	NUVOLA_MPRIS_PLAYER_CAN_SEEK,
	NUVOLA_MPRIS_PLAYER_CAN_CONTROL,
	NUVOLA_MPRIS_PLAYER_NUVOLA_CAN_RATE,
	NUVOLA_MPRIS_PLAYER_METADATA,
	NUVOLA_MPRIS_PLAYER_VOLUME
};
NuvolaMPRISPlayer* nuvola_mpris_player_new (NuvolaMediaPlayerModel* player, GDBusConnection* conn);
NuvolaMPRISPlayer* nuvola_mpris_player_construct (GType object_type, NuvolaMediaPlayerModel* player, GDBusConnection* conn);
static void __lambda21_ (NuvolaMPRISPlayer* self, GObject* o, GParamSpec* p);
static void nuvola_mpris_player_schedule_update (NuvolaMPRISPlayer* self, const gchar* param);
static void ___lambda21__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static GHashTable* nuvola_mpris_player_create_metadata (NuvolaMPRISPlayer* self);
static void nuvola_mpris_player_set_metadata (NuvolaMPRISPlayer* self, GHashTable* value);
gint64 nuvola_media_player_model_get_track_position (NuvolaMediaPlayerModel* self);
static void nuvola_mpris_player_set_position (NuvolaMPRISPlayer* self, gint64 value);
gdouble nuvola_media_player_model_get_volume (NuvolaMediaPlayerModel* self);
static gchar* nuvola_mpris_player_map_playback_state (NuvolaMPRISPlayer* self);
static void nuvola_mpris_player_set_playback_status (NuvolaMPRISPlayer* self, const gchar* value);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
gboolean nuvola_media_player_model_get_can_go_next (NuvolaMediaPlayerModel* self);
static void nuvola_mpris_player_set_can_go_next (NuvolaMPRISPlayer* self, gboolean value);
gboolean nuvola_media_player_model_get_can_go_previous (NuvolaMediaPlayerModel* self);
static void nuvola_mpris_player_set_can_go_previous (NuvolaMPRISPlayer* self, gboolean value);
gboolean nuvola_media_player_model_get_can_seek (NuvolaMediaPlayerModel* self);
static void nuvola_mpris_player_set_can_seek (NuvolaMPRISPlayer* self, gboolean value);
static gboolean nuvola_mpris_player_update_can_play (NuvolaMPRISPlayer* self);
static gboolean nuvola_mpris_player_update_can_pause (NuvolaMPRISPlayer* self);
void nuvola_mpris_player_next (NuvolaMPRISPlayer* self);
void nuvola_media_player_model_next_song (NuvolaMediaPlayerModel* self);
void nuvola_mpris_player_previous (NuvolaMPRISPlayer* self);
void nuvola_media_player_model_prev_song (NuvolaMediaPlayerModel* self);
void nuvola_mpris_player_pause (NuvolaMPRISPlayer* self);
void nuvola_media_player_model_pause (NuvolaMediaPlayerModel* self);
void nuvola_mpris_player_play_pause (NuvolaMPRISPlayer* self);
void nuvola_media_player_model_toggle_play (NuvolaMediaPlayerModel* self);
void nuvola_mpris_player_stop (NuvolaMPRISPlayer* self);
void nuvola_media_player_model_stop (NuvolaMediaPlayerModel* self);
void nuvola_mpris_player_play (NuvolaMPRISPlayer* self);
void nuvola_media_player_model_play (NuvolaMediaPlayerModel* self);
void nuvola_mpris_player_seek (NuvolaMPRISPlayer* self, gint64 offset);
gboolean nuvola_mpris_player_get_can_seek (NuvolaMPRISPlayer* self);
void nuvola_media_player_model_seek (NuvolaMediaPlayerModel* self, gint64 position);
void nuvola_mpris_player_SetPosition (NuvolaMPRISPlayer* self, const char* track_id, gint64 position);
void nuvola_mpris_player_open_uri (NuvolaMPRISPlayer* self, const gchar* uri);
void nuvola_mpris_player_nuvola_set_rating (NuvolaMPRISPlayer* self, gdouble rating);
GHashTable* nuvola_mpris_player_get_metadata (NuvolaMPRISPlayer* self);
static GVariant* _variant_new16 (GHashTable* value);
gint64 nuvola_mpris_player_get_position (NuvolaMPRISPlayer* self);
static GVariant* _variant_new17 (gint64 value);
static GVariant* _variant_new18 (gdouble value);
gboolean nuvola_mpris_player_get_can_play (NuvolaMPRISPlayer* self);
static GVariant* _variant_new19 (gboolean value);
gboolean nuvola_mpris_player_get_can_pause (NuvolaMPRISPlayer* self);
static GVariant* _variant_new20 (gboolean value);
const gchar* nuvola_mpris_player_get_playback_status (NuvolaMPRISPlayer* self);
static GVariant* _variant_new21 (const gchar* value);
gboolean nuvola_mpris_player_get_can_go_next (NuvolaMPRISPlayer* self);
static GVariant* _variant_new22 (gboolean value);
gboolean nuvola_mpris_player_get_can_go_previous (NuvolaMPRISPlayer* self);
static GVariant* _variant_new23 (gboolean value);
static GVariant* _variant_new24 (gboolean value);
static GVariant* _variant_new25 (gboolean value);
gboolean nuvola_mpris_player_get_nuvola_can_rate (NuvolaMPRISPlayer* self);
gboolean nuvola_media_player_model_get_can_rate (NuvolaMediaPlayerModel* self);
static void nuvola_mpris_player_set_nuvola_can_rate (NuvolaMPRISPlayer* self, gboolean value);
static GVariant* _variant_new26 (gboolean value);
static GVariant* _variant_new27 (gboolean value);
static gboolean nuvola_mpris_player_update_cb (NuvolaMPRISPlayer* self);
static gboolean _nuvola_mpris_player_update_cb_gsource_func (gpointer self);
const gchar* nuvola_media_player_model_get_artist (NuvolaMediaPlayerModel* self);
static GVariant* _variant_new28 (gchar** value, gint value_length1);
const gchar* nuvola_media_player_model_get_album (NuvolaMediaPlayerModel* self);
static GVariant* _variant_new29 (const gchar* value);
const gchar* nuvola_media_player_model_get_title (NuvolaMediaPlayerModel* self);
static GVariant* _variant_new30 (const gchar* value);
const gchar* nuvola_media_player_model_get_artwork_file (NuvolaMediaPlayerModel* self);
static GVariant* _variant_new31 (gchar* value);
gdouble nuvola_media_player_model_get_rating (NuvolaMediaPlayerModel* self);
static GVariant* _variant_new32 (gdouble value);
gint64 nuvola_media_player_model_get_track_length (NuvolaMediaPlayerModel* self);
gboolean nuvola_media_player_model_get_can_play (NuvolaMediaPlayerModel* self);
const gchar* nuvola_media_player_model_get_state (NuvolaMediaPlayerModel* self);
static void nuvola_mpris_player_set_can_play (NuvolaMPRISPlayer* self, gboolean value);
gboolean nuvola_media_player_model_get_can_pause (NuvolaMediaPlayerModel* self);
static void nuvola_mpris_player_set_can_pause (NuvolaMPRISPlayer* self, gboolean value);
gdouble nuvola_mpris_player_get_rate (NuvolaMPRISPlayer* self);
void nuvola_mpris_player_set_rate (NuvolaMPRISPlayer* self, gdouble value);
gdouble nuvola_mpris_player_get_minimum_rate (NuvolaMPRISPlayer* self);
gdouble nuvola_mpris_player_get_maximum_rate (NuvolaMPRISPlayer* self);
gboolean nuvola_mpris_player_get_can_control (NuvolaMPRISPlayer* self);
gdouble nuvola_mpris_player_get_volume (NuvolaMPRISPlayer* self);
void nuvola_mpris_player_set_volume (NuvolaMPRISPlayer* self, gdouble value);
void nuvola_media_player_model_change_volume (NuvolaMediaPlayerModel* self, gdouble volume);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void nuvola_mpris_player_finalize (GObject* obj);
static void _vala_nuvola_mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _dbus_nuvola_mpris_player_next (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_nuvola_mpris_player_previous (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_nuvola_mpris_player_pause (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_nuvola_mpris_player_play_pause (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_nuvola_mpris_player_stop (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_nuvola_mpris_player_play (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_nuvola_mpris_player_seek (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_nuvola_mpris_player_SetPosition (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_nuvola_mpris_player_open_uri (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_nuvola_mpris_player_nuvola_set_rating (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void nuvola_mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* nuvola_mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_nuvola_mpris_player_get_playback_status (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_rate (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_minimum_rate (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_maximum_rate (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_position (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_can_go_next (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_can_go_previous (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_can_play (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_can_pause (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_can_seek (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_can_control (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_nuvola_can_rate (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_metadata (NuvolaMPRISPlayer* self);
static GVariant* _dbus_nuvola_mpris_player_get_volume (NuvolaMPRISPlayer* self);
static gboolean nuvola_mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_nuvola_mpris_player_set_playback_status (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_rate (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_position (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_can_go_next (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_can_go_previous (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_can_play (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_can_pause (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_can_seek (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_nuvola_can_rate (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_metadata (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_set_volume (NuvolaMPRISPlayer* self, GVariant* _value);
static void _dbus_nuvola_mpris_player_seeked (GObject* _sender, gint64 position, gpointer* _data);
static void _nuvola_mpris_player_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_next_in[] = {NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_next_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_next = {-1, "Next", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_next_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_next_out)};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_previous_in[] = {NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_previous_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_previous = {-1, "Previous", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_previous_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_previous_out)};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_pause_in[] = {NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_pause_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_pause = {-1, "Pause", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_pause_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_pause_out)};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_play_pause_in[] = {NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_play_pause_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_play_pause = {-1, "PlayPause", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_play_pause_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_play_pause_out)};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_stop_in[] = {NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_stop_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_stop = {-1, "Stop", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_stop_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_stop_out)};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_play_in[] = {NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_play_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_play = {-1, "Play", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_play_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_play_out)};
static const GDBusArgInfo _nuvola_mpris_player_dbus_arg_info_seek_offset = {-1, "offset", "x"};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_seek_in[] = {&_nuvola_mpris_player_dbus_arg_info_seek_offset, NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_seek_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_seek = {-1, "Seek", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_seek_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_seek_out)};
static const GDBusArgInfo _nuvola_mpris_player_dbus_arg_info_SetPosition_track_id = {-1, "track_id", "o"};
static const GDBusArgInfo _nuvola_mpris_player_dbus_arg_info_SetPosition_position = {-1, "position", "x"};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_SetPosition_in[] = {&_nuvola_mpris_player_dbus_arg_info_SetPosition_track_id, &_nuvola_mpris_player_dbus_arg_info_SetPosition_position, NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_SetPosition_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_SetPosition = {-1, "SetPosition", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_SetPosition_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_SetPosition_out)};
static const GDBusArgInfo _nuvola_mpris_player_dbus_arg_info_open_uri_uri = {-1, "uri", "s"};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_open_uri_in[] = {&_nuvola_mpris_player_dbus_arg_info_open_uri_uri, NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_open_uri_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_open_uri = {-1, "OpenUri", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_open_uri_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_open_uri_out)};
static const GDBusArgInfo _nuvola_mpris_player_dbus_arg_info_nuvola_set_rating_rating = {-1, "rating", "d"};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_nuvola_set_rating_in[] = {&_nuvola_mpris_player_dbus_arg_info_nuvola_set_rating_rating, NULL};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_nuvola_set_rating_out[] = {NULL};
static const GDBusMethodInfo _nuvola_mpris_player_dbus_method_info_nuvola_set_rating = {-1, "NuvolaSetRating", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_nuvola_set_rating_in), (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_nuvola_set_rating_out)};
static const GDBusMethodInfo * const _nuvola_mpris_player_dbus_method_info[] = {&_nuvola_mpris_player_dbus_method_info_next, &_nuvola_mpris_player_dbus_method_info_previous, &_nuvola_mpris_player_dbus_method_info_pause, &_nuvola_mpris_player_dbus_method_info_play_pause, &_nuvola_mpris_player_dbus_method_info_stop, &_nuvola_mpris_player_dbus_method_info_play, &_nuvola_mpris_player_dbus_method_info_seek, &_nuvola_mpris_player_dbus_method_info_SetPosition, &_nuvola_mpris_player_dbus_method_info_open_uri, &_nuvola_mpris_player_dbus_method_info_nuvola_set_rating, NULL};
static const GDBusArgInfo _nuvola_mpris_player_dbus_arg_info_seeked_position = {-1, "position", "x"};
static const GDBusArgInfo * const _nuvola_mpris_player_dbus_arg_info_seeked[] = {&_nuvola_mpris_player_dbus_arg_info_seeked_position, NULL};
static const GDBusSignalInfo _nuvola_mpris_player_dbus_signal_info_seeked = {-1, "Seeked", (GDBusArgInfo **) (&_nuvola_mpris_player_dbus_arg_info_seeked)};
static const GDBusSignalInfo * const _nuvola_mpris_player_dbus_signal_info[] = {&_nuvola_mpris_player_dbus_signal_info_seeked, NULL};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_playback_status = {-1, "PlaybackStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_rate = {-1, "Rate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_minimum_rate = {-1, "MinimumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_maximum_rate = {-1, "MaximumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_position = {-1, "Position", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_can_go_next = {-1, "CanGoNext", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_can_go_previous = {-1, "CanGoPrevious", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_can_play = {-1, "CanPlay", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_can_pause = {-1, "CanPause", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_can_seek = {-1, "CanSeek", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_can_control = {-1, "CanControl", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_nuvola_can_rate = {-1, "NuvolaCanRate", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_metadata = {-1, "Metadata", "a{sv}", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _nuvola_mpris_player_dbus_property_info_volume = {-1, "Volume", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo * const _nuvola_mpris_player_dbus_property_info[] = {&_nuvola_mpris_player_dbus_property_info_playback_status, &_nuvola_mpris_player_dbus_property_info_rate, &_nuvola_mpris_player_dbus_property_info_minimum_rate, &_nuvola_mpris_player_dbus_property_info_maximum_rate, &_nuvola_mpris_player_dbus_property_info_position, &_nuvola_mpris_player_dbus_property_info_can_go_next, &_nuvola_mpris_player_dbus_property_info_can_go_previous, &_nuvola_mpris_player_dbus_property_info_can_play, &_nuvola_mpris_player_dbus_property_info_can_pause, &_nuvola_mpris_player_dbus_property_info_can_seek, &_nuvola_mpris_player_dbus_property_info_can_control, &_nuvola_mpris_player_dbus_property_info_nuvola_can_rate, &_nuvola_mpris_player_dbus_property_info_metadata, &_nuvola_mpris_player_dbus_property_info_volume, NULL};
static const GDBusInterfaceInfo _nuvola_mpris_player_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Player", (GDBusMethodInfo **) (&_nuvola_mpris_player_dbus_method_info), (GDBusSignalInfo **) (&_nuvola_mpris_player_dbus_signal_info), (GDBusPropertyInfo **) (&_nuvola_mpris_player_dbus_property_info)};
static const GDBusInterfaceVTable _nuvola_mpris_player_dbus_interface_vtable = {nuvola_mpris_player_dbus_interface_method_call, nuvola_mpris_player_dbus_interface_get_property, nuvola_mpris_player_dbus_interface_set_property};

static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void __lambda21_ (NuvolaMPRISPlayer* self, GObject* o, GParamSpec* p) {
	GParamSpec* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (o != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = p;
	_tmp1_ = _tmp0_->name;
	nuvola_mpris_player_schedule_update (self, _tmp1_);
}


static void ___lambda21__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda21_ ((NuvolaMPRISPlayer*) self, _sender, pspec);
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_variant_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
}


NuvolaMPRISPlayer* nuvola_mpris_player_construct (GType object_type, NuvolaMediaPlayerModel* player, GDBusConnection* conn) {
	NuvolaMPRISPlayer * self = NULL;
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	NuvolaMediaPlayerModel* _tmp1_ = NULL;
	GDBusConnection* _tmp2_ = NULL;
	GDBusConnection* _tmp3_ = NULL;
	NuvolaMediaPlayerModel* _tmp4_ = NULL;
	GHashTable* _tmp5_ = NULL;
	GHashTable* _tmp6_ = NULL;
	NuvolaMediaPlayerModel* _tmp7_ = NULL;
	gint64 _tmp8_ = 0LL;
	gint64 _tmp9_ = 0LL;
	NuvolaMediaPlayerModel* _tmp10_ = NULL;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	GHashFunc _tmp15_ = NULL;
	GEqualFunc _tmp16_ = NULL;
	GHashTable* _tmp17_ = NULL;
	NuvolaMediaPlayerModel* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	NuvolaMediaPlayerModel* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	NuvolaMediaPlayerModel* _tmp24_ = NULL;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	g_return_val_if_fail (player != NULL, NULL);
	g_return_val_if_fail (conn != NULL, NULL);
	self = (NuvolaMPRISPlayer*) g_object_new (object_type, NULL);
	_tmp0_ = player;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->player);
	self->priv->player = _tmp1_;
	_tmp2_ = conn;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->conn);
	self->priv->conn = _tmp3_;
	_tmp4_ = player;
	g_signal_connect_object ((GObject*) _tmp4_, "notify", (GCallback) ___lambda21__g_object_notify, self, G_CONNECT_AFTER);
	_tmp5_ = nuvola_mpris_player_create_metadata (self);
	_tmp6_ = _tmp5_;
	nuvola_mpris_player_set_metadata (self, _tmp6_);
	_g_hash_table_unref0 (_tmp6_);
	_tmp7_ = player;
	_tmp8_ = nuvola_media_player_model_get_track_position (_tmp7_);
	_tmp9_ = _tmp8_;
	nuvola_mpris_player_set_position (self, _tmp9_);
	_tmp10_ = player;
	_tmp11_ = nuvola_media_player_model_get_volume (_tmp10_);
	_tmp12_ = _tmp11_;
	self->priv->_volume = _tmp12_;
	_tmp13_ = nuvola_mpris_player_map_playback_state (self);
	_tmp14_ = _tmp13_;
	nuvola_mpris_player_set_playback_status (self, _tmp14_);
	_g_free0 (_tmp14_);
	_tmp15_ = g_str_hash;
	_tmp16_ = g_str_equal;
	_tmp17_ = g_hash_table_new_full (_tmp15_, _tmp16_, _g_free0_, _g_variant_unref0_);
	_g_hash_table_unref0 (self->priv->pending_update);
	self->priv->pending_update = _tmp17_;
	_tmp18_ = player;
	_tmp19_ = nuvola_media_player_model_get_can_go_next (_tmp18_);
	_tmp20_ = _tmp19_;
	nuvola_mpris_player_set_can_go_next (self, _tmp20_);
	_tmp21_ = player;
	_tmp22_ = nuvola_media_player_model_get_can_go_previous (_tmp21_);
	_tmp23_ = _tmp22_;
	nuvola_mpris_player_set_can_go_previous (self, _tmp23_);
	_tmp24_ = player;
	_tmp25_ = nuvola_media_player_model_get_can_seek (_tmp24_);
	_tmp26_ = _tmp25_;
	nuvola_mpris_player_set_can_seek (self, _tmp26_);
	nuvola_mpris_player_update_can_play (self);
	nuvola_mpris_player_update_can_pause (self);
	return self;
}


NuvolaMPRISPlayer* nuvola_mpris_player_new (NuvolaMediaPlayerModel* player, GDBusConnection* conn) {
	return nuvola_mpris_player_construct (NUVOLA_TYPE_MPRIS_PLAYER, player, conn);
}


void nuvola_mpris_player_next (NuvolaMPRISPlayer* self) {
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->player;
	nuvola_media_player_model_next_song (_tmp0_);
}


void nuvola_mpris_player_previous (NuvolaMPRISPlayer* self) {
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->player;
	nuvola_media_player_model_prev_song (_tmp0_);
}


void nuvola_mpris_player_pause (NuvolaMPRISPlayer* self) {
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->player;
	nuvola_media_player_model_pause (_tmp0_);
}


void nuvola_mpris_player_play_pause (NuvolaMPRISPlayer* self) {
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->player;
	nuvola_media_player_model_toggle_play (_tmp0_);
}


void nuvola_mpris_player_stop (NuvolaMPRISPlayer* self) {
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->player;
	nuvola_media_player_model_stop (_tmp0_);
}


void nuvola_mpris_player_play (NuvolaMPRISPlayer* self) {
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->player;
	nuvola_media_player_model_play (_tmp0_);
}


void nuvola_mpris_player_seek (NuvolaMPRISPlayer* self, gint64 offset) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_can_seek;
	if (_tmp0_) {
		NuvolaMediaPlayerModel* _tmp1_ = NULL;
		NuvolaMediaPlayerModel* _tmp2_ = NULL;
		gint64 _tmp3_ = 0LL;
		gint64 _tmp4_ = 0LL;
		gint64 _tmp5_ = 0LL;
		_tmp1_ = self->priv->player;
		_tmp2_ = self->priv->player;
		_tmp3_ = nuvola_media_player_model_get_track_position (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = offset;
		nuvola_media_player_model_seek (_tmp1_, _tmp4_ + _tmp5_);
	}
}


void nuvola_mpris_player_SetPosition (NuvolaMPRISPlayer* self, const char* track_id, gint64 position) {
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (track_id != NULL);
	_tmp0_ = self->priv->player;
	_tmp1_ = position;
	nuvola_media_player_model_seek (_tmp0_, _tmp1_);
}


void nuvola_mpris_player_open_uri (NuvolaMPRISPlayer* self, const gchar* uri) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (uri != NULL);
}


void nuvola_mpris_player_nuvola_set_rating (NuvolaMPRISPlayer* self, gdouble rating) {
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->player;
	_tmp1_ = rating;
	g_signal_emit_by_name (_tmp0_, "set-rating", _tmp1_);
}


static GVariant* _variant_new16 (GHashTable* value) {
	GVariantBuilder _tmp13_;
	GHashTableIter _tmp14_;
	gpointer _tmp15_;
	gpointer _tmp16_;
	g_hash_table_iter_init (&_tmp14_, value);
	g_variant_builder_init (&_tmp13_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp14_, &_tmp15_, &_tmp16_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp15_;
		_value = (GVariant*) _tmp16_;
		g_variant_builder_add (&_tmp13_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp13_));
}


static GVariant* _variant_new17 (gint64 value) {
	return g_variant_ref_sink (g_variant_new_int64 (value));
}


static GVariant* _variant_new18 (gdouble value) {
	return g_variant_ref_sink (g_variant_new_double (value));
}


static GVariant* _variant_new19 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static GVariant* _variant_new20 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static GVariant* _variant_new21 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new22 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static GVariant* _variant_new23 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static GVariant* _variant_new24 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static GVariant* _variant_new25 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static GVariant* _variant_new26 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static GVariant* _variant_new27 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


static gboolean _nuvola_mpris_player_update_cb_gsource_func (gpointer self) {
	gboolean result;
	result = nuvola_mpris_player_update_cb ((NuvolaMPRISPlayer*) self);
	return result;
}


static void nuvola_mpris_player_schedule_update (NuvolaMPRISPlayer* self, const gchar* param) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	static GQuark _tmp2_label6 = 0;
	static GQuark _tmp2_label7 = 0;
	static GQuark _tmp2_label8 = 0;
	static GQuark _tmp2_label9 = 0;
	static GQuark _tmp2_label10 = 0;
	static GQuark _tmp2_label11 = 0;
	static GQuark _tmp2_label12 = 0;
	static GQuark _tmp2_label13 = 0;
	static GQuark _tmp2_label14 = 0;
	guint _tmp111_ = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (param != NULL);
	_tmp0_ = param;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if ((((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("title")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("artist"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("album"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("artwork-file"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("rating"))))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("track-length"))))) {
		switch (0) {
			default:
			{
				GHashTable* new_metadata = NULL;
				GHashTable* _tmp4_ = NULL;
				gboolean _tmp5_ = FALSE;
				GHashTable* _tmp6_ = NULL;
				guint _tmp7_ = 0U;
				GHashTable* _tmp10_ = NULL;
				gchar* _tmp11_ = NULL;
				GHashTable* _tmp12_ = NULL;
				GVariant* _tmp17_ = NULL;
				_tmp4_ = nuvola_mpris_player_create_metadata (self);
				new_metadata = _tmp4_;
				_tmp6_ = new_metadata;
				_tmp7_ = g_hash_table_size (_tmp6_);
				if (_tmp7_ == ((guint) 0)) {
					GHashTable* _tmp8_ = NULL;
					guint _tmp9_ = 0U;
					_tmp8_ = self->priv->_metadata;
					_tmp9_ = g_hash_table_size (_tmp8_);
					_tmp5_ = _tmp9_ == ((guint) 0);
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					_g_hash_table_unref0 (new_metadata);
					return;
				}
				_tmp10_ = self->priv->pending_update;
				_tmp11_ = g_strdup ("Metadata");
				_tmp12_ = new_metadata;
				nuvola_mpris_player_set_metadata (self, _tmp12_);
				_tmp17_ = _variant_new16 (_tmp12_);
				g_hash_table_insert (_tmp10_, _tmp11_, _tmp17_);
				_g_hash_table_unref0 (new_metadata);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("track-position")))) {
		switch (0) {
			default:
			{
				gint64 delta = 0LL;
				NuvolaMediaPlayerModel* _tmp18_ = NULL;
				gint64 _tmp19_ = 0LL;
				gint64 _tmp20_ = 0LL;
				gint64 _tmp21_ = 0LL;
				NuvolaMediaPlayerModel* _tmp22_ = NULL;
				gint64 _tmp23_ = 0LL;
				gint64 _tmp24_ = 0LL;
				GHashTable* _tmp25_ = NULL;
				gchar* _tmp26_ = NULL;
				gint64 _tmp27_ = 0LL;
				GVariant* _tmp28_ = NULL;
				gboolean _tmp29_ = FALSE;
				gint64 _tmp30_ = 0LL;
				_tmp18_ = self->priv->player;
				_tmp19_ = nuvola_media_player_model_get_track_position (_tmp18_);
				_tmp20_ = _tmp19_;
				_tmp21_ = self->priv->_position;
				delta = _tmp20_ - _tmp21_;
				_tmp22_ = self->priv->player;
				_tmp23_ = nuvola_media_player_model_get_track_position (_tmp22_);
				_tmp24_ = _tmp23_;
				nuvola_mpris_player_set_position (self, _tmp24_);
				_tmp25_ = self->priv->pending_update;
				_tmp26_ = g_strdup ("Position");
				_tmp27_ = self->priv->_position;
				_tmp28_ = _variant_new17 (_tmp27_);
				g_hash_table_insert (_tmp25_, _tmp26_, _tmp28_);
				_tmp30_ = delta;
				if (_tmp30_ > ((gint64) 2)) {
					_tmp29_ = TRUE;
				} else {
					gint64 _tmp31_ = 0LL;
					_tmp31_ = delta;
					_tmp29_ = _tmp31_ < ((gint64) -2);
				}
				if (_tmp29_) {
					gint64 _tmp32_ = 0LL;
					_tmp32_ = self->priv->_position;
					g_signal_emit_by_name (self, "seeked", _tmp32_);
				}
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("volume")))) {
		switch (0) {
			default:
			{
				gdouble _tmp33_ = 0.0;
				NuvolaMediaPlayerModel* _tmp34_ = NULL;
				gdouble _tmp35_ = 0.0;
				gdouble _tmp36_ = 0.0;
				_tmp33_ = self->priv->_volume;
				_tmp34_ = self->priv->player;
				_tmp35_ = nuvola_media_player_model_get_volume (_tmp34_);
				_tmp36_ = _tmp35_;
				if (_tmp33_ != _tmp36_) {
					GHashTable* _tmp37_ = NULL;
					gchar* _tmp38_ = NULL;
					NuvolaMediaPlayerModel* _tmp39_ = NULL;
					gdouble _tmp40_ = 0.0;
					gdouble _tmp41_ = 0.0;
					gdouble _tmp42_ = 0.0;
					GVariant* _tmp43_ = NULL;
					_tmp37_ = self->priv->pending_update;
					_tmp38_ = g_strdup ("Volume");
					_tmp39_ = self->priv->player;
					_tmp40_ = nuvola_media_player_model_get_volume (_tmp39_);
					_tmp41_ = _tmp40_;
					self->priv->_volume = _tmp41_;
					_tmp42_ = self->priv->_volume;
					_tmp43_ = _variant_new18 (_tmp42_);
					g_hash_table_insert (_tmp37_, _tmp38_, _tmp43_);
				}
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("state")))) {
		switch (0) {
			default:
			{
				gboolean _tmp44_ = FALSE;
				gboolean _tmp49_ = FALSE;
				gchar* status = NULL;
				gchar* _tmp54_ = NULL;
				const gchar* _tmp55_ = NULL;
				const gchar* _tmp56_ = NULL;
				GHashTable* _tmp57_ = NULL;
				gchar* _tmp58_ = NULL;
				const gchar* _tmp59_ = NULL;
				GVariant* _tmp60_ = NULL;
				_tmp44_ = nuvola_mpris_player_update_can_play (self);
				if (_tmp44_) {
					GHashTable* _tmp45_ = NULL;
					gchar* _tmp46_ = NULL;
					gboolean _tmp47_ = FALSE;
					GVariant* _tmp48_ = NULL;
					_tmp45_ = self->priv->pending_update;
					_tmp46_ = g_strdup ("CanPlay");
					_tmp47_ = self->priv->_can_play;
					_tmp48_ = _variant_new19 (_tmp47_);
					g_hash_table_insert (_tmp45_, _tmp46_, _tmp48_);
				}
				_tmp49_ = nuvola_mpris_player_update_can_pause (self);
				if (_tmp49_) {
					GHashTable* _tmp50_ = NULL;
					gchar* _tmp51_ = NULL;
					gboolean _tmp52_ = FALSE;
					GVariant* _tmp53_ = NULL;
					_tmp50_ = self->priv->pending_update;
					_tmp51_ = g_strdup ("CanPause");
					_tmp52_ = self->priv->_can_pause;
					_tmp53_ = _variant_new20 (_tmp52_);
					g_hash_table_insert (_tmp50_, _tmp51_, _tmp53_);
				}
				_tmp54_ = nuvola_mpris_player_map_playback_state (self);
				status = _tmp54_;
				_tmp55_ = self->priv->_playback_status;
				_tmp56_ = status;
				if (g_strcmp0 (_tmp55_, _tmp56_) == 0) {
					_g_free0 (status);
					return;
				}
				_tmp57_ = self->priv->pending_update;
				_tmp58_ = g_strdup ("PlaybackStatus");
				_tmp59_ = status;
				nuvola_mpris_player_set_playback_status (self, _tmp59_);
				_tmp60_ = _variant_new21 (_tmp59_);
				g_hash_table_insert (_tmp57_, _tmp58_, _tmp60_);
				_g_free0 (status);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("can-go-next")))) {
		switch (0) {
			default:
			{
				gboolean _tmp61_ = FALSE;
				NuvolaMediaPlayerModel* _tmp62_ = NULL;
				gboolean _tmp63_ = FALSE;
				gboolean _tmp64_ = FALSE;
				GHashTable* _tmp65_ = NULL;
				gchar* _tmp66_ = NULL;
				NuvolaMediaPlayerModel* _tmp67_ = NULL;
				gboolean _tmp68_ = FALSE;
				gboolean _tmp69_ = FALSE;
				GVariant* _tmp70_ = NULL;
				_tmp61_ = self->priv->_can_go_next;
				_tmp62_ = self->priv->player;
				_tmp63_ = nuvola_media_player_model_get_can_go_next (_tmp62_);
				_tmp64_ = _tmp63_;
				if (_tmp61_ == _tmp64_) {
					return;
				}
				_tmp65_ = self->priv->pending_update;
				_tmp66_ = g_strdup ("CanGoNext");
				_tmp67_ = self->priv->player;
				_tmp68_ = nuvola_media_player_model_get_can_go_next (_tmp67_);
				_tmp69_ = _tmp68_;
				nuvola_mpris_player_set_can_go_next (self, _tmp69_);
				_tmp70_ = _variant_new22 (_tmp69_);
				g_hash_table_insert (_tmp65_, _tmp66_, _tmp70_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("can-go-previous")))) {
		switch (0) {
			default:
			{
				gboolean _tmp71_ = FALSE;
				NuvolaMediaPlayerModel* _tmp72_ = NULL;
				gboolean _tmp73_ = FALSE;
				gboolean _tmp74_ = FALSE;
				GHashTable* _tmp75_ = NULL;
				gchar* _tmp76_ = NULL;
				NuvolaMediaPlayerModel* _tmp77_ = NULL;
				gboolean _tmp78_ = FALSE;
				gboolean _tmp79_ = FALSE;
				GVariant* _tmp80_ = NULL;
				_tmp71_ = self->priv->_can_go_previous;
				_tmp72_ = self->priv->player;
				_tmp73_ = nuvola_media_player_model_get_can_go_previous (_tmp72_);
				_tmp74_ = _tmp73_;
				if (_tmp71_ == _tmp74_) {
					return;
				}
				_tmp75_ = self->priv->pending_update;
				_tmp76_ = g_strdup ("CanGoPrevious");
				_tmp77_ = self->priv->player;
				_tmp78_ = nuvola_media_player_model_get_can_go_previous (_tmp77_);
				_tmp79_ = _tmp78_;
				nuvola_mpris_player_set_can_go_previous (self, _tmp79_);
				_tmp80_ = _variant_new23 (_tmp79_);
				g_hash_table_insert (_tmp75_, _tmp76_, _tmp80_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("can-play")))) {
		switch (0) {
			default:
			{
				gboolean _tmp81_ = FALSE;
				GHashTable* _tmp82_ = NULL;
				gchar* _tmp83_ = NULL;
				gboolean _tmp84_ = FALSE;
				GVariant* _tmp85_ = NULL;
				_tmp81_ = nuvola_mpris_player_update_can_play (self);
				if (!_tmp81_) {
					return;
				}
				_tmp82_ = self->priv->pending_update;
				_tmp83_ = g_strdup ("CanPlay");
				_tmp84_ = self->priv->_can_play;
				_tmp85_ = _variant_new24 (_tmp84_);
				g_hash_table_insert (_tmp82_, _tmp83_, _tmp85_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("can-pause")))) {
		switch (0) {
			default:
			{
				gboolean _tmp86_ = FALSE;
				GHashTable* _tmp87_ = NULL;
				gchar* _tmp88_ = NULL;
				gboolean _tmp89_ = FALSE;
				GVariant* _tmp90_ = NULL;
				_tmp86_ = nuvola_mpris_player_update_can_pause (self);
				if (!_tmp86_) {
					return;
				}
				_tmp87_ = self->priv->pending_update;
				_tmp88_ = g_strdup ("CanPause");
				_tmp89_ = self->priv->_can_pause;
				_tmp90_ = _variant_new25 (_tmp89_);
				g_hash_table_insert (_tmp87_, _tmp88_, _tmp90_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("can-rate")))) {
		switch (0) {
			default:
			{
				gboolean _tmp91_ = FALSE;
				NuvolaMediaPlayerModel* _tmp92_ = NULL;
				gboolean _tmp93_ = FALSE;
				gboolean _tmp94_ = FALSE;
				GHashTable* _tmp95_ = NULL;
				gchar* _tmp96_ = NULL;
				NuvolaMediaPlayerModel* _tmp97_ = NULL;
				gboolean _tmp98_ = FALSE;
				gboolean _tmp99_ = FALSE;
				GVariant* _tmp100_ = NULL;
				_tmp91_ = self->priv->_nuvola_can_rate;
				_tmp92_ = self->priv->player;
				_tmp93_ = nuvola_media_player_model_get_can_rate (_tmp92_);
				_tmp94_ = _tmp93_;
				if (_tmp91_ == _tmp94_) {
					return;
				}
				_tmp95_ = self->priv->pending_update;
				_tmp96_ = g_strdup ("NuvolaCanRate");
				_tmp97_ = self->priv->player;
				_tmp98_ = nuvola_media_player_model_get_can_rate (_tmp97_);
				_tmp99_ = _tmp98_;
				nuvola_mpris_player_set_nuvola_can_rate (self, _tmp99_);
				_tmp100_ = _variant_new26 (_tmp99_);
				g_hash_table_insert (_tmp95_, _tmp96_, _tmp100_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("can-seek")))) {
		switch (0) {
			default:
			{
				gboolean _tmp101_ = FALSE;
				NuvolaMediaPlayerModel* _tmp102_ = NULL;
				gboolean _tmp103_ = FALSE;
				gboolean _tmp104_ = FALSE;
				GHashTable* _tmp105_ = NULL;
				gchar* _tmp106_ = NULL;
				NuvolaMediaPlayerModel* _tmp107_ = NULL;
				gboolean _tmp108_ = FALSE;
				gboolean _tmp109_ = FALSE;
				GVariant* _tmp110_ = NULL;
				_tmp101_ = self->priv->_can_seek;
				_tmp102_ = self->priv->player;
				_tmp103_ = nuvola_media_player_model_get_can_seek (_tmp102_);
				_tmp104_ = _tmp103_;
				if (_tmp101_ == _tmp104_) {
					return;
				}
				_tmp105_ = self->priv->pending_update;
				_tmp106_ = g_strdup ("CanSeek");
				_tmp107_ = self->priv->player;
				_tmp108_ = nuvola_media_player_model_get_can_seek (_tmp107_);
				_tmp109_ = _tmp108_;
				nuvola_mpris_player_set_can_seek (self, _tmp109_);
				_tmp110_ = _variant_new27 (_tmp109_);
				g_hash_table_insert (_tmp105_, _tmp106_, _tmp110_);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				return;
			}
		}
	}
	_tmp111_ = self->priv->pending_update_id;
	if (_tmp111_ == ((guint) 0)) {
		guint _tmp112_ = 0U;
		_tmp112_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, _nuvola_mpris_player_update_cb_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->pending_update_id = _tmp112_;
	}
}


static gboolean nuvola_mpris_player_update_cb (NuvolaMPRISPlayer* self) {
	gboolean result = FALSE;
	GVariantBuilder* builder = NULL;
	const GVariantType* _tmp0_ = NULL;
	GVariantBuilder* _tmp1_ = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp2_ = NULL;
	const gchar* name = NULL;
	GVariant* value = NULL;
	GHashTable* _tmp9_ = NULL;
	GVariantBuilder* invalid_builder = NULL;
	GVariantType* _tmp10_ = NULL;
	GVariantType* _tmp11_ = NULL;
	GVariantBuilder* _tmp12_ = NULL;
	GVariantBuilder* _tmp13_ = NULL;
	GVariant* payload = NULL;
	GVariantBuilder* _tmp14_ = NULL;
	GVariant* _tmp15_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->pending_update_id = (guint) 0;
	_tmp0_ = G_VARIANT_TYPE_ARRAY;
	_tmp1_ = g_variant_builder_new (_tmp0_);
	builder = _tmp1_;
	_tmp2_ = self->priv->pending_update;
	g_hash_table_iter_init (&iter, _tmp2_);
	while (TRUE) {
		gconstpointer _tmp3_ = NULL;
		gconstpointer _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		GVariantBuilder* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		GVariant* _tmp8_ = NULL;
		_tmp5_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp3_), (gpointer*) (&_tmp4_));
		name = _tmp3_;
		value = _tmp4_;
		if (!_tmp5_) {
			break;
		}
		_tmp6_ = builder;
		_tmp7_ = name;
		_tmp8_ = value;
		g_variant_builder_add (_tmp6_, "{sv}", _tmp7_, _tmp8_, NULL);
	}
	_tmp9_ = self->priv->pending_update;
	g_hash_table_remove_all (_tmp9_);
	_tmp10_ = g_variant_type_new ("as");
	_tmp11_ = _tmp10_;
	_tmp12_ = g_variant_builder_new (_tmp11_);
	_tmp13_ = _tmp12_;
	_g_variant_type_free0 (_tmp11_);
	invalid_builder = _tmp13_;
	_tmp14_ = builder;
	_tmp15_ = g_variant_new ("(sa{sv}as)", "org.mpris.MediaPlayer2.Player", _tmp14_, invalid_builder, NULL);
	g_variant_ref_sink (_tmp15_);
	payload = _tmp15_;
	{
		GDBusConnection* _tmp16_ = NULL;
		_tmp16_ = self->priv->conn;
		g_dbus_connection_emit_signal (_tmp16_, NULL, "/org/mpris/MediaPlayer2", "org.freedesktop.DBus.Properties", "PropertiesChanged", payload, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch45_g_error;
		}
	}
	goto __finally45;
	__catch45_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		g_warning ("MPRISPlayer.vala:233: Unable to emit PropertiesChanged signal: %s", _tmp18_);
		_g_error_free0 (e);
	}
	__finally45:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp19_ = FALSE;
		_g_variant_unref0 (payload);
		_g_variant_builder_unref0 (invalid_builder);
		_g_variant_builder_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp19_;
	}
	result = FALSE;
	_g_variant_unref0 (payload);
	_g_variant_builder_unref0 (invalid_builder);
	_g_variant_builder_unref0 (builder);
	return result;
}


static GVariant* _variant_new28 (gchar** value, gint value_length1) {
	gchar** _tmp14_;
	GVariantBuilder _tmp15_;
	int _tmp16_;
	_tmp14_ = value;
	g_variant_builder_init (&_tmp15_, G_VARIANT_TYPE ("as"));
	for (_tmp16_ = 0; _tmp16_ < value_length1; _tmp16_++) {
		g_variant_builder_add_value (&_tmp15_, g_variant_new_string (*_tmp14_));
		_tmp14_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp15_));
}


static GVariant* _variant_new29 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new30 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new31 (gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new32 (gdouble value) {
	return g_variant_ref_sink (g_variant_new_double (value));
}


static GHashTable* nuvola_mpris_player_create_metadata (NuvolaMPRISPlayer* self) {
	GHashTable* result = NULL;
	GHashTable* metadata = NULL;
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	GHashTable* _tmp2_ = NULL;
	NuvolaMediaPlayerModel* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	NuvolaMediaPlayerModel* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	NuvolaMediaPlayerModel* _tmp27_ = NULL;
	const gchar* _tmp28_ = NULL;
	const gchar* _tmp29_ = NULL;
	NuvolaMediaPlayerModel* _tmp36_ = NULL;
	const gchar* _tmp37_ = NULL;
	const gchar* _tmp38_ = NULL;
	NuvolaMediaPlayerModel* _tmp47_ = NULL;
	gdouble _tmp48_ = 0.0;
	gdouble _tmp49_ = 0.0;
	NuvolaMediaPlayerModel* _tmp56_ = NULL;
	gint64 _tmp57_ = 0LL;
	gint64 _tmp58_ = 0LL;
	GHashTable* _tmp65_ = NULL;
	guint _tmp66_ = 0U;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_variant_unref0_);
	metadata = _tmp2_;
	_tmp3_ = self->priv->player;
	_tmp4_ = nuvola_media_player_model_get_artist (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ != NULL) {
		gchar** artistArray = NULL;
		NuvolaMediaPlayerModel* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar** _tmp10_ = NULL;
		gint artistArray_length1 = 0;
		gint _artistArray_size_ = 0;
		GHashTable* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar** _tmp13_ = NULL;
		gint _tmp13__length1 = 0;
		GVariant* _tmp17_ = NULL;
		_tmp6_ = self->priv->player;
		_tmp7_ = nuvola_media_player_model_get_artist (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strdup (_tmp8_);
		_tmp10_ = g_new0 (gchar*, 1 + 1);
		_tmp10_[0] = _tmp9_;
		artistArray = _tmp10_;
		artistArray_length1 = 1;
		_artistArray_size_ = artistArray_length1;
		_tmp11_ = metadata;
		_tmp12_ = g_strdup ("xesam:artist");
		_tmp13_ = artistArray;
		_tmp13__length1 = artistArray_length1;
		_tmp17_ = _variant_new28 (_tmp13_, _tmp13__length1);
		g_hash_table_insert (_tmp11_, _tmp12_, _tmp17_);
		artistArray = (_vala_array_free (artistArray, artistArray_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp18_ = self->priv->player;
	_tmp19_ = nuvola_media_player_model_get_album (_tmp18_);
	_tmp20_ = _tmp19_;
	if (_tmp20_ != NULL) {
		GHashTable* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		NuvolaMediaPlayerModel* _tmp23_ = NULL;
		const gchar* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		GVariant* _tmp26_ = NULL;
		_tmp21_ = metadata;
		_tmp22_ = g_strdup ("xesam:album");
		_tmp23_ = self->priv->player;
		_tmp24_ = nuvola_media_player_model_get_album (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = _variant_new29 (_tmp25_);
		g_hash_table_insert (_tmp21_, _tmp22_, _tmp26_);
	}
	_tmp27_ = self->priv->player;
	_tmp28_ = nuvola_media_player_model_get_title (_tmp27_);
	_tmp29_ = _tmp28_;
	if (_tmp29_ != NULL) {
		GHashTable* _tmp30_ = NULL;
		gchar* _tmp31_ = NULL;
		NuvolaMediaPlayerModel* _tmp32_ = NULL;
		const gchar* _tmp33_ = NULL;
		const gchar* _tmp34_ = NULL;
		GVariant* _tmp35_ = NULL;
		_tmp30_ = metadata;
		_tmp31_ = g_strdup ("xesam:title");
		_tmp32_ = self->priv->player;
		_tmp33_ = nuvola_media_player_model_get_title (_tmp32_);
		_tmp34_ = _tmp33_;
		_tmp35_ = _variant_new30 (_tmp34_);
		g_hash_table_insert (_tmp30_, _tmp31_, _tmp35_);
	}
	_tmp36_ = self->priv->player;
	_tmp37_ = nuvola_media_player_model_get_artwork_file (_tmp36_);
	_tmp38_ = _tmp37_;
	if (_tmp38_ != NULL) {
		GHashTable* _tmp39_ = NULL;
		gchar* _tmp40_ = NULL;
		NuvolaMediaPlayerModel* _tmp41_ = NULL;
		const gchar* _tmp42_ = NULL;
		const gchar* _tmp43_ = NULL;
		gchar* _tmp44_ = NULL;
		gchar* _tmp45_ = NULL;
		GVariant* _tmp46_ = NULL;
		_tmp39_ = metadata;
		_tmp40_ = g_strdup ("mpris:artUrl");
		_tmp41_ = self->priv->player;
		_tmp42_ = nuvola_media_player_model_get_artwork_file (_tmp41_);
		_tmp43_ = _tmp42_;
		_tmp44_ = g_strconcat ("file://", _tmp43_, NULL);
		_tmp45_ = _tmp44_;
		_tmp46_ = _variant_new31 (_tmp45_);
		g_hash_table_insert (_tmp39_, _tmp40_, _tmp46_);
		_g_free0 (_tmp45_);
	}
	_tmp47_ = self->priv->player;
	_tmp48_ = nuvola_media_player_model_get_rating (_tmp47_);
	_tmp49_ = _tmp48_;
	if (_tmp49_ >= 0.0) {
		GHashTable* _tmp50_ = NULL;
		gchar* _tmp51_ = NULL;
		NuvolaMediaPlayerModel* _tmp52_ = NULL;
		gdouble _tmp53_ = 0.0;
		gdouble _tmp54_ = 0.0;
		GVariant* _tmp55_ = NULL;
		_tmp50_ = metadata;
		_tmp51_ = g_strdup ("xesam:userRating");
		_tmp52_ = self->priv->player;
		_tmp53_ = nuvola_media_player_model_get_rating (_tmp52_);
		_tmp54_ = _tmp53_;
		_tmp55_ = _variant_new32 (_tmp54_);
		g_hash_table_insert (_tmp50_, _tmp51_, _tmp55_);
	}
	_tmp56_ = self->priv->player;
	_tmp57_ = nuvola_media_player_model_get_track_length (_tmp56_);
	_tmp58_ = _tmp57_;
	if (_tmp58_ > ((gint64) 0)) {
		GHashTable* _tmp59_ = NULL;
		gchar* _tmp60_ = NULL;
		NuvolaMediaPlayerModel* _tmp61_ = NULL;
		gint64 _tmp62_ = 0LL;
		gint64 _tmp63_ = 0LL;
		GVariant* _tmp64_ = NULL;
		_tmp59_ = metadata;
		_tmp60_ = g_strdup ("mpris:length");
		_tmp61_ = self->priv->player;
		_tmp62_ = nuvola_media_player_model_get_track_length (_tmp61_);
		_tmp63_ = _tmp62_;
		_tmp64_ = g_variant_new_int64 ((gint64) _tmp63_);
		g_variant_ref_sink (_tmp64_);
		g_hash_table_insert (_tmp59_, _tmp60_, _tmp64_);
	}
	_tmp65_ = metadata;
	_tmp66_ = g_hash_table_size (_tmp65_);
	if (_tmp66_ > ((guint) 0)) {
		const gchar* _tmp67_ = NULL;
		NuvolaMediaPlayerModel* _tmp68_ = NULL;
		const gchar* _tmp69_ = NULL;
		const gchar* _tmp70_ = NULL;
		const gchar* _tmp71_ = NULL;
		NuvolaMediaPlayerModel* _tmp72_ = NULL;
		const gchar* _tmp73_ = NULL;
		const gchar* _tmp74_ = NULL;
		const gchar* _tmp75_ = NULL;
		NuvolaMediaPlayerModel* _tmp76_ = NULL;
		const gchar* _tmp77_ = NULL;
		const gchar* _tmp78_ = NULL;
		gchar* hash = NULL;
		gchar* _tmp79_ = NULL;
		gchar* _tmp80_ = NULL;
		gchar* _tmp81_ = NULL;
		gchar* _tmp82_ = NULL;
		GHashTable* _tmp83_ = NULL;
		gchar* _tmp84_ = NULL;
		gchar* _tmp85_ = NULL;
		gchar* _tmp86_ = NULL;
		gchar* _tmp87_ = NULL;
		gchar* _tmp88_ = NULL;
		const gchar* _tmp89_ = NULL;
		gchar* _tmp90_ = NULL;
		gchar* _tmp91_ = NULL;
		GVariant* _tmp92_ = NULL;
		GHashTable* _tmp93_ = NULL;
		gchar* _tmp94_ = NULL;
		const GVariantType* _tmp95_ = NULL;
		GVariant** _tmp96_ = NULL;
		GVariant** _tmp97_ = NULL;
		gint _tmp97__length1 = 0;
		GVariant* _tmp98_ = NULL;
		_tmp68_ = self->priv->player;
		_tmp69_ = nuvola_media_player_model_get_title (_tmp68_);
		_tmp70_ = _tmp69_;
		_tmp67_ = _tmp70_;
		if (_tmp67_ == NULL) {
			_tmp67_ = "unknown title";
		}
		_tmp72_ = self->priv->player;
		_tmp73_ = nuvola_media_player_model_get_artist (_tmp72_);
		_tmp74_ = _tmp73_;
		_tmp71_ = _tmp74_;
		if (_tmp71_ == NULL) {
			_tmp71_ = "unknown artist";
		}
		_tmp76_ = self->priv->player;
		_tmp77_ = nuvola_media_player_model_get_album (_tmp76_);
		_tmp78_ = _tmp77_;
		_tmp75_ = _tmp78_;
		if (_tmp75_ == NULL) {
			_tmp75_ = "unknown album";
		}
		_tmp79_ = g_strdup_printf ("%s:%s:%s", _tmp67_, _tmp71_, _tmp75_);
		_tmp80_ = _tmp79_;
		_tmp81_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, _tmp80_, (gsize) -1);
		_tmp82_ = _tmp81_;
		_g_free0 (_tmp80_);
		hash = _tmp82_;
		_tmp83_ = metadata;
		_tmp84_ = g_strdup ("mpris:trackid");
		_tmp85_ = nuvola_get_dbus_path ();
		_tmp86_ = _tmp85_;
		_tmp87_ = g_strconcat (_tmp86_, "/mpris/", NULL);
		_tmp88_ = _tmp87_;
		_tmp89_ = hash;
		_tmp90_ = g_strconcat (_tmp88_, _tmp89_, NULL);
		_tmp91_ = _tmp90_;
		_tmp92_ = g_variant_new_string (_tmp91_);
		g_variant_ref_sink (_tmp92_);
		g_hash_table_insert (_tmp83_, _tmp84_, _tmp92_);
		_g_free0 (_tmp91_);
		_g_free0 (_tmp88_);
		_g_free0 (_tmp86_);
		_tmp93_ = metadata;
		_tmp94_ = g_strdup ("xesam:genre");
		_tmp95_ = G_VARIANT_TYPE_STRING;
		_tmp96_ = g_new0 (GVariant*, 0 + 1);
		_tmp97_ = _tmp96_;
		_tmp97__length1 = 0;
		_tmp98_ = g_variant_new_array (_tmp95_, _tmp97_, 0);
		g_variant_ref_sink (_tmp98_);
		g_hash_table_insert (_tmp93_, _tmp94_, _tmp98_);
		_tmp97_ = (_vala_array_free (_tmp97_, _tmp97__length1, (GDestroyNotify) g_variant_unref), NULL);
		_g_free0 (hash);
	}
	result = metadata;
	return result;
}


static gboolean nuvola_mpris_player_update_can_play (NuvolaMPRISPlayer* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	NuvolaMediaPlayerModel* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean can_play = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->player;
	_tmp2_ = nuvola_media_player_model_get_can_play (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = TRUE;
	} else {
		NuvolaMediaPlayerModel* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		_tmp4_ = self->priv->player;
		_tmp5_ = nuvola_media_player_model_get_state (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = g_strcmp0 (_tmp6_, "unknown") != 0;
	}
	can_play = _tmp0_;
	_tmp7_ = self->priv->_can_play;
	_tmp8_ = can_play;
	if (_tmp7_ != _tmp8_) {
		gboolean _tmp9_ = FALSE;
		_tmp9_ = can_play;
		nuvola_mpris_player_set_can_play (self, _tmp9_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean nuvola_mpris_player_update_can_pause (NuvolaMPRISPlayer* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	NuvolaMediaPlayerModel* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean can_pause = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->player;
	_tmp2_ = nuvola_media_player_model_get_can_pause (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = TRUE;
	} else {
		NuvolaMediaPlayerModel* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		_tmp4_ = self->priv->player;
		_tmp5_ = nuvola_media_player_model_get_state (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = g_strcmp0 (_tmp6_, "unknown") != 0;
	}
	can_pause = _tmp0_;
	_tmp7_ = self->priv->_can_pause;
	_tmp8_ = can_pause;
	if (_tmp7_ != _tmp8_) {
		gboolean _tmp9_ = FALSE;
		_tmp9_ = can_pause;
		nuvola_mpris_player_set_can_pause (self, _tmp9_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gchar* nuvola_mpris_player_map_playback_state (NuvolaMPRISPlayer* self) {
	gchar* result = NULL;
	NuvolaMediaPlayerModel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GQuark _tmp5_ = 0U;
	static GQuark _tmp4_label0 = 0;
	static GQuark _tmp4_label1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->player;
	_tmp1_ = nuvola_media_player_model_get_state (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("paused")))) {
		switch (0) {
			default:
			{
				gchar* _tmp6_ = NULL;
				_tmp6_ = g_strdup ("Paused");
				result = _tmp6_;
				return result;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("playing")))) {
		switch (0) {
			default:
			{
				gchar* _tmp7_ = NULL;
				_tmp7_ = g_strdup ("Playing");
				result = _tmp7_;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				gchar* _tmp8_ = NULL;
				_tmp8_ = g_strdup ("Stopped");
				result = _tmp8_;
				return result;
			}
		}
	}
}


const gchar* nuvola_mpris_player_get_playback_status (NuvolaMPRISPlayer* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_playback_status;
	result = _tmp0_;
	return result;
}


static void nuvola_mpris_player_set_playback_status (NuvolaMPRISPlayer* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_playback_status);
	self->priv->_playback_status = _tmp1_;
	g_object_notify ((GObject *) self, "playback-status");
}


gdouble nuvola_mpris_player_get_rate (NuvolaMPRISPlayer* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


void nuvola_mpris_player_set_rate (NuvolaMPRISPlayer* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	if (_tmp0_ == 0.0) {
		nuvola_mpris_player_pause (self);
	}
	g_object_notify ((GObject *) self, "rate");
}


gdouble nuvola_mpris_player_get_minimum_rate (NuvolaMPRISPlayer* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


gdouble nuvola_mpris_player_get_maximum_rate (NuvolaMPRISPlayer* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


gint64 nuvola_mpris_player_get_position (NuvolaMPRISPlayer* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_position;
	result = _tmp0_;
	return result;
}


static void nuvola_mpris_player_set_position (NuvolaMPRISPlayer* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_position = _tmp0_;
	g_object_notify ((GObject *) self, "position");
}


gboolean nuvola_mpris_player_get_can_go_next (NuvolaMPRISPlayer* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_go_next;
	result = _tmp0_;
	return result;
}


static void nuvola_mpris_player_set_can_go_next (NuvolaMPRISPlayer* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_go_next = _tmp0_;
	g_object_notify ((GObject *) self, "can-go-next");
}


gboolean nuvola_mpris_player_get_can_go_previous (NuvolaMPRISPlayer* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_go_previous;
	result = _tmp0_;
	return result;
}


static void nuvola_mpris_player_set_can_go_previous (NuvolaMPRISPlayer* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_go_previous = _tmp0_;
	g_object_notify ((GObject *) self, "can-go-previous");
}


gboolean nuvola_mpris_player_get_can_play (NuvolaMPRISPlayer* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_play;
	result = _tmp0_;
	return result;
}


static void nuvola_mpris_player_set_can_play (NuvolaMPRISPlayer* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_play = _tmp0_;
	g_object_notify ((GObject *) self, "can-play");
}


gboolean nuvola_mpris_player_get_can_pause (NuvolaMPRISPlayer* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_pause;
	result = _tmp0_;
	return result;
}


static void nuvola_mpris_player_set_can_pause (NuvolaMPRISPlayer* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_pause = _tmp0_;
	g_object_notify ((GObject *) self, "can-pause");
}


gboolean nuvola_mpris_player_get_can_seek (NuvolaMPRISPlayer* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_seek;
	result = _tmp0_;
	return result;
}


static void nuvola_mpris_player_set_can_seek (NuvolaMPRISPlayer* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_seek = _tmp0_;
	g_object_notify ((GObject *) self, "can-seek");
}


gboolean nuvola_mpris_player_get_can_control (NuvolaMPRISPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean nuvola_mpris_player_get_nuvola_can_rate (NuvolaMPRISPlayer* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_nuvola_can_rate;
	result = _tmp0_;
	return result;
}


static void nuvola_mpris_player_set_nuvola_can_rate (NuvolaMPRISPlayer* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_nuvola_can_rate = _tmp0_;
	g_object_notify ((GObject *) self, "nuvola-can-rate");
}


GHashTable* nuvola_mpris_player_get_metadata (NuvolaMPRISPlayer* self) {
	GHashTable* result;
	GHashTable* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_metadata;
	result = _tmp0_;
	return result;
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


static void nuvola_mpris_player_set_metadata (NuvolaMPRISPlayer* self, GHashTable* value) {
	GHashTable* _tmp0_ = NULL;
	GHashTable* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_hash_table_ref0 (_tmp0_);
	_g_hash_table_unref0 (self->priv->_metadata);
	self->priv->_metadata = _tmp1_;
	g_object_notify ((GObject *) self, "metadata");
}


gdouble nuvola_mpris_player_get_volume (NuvolaMPRISPlayer* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_volume;
	result = _tmp0_;
	return result;
}


void nuvola_mpris_player_set_volume (NuvolaMPRISPlayer* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	NuvolaMediaPlayerModel* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = value;
	if (_tmp1_ < 0.0) {
		_tmp0_ = 0.0;
	} else {
		gdouble _tmp2_ = 0.0;
		_tmp2_ = value;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = self->priv->player;
	nuvola_media_player_model_change_volume (_tmp3_, _tmp0_);
	g_object_notify ((GObject *) self, "volume");
}


static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}


static void nuvola_mpris_player_class_init (NuvolaMPRISPlayerClass * klass) {
	nuvola_mpris_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaMPRISPlayerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_mpris_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_mpris_player_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_mpris_player_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_PLAYBACK_STATUS, g_param_spec_string ("playback-status", "playback-status", "playback-status", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_RATE, g_param_spec_double ("rate", "rate", "rate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_MINIMUM_RATE, g_param_spec_double ("minimum-rate", "minimum-rate", "minimum-rate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_MAXIMUM_RATE, g_param_spec_double ("maximum-rate", "maximum-rate", "maximum-rate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_POSITION, g_param_spec_int64 ("position", "position", "position", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_CAN_GO_NEXT, g_param_spec_boolean ("can-go-next", "can-go-next", "can-go-next", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_CAN_GO_PREVIOUS, g_param_spec_boolean ("can-go-previous", "can-go-previous", "can-go-previous", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_CAN_PLAY, g_param_spec_boolean ("can-play", "can-play", "can-play", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_CAN_PAUSE, g_param_spec_boolean ("can-pause", "can-pause", "can-pause", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_CAN_SEEK, g_param_spec_boolean ("can-seek", "can-seek", "can-seek", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_CAN_CONTROL, g_param_spec_boolean ("can-control", "can-control", "can-control", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_NUVOLA_CAN_RATE, g_param_spec_boolean ("nuvola-can-rate", "nuvola-can-rate", "nuvola-can-rate", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_METADATA, g_param_spec_boxed ("metadata", "metadata", "metadata", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MPRIS_PLAYER_VOLUME, g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("seeked", NUVOLA_TYPE_MPRIS_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
}


static void nuvola_mpris_player_instance_init (NuvolaMPRISPlayer * self) {
	self->priv = NUVOLA_MPRIS_PLAYER_GET_PRIVATE (self);
	self->priv->pending_update_id = (guint) 0;
	self->priv->_position = (gint64) 0;
	self->priv->_can_go_next = FALSE;
	self->priv->_can_go_previous = FALSE;
	self->priv->_can_play = FALSE;
	self->priv->_can_pause = FALSE;
	self->priv->_can_seek = FALSE;
	self->priv->_nuvola_can_rate = FALSE;
	self->priv->_metadata = NULL;
	self->priv->_volume = 1.0;
}


static void nuvola_mpris_player_finalize (GObject* obj) {
	NuvolaMPRISPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_MPRIS_PLAYER, NuvolaMPRISPlayer);
	_g_object_unref0 (self->priv->conn);
	_g_object_unref0 (self->priv->player);
	_g_hash_table_unref0 (self->priv->pending_update);
	_g_free0 (self->priv->_playback_status);
	_g_hash_table_unref0 (self->priv->_metadata);
	G_OBJECT_CLASS (nuvola_mpris_player_parent_class)->finalize (obj);
}


GType nuvola_mpris_player_get_type (void) {
	static volatile gsize nuvola_mpris_player_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_mpris_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaMPRISPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_mpris_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaMPRISPlayer), 0, (GInstanceInitFunc) nuvola_mpris_player_instance_init, NULL };
		GType nuvola_mpris_player_type_id;
		nuvola_mpris_player_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaMPRISPlayer", &g_define_type_info, 0);
		g_type_set_qdata (nuvola_mpris_player_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) nuvola_mpris_player_register_object);
		g_once_init_leave (&nuvola_mpris_player_type_id__volatile, nuvola_mpris_player_type_id);
	}
	return nuvola_mpris_player_type_id__volatile;
}


static void _vala_nuvola_mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaMPRISPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_MPRIS_PLAYER, NuvolaMPRISPlayer);
	switch (property_id) {
		case NUVOLA_MPRIS_PLAYER_PLAYBACK_STATUS:
		g_value_set_string (value, nuvola_mpris_player_get_playback_status (self));
		break;
		case NUVOLA_MPRIS_PLAYER_RATE:
		g_value_set_double (value, nuvola_mpris_player_get_rate (self));
		break;
		case NUVOLA_MPRIS_PLAYER_MINIMUM_RATE:
		g_value_set_double (value, nuvola_mpris_player_get_minimum_rate (self));
		break;
		case NUVOLA_MPRIS_PLAYER_MAXIMUM_RATE:
		g_value_set_double (value, nuvola_mpris_player_get_maximum_rate (self));
		break;
		case NUVOLA_MPRIS_PLAYER_POSITION:
		g_value_set_int64 (value, nuvola_mpris_player_get_position (self));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_GO_NEXT:
		g_value_set_boolean (value, nuvola_mpris_player_get_can_go_next (self));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_GO_PREVIOUS:
		g_value_set_boolean (value, nuvola_mpris_player_get_can_go_previous (self));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_PLAY:
		g_value_set_boolean (value, nuvola_mpris_player_get_can_play (self));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_PAUSE:
		g_value_set_boolean (value, nuvola_mpris_player_get_can_pause (self));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_SEEK:
		g_value_set_boolean (value, nuvola_mpris_player_get_can_seek (self));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_CONTROL:
		g_value_set_boolean (value, nuvola_mpris_player_get_can_control (self));
		break;
		case NUVOLA_MPRIS_PLAYER_NUVOLA_CAN_RATE:
		g_value_set_boolean (value, nuvola_mpris_player_get_nuvola_can_rate (self));
		break;
		case NUVOLA_MPRIS_PLAYER_METADATA:
		g_value_set_boxed (value, nuvola_mpris_player_get_metadata (self));
		break;
		case NUVOLA_MPRIS_PLAYER_VOLUME:
		g_value_set_double (value, nuvola_mpris_player_get_volume (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaMPRISPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_MPRIS_PLAYER, NuvolaMPRISPlayer);
	switch (property_id) {
		case NUVOLA_MPRIS_PLAYER_PLAYBACK_STATUS:
		nuvola_mpris_player_set_playback_status (self, g_value_get_string (value));
		break;
		case NUVOLA_MPRIS_PLAYER_RATE:
		nuvola_mpris_player_set_rate (self, g_value_get_double (value));
		break;
		case NUVOLA_MPRIS_PLAYER_POSITION:
		nuvola_mpris_player_set_position (self, g_value_get_int64 (value));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_GO_NEXT:
		nuvola_mpris_player_set_can_go_next (self, g_value_get_boolean (value));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_GO_PREVIOUS:
		nuvola_mpris_player_set_can_go_previous (self, g_value_get_boolean (value));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_PLAY:
		nuvola_mpris_player_set_can_play (self, g_value_get_boolean (value));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_PAUSE:
		nuvola_mpris_player_set_can_pause (self, g_value_get_boolean (value));
		break;
		case NUVOLA_MPRIS_PLAYER_CAN_SEEK:
		nuvola_mpris_player_set_can_seek (self, g_value_get_boolean (value));
		break;
		case NUVOLA_MPRIS_PLAYER_NUVOLA_CAN_RATE:
		nuvola_mpris_player_set_nuvola_can_rate (self, g_value_get_boolean (value));
		break;
		case NUVOLA_MPRIS_PLAYER_METADATA:
		nuvola_mpris_player_set_metadata (self, g_value_get_boxed (value));
		break;
		case NUVOLA_MPRIS_PLAYER_VOLUME:
		nuvola_mpris_player_set_volume (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _dbus_nuvola_mpris_player_next (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	nuvola_mpris_player_next (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_nuvola_mpris_player_previous (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	nuvola_mpris_player_previous (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_nuvola_mpris_player_pause (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	nuvola_mpris_player_pause (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_nuvola_mpris_player_play_pause (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	nuvola_mpris_player_play_pause (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_nuvola_mpris_player_stop (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	nuvola_mpris_player_stop (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_nuvola_mpris_player_play (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	nuvola_mpris_player_play (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_nuvola_mpris_player_seek (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint64 offset = 0LL;
	GVariant* _tmp16_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp16_ = g_variant_iter_next_value (&_arguments_iter);
	offset = g_variant_get_int64 (_tmp16_);
	g_variant_unref (_tmp16_);
	nuvola_mpris_player_seek (self, offset);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_nuvola_mpris_player_SetPosition (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* track_id = NULL;
	GVariant* _tmp17_;
	gint64 position = 0LL;
	GVariant* _tmp18_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp17_ = g_variant_iter_next_value (&_arguments_iter);
	track_id = g_variant_dup_string (_tmp17_, NULL);
	g_variant_unref (_tmp17_);
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	position = g_variant_get_int64 (_tmp18_);
	g_variant_unref (_tmp18_);
	nuvola_mpris_player_SetPosition (self, track_id, position);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (track_id);
}


static void _dbus_nuvola_mpris_player_open_uri (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp19_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp19_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp19_, NULL);
	g_variant_unref (_tmp19_);
	nuvola_mpris_player_open_uri (self, uri);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (uri);
}


static void _dbus_nuvola_mpris_player_nuvola_set_rating (NuvolaMPRISPlayer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gdouble rating = 0.0;
	GVariant* _tmp20_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp20_ = g_variant_iter_next_value (&_arguments_iter);
	rating = g_variant_get_double (_tmp20_);
	g_variant_unref (_tmp20_);
	nuvola_mpris_player_nuvola_set_rating (self, rating);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void nuvola_mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Next") == 0) {
		_dbus_nuvola_mpris_player_next (object, parameters, invocation);
	} else if (strcmp (method_name, "Previous") == 0) {
		_dbus_nuvola_mpris_player_previous (object, parameters, invocation);
	} else if (strcmp (method_name, "Pause") == 0) {
		_dbus_nuvola_mpris_player_pause (object, parameters, invocation);
	} else if (strcmp (method_name, "PlayPause") == 0) {
		_dbus_nuvola_mpris_player_play_pause (object, parameters, invocation);
	} else if (strcmp (method_name, "Stop") == 0) {
		_dbus_nuvola_mpris_player_stop (object, parameters, invocation);
	} else if (strcmp (method_name, "Play") == 0) {
		_dbus_nuvola_mpris_player_play (object, parameters, invocation);
	} else if (strcmp (method_name, "Seek") == 0) {
		_dbus_nuvola_mpris_player_seek (object, parameters, invocation);
	} else if (strcmp (method_name, "SetPosition") == 0) {
		_dbus_nuvola_mpris_player_SetPosition (object, parameters, invocation);
	} else if (strcmp (method_name, "OpenUri") == 0) {
		_dbus_nuvola_mpris_player_open_uri (object, parameters, invocation);
	} else if (strcmp (method_name, "NuvolaSetRating") == 0) {
		_dbus_nuvola_mpris_player_nuvola_set_rating (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* _dbus_nuvola_mpris_player_get_playback_status (NuvolaMPRISPlayer* self) {
	const gchar* result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_playback_status (self);
	_reply = g_variant_new_string (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_rate (NuvolaMPRISPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_minimum_rate (NuvolaMPRISPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_minimum_rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_maximum_rate (NuvolaMPRISPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_maximum_rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_position (NuvolaMPRISPlayer* self) {
	gint64 result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_position (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_can_go_next (NuvolaMPRISPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_can_go_next (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_can_go_previous (NuvolaMPRISPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_can_go_previous (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_can_play (NuvolaMPRISPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_can_play (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_can_pause (NuvolaMPRISPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_can_pause (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_can_seek (NuvolaMPRISPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_can_seek (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_can_control (NuvolaMPRISPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_can_control (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_nuvola_can_rate (NuvolaMPRISPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_nuvola_can_rate (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_metadata (NuvolaMPRISPlayer* self) {
	GHashTable* result;
	GVariantBuilder _tmp21_;
	GHashTableIter _tmp22_;
	gpointer _tmp23_;
	gpointer _tmp24_;
	GVariant* _reply;
	result = nuvola_mpris_player_get_metadata (self);
	g_hash_table_iter_init (&_tmp22_, result);
	g_variant_builder_init (&_tmp21_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp22_, &_tmp23_, &_tmp24_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp23_;
		_value = (GVariant*) _tmp24_;
		g_variant_builder_add (&_tmp21_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	_reply = g_variant_builder_end (&_tmp21_);
	return _reply;
}


static GVariant* _dbus_nuvola_mpris_player_get_volume (NuvolaMPRISPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = nuvola_mpris_player_get_volume (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* nuvola_mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaybackStatus") == 0) {
		return _dbus_nuvola_mpris_player_get_playback_status (object);
	} else if (strcmp (property_name, "Rate") == 0) {
		return _dbus_nuvola_mpris_player_get_rate (object);
	} else if (strcmp (property_name, "MinimumRate") == 0) {
		return _dbus_nuvola_mpris_player_get_minimum_rate (object);
	} else if (strcmp (property_name, "MaximumRate") == 0) {
		return _dbus_nuvola_mpris_player_get_maximum_rate (object);
	} else if (strcmp (property_name, "Position") == 0) {
		return _dbus_nuvola_mpris_player_get_position (object);
	} else if (strcmp (property_name, "CanGoNext") == 0) {
		return _dbus_nuvola_mpris_player_get_can_go_next (object);
	} else if (strcmp (property_name, "CanGoPrevious") == 0) {
		return _dbus_nuvola_mpris_player_get_can_go_previous (object);
	} else if (strcmp (property_name, "CanPlay") == 0) {
		return _dbus_nuvola_mpris_player_get_can_play (object);
	} else if (strcmp (property_name, "CanPause") == 0) {
		return _dbus_nuvola_mpris_player_get_can_pause (object);
	} else if (strcmp (property_name, "CanSeek") == 0) {
		return _dbus_nuvola_mpris_player_get_can_seek (object);
	} else if (strcmp (property_name, "CanControl") == 0) {
		return _dbus_nuvola_mpris_player_get_can_control (object);
	} else if (strcmp (property_name, "NuvolaCanRate") == 0) {
		return _dbus_nuvola_mpris_player_get_nuvola_can_rate (object);
	} else if (strcmp (property_name, "Metadata") == 0) {
		return _dbus_nuvola_mpris_player_get_metadata (object);
	} else if (strcmp (property_name, "Volume") == 0) {
		return _dbus_nuvola_mpris_player_get_volume (object);
	}
	return NULL;
}


static void _dbus_nuvola_mpris_player_set_playback_status (NuvolaMPRISPlayer* self, GVariant* _value) {
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	nuvola_mpris_player_set_playback_status (self, value);
	_g_free0 (value);
}


static void _dbus_nuvola_mpris_player_set_rate (NuvolaMPRISPlayer* self, GVariant* _value) {
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	nuvola_mpris_player_set_rate (self, value);
}


static void _dbus_nuvola_mpris_player_set_position (NuvolaMPRISPlayer* self, GVariant* _value) {
	gint64 value = 0LL;
	value = g_variant_get_int64 (_value);
	nuvola_mpris_player_set_position (self, value);
}


static void _dbus_nuvola_mpris_player_set_can_go_next (NuvolaMPRISPlayer* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	nuvola_mpris_player_set_can_go_next (self, value);
}


static void _dbus_nuvola_mpris_player_set_can_go_previous (NuvolaMPRISPlayer* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	nuvola_mpris_player_set_can_go_previous (self, value);
}


static void _dbus_nuvola_mpris_player_set_can_play (NuvolaMPRISPlayer* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	nuvola_mpris_player_set_can_play (self, value);
}


static void _dbus_nuvola_mpris_player_set_can_pause (NuvolaMPRISPlayer* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	nuvola_mpris_player_set_can_pause (self, value);
}


static void _dbus_nuvola_mpris_player_set_can_seek (NuvolaMPRISPlayer* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	nuvola_mpris_player_set_can_seek (self, value);
}


static void _dbus_nuvola_mpris_player_set_nuvola_can_rate (NuvolaMPRISPlayer* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	nuvola_mpris_player_set_nuvola_can_rate (self, value);
}


static void _dbus_nuvola_mpris_player_set_metadata (NuvolaMPRISPlayer* self, GVariant* _value) {
	GHashTable* value = NULL;
	GHashTable* _tmp25_;
	GVariantIter _tmp26_;
	GVariant* _tmp27_;
	GVariant* _tmp28_;
	_tmp25_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp26_, _value);
	while (g_variant_iter_loop (&_tmp26_, "{?*}", &_tmp27_, &_tmp28_)) {
		g_hash_table_insert (_tmp25_, g_variant_dup_string (_tmp27_, NULL), g_variant_get_variant (_tmp28_));
	}
	value = _tmp25_;
	nuvola_mpris_player_set_metadata (self, value);
	_g_hash_table_unref0 (value);
}


static void _dbus_nuvola_mpris_player_set_volume (NuvolaMPRISPlayer* self, GVariant* _value) {
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	nuvola_mpris_player_set_volume (self, value);
}


static gboolean nuvola_mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaybackStatus") == 0) {
		_dbus_nuvola_mpris_player_set_playback_status (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Rate") == 0) {
		_dbus_nuvola_mpris_player_set_rate (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Position") == 0) {
		_dbus_nuvola_mpris_player_set_position (object, value);
		return TRUE;
	} else if (strcmp (property_name, "CanGoNext") == 0) {
		_dbus_nuvola_mpris_player_set_can_go_next (object, value);
		return TRUE;
	} else if (strcmp (property_name, "CanGoPrevious") == 0) {
		_dbus_nuvola_mpris_player_set_can_go_previous (object, value);
		return TRUE;
	} else if (strcmp (property_name, "CanPlay") == 0) {
		_dbus_nuvola_mpris_player_set_can_play (object, value);
		return TRUE;
	} else if (strcmp (property_name, "CanPause") == 0) {
		_dbus_nuvola_mpris_player_set_can_pause (object, value);
		return TRUE;
	} else if (strcmp (property_name, "CanSeek") == 0) {
		_dbus_nuvola_mpris_player_set_can_seek (object, value);
		return TRUE;
	} else if (strcmp (property_name, "NuvolaCanRate") == 0) {
		_dbus_nuvola_mpris_player_set_nuvola_can_rate (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Metadata") == 0) {
		_dbus_nuvola_mpris_player_set_metadata (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Volume") == 0) {
		_dbus_nuvola_mpris_player_set_volume (object, value);
		return TRUE;
	}
	return FALSE;
}


static void _dbus_nuvola_mpris_player_seeked (GObject* _sender, gint64 position, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int64 (position));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.mpris.MediaPlayer2.Player", "Seeked", _arguments, NULL);
}


guint nuvola_mpris_player_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_nuvola_mpris_player_dbus_interface_info), &_nuvola_mpris_player_dbus_interface_vtable, data, _nuvola_mpris_player_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "seeked", (GCallback) _dbus_nuvola_mpris_player_seeked, data);
	return result;
}


static void _nuvola_mpris_player_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_nuvola_mpris_player_seeked, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



