/* MasterWindow.c generated by valac 0.34.9, the Vala compiler
 * generated from MasterWindow.vala, do not modify */

/*
 * Copyright 2014-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <dioritegtk4.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_MASTER_WINDOW (nuvola_master_window_get_type ())
#define NUVOLA_MASTER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_MASTER_WINDOW, NuvolaMasterWindow))
#define NUVOLA_MASTER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_MASTER_WINDOW, NuvolaMasterWindowClass))
#define NUVOLA_IS_MASTER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_MASTER_WINDOW))
#define NUVOLA_IS_MASTER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_MASTER_WINDOW))
#define NUVOLA_MASTER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_MASTER_WINDOW, NuvolaMasterWindowClass))

typedef struct _NuvolaMasterWindow NuvolaMasterWindow;
typedef struct _NuvolaMasterWindowClass NuvolaMasterWindowClass;
typedef struct _NuvolaMasterWindowPrivate NuvolaMasterWindowPrivate;

#define NUVOLA_TYPE_MASTER_CONTROLLER (nuvola_master_controller_get_type ())
#define NUVOLA_MASTER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_MASTER_CONTROLLER, NuvolaMasterController))
#define NUVOLA_MASTER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_MASTER_CONTROLLER, NuvolaMasterControllerClass))
#define NUVOLA_IS_MASTER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_MASTER_CONTROLLER))
#define NUVOLA_IS_MASTER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_MASTER_CONTROLLER))
#define NUVOLA_MASTER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_MASTER_CONTROLLER, NuvolaMasterControllerClass))

typedef struct _NuvolaMasterController NuvolaMasterController;
typedef struct _NuvolaMasterControllerClass NuvolaMasterControllerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NuvolaMasterWindow {
	DrtApplicationWindow parent_instance;
	NuvolaMasterWindowPrivate * priv;
	GtkStack* stack;
};

struct _NuvolaMasterWindowClass {
	DrtApplicationWindowClass parent_class;
};

struct _NuvolaMasterWindowPrivate {
	GtkStackSwitcher* switcher;
	NuvolaMasterController* app;
};


static gpointer nuvola_master_window_parent_class = NULL;

GType nuvola_master_window_get_type (void) G_GNUC_CONST;
GType nuvola_master_controller_get_type (void) G_GNUC_CONST;
#define NUVOLA_MASTER_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_MASTER_WINDOW, NuvolaMasterWindowPrivate))
enum  {
	NUVOLA_MASTER_WINDOW_DUMMY_PROPERTY
};
NuvolaMasterWindow* nuvola_master_window_new (NuvolaMasterController* app);
NuvolaMasterWindow* nuvola_master_window_construct (GType object_type, NuvolaMasterController* app);
static void nuvola_master_window_update_title (NuvolaMasterWindow* self, const gchar* title);
static void nuvola_master_window_update (NuvolaMasterWindow* self);
static void _nuvola_master_window_update_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
void nuvola_master_window_add_page (NuvolaMasterWindow* self, GtkWidget* page, const gchar* name, const gchar* title);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void nuvola_master_window_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
 * Creates new MasterWindow for given app
 */
static void _nuvola_master_window_update_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	nuvola_master_window_update ((NuvolaMasterWindow*) self);
}


NuvolaMasterWindow* nuvola_master_window_construct (GType object_type, NuvolaMasterController* app) {
	NuvolaMasterWindow * self = NULL;
	NuvolaMasterController* _tmp0_ = NULL;
	NuvolaMasterController* _tmp7_ = NULL;
	gchar** _tmp8_ = NULL;
	gchar** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	GtkStack* _tmp10_ = NULL;
	GtkStack* _tmp11_ = NULL;
	GtkStackSwitcher* _tmp12_ = NULL;
	GtkStackSwitcher* _tmp13_ = NULL;
	GtkStack* _tmp14_ = NULL;
	GtkHeaderBar* _tmp15_ = NULL;
	GtkHeaderBar* _tmp16_ = NULL;
	GtkStackSwitcher* _tmp17_ = NULL;
	GtkStackSwitcher* _tmp18_ = NULL;
	GtkGrid* _tmp19_ = NULL;
	GtkGrid* _tmp20_ = NULL;
	GtkStack* _tmp21_ = NULL;
	GtkStack* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	_tmp0_ = app;
	self = (NuvolaMasterWindow*) drt_application_window_construct (object_type, (DrtApplication*) _tmp0_, FALSE);
	{
		GdkPixbuf* _tmp1_ = NULL;
		GtkIconTheme* _tmp2_ = NULL;
		NuvolaMasterController* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		GdkPixbuf* _tmp6_ = NULL;
		_tmp2_ = gtk_icon_theme_get_default ();
		_tmp3_ = app;
		_tmp4_ = drt_application_get_icon ((DrtApplication*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = gtk_icon_theme_load_icon (_tmp2_, _tmp5_, 48, 0, &_inner_error_);
		_tmp1_ = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch85_g_error;
		}
		gtk_window_set_icon ((GtkWindow*) self, _tmp1_);
		_g_object_unref0 (_tmp1_);
	}
	goto __finally85;
	__catch85_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("MasterWindow.vala:50: Unable to load application icon.");
		_g_error_free0 (e);
	}
	__finally85:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	gtk_window_set_default_size ((GtkWindow*) self, 900, 600);
	_tmp7_ = app;
	self->priv->app = _tmp7_;
	nuvola_master_window_update_title (self, NULL);
	_tmp8_ = g_new0 (gchar*, 0 + 1);
	_tmp9_ = _tmp8_;
	_tmp9__length1 = 0;
	drt_application_window_create_toolbar ((DrtApplicationWindow*) self, _tmp9_, 0);
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
	_tmp10_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->stack);
	self->stack = _tmp10_;
	_tmp11_ = self->stack;
	g_signal_connect_object ((GObject*) _tmp11_, "notify::visible-child", (GCallback) _nuvola_master_window_update_g_object_notify, self, G_CONNECT_AFTER);
	_tmp12_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->switcher);
	self->priv->switcher = _tmp12_;
	_tmp13_ = self->priv->switcher;
	_tmp14_ = self->stack;
	gtk_stack_switcher_set_stack (_tmp13_, _tmp14_);
	_tmp15_ = drt_application_window_get_header_bar ((DrtApplicationWindow*) self);
	_tmp16_ = _tmp15_;
	_tmp17_ = self->priv->switcher;
	gtk_header_bar_set_custom_title (_tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = self->priv->switcher;
	gtk_widget_show ((GtkWidget*) _tmp18_);
	_tmp19_ = drt_application_window_get_top_grid ((DrtApplicationWindow*) self);
	_tmp20_ = _tmp19_;
	_tmp21_ = self->stack;
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = self->stack;
	gtk_widget_show_all ((GtkWidget*) _tmp22_);
	return self;
}


NuvolaMasterWindow* nuvola_master_window_new (NuvolaMasterController* app) {
	return nuvola_master_window_construct (NUVOLA_TYPE_MASTER_WINDOW, app);
}


/**
 * Add page to the main page stack
 * 
 * @param page     A widget to add.
 * @param name     A page name.
 * @param title    A title for the switcher.
 */
void nuvola_master_window_add_page (NuvolaMasterWindow* self, GtkWidget* page, const gchar* name, const gchar* title) {
	gboolean was_empty = FALSE;
	GtkStack* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	GtkStack* _tmp3_ = NULL;
	GtkWidget* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (title != NULL);
	_tmp0_ = self->stack;
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
	_tmp2_ = _tmp1_;
	was_empty = _tmp2_ == NULL;
	_tmp3_ = self->stack;
	_tmp4_ = page;
	_tmp5_ = name;
	_tmp6_ = title;
	gtk_stack_add_titled (_tmp3_, _tmp4_, _tmp5_, _tmp6_);
	_tmp7_ = was_empty;
	if (_tmp7_) {
		nuvola_master_window_update (self);
	}
}


static void nuvola_master_window_update_title (NuvolaMasterWindow* self, const gchar* title) {
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = title;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_ = NULL;
		NuvolaMasterController* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp2_ = title;
		_tmp3_ = self->priv->app;
		_tmp4_ = drt_application_get_app_name ((DrtApplication*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup_printf ("%s - %s", _tmp2_, _tmp5_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp6_;
	} else {
		NuvolaMasterController* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		_tmp7_ = self->priv->app;
		_tmp8_ = drt_application_get_app_name ((DrtApplication*) _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strdup (_tmp9_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp10_;
	}
	gtk_window_set_title ((GtkWindow*) self, _tmp0_);
	_g_free0 (_tmp0_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void nuvola_master_window_update (NuvolaMasterWindow* self) {
	GtkWidget* child = NULL;
	GtkStack* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	GtkWidget* _tmp3_ = NULL;
	gchar* name = NULL;
	gchar* title = NULL;
	GtkWidget* _tmp4_ = NULL;
	const gchar* _tmp7_ = NULL;
	GtkWidget* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->stack;
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	child = _tmp3_;
	name = NULL;
	title = NULL;
	_tmp4_ = child;
	if (_tmp4_ != NULL) {
		GtkStack* _tmp5_ = NULL;
		GtkWidget* _tmp6_ = NULL;
		_tmp5_ = self->stack;
		_tmp6_ = child;
		gtk_container_child_get ((GtkContainer*) _tmp5_, _tmp6_, "name", &name, "title", &title, NULL);
	}
	_tmp7_ = title;
	nuvola_master_window_update_title (self, _tmp7_);
	_tmp8_ = child;
	_tmp9_ = name;
	_tmp10_ = title;
	g_signal_emit_by_name (self, "page-changed", _tmp8_, _tmp9_, _tmp10_);
	_g_free0 (title);
	_g_free0 (name);
	_g_object_unref0 (child);
}


static void g_cclosure_user_marshal_VOID__OBJECT_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), data2);
}


static void nuvola_master_window_class_init (NuvolaMasterWindowClass * klass) {
	nuvola_master_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaMasterWindowPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_master_window_finalize;
	/**
	 * Emitted when a page in the stack has changed
	 * 
	 * @param widget    Page widget
	 * @param name      Name of the page or null.
	 * @param title     Title of the page or null.
	 */
	g_signal_new ("page_changed", NUVOLA_TYPE_MASTER_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING_STRING, G_TYPE_NONE, 3, gtk_widget_get_type (), G_TYPE_STRING, G_TYPE_STRING);
}


static void nuvola_master_window_instance_init (NuvolaMasterWindow * self) {
	self->priv = NUVOLA_MASTER_WINDOW_GET_PRIVATE (self);
}


static void nuvola_master_window_finalize (GObject* obj) {
	NuvolaMasterWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_MASTER_WINDOW, NuvolaMasterWindow);
	_g_object_unref0 (self->stack);
	_g_object_unref0 (self->priv->switcher);
	G_OBJECT_CLASS (nuvola_master_window_parent_class)->finalize (obj);
}


/**
 * Main window of the Nuvola Master process
 */
GType nuvola_master_window_get_type (void) {
	static volatile gsize nuvola_master_window_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_master_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaMasterWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_master_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaMasterWindow), 0, (GInstanceInitFunc) nuvola_master_window_instance_init, NULL };
		GType nuvola_master_window_type_id;
		nuvola_master_window_type_id = g_type_register_static (DRT_TYPE_APPLICATION_WINDOW, "NuvolaMasterWindow", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_master_window_type_id__volatile, nuvola_master_window_type_id);
	}
	return nuvola_master_window_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



