/* MediaPlayer.c generated by valac 0.34.9, the Vala compiler
 * generated from MediaPlayer.vala, do not modify */

/*
 * Copyright 2014-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <dioritegtk4.h>


#define NUVOLA_TYPE_MEDIA_PLAYER_MODEL (nuvola_media_player_model_get_type ())
#define NUVOLA_MEDIA_PLAYER_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_MEDIA_PLAYER_MODEL, NuvolaMediaPlayerModel))
#define NUVOLA_IS_MEDIA_PLAYER_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_MEDIA_PLAYER_MODEL))
#define NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_MEDIA_PLAYER_MODEL, NuvolaMediaPlayerModelIface))

typedef struct _NuvolaMediaPlayerModel NuvolaMediaPlayerModel;
typedef struct _NuvolaMediaPlayerModelIface NuvolaMediaPlayerModelIface;

#define NUVOLA_TYPE_MEDIA_PLAYER (nuvola_media_player_get_type ())
#define NUVOLA_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_MEDIA_PLAYER, NuvolaMediaPlayer))
#define NUVOLA_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_MEDIA_PLAYER, NuvolaMediaPlayerClass))
#define NUVOLA_IS_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_MEDIA_PLAYER))
#define NUVOLA_IS_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_MEDIA_PLAYER))
#define NUVOLA_MEDIA_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_MEDIA_PLAYER, NuvolaMediaPlayerClass))

typedef struct _NuvolaMediaPlayer NuvolaMediaPlayer;
typedef struct _NuvolaMediaPlayerClass NuvolaMediaPlayerClass;
typedef struct _NuvolaMediaPlayerPrivate NuvolaMediaPlayerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _NuvolaMediaPlayerModelIface {
	GTypeInterface parent_iface;
	void (*handle_set_track_info) (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length);
	void (*play) (NuvolaMediaPlayerModel* self);
	void (*pause) (NuvolaMediaPlayerModel* self);
	void (*toggle_play) (NuvolaMediaPlayerModel* self);
	void (*stop) (NuvolaMediaPlayerModel* self);
	void (*prev_song) (NuvolaMediaPlayerModel* self);
	void (*next_song) (NuvolaMediaPlayerModel* self);
	void (*seek) (NuvolaMediaPlayerModel* self, gint64 position);
	void (*change_volume) (NuvolaMediaPlayerModel* self, gdouble volume);
	void (*set_track_info) (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length);
	const gchar* (*get_title) (NuvolaMediaPlayerModel* self);
	void (*set_title) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_artist) (NuvolaMediaPlayerModel* self);
	void (*set_artist) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_album) (NuvolaMediaPlayerModel* self);
	void (*set_album) (NuvolaMediaPlayerModel* self, const gchar* value);
	gdouble (*get_rating) (NuvolaMediaPlayerModel* self);
	void (*set_rating) (NuvolaMediaPlayerModel* self, gdouble value);
	const gchar* (*get_state) (NuvolaMediaPlayerModel* self);
	void (*set_state) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_artwork_location) (NuvolaMediaPlayerModel* self);
	void (*set_artwork_location) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_artwork_file) (NuvolaMediaPlayerModel* self);
	void (*set_artwork_file) (NuvolaMediaPlayerModel* self, const gchar* value);
	gint64 (*get_track_length) (NuvolaMediaPlayerModel* self);
	void (*set_track_length) (NuvolaMediaPlayerModel* self, gint64 value);
	gint64 (*get_track_position) (NuvolaMediaPlayerModel* self);
	void (*set_track_position) (NuvolaMediaPlayerModel* self, gint64 value);
	gdouble (*get_volume) (NuvolaMediaPlayerModel* self);
	void (*set_volume) (NuvolaMediaPlayerModel* self, gdouble value);
	gboolean (*get_can_go_next) (NuvolaMediaPlayerModel* self);
	void (*set_can_go_next) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_go_previous) (NuvolaMediaPlayerModel* self);
	void (*set_can_go_previous) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_play) (NuvolaMediaPlayerModel* self);
	void (*set_can_play) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_pause) (NuvolaMediaPlayerModel* self);
	void (*set_can_pause) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_stop) (NuvolaMediaPlayerModel* self);
	void (*set_can_stop) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_rate) (NuvolaMediaPlayerModel* self);
	void (*set_can_rate) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_seek) (NuvolaMediaPlayerModel* self);
	void (*set_can_seek) (NuvolaMediaPlayerModel* self, gboolean value);
	GSList* (*get_playback_actions) (NuvolaMediaPlayerModel* self);
	void (*set_playback_actions) (NuvolaMediaPlayerModel* self, GSList* value);
};

struct _NuvolaMediaPlayer {
	GObject parent_instance;
	NuvolaMediaPlayerPrivate * priv;
};

struct _NuvolaMediaPlayerClass {
	GObjectClass parent_class;
};

struct _NuvolaMediaPlayerPrivate {
	gchar* _title;
	gchar* _artist;
	gchar* _album;
	gdouble _rating;
	gchar* _state;
	gchar* _artwork_location;
	gchar* _artwork_file;
	gint64 _track_length;
	gint64 _track_position;
	gdouble _volume;
	gboolean _can_go_next;
	gboolean _can_go_previous;
	gboolean _can_play;
	gboolean _can_pause;
	gboolean _can_stop;
	gboolean _can_rate;
	gboolean _can_seek;
	gboolean _can_change_volume;
	GSList* _playback_actions;
	DrtActions* actions;
};


static gpointer nuvola_media_player_parent_class = NULL;
static NuvolaMediaPlayerModelIface* nuvola_media_player_nuvola_media_player_model_parent_iface = NULL;

GType nuvola_media_player_model_get_type (void) G_GNUC_CONST;
GType nuvola_media_player_get_type (void) G_GNUC_CONST;
#define NUVOLA_MEDIA_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_MEDIA_PLAYER, NuvolaMediaPlayerPrivate))
enum  {
	NUVOLA_MEDIA_PLAYER_DUMMY_PROPERTY,
	NUVOLA_MEDIA_PLAYER_TITLE,
	NUVOLA_MEDIA_PLAYER_ARTIST,
	NUVOLA_MEDIA_PLAYER_ALBUM,
	NUVOLA_MEDIA_PLAYER_RATING,
	NUVOLA_MEDIA_PLAYER_STATE,
	NUVOLA_MEDIA_PLAYER_ARTWORK_LOCATION,
	NUVOLA_MEDIA_PLAYER_ARTWORK_FILE,
	NUVOLA_MEDIA_PLAYER_TRACK_LENGTH,
	NUVOLA_MEDIA_PLAYER_TRACK_POSITION,
	NUVOLA_MEDIA_PLAYER_VOLUME,
	NUVOLA_MEDIA_PLAYER_CAN_GO_NEXT,
	NUVOLA_MEDIA_PLAYER_CAN_GO_PREVIOUS,
	NUVOLA_MEDIA_PLAYER_CAN_PLAY,
	NUVOLA_MEDIA_PLAYER_CAN_PAUSE,
	NUVOLA_MEDIA_PLAYER_CAN_STOP,
	NUVOLA_MEDIA_PLAYER_CAN_RATE,
	NUVOLA_MEDIA_PLAYER_CAN_SEEK,
	NUVOLA_MEDIA_PLAYER_CAN_CHANGE_VOLUME,
	NUVOLA_MEDIA_PLAYER_PLAYBACK_ACTIONS
};
static void _g_free0_ (gpointer var);
static void _g_slist_free__g_free0_ (GSList* self);
NuvolaMediaPlayer* nuvola_media_player_new (DrtActions* actions);
NuvolaMediaPlayer* nuvola_media_player_construct (GType object_type, DrtActions* actions);
static void nuvola_media_player_real_handle_set_track_info (NuvolaMediaPlayerModel* base, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length);
void nuvola_media_player_model_set_title (NuvolaMediaPlayerModel* self, const gchar* value);
void nuvola_media_player_model_set_artist (NuvolaMediaPlayerModel* self, const gchar* value);
void nuvola_media_player_model_set_album (NuvolaMediaPlayerModel* self, const gchar* value);
void nuvola_media_player_model_set_rating (NuvolaMediaPlayerModel* self, gdouble value);
void nuvola_media_player_model_set_state (NuvolaMediaPlayerModel* self, const gchar* value);
void nuvola_media_player_model_set_artwork_location (NuvolaMediaPlayerModel* self, const gchar* value);
void nuvola_media_player_model_set_artwork_file (NuvolaMediaPlayerModel* self, const gchar* value);
void nuvola_media_player_model_set_track_length (NuvolaMediaPlayerModel* self, gint64 value);
static void nuvola_media_player_real_play (NuvolaMediaPlayerModel* base);
static void nuvola_media_player_activate_action (NuvolaMediaPlayer* self, const gchar* name, GVariant* parameter);
static void nuvola_media_player_real_pause (NuvolaMediaPlayerModel* base);
static void nuvola_media_player_real_toggle_play (NuvolaMediaPlayerModel* base);
static void nuvola_media_player_real_stop (NuvolaMediaPlayerModel* base);
static void nuvola_media_player_real_prev_song (NuvolaMediaPlayerModel* base);
static void nuvola_media_player_real_next_song (NuvolaMediaPlayerModel* base);
static void nuvola_media_player_real_seek (NuvolaMediaPlayerModel* base, gint64 position);
static GVariant* _variant_new9 (gint64 value);
static void nuvola_media_player_real_change_volume (NuvolaMediaPlayerModel* base, gdouble volume);
static GVariant* _variant_new10 (gdouble value);
gboolean nuvola_media_player_get_can_change_volume (NuvolaMediaPlayer* self);
void nuvola_media_player_set_can_change_volume (NuvolaMediaPlayer* self, gboolean value);
static void nuvola_media_player_finalize (GObject* obj);
const gchar* nuvola_media_player_model_get_title (NuvolaMediaPlayerModel* self);
const gchar* nuvola_media_player_model_get_artist (NuvolaMediaPlayerModel* self);
const gchar* nuvola_media_player_model_get_album (NuvolaMediaPlayerModel* self);
gdouble nuvola_media_player_model_get_rating (NuvolaMediaPlayerModel* self);
const gchar* nuvola_media_player_model_get_state (NuvolaMediaPlayerModel* self);
const gchar* nuvola_media_player_model_get_artwork_location (NuvolaMediaPlayerModel* self);
const gchar* nuvola_media_player_model_get_artwork_file (NuvolaMediaPlayerModel* self);
gint64 nuvola_media_player_model_get_track_length (NuvolaMediaPlayerModel* self);
gint64 nuvola_media_player_model_get_track_position (NuvolaMediaPlayerModel* self);
gdouble nuvola_media_player_model_get_volume (NuvolaMediaPlayerModel* self);
gboolean nuvola_media_player_model_get_can_go_next (NuvolaMediaPlayerModel* self);
gboolean nuvola_media_player_model_get_can_go_previous (NuvolaMediaPlayerModel* self);
gboolean nuvola_media_player_model_get_can_play (NuvolaMediaPlayerModel* self);
gboolean nuvola_media_player_model_get_can_pause (NuvolaMediaPlayerModel* self);
gboolean nuvola_media_player_model_get_can_stop (NuvolaMediaPlayerModel* self);
gboolean nuvola_media_player_model_get_can_rate (NuvolaMediaPlayerModel* self);
gboolean nuvola_media_player_model_get_can_seek (NuvolaMediaPlayerModel* self);
GSList* nuvola_media_player_model_get_playback_actions (NuvolaMediaPlayerModel* self);
static void _vala_nuvola_media_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
void nuvola_media_player_model_set_track_position (NuvolaMediaPlayerModel* self, gint64 value);
void nuvola_media_player_model_set_volume (NuvolaMediaPlayerModel* self, gdouble value);
void nuvola_media_player_model_set_can_go_next (NuvolaMediaPlayerModel* self, gboolean value);
void nuvola_media_player_model_set_can_go_previous (NuvolaMediaPlayerModel* self, gboolean value);
void nuvola_media_player_model_set_can_play (NuvolaMediaPlayerModel* self, gboolean value);
void nuvola_media_player_model_set_can_pause (NuvolaMediaPlayerModel* self, gboolean value);
void nuvola_media_player_model_set_can_stop (NuvolaMediaPlayerModel* self, gboolean value);
void nuvola_media_player_model_set_can_rate (NuvolaMediaPlayerModel* self, gboolean value);
void nuvola_media_player_model_set_can_seek (NuvolaMediaPlayerModel* self, gboolean value);
void nuvola_media_player_model_set_playback_actions (NuvolaMediaPlayerModel* self, GSList* value);
static void _vala_nuvola_media_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_slist_free__g_free0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_free0_, NULL);
	g_slist_free (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


NuvolaMediaPlayer* nuvola_media_player_construct (GType object_type, DrtActions* actions) {
	NuvolaMediaPlayer * self = NULL;
	DrtActions* _tmp0_ = NULL;
	DrtActions* _tmp1_ = NULL;
	g_return_val_if_fail (actions != NULL, NULL);
	self = (NuvolaMediaPlayer*) g_object_new (object_type, NULL);
	_tmp0_ = actions;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->actions);
	self->priv->actions = _tmp1_;
	return self;
}


NuvolaMediaPlayer* nuvola_media_player_new (DrtActions* actions) {
	return nuvola_media_player_construct (NUVOLA_TYPE_MEDIA_PLAYER, actions);
}


static void nuvola_media_player_real_handle_set_track_info (NuvolaMediaPlayerModel* base, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length) {
	NuvolaMediaPlayer * self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gint64 _tmp7_ = 0LL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = title;
	nuvola_media_player_model_set_title ((NuvolaMediaPlayerModel*) self, _tmp0_);
	_tmp1_ = artist;
	nuvola_media_player_model_set_artist ((NuvolaMediaPlayerModel*) self, _tmp1_);
	_tmp2_ = album;
	nuvola_media_player_model_set_album ((NuvolaMediaPlayerModel*) self, _tmp2_);
	_tmp3_ = rating;
	nuvola_media_player_model_set_rating ((NuvolaMediaPlayerModel*) self, _tmp3_);
	_tmp4_ = state;
	nuvola_media_player_model_set_state ((NuvolaMediaPlayerModel*) self, _tmp4_);
	_tmp5_ = artwork_location;
	nuvola_media_player_model_set_artwork_location ((NuvolaMediaPlayerModel*) self, _tmp5_);
	_tmp6_ = artwork_file;
	nuvola_media_player_model_set_artwork_file ((NuvolaMediaPlayerModel*) self, _tmp6_);
	_tmp7_ = length;
	nuvola_media_player_model_set_track_length ((NuvolaMediaPlayerModel*) self, _tmp7_);
}


static void nuvola_media_player_real_play (NuvolaMediaPlayerModel* base) {
	NuvolaMediaPlayer * self;
	self = (NuvolaMediaPlayer*) base;
	nuvola_media_player_activate_action (self, "play", NULL);
}


static void nuvola_media_player_real_pause (NuvolaMediaPlayerModel* base) {
	NuvolaMediaPlayer * self;
	self = (NuvolaMediaPlayer*) base;
	nuvola_media_player_activate_action (self, "pause", NULL);
}


static void nuvola_media_player_real_toggle_play (NuvolaMediaPlayerModel* base) {
	NuvolaMediaPlayer * self;
	self = (NuvolaMediaPlayer*) base;
	nuvola_media_player_activate_action (self, "toggle-play", NULL);
}


static void nuvola_media_player_real_stop (NuvolaMediaPlayerModel* base) {
	NuvolaMediaPlayer * self;
	self = (NuvolaMediaPlayer*) base;
	nuvola_media_player_activate_action (self, "stop", NULL);
}


static void nuvola_media_player_real_prev_song (NuvolaMediaPlayerModel* base) {
	NuvolaMediaPlayer * self;
	self = (NuvolaMediaPlayer*) base;
	nuvola_media_player_activate_action (self, "prev-song", NULL);
}


static void nuvola_media_player_real_next_song (NuvolaMediaPlayerModel* base) {
	NuvolaMediaPlayer * self;
	self = (NuvolaMediaPlayer*) base;
	nuvola_media_player_activate_action (self, "next-song", NULL);
}


static GVariant* _variant_new9 (gint64 value) {
	return g_variant_ref_sink (g_variant_new_int64 (value));
}


static void nuvola_media_player_real_seek (NuvolaMediaPlayerModel* base, gint64 position) {
	NuvolaMediaPlayer * self;
	gint64 _tmp0_ = 0LL;
	GVariant* _tmp1_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = position;
	_tmp1_ = _variant_new9 (_tmp0_);
	nuvola_media_player_activate_action (self, "seek", _tmp1_);
	_g_variant_unref0 (_tmp1_);
}


static GVariant* _variant_new10 (gdouble value) {
	return g_variant_ref_sink (g_variant_new_double (value));
}


static void nuvola_media_player_real_change_volume (NuvolaMediaPlayerModel* base, gdouble volume) {
	NuvolaMediaPlayer * self;
	gdouble _tmp0_ = 0.0;
	GVariant* _tmp1_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = volume;
	_tmp1_ = _variant_new10 (_tmp0_);
	nuvola_media_player_activate_action (self, "change-volume", _tmp1_);
	_g_variant_unref0 (_tmp1_);
}


static void nuvola_media_player_activate_action (NuvolaMediaPlayer* self, const gchar* name, GVariant* parameter) {
	DrtActions* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->actions;
	_tmp1_ = name;
	_tmp2_ = parameter;
	_tmp3_ = drt_actions_activate_action (_tmp0_, _tmp1_, _tmp2_);
	if (!_tmp3_) {
		const gchar* _tmp4_ = NULL;
		_tmp4_ = name;
		g_critical ("MediaPlayer.vala:110: Failed to activate action '%s'.", _tmp4_);
	}
}


static const gchar* nuvola_media_player_real_get_title (NuvolaMediaPlayerModel* base) {
	const gchar* result;
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_title (NuvolaMediaPlayerModel* base, const gchar* value) {
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_title);
	self->priv->_title = _tmp1_;
	g_object_notify ((GObject *) self, "title");
}


static const gchar* nuvola_media_player_real_get_artist (NuvolaMediaPlayerModel* base) {
	const gchar* result;
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_artist;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_artist (NuvolaMediaPlayerModel* base, const gchar* value) {
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_artist);
	self->priv->_artist = _tmp1_;
	g_object_notify ((GObject *) self, "artist");
}


static const gchar* nuvola_media_player_real_get_album (NuvolaMediaPlayerModel* base) {
	const gchar* result;
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_album;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_album (NuvolaMediaPlayerModel* base, const gchar* value) {
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_album);
	self->priv->_album = _tmp1_;
	g_object_notify ((GObject *) self, "album");
}


static gdouble nuvola_media_player_real_get_rating (NuvolaMediaPlayerModel* base) {
	gdouble result;
	NuvolaMediaPlayer* self;
	gdouble _tmp0_ = 0.0;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_rating;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_rating (NuvolaMediaPlayerModel* base, gdouble value) {
	NuvolaMediaPlayer* self;
	gdouble _tmp0_ = 0.0;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_rating = _tmp0_;
	g_object_notify ((GObject *) self, "rating");
}


static const gchar* nuvola_media_player_real_get_state (NuvolaMediaPlayerModel* base) {
	const gchar* result;
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_state (NuvolaMediaPlayerModel* base, const gchar* value) {
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_state);
	self->priv->_state = _tmp1_;
	g_object_notify ((GObject *) self, "state");
}


static const gchar* nuvola_media_player_real_get_artwork_location (NuvolaMediaPlayerModel* base) {
	const gchar* result;
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_artwork_location;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_artwork_location (NuvolaMediaPlayerModel* base, const gchar* value) {
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_artwork_location);
	self->priv->_artwork_location = _tmp1_;
	g_object_notify ((GObject *) self, "artwork-location");
}


static const gchar* nuvola_media_player_real_get_artwork_file (NuvolaMediaPlayerModel* base) {
	const gchar* result;
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_artwork_file;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_artwork_file (NuvolaMediaPlayerModel* base, const gchar* value) {
	NuvolaMediaPlayer* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_artwork_file);
	self->priv->_artwork_file = _tmp1_;
	g_object_notify ((GObject *) self, "artwork-file");
}


static gint64 nuvola_media_player_real_get_track_length (NuvolaMediaPlayerModel* base) {
	gint64 result;
	NuvolaMediaPlayer* self;
	gint64 _tmp0_ = 0LL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_track_length;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_track_length (NuvolaMediaPlayerModel* base, gint64 value) {
	NuvolaMediaPlayer* self;
	gint64 _tmp0_ = 0LL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_track_length = _tmp0_;
	g_object_notify ((GObject *) self, "track-length");
}


static gint64 nuvola_media_player_real_get_track_position (NuvolaMediaPlayerModel* base) {
	gint64 result;
	NuvolaMediaPlayer* self;
	gint64 _tmp0_ = 0LL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_track_position;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_track_position (NuvolaMediaPlayerModel* base, gint64 value) {
	NuvolaMediaPlayer* self;
	gint64 _tmp0_ = 0LL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_track_position = _tmp0_;
	g_object_notify ((GObject *) self, "track-position");
}


static gdouble nuvola_media_player_real_get_volume (NuvolaMediaPlayerModel* base) {
	gdouble result;
	NuvolaMediaPlayer* self;
	gdouble _tmp0_ = 0.0;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_volume;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_volume (NuvolaMediaPlayerModel* base, gdouble value) {
	NuvolaMediaPlayer* self;
	gdouble _tmp0_ = 0.0;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_volume = _tmp0_;
	g_object_notify ((GObject *) self, "volume");
}


static gboolean nuvola_media_player_real_get_can_go_next (NuvolaMediaPlayerModel* base) {
	gboolean result;
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_can_go_next;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_can_go_next (NuvolaMediaPlayerModel* base, gboolean value) {
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_can_go_next = _tmp0_;
	g_object_notify ((GObject *) self, "can-go-next");
}


static gboolean nuvola_media_player_real_get_can_go_previous (NuvolaMediaPlayerModel* base) {
	gboolean result;
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_can_go_previous;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_can_go_previous (NuvolaMediaPlayerModel* base, gboolean value) {
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_can_go_previous = _tmp0_;
	g_object_notify ((GObject *) self, "can-go-previous");
}


static gboolean nuvola_media_player_real_get_can_play (NuvolaMediaPlayerModel* base) {
	gboolean result;
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_can_play;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_can_play (NuvolaMediaPlayerModel* base, gboolean value) {
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_can_play = _tmp0_;
	g_object_notify ((GObject *) self, "can-play");
}


static gboolean nuvola_media_player_real_get_can_pause (NuvolaMediaPlayerModel* base) {
	gboolean result;
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_can_pause;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_can_pause (NuvolaMediaPlayerModel* base, gboolean value) {
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_can_pause = _tmp0_;
	g_object_notify ((GObject *) self, "can-pause");
}


static gboolean nuvola_media_player_real_get_can_stop (NuvolaMediaPlayerModel* base) {
	gboolean result;
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_can_stop;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_can_stop (NuvolaMediaPlayerModel* base, gboolean value) {
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_can_stop = _tmp0_;
	g_object_notify ((GObject *) self, "can-stop");
}


static gboolean nuvola_media_player_real_get_can_rate (NuvolaMediaPlayerModel* base) {
	gboolean result;
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_can_rate;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_can_rate (NuvolaMediaPlayerModel* base, gboolean value) {
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_can_rate = _tmp0_;
	g_object_notify ((GObject *) self, "can-rate");
}


static gboolean nuvola_media_player_real_get_can_seek (NuvolaMediaPlayerModel* base) {
	gboolean result;
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_can_seek;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_can_seek (NuvolaMediaPlayerModel* base, gboolean value) {
	NuvolaMediaPlayer* self;
	gboolean _tmp0_ = FALSE;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	self->priv->_can_seek = _tmp0_;
	g_object_notify ((GObject *) self, "can-seek");
}


gboolean nuvola_media_player_get_can_change_volume (NuvolaMediaPlayer* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_change_volume;
	result = _tmp0_;
	return result;
}


void nuvola_media_player_set_can_change_volume (NuvolaMediaPlayer* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_change_volume = _tmp0_;
	g_object_notify ((GObject *) self, "can-change-volume");
}


static GSList* nuvola_media_player_real_get_playback_actions (NuvolaMediaPlayerModel* base) {
	GSList* result;
	NuvolaMediaPlayer* self;
	GSList* _tmp0_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = self->priv->_playback_actions;
	result = _tmp0_;
	return result;
}


static void nuvola_media_player_real_set_playback_actions (NuvolaMediaPlayerModel* base, GSList* value) {
	NuvolaMediaPlayer* self;
	GSList* _tmp0_ = NULL;
	self = (NuvolaMediaPlayer*) base;
	_tmp0_ = value;
	value = NULL;
	__g_slist_free__g_free0_0 (self->priv->_playback_actions);
	self->priv->_playback_actions = _tmp0_;
	__g_slist_free__g_free0_0 (value);
	g_object_notify ((GObject *) self, "playback-actions");
}


static void nuvola_media_player_class_init (NuvolaMediaPlayerClass * klass) {
	nuvola_media_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaMediaPlayerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_media_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_media_player_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_media_player_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_TITLE, g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_ARTIST, g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_ALBUM, g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_RATING, g_param_spec_double ("rating", "rating", "rating", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_STATE, g_param_spec_string ("state", "state", "state", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_ARTWORK_LOCATION, g_param_spec_string ("artwork-location", "artwork-location", "artwork-location", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_ARTWORK_FILE, g_param_spec_string ("artwork-file", "artwork-file", "artwork-file", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_TRACK_LENGTH, g_param_spec_int64 ("track-length", "track-length", "track-length", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_TRACK_POSITION, g_param_spec_int64 ("track-position", "track-position", "track-position", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_VOLUME, g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 1.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_CAN_GO_NEXT, g_param_spec_boolean ("can-go-next", "can-go-next", "can-go-next", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_CAN_GO_PREVIOUS, g_param_spec_boolean ("can-go-previous", "can-go-previous", "can-go-previous", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_CAN_PLAY, g_param_spec_boolean ("can-play", "can-play", "can-play", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_CAN_PAUSE, g_param_spec_boolean ("can-pause", "can-pause", "can-pause", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_CAN_STOP, g_param_spec_boolean ("can-stop", "can-stop", "can-stop", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_CAN_RATE, g_param_spec_boolean ("can-rate", "can-rate", "can-rate", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_CAN_SEEK, g_param_spec_boolean ("can-seek", "can-seek", "can-seek", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_CAN_CHANGE_VOLUME, g_param_spec_boolean ("can-change-volume", "can-change-volume", "can-change-volume", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_MEDIA_PLAYER_PLAYBACK_ACTIONS, g_param_spec_pointer ("playback-actions", "playback-actions", "playback-actions", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void nuvola_media_player_nuvola_media_player_model_interface_init (NuvolaMediaPlayerModelIface * iface) {
	nuvola_media_player_nuvola_media_player_model_parent_iface = g_type_interface_peek_parent (iface);
	iface->handle_set_track_info = (void (*)(NuvolaMediaPlayerModel*, const gchar*, const gchar*, const gchar*, const gchar*, const gchar*, const gchar*, gdouble, gint64)) nuvola_media_player_real_handle_set_track_info;
	iface->play = (void (*)(NuvolaMediaPlayerModel*)) nuvola_media_player_real_play;
	iface->pause = (void (*)(NuvolaMediaPlayerModel*)) nuvola_media_player_real_pause;
	iface->toggle_play = (void (*)(NuvolaMediaPlayerModel*)) nuvola_media_player_real_toggle_play;
	iface->stop = (void (*)(NuvolaMediaPlayerModel*)) nuvola_media_player_real_stop;
	iface->prev_song = (void (*)(NuvolaMediaPlayerModel*)) nuvola_media_player_real_prev_song;
	iface->next_song = (void (*)(NuvolaMediaPlayerModel*)) nuvola_media_player_real_next_song;
	iface->seek = (void (*)(NuvolaMediaPlayerModel*, gint64)) nuvola_media_player_real_seek;
	iface->change_volume = (void (*)(NuvolaMediaPlayerModel*, gdouble)) nuvola_media_player_real_change_volume;
	iface->get_title = nuvola_media_player_real_get_title;
	iface->set_title = nuvola_media_player_real_set_title;
	iface->get_artist = nuvola_media_player_real_get_artist;
	iface->set_artist = nuvola_media_player_real_set_artist;
	iface->get_album = nuvola_media_player_real_get_album;
	iface->set_album = nuvola_media_player_real_set_album;
	iface->get_rating = nuvola_media_player_real_get_rating;
	iface->set_rating = nuvola_media_player_real_set_rating;
	iface->get_state = nuvola_media_player_real_get_state;
	iface->set_state = nuvola_media_player_real_set_state;
	iface->get_artwork_location = nuvola_media_player_real_get_artwork_location;
	iface->set_artwork_location = nuvola_media_player_real_set_artwork_location;
	iface->get_artwork_file = nuvola_media_player_real_get_artwork_file;
	iface->set_artwork_file = nuvola_media_player_real_set_artwork_file;
	iface->get_track_length = nuvola_media_player_real_get_track_length;
	iface->set_track_length = nuvola_media_player_real_set_track_length;
	iface->get_track_position = nuvola_media_player_real_get_track_position;
	iface->set_track_position = nuvola_media_player_real_set_track_position;
	iface->get_volume = nuvola_media_player_real_get_volume;
	iface->set_volume = nuvola_media_player_real_set_volume;
	iface->get_can_go_next = nuvola_media_player_real_get_can_go_next;
	iface->set_can_go_next = nuvola_media_player_real_set_can_go_next;
	iface->get_can_go_previous = nuvola_media_player_real_get_can_go_previous;
	iface->set_can_go_previous = nuvola_media_player_real_set_can_go_previous;
	iface->get_can_play = nuvola_media_player_real_get_can_play;
	iface->set_can_play = nuvola_media_player_real_set_can_play;
	iface->get_can_pause = nuvola_media_player_real_get_can_pause;
	iface->set_can_pause = nuvola_media_player_real_set_can_pause;
	iface->get_can_stop = nuvola_media_player_real_get_can_stop;
	iface->set_can_stop = nuvola_media_player_real_set_can_stop;
	iface->get_can_rate = nuvola_media_player_real_get_can_rate;
	iface->set_can_rate = nuvola_media_player_real_set_can_rate;
	iface->get_can_seek = nuvola_media_player_real_get_can_seek;
	iface->set_can_seek = nuvola_media_player_real_set_can_seek;
	iface->get_playback_actions = nuvola_media_player_real_get_playback_actions;
	iface->set_playback_actions = nuvola_media_player_real_set_playback_actions;
}


static void nuvola_media_player_instance_init (NuvolaMediaPlayer * self) {
	self->priv = NUVOLA_MEDIA_PLAYER_GET_PRIVATE (self);
	self->priv->_title = NULL;
	self->priv->_artist = NULL;
	self->priv->_album = NULL;
	self->priv->_rating = 0.0;
	self->priv->_state = NULL;
	self->priv->_artwork_location = NULL;
	self->priv->_artwork_file = NULL;
	self->priv->_track_length = (gint64) 0;
	self->priv->_track_position = (gint64) 0;
	self->priv->_volume = 1.0;
	self->priv->_can_go_next = FALSE;
	self->priv->_can_go_previous = FALSE;
	self->priv->_can_play = FALSE;
	self->priv->_can_pause = FALSE;
	self->priv->_can_stop = FALSE;
	self->priv->_can_rate = FALSE;
	self->priv->_can_seek = FALSE;
	self->priv->_can_change_volume = FALSE;
}


static void nuvola_media_player_finalize (GObject* obj) {
	NuvolaMediaPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_MEDIA_PLAYER, NuvolaMediaPlayer);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_artist);
	_g_free0 (self->priv->_album);
	_g_free0 (self->priv->_state);
	_g_free0 (self->priv->_artwork_location);
	_g_free0 (self->priv->_artwork_file);
	__g_slist_free__g_free0_0 (self->priv->_playback_actions);
	_g_object_unref0 (self->priv->actions);
	G_OBJECT_CLASS (nuvola_media_player_parent_class)->finalize (obj);
}


GType nuvola_media_player_get_type (void) {
	static volatile gsize nuvola_media_player_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_media_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaMediaPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_media_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaMediaPlayer), 0, (GInstanceInitFunc) nuvola_media_player_instance_init, NULL };
		static const GInterfaceInfo nuvola_media_player_model_info = { (GInterfaceInitFunc) nuvola_media_player_nuvola_media_player_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType nuvola_media_player_type_id;
		nuvola_media_player_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaMediaPlayer", &g_define_type_info, 0);
		g_type_add_interface_static (nuvola_media_player_type_id, NUVOLA_TYPE_MEDIA_PLAYER_MODEL, &nuvola_media_player_model_info);
		g_once_init_leave (&nuvola_media_player_type_id__volatile, nuvola_media_player_type_id);
	}
	return nuvola_media_player_type_id__volatile;
}


static void _vala_nuvola_media_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaMediaPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_MEDIA_PLAYER, NuvolaMediaPlayer);
	switch (property_id) {
		case NUVOLA_MEDIA_PLAYER_TITLE:
		g_value_set_string (value, nuvola_media_player_model_get_title ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_ARTIST:
		g_value_set_string (value, nuvola_media_player_model_get_artist ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_ALBUM:
		g_value_set_string (value, nuvola_media_player_model_get_album ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_RATING:
		g_value_set_double (value, nuvola_media_player_model_get_rating ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_STATE:
		g_value_set_string (value, nuvola_media_player_model_get_state ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_ARTWORK_LOCATION:
		g_value_set_string (value, nuvola_media_player_model_get_artwork_location ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_ARTWORK_FILE:
		g_value_set_string (value, nuvola_media_player_model_get_artwork_file ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_TRACK_LENGTH:
		g_value_set_int64 (value, nuvola_media_player_model_get_track_length ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_TRACK_POSITION:
		g_value_set_int64 (value, nuvola_media_player_model_get_track_position ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_VOLUME:
		g_value_set_double (value, nuvola_media_player_model_get_volume ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_GO_NEXT:
		g_value_set_boolean (value, nuvola_media_player_model_get_can_go_next ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_GO_PREVIOUS:
		g_value_set_boolean (value, nuvola_media_player_model_get_can_go_previous ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_PLAY:
		g_value_set_boolean (value, nuvola_media_player_model_get_can_play ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_PAUSE:
		g_value_set_boolean (value, nuvola_media_player_model_get_can_pause ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_STOP:
		g_value_set_boolean (value, nuvola_media_player_model_get_can_stop ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_RATE:
		g_value_set_boolean (value, nuvola_media_player_model_get_can_rate ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_SEEK:
		g_value_set_boolean (value, nuvola_media_player_model_get_can_seek ((NuvolaMediaPlayerModel*) self));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_CHANGE_VOLUME:
		g_value_set_boolean (value, nuvola_media_player_get_can_change_volume (self));
		break;
		case NUVOLA_MEDIA_PLAYER_PLAYBACK_ACTIONS:
		g_value_set_pointer (value, nuvola_media_player_model_get_playback_actions ((NuvolaMediaPlayerModel*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_media_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaMediaPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_MEDIA_PLAYER, NuvolaMediaPlayer);
	switch (property_id) {
		case NUVOLA_MEDIA_PLAYER_TITLE:
		nuvola_media_player_model_set_title ((NuvolaMediaPlayerModel*) self, g_value_get_string (value));
		break;
		case NUVOLA_MEDIA_PLAYER_ARTIST:
		nuvola_media_player_model_set_artist ((NuvolaMediaPlayerModel*) self, g_value_get_string (value));
		break;
		case NUVOLA_MEDIA_PLAYER_ALBUM:
		nuvola_media_player_model_set_album ((NuvolaMediaPlayerModel*) self, g_value_get_string (value));
		break;
		case NUVOLA_MEDIA_PLAYER_RATING:
		nuvola_media_player_model_set_rating ((NuvolaMediaPlayerModel*) self, g_value_get_double (value));
		break;
		case NUVOLA_MEDIA_PLAYER_STATE:
		nuvola_media_player_model_set_state ((NuvolaMediaPlayerModel*) self, g_value_get_string (value));
		break;
		case NUVOLA_MEDIA_PLAYER_ARTWORK_LOCATION:
		nuvola_media_player_model_set_artwork_location ((NuvolaMediaPlayerModel*) self, g_value_get_string (value));
		break;
		case NUVOLA_MEDIA_PLAYER_ARTWORK_FILE:
		nuvola_media_player_model_set_artwork_file ((NuvolaMediaPlayerModel*) self, g_value_get_string (value));
		break;
		case NUVOLA_MEDIA_PLAYER_TRACK_LENGTH:
		nuvola_media_player_model_set_track_length ((NuvolaMediaPlayerModel*) self, g_value_get_int64 (value));
		break;
		case NUVOLA_MEDIA_PLAYER_TRACK_POSITION:
		nuvola_media_player_model_set_track_position ((NuvolaMediaPlayerModel*) self, g_value_get_int64 (value));
		break;
		case NUVOLA_MEDIA_PLAYER_VOLUME:
		nuvola_media_player_model_set_volume ((NuvolaMediaPlayerModel*) self, g_value_get_double (value));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_GO_NEXT:
		nuvola_media_player_model_set_can_go_next ((NuvolaMediaPlayerModel*) self, g_value_get_boolean (value));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_GO_PREVIOUS:
		nuvola_media_player_model_set_can_go_previous ((NuvolaMediaPlayerModel*) self, g_value_get_boolean (value));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_PLAY:
		nuvola_media_player_model_set_can_play ((NuvolaMediaPlayerModel*) self, g_value_get_boolean (value));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_PAUSE:
		nuvola_media_player_model_set_can_pause ((NuvolaMediaPlayerModel*) self, g_value_get_boolean (value));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_STOP:
		nuvola_media_player_model_set_can_stop ((NuvolaMediaPlayerModel*) self, g_value_get_boolean (value));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_RATE:
		nuvola_media_player_model_set_can_rate ((NuvolaMediaPlayerModel*) self, g_value_get_boolean (value));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_SEEK:
		nuvola_media_player_model_set_can_seek ((NuvolaMediaPlayerModel*) self, g_value_get_boolean (value));
		break;
		case NUVOLA_MEDIA_PLAYER_CAN_CHANGE_VOLUME:
		nuvola_media_player_set_can_change_volume (self, g_value_get_boolean (value));
		break;
		case NUVOLA_MEDIA_PLAYER_PLAYBACK_ACTIONS:
		nuvola_media_player_model_set_playback_actions ((NuvolaMediaPlayerModel*) self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



