/* MediaPlayerModel.c generated by valac 0.34.9, the Vala compiler
 * generated from MediaPlayerModel.vala, do not modify */

/*
 * Copyright 2014-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define NUVOLA_TYPE_MEDIA_PLAYER_MODEL (nuvola_media_player_model_get_type ())
#define NUVOLA_MEDIA_PLAYER_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_MEDIA_PLAYER_MODEL, NuvolaMediaPlayerModel))
#define NUVOLA_IS_MEDIA_PLAYER_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_MEDIA_PLAYER_MODEL))
#define NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_MEDIA_PLAYER_MODEL, NuvolaMediaPlayerModelIface))

typedef struct _NuvolaMediaPlayerModel NuvolaMediaPlayerModel;
typedef struct _NuvolaMediaPlayerModelIface NuvolaMediaPlayerModelIface;

struct _NuvolaMediaPlayerModelIface {
	GTypeInterface parent_iface;
	void (*handle_set_track_info) (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length);
	void (*play) (NuvolaMediaPlayerModel* self);
	void (*pause) (NuvolaMediaPlayerModel* self);
	void (*toggle_play) (NuvolaMediaPlayerModel* self);
	void (*stop) (NuvolaMediaPlayerModel* self);
	void (*prev_song) (NuvolaMediaPlayerModel* self);
	void (*next_song) (NuvolaMediaPlayerModel* self);
	void (*seek) (NuvolaMediaPlayerModel* self, gint64 position);
	void (*change_volume) (NuvolaMediaPlayerModel* self, gdouble volume);
	void (*set_track_info) (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length);
	const gchar* (*get_title) (NuvolaMediaPlayerModel* self);
	void (*set_title) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_artist) (NuvolaMediaPlayerModel* self);
	void (*set_artist) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_album) (NuvolaMediaPlayerModel* self);
	void (*set_album) (NuvolaMediaPlayerModel* self, const gchar* value);
	gdouble (*get_rating) (NuvolaMediaPlayerModel* self);
	void (*set_rating) (NuvolaMediaPlayerModel* self, gdouble value);
	const gchar* (*get_state) (NuvolaMediaPlayerModel* self);
	void (*set_state) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_artwork_location) (NuvolaMediaPlayerModel* self);
	void (*set_artwork_location) (NuvolaMediaPlayerModel* self, const gchar* value);
	const gchar* (*get_artwork_file) (NuvolaMediaPlayerModel* self);
	void (*set_artwork_file) (NuvolaMediaPlayerModel* self, const gchar* value);
	gint64 (*get_track_length) (NuvolaMediaPlayerModel* self);
	void (*set_track_length) (NuvolaMediaPlayerModel* self, gint64 value);
	gint64 (*get_track_position) (NuvolaMediaPlayerModel* self);
	void (*set_track_position) (NuvolaMediaPlayerModel* self, gint64 value);
	gdouble (*get_volume) (NuvolaMediaPlayerModel* self);
	void (*set_volume) (NuvolaMediaPlayerModel* self, gdouble value);
	gboolean (*get_can_go_next) (NuvolaMediaPlayerModel* self);
	void (*set_can_go_next) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_go_previous) (NuvolaMediaPlayerModel* self);
	void (*set_can_go_previous) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_play) (NuvolaMediaPlayerModel* self);
	void (*set_can_play) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_pause) (NuvolaMediaPlayerModel* self);
	void (*set_can_pause) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_stop) (NuvolaMediaPlayerModel* self);
	void (*set_can_stop) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_rate) (NuvolaMediaPlayerModel* self);
	void (*set_can_rate) (NuvolaMediaPlayerModel* self, gboolean value);
	gboolean (*get_can_seek) (NuvolaMediaPlayerModel* self);
	void (*set_can_seek) (NuvolaMediaPlayerModel* self, gboolean value);
	GSList* (*get_playback_actions) (NuvolaMediaPlayerModel* self);
	void (*set_playback_actions) (NuvolaMediaPlayerModel* self, GSList* value);
};



GType nuvola_media_player_model_get_type (void) G_GNUC_CONST;
void nuvola_media_player_model_handle_set_track_info (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length);
void nuvola_media_player_model_play (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_pause (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_toggle_play (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_stop (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_prev_song (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_next_song (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_seek (NuvolaMediaPlayerModel* self, gint64 position);
void nuvola_media_player_model_change_volume (NuvolaMediaPlayerModel* self, gdouble volume);
const gchar* nuvola_media_player_model_get_title (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_title (NuvolaMediaPlayerModel* self, const gchar* value);
const gchar* nuvola_media_player_model_get_artist (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_artist (NuvolaMediaPlayerModel* self, const gchar* value);
const gchar* nuvola_media_player_model_get_album (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_album (NuvolaMediaPlayerModel* self, const gchar* value);
gdouble nuvola_media_player_model_get_rating (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_rating (NuvolaMediaPlayerModel* self, gdouble value);
const gchar* nuvola_media_player_model_get_state (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_state (NuvolaMediaPlayerModel* self, const gchar* value);
const gchar* nuvola_media_player_model_get_artwork_location (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_artwork_location (NuvolaMediaPlayerModel* self, const gchar* value);
const gchar* nuvola_media_player_model_get_artwork_file (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_artwork_file (NuvolaMediaPlayerModel* self, const gchar* value);
gint64 nuvola_media_player_model_get_track_length (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_track_length (NuvolaMediaPlayerModel* self, gint64 value);
gint64 nuvola_media_player_model_get_track_position (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_track_position (NuvolaMediaPlayerModel* self, gint64 value);
gdouble nuvola_media_player_model_get_volume (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_volume (NuvolaMediaPlayerModel* self, gdouble value);
gboolean nuvola_media_player_model_get_can_go_next (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_can_go_next (NuvolaMediaPlayerModel* self, gboolean value);
gboolean nuvola_media_player_model_get_can_go_previous (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_can_go_previous (NuvolaMediaPlayerModel* self, gboolean value);
gboolean nuvola_media_player_model_get_can_play (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_can_play (NuvolaMediaPlayerModel* self, gboolean value);
gboolean nuvola_media_player_model_get_can_pause (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_can_pause (NuvolaMediaPlayerModel* self, gboolean value);
gboolean nuvola_media_player_model_get_can_stop (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_can_stop (NuvolaMediaPlayerModel* self, gboolean value);
gboolean nuvola_media_player_model_get_can_rate (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_can_rate (NuvolaMediaPlayerModel* self, gboolean value);
gboolean nuvola_media_player_model_get_can_seek (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_can_seek (NuvolaMediaPlayerModel* self, gboolean value);
GSList* nuvola_media_player_model_get_playback_actions (NuvolaMediaPlayerModel* self);
void nuvola_media_player_model_set_playback_actions (NuvolaMediaPlayerModel* self, GSList* value);
static void nuvola_media_player_model_real_set_track_info (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING_STRING_STRING_STRING_DOUBLE_INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);


void nuvola_media_player_model_handle_set_track_info (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->handle_set_track_info (self, title, artist, album, state, artwork_location, artwork_file, rating, length);
}


void nuvola_media_player_model_play (NuvolaMediaPlayerModel* self) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->play (self);
}


void nuvola_media_player_model_pause (NuvolaMediaPlayerModel* self) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->pause (self);
}


void nuvola_media_player_model_toggle_play (NuvolaMediaPlayerModel* self) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->toggle_play (self);
}


void nuvola_media_player_model_stop (NuvolaMediaPlayerModel* self) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->stop (self);
}


void nuvola_media_player_model_prev_song (NuvolaMediaPlayerModel* self) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->prev_song (self);
}


void nuvola_media_player_model_next_song (NuvolaMediaPlayerModel* self) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->next_song (self);
}


void nuvola_media_player_model_seek (NuvolaMediaPlayerModel* self, gint64 position) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->seek (self, position);
}


void nuvola_media_player_model_change_volume (NuvolaMediaPlayerModel* self, gdouble volume) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->change_volume (self, volume);
}


const gchar* nuvola_media_player_model_get_title (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_title (self);
}


void nuvola_media_player_model_set_title (NuvolaMediaPlayerModel* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_title (self, value);
}


const gchar* nuvola_media_player_model_get_artist (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_artist (self);
}


void nuvola_media_player_model_set_artist (NuvolaMediaPlayerModel* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_artist (self, value);
}


const gchar* nuvola_media_player_model_get_album (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_album (self);
}


void nuvola_media_player_model_set_album (NuvolaMediaPlayerModel* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_album (self, value);
}


gdouble nuvola_media_player_model_get_rating (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, 0.0);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_rating (self);
}


void nuvola_media_player_model_set_rating (NuvolaMediaPlayerModel* self, gdouble value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_rating (self, value);
}


const gchar* nuvola_media_player_model_get_state (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_state (self);
}


void nuvola_media_player_model_set_state (NuvolaMediaPlayerModel* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_state (self, value);
}


const gchar* nuvola_media_player_model_get_artwork_location (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_artwork_location (self);
}


void nuvola_media_player_model_set_artwork_location (NuvolaMediaPlayerModel* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_artwork_location (self, value);
}


const gchar* nuvola_media_player_model_get_artwork_file (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_artwork_file (self);
}


void nuvola_media_player_model_set_artwork_file (NuvolaMediaPlayerModel* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_artwork_file (self, value);
}


gint64 nuvola_media_player_model_get_track_length (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, 0LL);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_track_length (self);
}


void nuvola_media_player_model_set_track_length (NuvolaMediaPlayerModel* self, gint64 value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_track_length (self, value);
}


gint64 nuvola_media_player_model_get_track_position (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, 0LL);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_track_position (self);
}


void nuvola_media_player_model_set_track_position (NuvolaMediaPlayerModel* self, gint64 value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_track_position (self, value);
}


gdouble nuvola_media_player_model_get_volume (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, 0.0);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_volume (self);
}


void nuvola_media_player_model_set_volume (NuvolaMediaPlayerModel* self, gdouble value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_volume (self, value);
}


gboolean nuvola_media_player_model_get_can_go_next (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_can_go_next (self);
}


void nuvola_media_player_model_set_can_go_next (NuvolaMediaPlayerModel* self, gboolean value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_can_go_next (self, value);
}


gboolean nuvola_media_player_model_get_can_go_previous (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_can_go_previous (self);
}


void nuvola_media_player_model_set_can_go_previous (NuvolaMediaPlayerModel* self, gboolean value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_can_go_previous (self, value);
}


gboolean nuvola_media_player_model_get_can_play (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_can_play (self);
}


void nuvola_media_player_model_set_can_play (NuvolaMediaPlayerModel* self, gboolean value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_can_play (self, value);
}


gboolean nuvola_media_player_model_get_can_pause (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_can_pause (self);
}


void nuvola_media_player_model_set_can_pause (NuvolaMediaPlayerModel* self, gboolean value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_can_pause (self, value);
}


gboolean nuvola_media_player_model_get_can_stop (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_can_stop (self);
}


void nuvola_media_player_model_set_can_stop (NuvolaMediaPlayerModel* self, gboolean value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_can_stop (self, value);
}


gboolean nuvola_media_player_model_get_can_rate (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_can_rate (self);
}


void nuvola_media_player_model_set_can_rate (NuvolaMediaPlayerModel* self, gboolean value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_can_rate (self, value);
}


gboolean nuvola_media_player_model_get_can_seek (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_can_seek (self);
}


void nuvola_media_player_model_set_can_seek (NuvolaMediaPlayerModel* self, gboolean value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_can_seek (self, value);
}


GSList* nuvola_media_player_model_get_playback_actions (NuvolaMediaPlayerModel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->get_playback_actions (self);
}


void nuvola_media_player_model_set_playback_actions (NuvolaMediaPlayerModel* self, GSList* value) {
	g_return_if_fail (self != NULL);
	NUVOLA_MEDIA_PLAYER_MODEL_GET_INTERFACE (self)->set_playback_actions (self, value);
}


static void nuvola_media_player_model_real_set_track_info (NuvolaMediaPlayerModel* self, const gchar* title, const gchar* artist, const gchar* album, const gchar* state, const gchar* artwork_location, const gchar* artwork_file, gdouble rating, gint64 length) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gdouble _tmp6_ = 0.0;
	gint64 _tmp7_ = 0LL;
	_tmp0_ = title;
	_tmp1_ = artist;
	_tmp2_ = album;
	_tmp3_ = state;
	_tmp4_ = artwork_location;
	_tmp5_ = artwork_file;
	_tmp6_ = rating;
	_tmp7_ = length;
	nuvola_media_player_model_handle_set_track_info (self, _tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, _tmp6_, _tmp7_);
}


static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING_STRING_STRING_STRING_DOUBLE_INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING_STRING_STRING_STRING_DOUBLE_INT64) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, const char* arg_4, const char* arg_5, const char* arg_6, gdouble arg_7, gint64 arg_8, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING_STRING_STRING_STRING_DOUBLE_INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 9);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING_STRING_STRING_STRING_DOUBLE_INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), g_value_get_string (param_values + 4), g_value_get_string (param_values + 5), g_value_get_string (param_values + 6), g_value_get_double (param_values + 7), g_value_get_int64 (param_values + 8), data2);
}


static void nuvola_media_player_model_base_init (NuvolaMediaPlayerModelIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_double ("rating", "rating", "rating", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("state", "state", "state", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("artwork-location", "artwork-location", "artwork-location", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("artwork-file", "artwork-file", "artwork-file", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_int64 ("track-length", "track-length", "track-length", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_int64 ("track-position", "track-position", "track-position", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 1.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("can-go-next", "can-go-next", "can-go-next", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("can-go-previous", "can-go-previous", "can-go-previous", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("can-play", "can-play", "can-play", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("can-pause", "can-pause", "can-pause", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("can-stop", "can-stop", "can-stop", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("can-rate", "can-rate", "can-rate", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("can-seek", "can-seek", "can-seek", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_pointer ("playback-actions", "playback-actions", "playback-actions", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		iface->set_track_info = nuvola_media_player_model_real_set_track_info;
		g_signal_new ("set_track_info", NUVOLA_TYPE_MEDIA_PLAYER_MODEL, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (NuvolaMediaPlayerModelIface, set_track_info), NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING_STRING_STRING_STRING_DOUBLE_INT64, G_TYPE_NONE, 8, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_DOUBLE, G_TYPE_INT64);
		g_signal_new ("set_rating", NUVOLA_TYPE_MEDIA_PLAYER_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	}
}


GType nuvola_media_player_model_get_type (void) {
	static volatile gsize nuvola_media_player_model_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_media_player_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaMediaPlayerModelIface), (GBaseInitFunc) nuvola_media_player_model_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType nuvola_media_player_model_type_id;
		nuvola_media_player_model_type_id = g_type_register_static (G_TYPE_INTERFACE, "NuvolaMediaPlayerModel", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (nuvola_media_player_model_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&nuvola_media_player_model_type_id__volatile, nuvola_media_player_model_type_id);
	}
	return nuvola_media_player_model_type_id__volatile;
}



