/* NotificationInterface.c generated by valac 0.34.9, the Vala compiler
 * generated from NotificationInterface.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_NOTIFICATION_INTERFACE (nuvola_notification_interface_get_type ())
#define NUVOLA_NOTIFICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_NOTIFICATION_INTERFACE, NuvolaNotificationInterface))
#define NUVOLA_IS_NOTIFICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_NOTIFICATION_INTERFACE))
#define NUVOLA_NOTIFICATION_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NUVOLA_TYPE_NOTIFICATION_INTERFACE, NuvolaNotificationInterfaceIface))

typedef struct _NuvolaNotificationInterface NuvolaNotificationInterface;
typedef struct _NuvolaNotificationInterfaceIface NuvolaNotificationInterfaceIface;

struct _NuvolaNotificationInterfaceIface {
	GTypeInterface parent_iface;
	gboolean (*update) (NuvolaNotificationInterface* self, const gchar* name, const gchar* summary, const gchar* body, const gchar* icon_name, const gchar* icon_path, gboolean resident, const gchar* category);
	gboolean (*set_actions) (NuvolaNotificationInterface* self, const gchar* name, gchar** actions, int actions_length1);
	gboolean (*remove_actions) (NuvolaNotificationInterface* self, const gchar* name);
	gboolean (*show) (NuvolaNotificationInterface* self, const gchar* name, gboolean force);
};



GType nuvola_notification_interface_get_type (void) G_GNUC_CONST;
gboolean nuvola_notification_interface_update (NuvolaNotificationInterface* self, const gchar* name, const gchar* summary, const gchar* body, const gchar* icon_name, const gchar* icon_path, gboolean resident, const gchar* category);
gboolean nuvola_notification_interface_set_actions (NuvolaNotificationInterface* self, const gchar* name, gchar** actions, int actions_length1);
gboolean nuvola_notification_interface_remove_actions (NuvolaNotificationInterface* self, const gchar* name);
gboolean nuvola_notification_interface_show (NuvolaNotificationInterface* self, const gchar* name, gboolean force);


gboolean nuvola_notification_interface_update (NuvolaNotificationInterface* self, const gchar* name, const gchar* summary, const gchar* body, const gchar* icon_name, const gchar* icon_path, gboolean resident, const gchar* category) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_NOTIFICATION_INTERFACE_GET_INTERFACE (self)->update (self, name, summary, body, icon_name, icon_path, resident, category);
}


gboolean nuvola_notification_interface_set_actions (NuvolaNotificationInterface* self, const gchar* name, gchar** actions, int actions_length1) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_NOTIFICATION_INTERFACE_GET_INTERFACE (self)->set_actions (self, name, actions, actions_length1);
}


gboolean nuvola_notification_interface_remove_actions (NuvolaNotificationInterface* self, const gchar* name) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_NOTIFICATION_INTERFACE_GET_INTERFACE (self)->remove_actions (self, name);
}


gboolean nuvola_notification_interface_show (NuvolaNotificationInterface* self, const gchar* name, gboolean force) {
	g_return_val_if_fail (self != NULL, FALSE);
	return NUVOLA_NOTIFICATION_INTERFACE_GET_INTERFACE (self)->show (self, name, force);
}


static void nuvola_notification_interface_base_init (NuvolaNotificationInterfaceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType nuvola_notification_interface_get_type (void) {
	static volatile gsize nuvola_notification_interface_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_notification_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaNotificationInterfaceIface), (GBaseInitFunc) nuvola_notification_interface_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType nuvola_notification_interface_type_id;
		nuvola_notification_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "NuvolaNotificationInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (nuvola_notification_interface_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&nuvola_notification_interface_type_id__volatile, nuvola_notification_interface_type_id);
	}
	return nuvola_notification_interface_type_id__volatile;
}



