/* Oauth2Client.c generated by valac 0.34.9, the Vala compiler
 * generated from Oauth2Client.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <dioriteglib4.h>
#include <libsoup/soup.h>
#include <gobject/gvaluecollector.h>


#define NUVOLA_TYPE_OAUTH2_CLIENT (nuvola_oauth2_client_get_type ())
#define NUVOLA_OAUTH2_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_OAUTH2_CLIENT, NuvolaOauth2Client))
#define NUVOLA_OAUTH2_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_OAUTH2_CLIENT, NuvolaOauth2ClientClass))
#define NUVOLA_IS_OAUTH2_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_OAUTH2_CLIENT))
#define NUVOLA_IS_OAUTH2_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_OAUTH2_CLIENT))
#define NUVOLA_OAUTH2_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_OAUTH2_CLIENT, NuvolaOauth2ClientClass))

typedef struct _NuvolaOauth2Client NuvolaOauth2Client;
typedef struct _NuvolaOauth2ClientClass NuvolaOauth2ClientClass;
typedef struct _NuvolaOauth2ClientPrivate NuvolaOauth2ClientPrivate;

#define NUVOLA_TYPE_OAUTH2_TOKEN (nuvola_oauth2_token_get_type ())
#define NUVOLA_OAUTH2_TOKEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_OAUTH2_TOKEN, NuvolaOauth2Token))
#define NUVOLA_OAUTH2_TOKEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_OAUTH2_TOKEN, NuvolaOauth2TokenClass))
#define NUVOLA_IS_OAUTH2_TOKEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_OAUTH2_TOKEN))
#define NUVOLA_IS_OAUTH2_TOKEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_OAUTH2_TOKEN))
#define NUVOLA_OAUTH2_TOKEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_OAUTH2_TOKEN, NuvolaOauth2TokenClass))

typedef struct _NuvolaOauth2Token NuvolaOauth2Token;
typedef struct _NuvolaOauth2TokenClass NuvolaOauth2TokenClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _nuvola_oauth2_token_unref0(var) ((var == NULL) ? NULL : (var = (nuvola_oauth2_token_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _drt_json_node_unref0(var) ((var == NULL) ? NULL : (var = (drt_json_node_unref (var), NULL)))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
typedef struct _NuvolaOauth2ClientCallData NuvolaOauth2ClientCallData;
typedef struct _Block10Data Block10Data;
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NuvolaOauth2ClientRefreshTokenData NuvolaOauth2ClientRefreshTokenData;
typedef struct _Block11Data Block11Data;
typedef struct _NuvolaOauth2ClientSendMessageData NuvolaOauth2ClientSendMessageData;
typedef struct _NuvolaOauth2TokenPrivate NuvolaOauth2TokenPrivate;
typedef struct _NuvolaParamSpecOauth2Token NuvolaParamSpecOauth2Token;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	NUVOLA_OAUTH2_ERROR_UNKNOWN,
	NUVOLA_OAUTH2_ERROR_PARSE_ERROR,
	NUVOLA_OAUTH2_ERROR_RESPONSE_ERROR,
	NUVOLA_OAUTH2_ERROR_INVALID_CLIENT,
	NUVOLA_OAUTH2_ERROR_INVALID_REQUEST,
	NUVOLA_OAUTH2_ERROR_HTTP_ERROR,
	NUVOLA_OAUTH2_ERROR_HTTP_UNAUTHORIZED,
	NUVOLA_OAUTH2_ERROR_INVALID_GRANT,
	NUVOLA_OAUTH2_ERROR_UNAUTHORIZED_CLIENT,
	NUVOLA_OAUTH2_ERROR_UNSUPPORTED_GRANT_TYPE
} NuvolaOauth2Error;
#define NUVOLA_OAUTH2_ERROR nuvola_oauth2_error_quark ()
struct _NuvolaOauth2Client {
	GObject parent_instance;
	NuvolaOauth2ClientPrivate * priv;
	gchar* client_id;
	gchar* client_secret;
	gchar* api_endpoint;
	gchar* token_endpoint;
};

struct _NuvolaOauth2ClientClass {
	GObjectClass parent_class;
	void (*call) (NuvolaOauth2Client* self, const gchar* method, GHashTable* params, GHashTable* headers, GAsyncReadyCallback _callback_, gpointer _user_data_);
	DrtJsonObject* (*call_finish) (NuvolaOauth2Client* self, GAsyncResult* _res_, GError** error);
	void (*device_code_grant_started) (NuvolaOauth2Client* self, const gchar* verification_uri);
	void (*device_code_grant_error) (NuvolaOauth2Client* self, const gchar* code, const gchar* description);
};

struct _NuvolaOauth2ClientPrivate {
	NuvolaOauth2Token* _token;
	SoupSession* soup;
	gchar* device_code_endpoint;
	gchar* device_code;
	guint device_code_cb_id;
};

struct _NuvolaOauth2ClientCallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaOauth2Client* self;
	gchar* method;
	GHashTable* params;
	GHashTable* headers;
	DrtJsonObject* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	SoupURI* uri;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SoupURI* _tmp5_;
	SoupURI* _tmp6_;
	GHashTable* _tmp7_;
	SoupURI* _tmp8_;
	GHashTable* _tmp9_;
	SoupMessage* msg;
	SoupURI* _tmp10_;
	SoupMessage* _tmp11_;
	SoupURI* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GHashTable* _tmp15_;
	GHashTable* _tmp16_;
	SoupMessage* _tmp17_;
	SoupMessageHeaders* _tmp18_;
	DrtJsonObject* _tmp19_;
	SoupMessage* _tmp20_;
	DrtJsonObject* _tmp21_;
	DrtJsonObject* _tmp22_;
	GError * _inner_error_;
};

struct _Block10Data {
	int _ref_count_;
	NuvolaOauth2Client* self;
	GSourceFunc resume_cb;
	gpointer resume_cb_target;
	GDestroyNotify resume_cb_target_destroy_notify;
	gpointer _async_data_;
};

struct _NuvolaOauth2ClientRefreshTokenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaOauth2Client* self;
	gboolean result;
	Block10Data* _data10_;
	gboolean _tmp0_;
	NuvolaOauth2Token* _tmp1_;
	NuvolaOauth2Token* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	SoupMessage* msg;
	const gchar* _tmp5_;
	NuvolaOauth2Token* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	SoupMessage* _tmp10_;
	const gchar* _tmp11_;
	SoupMessage* _tmp12_;
	SoupMessageHeaders* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	guint8* _tmp19_;
	gint _tmp19__length1;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	SoupSession* _tmp24_;
	SoupMessage* _tmp25_;
	SoupMessage* _tmp26_;
	const gchar* response_data;
	SoupMessage* _tmp27_;
	SoupMessageBody* _tmp28_;
	SoupBuffer* _tmp29_;
	SoupBuffer* _tmp30_;
	guint8* _tmp31_;
	gint _tmp31__length1;
	const gchar* _tmp32_;
	DrtJsonObject* response;
	DrtJsonObject* _tmp33_;
	const gchar* _tmp34_;
	DrtJsonObject* _tmp35_;
	DrtJsonObject* _tmp36_;
	GError* e;
	GError* _tmp37_;
	const gchar* _tmp38_;
	GError* _tmp39_;
	gboolean _tmp40_;
	SoupMessage* _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	SoupMessage* _tmp44_;
	guint _tmp45_;
	guint _tmp46_;
	gchar* error_code;
	gchar* error_description;
	DrtJsonObject* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	GQuark _tmp59_;
	const gchar* _tmp60_;
	GError* _tmp61_;
	const gchar* _tmp62_;
	GError* _tmp63_;
	const gchar* _tmp64_;
	GError* _tmp65_;
	const gchar* _tmp66_;
	GError* _tmp67_;
	const gchar* _tmp68_;
	GError* _tmp69_;
	const gchar* _tmp70_;
	SoupMessage* _tmp71_;
	guint _tmp72_;
	guint _tmp73_;
	SoupMessage* _tmp74_;
	guint _tmp75_;
	guint _tmp76_;
	const gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	GError* _tmp80_;
	GError* _tmp81_;
	gchar* access_token;
	DrtJsonObject* _tmp82_;
	gchar* _tmp83_;
	gchar* refresh_token;
	DrtJsonObject* _tmp84_;
	gchar* _tmp85_;
	gchar* token_type;
	DrtJsonObject* _tmp86_;
	gchar* _tmp87_;
	gchar* scope;
	DrtJsonObject* _tmp88_;
	gchar* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	const gchar* _tmp92_;
	const gchar* _tmp93_;
	NuvolaOauth2Token* _tmp94_;
	NuvolaOauth2Token* _tmp95_;
	NuvolaOauth2Token* _tmp96_;
	gchar* _tmp97_;
	gchar* _tmp98_;
	GError * _inner_error_;
};

struct _Block11Data {
	int _ref_count_;
	NuvolaOauth2Client* self;
	GSourceFunc resume_cb;
	gpointer resume_cb_target;
	GDestroyNotify resume_cb_target_destroy_notify;
	gpointer _async_data_;
};

struct _NuvolaOauth2ClientSendMessageData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaOauth2Client* self;
	SoupMessage* msg;
	gboolean retry;
	DrtJsonObject* result;
	Block11Data* _data11_;
	NuvolaOauth2Token* _tmp0_;
	SoupMessage* _tmp1_;
	SoupMessageHeaders* _tmp2_;
	NuvolaOauth2Token* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	NuvolaOauth2Token* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	SoupSession* _tmp11_;
	SoupMessage* _tmp12_;
	SoupMessage* _tmp13_;
	const gchar* response_data;
	SoupMessage* _tmp14_;
	SoupMessageBody* _tmp15_;
	SoupBuffer* _tmp16_;
	SoupBuffer* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_;
	gboolean _tmp20_;
	SoupMessage* _tmp21_;
	guint _tmp22_;
	guint _tmp23_;
	SoupMessage* _tmp24_;
	guint _tmp25_;
	guint _tmp26_;
	gchar* http_error;
	SoupMessage* _tmp27_;
	guint _tmp28_;
	guint _tmp29_;
	SoupMessage* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	SoupMessage* _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	NuvolaOauth2Token* _tmp40_;
	gboolean _tmp41_;
	NuvolaOauth2Token* _tmp42_;
	gboolean _tmp43_;
	const gchar* _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	DrtJsonObject* _tmp47_;
	SoupMessage* _tmp48_;
	DrtJsonObject* _tmp49_;
	DrtJsonObject* _tmp50_;
	const gchar* _tmp51_;
	GError* _tmp52_;
	const gchar* _tmp53_;
	GError* _tmp54_;
	DrtJsonObject* _tmp55_;
	const gchar* _tmp56_;
	DrtJsonObject* _tmp57_;
	DrtJsonObject* _tmp58_;
	GError* e;
	GError* _tmp59_;
	const gchar* _tmp60_;
	GError* _tmp61_;
	GError * _inner_error_;
};

struct _NuvolaOauth2Token {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NuvolaOauth2TokenPrivate * priv;
};

struct _NuvolaOauth2TokenClass {
	GTypeClass parent_class;
	void (*finalize) (NuvolaOauth2Token *self);
};

struct _NuvolaOauth2TokenPrivate {
	gchar* _access_token;
	gchar* _refresh_token;
	gchar* _token_type;
	gchar* _scope;
};

struct _NuvolaParamSpecOauth2Token {
	GParamSpec parent_instance;
};


static gpointer nuvola_oauth2_client_parent_class = NULL;
static gboolean nuvola_oauth2_client_debug_soup;
static gboolean nuvola_oauth2_client_debug_soup = FALSE;
static gpointer nuvola_oauth2_token_parent_class = NULL;

GQuark nuvola_oauth2_error_quark (void);
GType nuvola_oauth2_client_get_type (void) G_GNUC_CONST;
gpointer nuvola_oauth2_token_ref (gpointer instance);
void nuvola_oauth2_token_unref (gpointer instance);
GParamSpec* nuvola_param_spec_oauth2_token (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void nuvola_value_set_oauth2_token (GValue* value, gpointer v_object);
void nuvola_value_take_oauth2_token (GValue* value, gpointer v_object);
gpointer nuvola_value_get_oauth2_token (const GValue* value);
GType nuvola_oauth2_token_get_type (void) G_GNUC_CONST;
#define NUVOLA_OAUTH2_CLIENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_OAUTH2_CLIENT, NuvolaOauth2ClientPrivate))
enum  {
	NUVOLA_OAUTH2_CLIENT_DUMMY_PROPERTY,
	NUVOLA_OAUTH2_CLIENT_TOKEN
};
NuvolaOauth2Client* nuvola_oauth2_client_new (const gchar* client_id, const gchar* client_secret, const gchar* api_endpoint, const gchar* token_endpoint, NuvolaOauth2Token* token);
NuvolaOauth2Client* nuvola_oauth2_client_construct (GType object_type, const gchar* client_id, const gchar* client_secret, const gchar* api_endpoint, const gchar* token_endpoint, NuvolaOauth2Token* token);
void nuvola_oauth2_client_set_token (NuvolaOauth2Client* self, NuvolaOauth2Token* value);
static void nuvola_oauth2_client_real_call_data_free (gpointer _data);
static void nuvola_oauth2_client_real_call (NuvolaOauth2Client* self, const gchar* method, GHashTable* params, GHashTable* headers, GAsyncReadyCallback _callback_, gpointer _user_data_);
void nuvola_oauth2_client_call (NuvolaOauth2Client* self, const gchar* method, GHashTable* params, GHashTable* headers, GAsyncReadyCallback _callback_, gpointer _user_data_);
DrtJsonObject* nuvola_oauth2_client_call_finish (NuvolaOauth2Client* self, GAsyncResult* _res_, GError** error);
static gboolean nuvola_oauth2_client_real_call_co (NuvolaOauth2ClientCallData* _data_);
static void _soup_message_headers_replace_gh_func (gconstpointer key, gconstpointer value, gpointer self);
static void nuvola_oauth2_client_send_message (NuvolaOauth2Client* self, SoupMessage* msg, gboolean retry, GAsyncReadyCallback _callback_, gpointer _user_data_);
static DrtJsonObject* nuvola_oauth2_client_send_message_finish (NuvolaOauth2Client* self, GAsyncResult* _res_, GError** error);
static void nuvola_oauth2_client_call_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void _vala_SoupURI_free (SoupURI* self);
static void nuvola_oauth2_client_refresh_token_data_free (gpointer _data);
void nuvola_oauth2_client_refresh_token (NuvolaOauth2Client* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean nuvola_oauth2_client_refresh_token_finish (NuvolaOauth2Client* self, GAsyncResult* _res_, GError** error);
static gboolean nuvola_oauth2_client_refresh_token_co (NuvolaOauth2ClientRefreshTokenData* _data_);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
NuvolaOauth2Token* nuvola_oauth2_client_get_token (NuvolaOauth2Client* self);
const gchar* nuvola_oauth2_token_get_refresh_token (NuvolaOauth2Token* self);
static gboolean _nuvola_oauth2_client_refresh_token_co_gsource_func (gpointer self);
static void __lambda29_ (Block10Data* _data10_, SoupSession* s, SoupMessage* m);
static void ___lambda29__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self);
static void _vala_SoupBuffer_free (SoupBuffer* self);
static void nuvola_oauth2_client_parse_error (NuvolaOauth2Client* self, DrtJsonObject* response, gchar** error_code, gchar** error_description);
NuvolaOauth2Token* nuvola_oauth2_token_new (const gchar* access_token, const gchar* refresh_token, const gchar* token_type, const gchar* scope);
NuvolaOauth2Token* nuvola_oauth2_token_construct (GType object_type, const gchar* access_token, const gchar* refresh_token, const gchar* token_type, const gchar* scope);
gchar* nuvola_oauth2_token_to_string (NuvolaOauth2Token* self);
void nuvola_oauth2_client_start_device_code_grant (NuvolaOauth2Client* self, const gchar* device_code_endpoint);
static gboolean nuvola_oauth2_client_device_code_grant_cb (NuvolaOauth2Client* self);
static gboolean _nuvola_oauth2_client_device_code_grant_cb_gsource_func (gpointer self);
void nuvola_oauth2_client_cancel_device_code_grant (NuvolaOauth2Client* self);
gchar* nuvola_oauth2_client_hmac_sha1_for_string (NuvolaOauth2Client* self, const gchar* data);
gchar* nuvola_oauth2_client_hmac_for_string (NuvolaOauth2Client* self, GChecksumType checksum, const gchar* data);
gboolean nuvola_oauth2_client_hmac_sha1_verify_string (NuvolaOauth2Client* self, const gchar* data, const gchar* hmac);
gboolean nuvola_oauth2_client_hmac_verify_string (NuvolaOauth2Client* self, GChecksumType checksum, const gchar* data, const gchar* hmac);
static void nuvola_oauth2_client_send_message_data_free (gpointer _data);
static gboolean nuvola_oauth2_client_send_message_co (NuvolaOauth2ClientSendMessageData* _data_);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
const gchar* nuvola_oauth2_token_get_token_type (NuvolaOauth2Token* self);
const gchar* nuvola_oauth2_token_get_access_token (NuvolaOauth2Token* self);
static gboolean _nuvola_oauth2_client_send_message_co_gsource_func (gpointer self);
static void __lambda28_ (Block11Data* _data11_, SoupSession* s, SoupMessage* m);
static void ___lambda28__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self);
static void nuvola_oauth2_client_send_message_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void g_cclosure_user_marshal_VOID__NUVOLA_OAUTH2_TOKEN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void nuvola_oauth2_client_real_device_code_grant_started (NuvolaOauth2Client* self, const gchar* verification_uri);
static void nuvola_oauth2_client_real_device_code_grant_error (NuvolaOauth2Client* self, const gchar* code, const gchar* description);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void nuvola_oauth2_client_finalize (GObject* obj);
static void _vala_nuvola_oauth2_client_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_oauth2_client_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define NUVOLA_OAUTH2_TOKEN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_OAUTH2_TOKEN, NuvolaOauth2TokenPrivate))
enum  {
	NUVOLA_OAUTH2_TOKEN_DUMMY_PROPERTY
};
static void nuvola_oauth2_token_set_access_token (NuvolaOauth2Token* self, const gchar* value);
static void nuvola_oauth2_token_set_refresh_token (NuvolaOauth2Token* self, const gchar* value);
static void nuvola_oauth2_token_set_token_type (NuvolaOauth2Token* self, const gchar* value);
static void nuvola_oauth2_token_set_scope (NuvolaOauth2Token* self, const gchar* value);
const gchar* nuvola_oauth2_token_get_scope (NuvolaOauth2Token* self);
static void nuvola_oauth2_token_finalize (NuvolaOauth2Token* obj);


GQuark nuvola_oauth2_error_quark (void) {
	return g_quark_from_static_string ("nuvola_oauth2_error-quark");
}


NuvolaOauth2Client* nuvola_oauth2_client_construct (GType object_type, const gchar* client_id, const gchar* client_secret, const gchar* api_endpoint, const gchar* token_endpoint, NuvolaOauth2Token* token) {
	NuvolaOauth2Client * self = NULL;
	SoupSession* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	NuvolaOauth2Token* _tmp13_ = NULL;
	g_return_val_if_fail (client_id != NULL, NULL);
	g_return_val_if_fail (api_endpoint != NULL, NULL);
	self = (NuvolaOauth2Client*) g_object_new (object_type, NULL);
	_tmp0_ = soup_session_new ();
	_g_object_unref0 (self->priv->soup);
	self->priv->soup = _tmp0_;
	_tmp1_ = nuvola_oauth2_client_debug_soup;
	if (_tmp1_) {
		SoupSession* _tmp2_ = NULL;
		SoupLogger* _tmp3_ = NULL;
		SoupLogger* _tmp4_ = NULL;
		_tmp2_ = self->priv->soup;
		_tmp3_ = soup_logger_new (SOUP_LOGGER_LOG_BODY, -1);
		_tmp4_ = _tmp3_;
		soup_session_add_feature (_tmp2_, (SoupSessionFeature*) _tmp4_);
		_g_object_unref0 (_tmp4_);
	}
	_tmp5_ = client_id;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (self->client_id);
	self->client_id = _tmp6_;
	_tmp7_ = client_secret;
	_tmp8_ = g_strdup (_tmp7_);
	_g_free0 (self->client_secret);
	self->client_secret = _tmp8_;
	_tmp9_ = api_endpoint;
	_tmp10_ = g_strdup (_tmp9_);
	_g_free0 (self->api_endpoint);
	self->api_endpoint = _tmp10_;
	_tmp11_ = token_endpoint;
	_tmp12_ = g_strdup (_tmp11_);
	_g_free0 (self->token_endpoint);
	self->token_endpoint = _tmp12_;
	_tmp13_ = token;
	nuvola_oauth2_client_set_token (self, _tmp13_);
	return self;
}


NuvolaOauth2Client* nuvola_oauth2_client_new (const gchar* client_id, const gchar* client_secret, const gchar* api_endpoint, const gchar* token_endpoint, NuvolaOauth2Token* token) {
	return nuvola_oauth2_client_construct (NUVOLA_TYPE_OAUTH2_CLIENT, client_id, client_secret, api_endpoint, token_endpoint, token);
}


static void nuvola_oauth2_client_real_call_data_free (gpointer _data) {
	NuvolaOauth2ClientCallData* _data_;
	_data_ = _data;
	_g_free0 (_data_->method);
	_g_hash_table_unref0 (_data_->params);
	_g_hash_table_unref0 (_data_->headers);
	_drt_json_node_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (NuvolaOauth2ClientCallData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


static void nuvola_oauth2_client_real_call (NuvolaOauth2Client* self, const gchar* method, GHashTable* params, GHashTable* headers, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaOauth2ClientCallData* _data_;
	NuvolaOauth2Client* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GHashTable* _tmp3_ = NULL;
	GHashTable* _tmp4_ = NULL;
	GHashTable* _tmp5_ = NULL;
	GHashTable* _tmp6_ = NULL;
	_data_ = g_slice_new0 (NuvolaOauth2ClientCallData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, nuvola_oauth2_client_real_call);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_oauth2_client_real_call_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = method;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->method);
	_data_->method = _tmp2_;
	_tmp3_ = params;
	_tmp4_ = _g_hash_table_ref0 (_tmp3_);
	_g_hash_table_unref0 (_data_->params);
	_data_->params = _tmp4_;
	_tmp5_ = headers;
	_tmp6_ = _g_hash_table_ref0 (_tmp5_);
	_g_hash_table_unref0 (_data_->headers);
	_data_->headers = _tmp6_;
	nuvola_oauth2_client_real_call_co (_data_);
}


static DrtJsonObject* nuvola_oauth2_client_real_call_finish (NuvolaOauth2Client* self, GAsyncResult* _res_, GError** error) {
	DrtJsonObject* result;
	NuvolaOauth2ClientCallData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return NULL;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	result = _data_->result;
	_data_->result = NULL;
	return result;
}


static void _soup_message_headers_replace_gh_func (gconstpointer key, gconstpointer value, gpointer self) {
	soup_message_headers_replace ((SoupMessageHeaders*) self, (const gchar*) key, (const gchar*) value);
}


static void nuvola_oauth2_client_call_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NuvolaOauth2ClientCallData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	nuvola_oauth2_client_real_call_co (_data_);
}


static void _vala_SoupURI_free (SoupURI* self) {
	g_boxed_free (soup_uri_get_type (), self);
}


static gboolean nuvola_oauth2_client_real_call_co (NuvolaOauth2ClientCallData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = _data_->method;
	_data_->_tmp0_ = _data_->_tmp1_;
	if (_data_->_tmp0_ == NULL) {
		_data_->_tmp0_ = "";
	}
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = _data_->self->api_endpoint;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = g_strconcat (_data_->_tmp2_, _data_->_tmp0_, NULL);
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _data_->_tmp3_;
	_data_->_tmp5_ = NULL;
	_data_->_tmp5_ = soup_uri_new (_data_->_tmp4_);
	_data_->_tmp6_ = NULL;
	_data_->_tmp6_ = _data_->_tmp5_;
	_g_free0 (_data_->_tmp4_);
	_data_->uri = _data_->_tmp6_;
	_data_->_tmp7_ = NULL;
	_data_->_tmp7_ = _data_->params;
	if (_data_->_tmp7_ != NULL) {
		_data_->_tmp8_ = NULL;
		_data_->_tmp8_ = _data_->uri;
		_data_->_tmp9_ = NULL;
		_data_->_tmp9_ = _data_->params;
		soup_uri_set_query_from_form (_data_->_tmp8_, _data_->_tmp9_);
	}
	_data_->_tmp10_ = NULL;
	_data_->_tmp10_ = _data_->uri;
	_data_->_tmp11_ = NULL;
	_data_->_tmp11_ = soup_message_new_from_uri ("GET", _data_->_tmp10_);
	_data_->msg = _data_->_tmp11_;
	_data_->_tmp12_ = NULL;
	_data_->_tmp12_ = _data_->uri;
	_data_->_tmp13_ = NULL;
	_data_->_tmp13_ = soup_uri_to_string (_data_->_tmp12_, FALSE);
	_data_->_tmp14_ = NULL;
	_data_->_tmp14_ = _data_->_tmp13_;
	g_debug ("Oauth2Client.vala:93: Oauth2 GET %s", _data_->_tmp14_);
	_g_free0 (_data_->_tmp14_);
	_data_->_tmp15_ = NULL;
	_data_->_tmp15_ = _data_->headers;
	if (_data_->_tmp15_ != NULL) {
		_data_->_tmp16_ = NULL;
		_data_->_tmp16_ = _data_->headers;
		_data_->_tmp17_ = NULL;
		_data_->_tmp17_ = _data_->msg;
		_data_->_tmp18_ = NULL;
		_data_->_tmp18_ = _data_->_tmp17_->request_headers;
		g_hash_table_foreach (_data_->_tmp16_, _soup_message_headers_replace_gh_func, _data_->_tmp18_);
	}
	_data_->_tmp20_ = NULL;
	_data_->_tmp20_ = _data_->msg;
	_data_->_state_ = 1;
	nuvola_oauth2_client_send_message (_data_->self, _data_->_tmp20_, TRUE, nuvola_oauth2_client_call_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp21_ = NULL;
	_data_->_tmp21_ = nuvola_oauth2_client_send_message_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
	_data_->_tmp19_ = _data_->_tmp21_;
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			_g_object_unref0 (_data_->msg);
			__vala_SoupURI_free0 (_data_->uri);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_object_unref0 (_data_->msg);
			__vala_SoupURI_free0 (_data_->uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp22_ = NULL;
	_data_->_tmp22_ = _data_->_tmp19_;
	_data_->_tmp19_ = NULL;
	_data_->result = _data_->_tmp22_;
	_drt_json_node_unref0 (_data_->_tmp19_);
	_g_object_unref0 (_data_->msg);
	__vala_SoupURI_free0 (_data_->uri);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
	_drt_json_node_unref0 (_data_->_tmp19_);
	_g_object_unref0 (_data_->msg);
	__vala_SoupURI_free0 (_data_->uri);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void nuvola_oauth2_client_call (NuvolaOauth2Client* self, const gchar* method, GHashTable* params, GHashTable* headers, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NUVOLA_OAUTH2_CLIENT_GET_CLASS (self)->call (self, method, params, headers, _callback_, _user_data_);
}


DrtJsonObject* nuvola_oauth2_client_call_finish (NuvolaOauth2Client* self, GAsyncResult* _res_, GError** error) {
	return NUVOLA_OAUTH2_CLIENT_GET_CLASS (self)->call_finish (self, _res_, error);
}


static void nuvola_oauth2_client_refresh_token_data_free (gpointer _data) {
	NuvolaOauth2ClientRefreshTokenData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (NuvolaOauth2ClientRefreshTokenData, _data_);
}


void nuvola_oauth2_client_refresh_token (NuvolaOauth2Client* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaOauth2ClientRefreshTokenData* _data_;
	NuvolaOauth2Client* _tmp0_ = NULL;
	_data_ = g_slice_new0 (NuvolaOauth2ClientRefreshTokenData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, nuvola_oauth2_client_refresh_token);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_oauth2_client_refresh_token_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	nuvola_oauth2_client_refresh_token_co (_data_);
}


gboolean nuvola_oauth2_client_refresh_token_finish (NuvolaOauth2Client* self, GAsyncResult* _res_, GError** error) {
	gboolean result;
	NuvolaOauth2ClientRefreshTokenData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		gboolean _tmp0_ = FALSE;
		return _tmp0_;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	result = _data_->result;
	return result;
}


static Block10Data* block10_data_ref (Block10Data* _data10_) {
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}


static void block10_data_unref (void * _userdata_) {
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		NuvolaOauth2Client* self;
		self = _data10_->self;
		(_data10_->resume_cb_target_destroy_notify == NULL) ? NULL : (_data10_->resume_cb_target_destroy_notify (_data10_->resume_cb_target), NULL);
		_data10_->resume_cb = NULL;
		_data10_->resume_cb_target = NULL;
		_data10_->resume_cb_target_destroy_notify = NULL;
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static gboolean _nuvola_oauth2_client_refresh_token_co_gsource_func (gpointer self) {
	gboolean result;
	result = nuvola_oauth2_client_refresh_token_co (self);
	return result;
}


static void __lambda29_ (Block10Data* _data10_, SoupSession* s, SoupMessage* m) {
	NuvolaOauth2Client* self;
	GSourceFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GDestroyNotify _tmp0__target_destroy_notify = NULL;
	self = _data10_->self;
	g_return_if_fail (s != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = _data10_->resume_cb;
	_tmp0__target = _data10_->resume_cb_target;
	_tmp0__target_destroy_notify = _data10_->resume_cb_target_destroy_notify;
	_data10_->resume_cb = NULL;
	_data10_->resume_cb_target = NULL;
	_data10_->resume_cb_target_destroy_notify = NULL;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
}


static void ___lambda29__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self) {
	__lambda29_ (self, session, msg);
	block10_data_unref (self);
}


static void _vala_SoupBuffer_free (SoupBuffer* self) {
	g_boxed_free (soup_buffer_get_type (), self);
}


static gboolean nuvola_oauth2_client_refresh_token_co (NuvolaOauth2ClientRefreshTokenData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data10_ = g_slice_new0 (Block10Data);
	_data_->_data10_->_ref_count_ = 1;
	_data_->_data10_->self = g_object_ref (_data_->self);
	_data_->_data10_->_async_data_ = _data_;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = _data_->self->priv->_token;
	if (_data_->_tmp1_ == NULL) {
		_data_->_tmp0_ = TRUE;
	} else {
		_data_->_tmp2_ = NULL;
		_data_->_tmp2_ = _data_->self->priv->_token;
		_data_->_tmp3_ = NULL;
		_data_->_tmp3_ = nuvola_oauth2_token_get_refresh_token (_data_->_tmp2_);
		_data_->_tmp4_ = NULL;
		_data_->_tmp4_ = _data_->_tmp3_;
		_data_->_tmp0_ = _data_->_tmp4_ == NULL;
	}
	if (_data_->_tmp0_) {
		_data_->result = FALSE;
		block10_data_unref (_data_->_data10_);
		_data_->_data10_ = NULL;
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp5_ = NULL;
	_data_->_tmp5_ = _data_->self->token_endpoint;
	_data_->_tmp6_ = NULL;
	_data_->_tmp6_ = _data_->self->priv->_token;
	_data_->_tmp7_ = NULL;
	_data_->_tmp7_ = nuvola_oauth2_token_get_refresh_token (_data_->_tmp6_);
	_data_->_tmp8_ = NULL;
	_data_->_tmp8_ = _data_->_tmp7_;
	_data_->_tmp9_ = NULL;
	_data_->_tmp9_ = _data_->self->client_id;
	_data_->_tmp10_ = NULL;
	_data_->_tmp10_ = soup_form_request_new ("POST", _data_->_tmp5_, "grant_type", "refresh_token", "refresh_token", _data_->_tmp8_, "client_id", _data_->_tmp9_, NULL);
	_data_->msg = _data_->_tmp10_;
	_data_->_tmp11_ = NULL;
	_data_->_tmp11_ = _data_->self->client_secret;
	if (_data_->_tmp11_ != NULL) {
		_data_->_tmp12_ = NULL;
		_data_->_tmp12_ = _data_->msg;
		_data_->_tmp13_ = NULL;
		_data_->_tmp13_ = _data_->_tmp12_->request_headers;
		_data_->_tmp14_ = NULL;
		_data_->_tmp14_ = _data_->self->client_id;
		_data_->_tmp15_ = NULL;
		_data_->_tmp15_ = _data_->self->client_secret;
		_data_->_tmp16_ = NULL;
		_data_->_tmp16_ = g_strdup_printf ("%s:%s", _data_->_tmp14_, _data_->_tmp15_);
		_data_->_tmp17_ = NULL;
		_data_->_tmp17_ = _data_->_tmp16_;
		_data_->_tmp18_ = NULL;
		_data_->_tmp18__length1 = 0;
		_data_->_tmp18_ = string_get_data (_data_->_tmp17_, &_data_->_tmp18__length1);
		_data_->_tmp19_ = NULL;
		_data_->_tmp19__length1 = 0;
		_data_->_tmp19_ = _data_->_tmp18_;
		_data_->_tmp19__length1 = _data_->_tmp18__length1;
		_data_->_tmp20_ = NULL;
		_data_->_tmp20_ = g_base64_encode (_data_->_tmp19_, _data_->_tmp19__length1);
		_data_->_tmp21_ = NULL;
		_data_->_tmp21_ = _data_->_tmp20_;
		_data_->_tmp22_ = NULL;
		_data_->_tmp22_ = g_strconcat ("Basic ", _data_->_tmp21_, NULL);
		_data_->_tmp23_ = NULL;
		_data_->_tmp23_ = _data_->_tmp22_;
		soup_message_headers_replace (_data_->_tmp13_, "Authorization", _data_->_tmp23_);
		_g_free0 (_data_->_tmp23_);
		_g_free0 (_data_->_tmp21_);
		_g_free0 (_data_->_tmp17_);
	}
	_data_->_data10_->resume_cb = _nuvola_oauth2_client_refresh_token_co_gsource_func;
	_data_->_data10_->resume_cb_target = _data_;
	_data_->_data10_->resume_cb_target_destroy_notify = NULL;
	_data_->_tmp24_ = NULL;
	_data_->_tmp24_ = _data_->self->priv->soup;
	_data_->_tmp25_ = NULL;
	_data_->_tmp25_ = _data_->msg;
	_data_->_tmp26_ = NULL;
	_data_->_tmp26_ = _g_object_ref0 (_data_->_tmp25_);
	soup_session_queue_message (_data_->_tmp24_, _data_->_tmp26_, ___lambda29__soup_session_callback, block10_data_ref (_data_->_data10_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp27_ = NULL;
	_data_->_tmp27_ = _data_->msg;
	_data_->_tmp28_ = NULL;
	_data_->_tmp28_ = _data_->_tmp27_->response_body;
	_data_->_tmp29_ = NULL;
	_data_->_tmp29_ = soup_message_body_flatten (_data_->_tmp28_);
	_data_->_tmp30_ = NULL;
	_data_->_tmp30_ = _data_->_tmp29_;
	_data_->_tmp31_ = NULL;
	_data_->_tmp31__length1 = 0;
	_data_->_tmp31_ = _data_->_tmp30_->data;
	_data_->_tmp31__length1 = (gint) _data_->_tmp30_->length;
	_data_->_tmp32_ = NULL;
	_data_->_tmp32_ = (const gchar*) _data_->_tmp31_;
	__vala_SoupBuffer_free0 (_data_->_tmp30_);
	_data_->response_data = _data_->_tmp32_;
	{
		_data_->_tmp34_ = NULL;
		_data_->_tmp34_ = _data_->response_data;
		_data_->_tmp35_ = NULL;
		_data_->_tmp35_ = drt_json_parser_load_object (_data_->_tmp34_, &_data_->_inner_error_);
		_data_->_tmp33_ = _data_->_tmp35_;
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			goto __catch99_g_error;
		}
		_data_->_tmp36_ = NULL;
		_data_->_tmp36_ = _data_->_tmp33_;
		_data_->_tmp33_ = NULL;
		_drt_json_node_unref0 (_data_->response);
		_data_->response = _data_->_tmp36_;
		_drt_json_node_unref0 (_data_->_tmp33_);
	}
	goto __finally99;
	__catch99_g_error:
	{
		_data_->e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp37_ = NULL;
		_data_->_tmp37_ = _data_->e;
		_data_->_tmp38_ = NULL;
		_data_->_tmp38_ = _data_->_tmp37_->message;
		_data_->_tmp39_ = NULL;
		_data_->_tmp39_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_PARSE_ERROR, _data_->_tmp38_);
		_data_->_inner_error_ = _data_->_tmp39_;
		_g_error_free0 (_data_->e);
		goto __finally99;
	}
	__finally99:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			_drt_json_node_unref0 (_data_->response);
			_g_object_unref0 (_data_->msg);
			block10_data_unref (_data_->_data10_);
			_data_->_data10_ = NULL;
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_drt_json_node_unref0 (_data_->response);
			_g_object_unref0 (_data_->msg);
			block10_data_unref (_data_->_data10_);
			_data_->_data10_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp41_ = NULL;
	_data_->_tmp41_ = _data_->msg;
	_data_->_tmp42_ = 0U;
	g_object_get (_data_->_tmp41_, "status-code", &_data_->_tmp42_, NULL);
	_data_->_tmp43_ = 0U;
	_data_->_tmp43_ = _data_->_tmp42_;
	if (_data_->_tmp43_ < ((guint) 200)) {
		_data_->_tmp40_ = TRUE;
	} else {
		_data_->_tmp44_ = NULL;
		_data_->_tmp44_ = _data_->msg;
		_data_->_tmp45_ = 0U;
		g_object_get (_data_->_tmp44_, "status-code", &_data_->_tmp45_, NULL);
		_data_->_tmp46_ = 0U;
		_data_->_tmp46_ = _data_->_tmp45_;
		_data_->_tmp40_ = _data_->_tmp46_ >= ((guint) 300);
	}
	if (_data_->_tmp40_) {
		static GQuark _tmp58_label0 = 0;
		static GQuark _tmp58_label1 = 0;
		static GQuark _tmp58_label2 = 0;
		static GQuark _tmp58_label3 = 0;
		static GQuark _tmp58_label4 = 0;
		_data_->_tmp47_ = NULL;
		_data_->_tmp47_ = _data_->response;
		_data_->_tmp48_ = NULL;
		_data_->_tmp49_ = NULL;
		nuvola_oauth2_client_parse_error (_data_->self, _data_->_tmp47_, &_data_->_tmp48_, &_data_->_tmp49_);
		_g_free0 (_data_->error_code);
		_data_->error_code = _data_->_tmp48_;
		_g_free0 (_data_->error_description);
		_data_->error_description = _data_->_tmp49_;
		_data_->_tmp50_ = NULL;
		_data_->_tmp50_ = _data_->error_description;
		if (_data_->_tmp50_ == NULL) {
			_data_->_tmp51_ = NULL;
			_data_->_tmp51_ = _data_->error_code;
			_data_->_tmp52_ = NULL;
			_data_->_tmp52_ = g_strdup (_data_->_tmp51_);
			_g_free0 (_data_->error_description);
			_data_->error_description = _data_->_tmp52_;
		} else {
			_data_->_tmp53_ = NULL;
			_data_->_tmp53_ = _data_->error_code;
			_data_->_tmp54_ = NULL;
			_data_->_tmp54_ = _data_->error_description;
			_data_->_tmp55_ = NULL;
			_data_->_tmp55_ = g_strdup_printf ("%s: %s", _data_->_tmp53_, _data_->_tmp54_);
			_g_free0 (_data_->error_description);
			_data_->error_description = _data_->_tmp55_;
		}
		_data_->_tmp56_ = NULL;
		_data_->_tmp56_ = _data_->error_code;
		_data_->_tmp57_ = NULL;
		_data_->_tmp59_ = 0U;
		_data_->_tmp57_ = _data_->_tmp56_;
		_data_->_tmp59_ = (NULL == _data_->_tmp57_) ? 0 : g_quark_from_string (_data_->_tmp57_);
		if (_data_->_tmp59_ == ((0 != _tmp58_label0) ? _tmp58_label0 : (_tmp58_label0 = g_quark_from_static_string ("invalid_request")))) {
			switch (0) {
				default:
				{
					nuvola_oauth2_client_set_token (_data_->self, NULL);
					_data_->_tmp60_ = NULL;
					_data_->_tmp60_ = _data_->error_description;
					_data_->_tmp61_ = NULL;
					_data_->_tmp61_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_INVALID_REQUEST, _data_->_tmp60_);
					_data_->_inner_error_ = _data_->_tmp61_;
					if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
						g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
						g_error_free (_data_->_inner_error_);
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						if (_data_->_state_ == 0) {
							g_simple_async_result_complete_in_idle (_data_->_async_result);
						} else {
							g_simple_async_result_complete (_data_->_async_result);
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					} else {
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
						g_clear_error (&_data_->_inner_error_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
				}
			}
		} else if (_data_->_tmp59_ == ((0 != _tmp58_label1) ? _tmp58_label1 : (_tmp58_label1 = g_quark_from_static_string ("invalid_grant")))) {
			switch (0) {
				default:
				{
					nuvola_oauth2_client_set_token (_data_->self, NULL);
					_data_->_tmp62_ = NULL;
					_data_->_tmp62_ = _data_->error_description;
					_data_->_tmp63_ = NULL;
					_data_->_tmp63_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_INVALID_GRANT, _data_->_tmp62_);
					_data_->_inner_error_ = _data_->_tmp63_;
					if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
						g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
						g_error_free (_data_->_inner_error_);
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						if (_data_->_state_ == 0) {
							g_simple_async_result_complete_in_idle (_data_->_async_result);
						} else {
							g_simple_async_result_complete (_data_->_async_result);
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					} else {
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
						g_clear_error (&_data_->_inner_error_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
				}
			}
		} else if (_data_->_tmp59_ == ((0 != _tmp58_label2) ? _tmp58_label2 : (_tmp58_label2 = g_quark_from_static_string ("invalid_client")))) {
			switch (0) {
				default:
				{
					nuvola_oauth2_client_set_token (_data_->self, NULL);
					_data_->_tmp64_ = NULL;
					_data_->_tmp64_ = _data_->error_description;
					_data_->_tmp65_ = NULL;
					_data_->_tmp65_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_INVALID_CLIENT, _data_->_tmp64_);
					_data_->_inner_error_ = _data_->_tmp65_;
					if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
						g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
						g_error_free (_data_->_inner_error_);
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						if (_data_->_state_ == 0) {
							g_simple_async_result_complete_in_idle (_data_->_async_result);
						} else {
							g_simple_async_result_complete (_data_->_async_result);
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					} else {
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
						g_clear_error (&_data_->_inner_error_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
				}
			}
		} else if (_data_->_tmp59_ == ((0 != _tmp58_label3) ? _tmp58_label3 : (_tmp58_label3 = g_quark_from_static_string ("unauthorized_client")))) {
			switch (0) {
				default:
				{
					nuvola_oauth2_client_set_token (_data_->self, NULL);
					_data_->_tmp66_ = NULL;
					_data_->_tmp66_ = _data_->error_description;
					_data_->_tmp67_ = NULL;
					_data_->_tmp67_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_UNAUTHORIZED_CLIENT, _data_->_tmp66_);
					_data_->_inner_error_ = _data_->_tmp67_;
					if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
						g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
						g_error_free (_data_->_inner_error_);
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						if (_data_->_state_ == 0) {
							g_simple_async_result_complete_in_idle (_data_->_async_result);
						} else {
							g_simple_async_result_complete (_data_->_async_result);
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					} else {
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
						g_clear_error (&_data_->_inner_error_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
				}
			}
		} else if (_data_->_tmp59_ == ((0 != _tmp58_label4) ? _tmp58_label4 : (_tmp58_label4 = g_quark_from_static_string ("unsupported_grant_type")))) {
			switch (0) {
				default:
				{
					nuvola_oauth2_client_set_token (_data_->self, NULL);
					_data_->_tmp68_ = NULL;
					_data_->_tmp68_ = _data_->error_description;
					_data_->_tmp69_ = NULL;
					_data_->_tmp69_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_UNSUPPORTED_GRANT_TYPE, _data_->_tmp68_);
					_data_->_inner_error_ = _data_->_tmp69_;
					if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
						g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
						g_error_free (_data_->_inner_error_);
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						if (_data_->_state_ == 0) {
							g_simple_async_result_complete_in_idle (_data_->_async_result);
						} else {
							g_simple_async_result_complete (_data_->_async_result);
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					} else {
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
						g_clear_error (&_data_->_inner_error_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
				}
			}
		} else {
			switch (0) {
				default:
				{
					_data_->_tmp70_ = NULL;
					_data_->_tmp70_ = _data_->error_description;
					_data_->_tmp71_ = NULL;
					_data_->_tmp71_ = _data_->msg;
					_data_->_tmp72_ = 0U;
					g_object_get (_data_->_tmp71_, "status-code", &_data_->_tmp72_, NULL);
					_data_->_tmp73_ = 0U;
					_data_->_tmp73_ = _data_->_tmp72_;
					_data_->_tmp74_ = NULL;
					_data_->_tmp74_ = _data_->msg;
					_data_->_tmp75_ = 0U;
					g_object_get (_data_->_tmp74_, "status-code", &_data_->_tmp75_, NULL);
					_data_->_tmp76_ = 0U;
					_data_->_tmp76_ = _data_->_tmp75_;
					_data_->_tmp77_ = NULL;
					_data_->_tmp77_ = soup_status_get_phrase (_data_->_tmp76_);
					_data_->_tmp78_ = NULL;
					_data_->_tmp78_ = g_strdup_printf ("%s. %u: %s", _data_->_tmp70_, _data_->_tmp73_, _data_->_tmp77_);
					_data_->_tmp79_ = NULL;
					_data_->_tmp79_ = _data_->_tmp78_;
					_data_->_tmp80_ = NULL;
					_data_->_tmp80_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_UNKNOWN, _data_->_tmp79_);
					_data_->_tmp81_ = NULL;
					_data_->_tmp81_ = _data_->_tmp80_;
					_g_free0 (_data_->_tmp79_);
					_data_->_inner_error_ = _data_->_tmp81_;
					if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
						g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
						g_error_free (_data_->_inner_error_);
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						if (_data_->_state_ == 0) {
							g_simple_async_result_complete_in_idle (_data_->_async_result);
						} else {
							g_simple_async_result_complete (_data_->_async_result);
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					} else {
						_g_free0 (_data_->error_description);
						_g_free0 (_data_->error_code);
						_drt_json_node_unref0 (_data_->response);
						_g_object_unref0 (_data_->msg);
						block10_data_unref (_data_->_data10_);
						_data_->_data10_ = NULL;
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
						g_clear_error (&_data_->_inner_error_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
				}
			}
		}
		_g_free0 (_data_->error_description);
		_g_free0 (_data_->error_code);
	}
	_data_->_tmp82_ = NULL;
	_data_->_tmp82_ = _data_->response;
	_data_->_tmp83_ = NULL;
	drt_json_object_get_string (_data_->_tmp82_, "access_token", &_data_->_tmp83_);
	_g_free0 (_data_->access_token);
	_data_->access_token = _data_->_tmp83_;
	_data_->_tmp84_ = NULL;
	_data_->_tmp84_ = _data_->response;
	_data_->_tmp85_ = NULL;
	drt_json_object_get_string (_data_->_tmp84_, "refresh_token", &_data_->_tmp85_);
	_g_free0 (_data_->refresh_token);
	_data_->refresh_token = _data_->_tmp85_;
	_data_->_tmp86_ = NULL;
	_data_->_tmp86_ = _data_->response;
	_data_->_tmp87_ = NULL;
	drt_json_object_get_string (_data_->_tmp86_, "token_type", &_data_->_tmp87_);
	_g_free0 (_data_->token_type);
	_data_->token_type = _data_->_tmp87_;
	_data_->_tmp88_ = NULL;
	_data_->_tmp88_ = _data_->response;
	_data_->_tmp89_ = NULL;
	drt_json_object_get_string (_data_->_tmp88_, "scope", &_data_->_tmp89_);
	_g_free0 (_data_->scope);
	_data_->scope = _data_->_tmp89_;
	_data_->_tmp90_ = NULL;
	_data_->_tmp90_ = _data_->access_token;
	_data_->_tmp91_ = NULL;
	_data_->_tmp91_ = _data_->refresh_token;
	_data_->_tmp92_ = NULL;
	_data_->_tmp92_ = _data_->token_type;
	_data_->_tmp93_ = NULL;
	_data_->_tmp93_ = _data_->scope;
	_data_->_tmp94_ = NULL;
	_data_->_tmp94_ = nuvola_oauth2_token_new (_data_->_tmp90_, _data_->_tmp91_, _data_->_tmp92_, _data_->_tmp93_);
	_data_->_tmp95_ = NULL;
	_data_->_tmp95_ = _data_->_tmp94_;
	nuvola_oauth2_client_set_token (_data_->self, _data_->_tmp95_);
	_nuvola_oauth2_token_unref0 (_data_->_tmp95_);
	_data_->_tmp96_ = NULL;
	_data_->_tmp96_ = _data_->self->priv->_token;
	_data_->_tmp97_ = NULL;
	_data_->_tmp97_ = nuvola_oauth2_token_to_string (_data_->_tmp96_);
	_data_->_tmp98_ = NULL;
	_data_->_tmp98_ = _data_->_tmp97_;
	g_debug ("Oauth2Client.vala:165: Refreshed token: %s.", _data_->_tmp98_);
	_g_free0 (_data_->_tmp98_);
	_data_->result = TRUE;
	_g_free0 (_data_->scope);
	_g_free0 (_data_->token_type);
	_g_free0 (_data_->refresh_token);
	_g_free0 (_data_->access_token);
	_drt_json_node_unref0 (_data_->response);
	_g_object_unref0 (_data_->msg);
	block10_data_unref (_data_->_data10_);
	_data_->_data10_ = NULL;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
	_g_free0 (_data_->scope);
	_g_free0 (_data_->token_type);
	_g_free0 (_data_->refresh_token);
	_g_free0 (_data_->access_token);
	_drt_json_node_unref0 (_data_->response);
	_g_object_unref0 (_data_->msg);
	block10_data_unref (_data_->_data10_);
	_data_->_data10_ = NULL;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static gboolean _nuvola_oauth2_client_device_code_grant_cb_gsource_func (gpointer self) {
	gboolean result;
	result = nuvola_oauth2_client_device_code_grant_cb ((NuvolaOauth2Client*) self);
	return result;
}


void nuvola_oauth2_client_start_device_code_grant (NuvolaOauth2Client* self, const gchar* device_code_endpoint) {
	SoupMessage* msg = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	SoupMessage* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	SoupSession* _tmp16_ = NULL;
	SoupMessage* _tmp17_ = NULL;
	const gchar* response_data = NULL;
	SoupMessage* _tmp18_ = NULL;
	SoupMessageBody* _tmp19_ = NULL;
	SoupBuffer* _tmp20_ = NULL;
	SoupBuffer* _tmp21_ = NULL;
	guint8* _tmp22_ = NULL;
	gint _tmp22__length1 = 0;
	const gchar* _tmp23_ = NULL;
	DrtJsonObject* response = NULL;
	SoupMessage* _tmp30_ = NULL;
	guint _tmp31_ = 0U;
	guint _tmp32_ = 0U;
	gchar* device_code = NULL;
	DrtJsonObject* _tmp38_ = NULL;
	gchar* _tmp39_ = NULL;
	gboolean _tmp40_ = FALSE;
	gchar* verification_uri = NULL;
	DrtJsonObject* _tmp41_ = NULL;
	gchar* _tmp42_ = NULL;
	gboolean _tmp43_ = FALSE;
	gint interval = 0;
	DrtJsonObject* _tmp44_ = NULL;
	gint _tmp45_ = 0;
	gboolean _tmp46_ = FALSE;
	const gchar* _tmp47_ = NULL;
	gchar* _tmp48_ = NULL;
	const gchar* _tmp49_ = NULL;
	gchar* _tmp50_ = NULL;
	gint _tmp51_ = 0;
	guint _tmp52_ = 0U;
	const gchar* _tmp53_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device_code_endpoint != NULL);
	_tmp0_ = device_code_endpoint;
	_tmp1_ = self->client_id;
	_tmp2_ = soup_form_request_new ("POST", _tmp0_, "response_type", "tiliado_device_code", "client_id", _tmp1_, NULL);
	msg = _tmp2_;
	_tmp3_ = self->client_secret;
	if (_tmp3_ != NULL) {
		SoupMessage* _tmp4_ = NULL;
		SoupMessageHeaders* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		guint8* _tmp10_ = NULL;
		gint _tmp10__length1 = 0;
		guint8* _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		_tmp4_ = msg;
		_tmp5_ = _tmp4_->request_headers;
		_tmp6_ = self->client_id;
		_tmp7_ = self->client_secret;
		_tmp8_ = g_strdup_printf ("%s:%s", _tmp6_, _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = string_get_data (_tmp9_, &_tmp10__length1);
		_tmp11_ = _tmp10_;
		_tmp11__length1 = _tmp10__length1;
		_tmp12_ = g_base64_encode (_tmp11_, _tmp11__length1);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strconcat ("Basic ", _tmp13_, NULL);
		_tmp15_ = _tmp14_;
		soup_message_headers_replace (_tmp5_, "Authorization", _tmp15_);
		_g_free0 (_tmp15_);
		_g_free0 (_tmp13_);
		_g_free0 (_tmp9_);
	}
	_tmp16_ = self->priv->soup;
	_tmp17_ = msg;
	soup_session_send_message (_tmp16_, _tmp17_);
	_tmp18_ = msg;
	_tmp19_ = _tmp18_->response_body;
	_tmp20_ = soup_message_body_flatten (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = _tmp21_->data;
	_tmp22__length1 = (gint) _tmp21_->length;
	_tmp23_ = (const gchar*) _tmp22_;
	__vala_SoupBuffer_free0 (_tmp21_);
	response_data = _tmp23_;
	{
		DrtJsonObject* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		DrtJsonObject* _tmp26_ = NULL;
		DrtJsonObject* _tmp27_ = NULL;
		_tmp25_ = response_data;
		_tmp26_ = drt_json_parser_load_object (_tmp25_, &_inner_error_);
		_tmp24_ = _tmp26_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch100_g_error;
		}
		_tmp27_ = _tmp24_;
		_tmp24_ = NULL;
		_drt_json_node_unref0 (response);
		response = _tmp27_;
		_drt_json_node_unref0 (_tmp24_);
	}
	goto __finally100;
	__catch100_g_error:
	{
		GError* e = NULL;
		GError* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp28_ = e;
		_tmp29_ = _tmp28_->message;
		g_signal_emit_by_name (self, "device-code-grant-error", "parse_error", _tmp29_);
		_g_error_free0 (e);
		_drt_json_node_unref0 (response);
		_g_object_unref0 (msg);
		return;
	}
	__finally100:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_drt_json_node_unref0 (response);
		_g_object_unref0 (msg);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp30_ = msg;
	g_object_get (_tmp30_, "status-code", &_tmp31_, NULL);
	_tmp32_ = _tmp31_;
	if (_tmp32_ != ((guint) 200)) {
		gchar* error_code = NULL;
		gchar* error_description = NULL;
		DrtJsonObject* _tmp33_ = NULL;
		gchar* _tmp34_ = NULL;
		gchar* _tmp35_ = NULL;
		const gchar* _tmp36_ = NULL;
		const gchar* _tmp37_ = NULL;
		_tmp33_ = response;
		nuvola_oauth2_client_parse_error (self, _tmp33_, &_tmp34_, &_tmp35_);
		_g_free0 (error_code);
		error_code = _tmp34_;
		_g_free0 (error_description);
		error_description = _tmp35_;
		_tmp36_ = error_code;
		_tmp37_ = error_description;
		g_signal_emit_by_name (self, "device-code-grant-error", _tmp36_, _tmp37_);
		_g_free0 (error_description);
		_g_free0 (error_code);
		_drt_json_node_unref0 (response);
		_g_object_unref0 (msg);
		return;
	}
	_tmp38_ = response;
	_tmp40_ = drt_json_object_get_string (_tmp38_, "device_code", &_tmp39_);
	_g_free0 (device_code);
	device_code = _tmp39_;
	if (!_tmp40_) {
		g_signal_emit_by_name (self, "device-code-grant-error", "response_error", "The 'device_code' member is missing.");
		_g_free0 (device_code);
		_drt_json_node_unref0 (response);
		_g_object_unref0 (msg);
		return;
	}
	_tmp41_ = response;
	_tmp43_ = drt_json_object_get_string (_tmp41_, "verification_uri", &_tmp42_);
	_g_free0 (verification_uri);
	verification_uri = _tmp42_;
	if (!_tmp43_) {
		g_signal_emit_by_name (self, "device-code-grant-error", "response_error", "The 'verification_uri' member is missing.");
		_g_free0 (verification_uri);
		_g_free0 (device_code);
		_drt_json_node_unref0 (response);
		_g_object_unref0 (msg);
		return;
	}
	_tmp44_ = response;
	_tmp46_ = drt_json_object_get_int (_tmp44_, "interval", &_tmp45_);
	interval = _tmp45_;
	if (!_tmp46_) {
		interval = 5;
	}
	_tmp47_ = device_code_endpoint;
	_tmp48_ = g_strdup (_tmp47_);
	_g_free0 (self->priv->device_code_endpoint);
	self->priv->device_code_endpoint = _tmp48_;
	_tmp49_ = device_code;
	_tmp50_ = g_strdup (_tmp49_);
	_g_free0 (self->priv->device_code);
	self->priv->device_code = _tmp50_;
	_tmp51_ = interval;
	_tmp52_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) _tmp51_, _nuvola_oauth2_client_device_code_grant_cb_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->device_code_cb_id = _tmp52_;
	_tmp53_ = verification_uri;
	g_signal_emit_by_name (self, "device-code-grant-started", _tmp53_);
	_g_free0 (verification_uri);
	_g_free0 (device_code);
	_drt_json_node_unref0 (response);
	_g_object_unref0 (msg);
}


void nuvola_oauth2_client_cancel_device_code_grant (NuvolaOauth2Client* self) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_g_free0 (self->priv->device_code);
	self->priv->device_code = NULL;
	_g_free0 (self->priv->device_code_endpoint);
	self->priv->device_code_endpoint = NULL;
	_tmp0_ = self->priv->device_code_cb_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->device_code_cb_id;
		g_source_remove (_tmp1_);
		self->priv->device_code_cb_id = (guint) 0;
	}
	g_signal_emit_by_name (self, "device-code-grant-cancelled");
}


gchar* nuvola_oauth2_client_hmac_sha1_for_string (NuvolaOauth2Client* self, const gchar* data) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_tmp0_ = data;
	_tmp1_ = nuvola_oauth2_client_hmac_for_string (self, G_CHECKSUM_SHA1, _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* nuvola_oauth2_client_hmac_for_string (NuvolaOauth2Client* self, GChecksumType checksum, const gchar* data) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_tmp1_ = self->client_secret;
	if (_tmp1_ != NULL) {
		GChecksumType _tmp2_ = 0;
		const gchar* _tmp3_ = NULL;
		guint8* _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		guint8* _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		_tmp2_ = checksum;
		_tmp3_ = self->client_secret;
		_tmp4_ = string_get_data (_tmp3_, &_tmp4__length1);
		_tmp5_ = _tmp4_;
		_tmp5__length1 = _tmp4__length1;
		_tmp6_ = data;
		_tmp7_ = g_compute_hmac_for_string (_tmp2_, _tmp5_, _tmp5__length1, _tmp6_, (gsize) -1);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp7_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


gboolean nuvola_oauth2_client_hmac_sha1_verify_string (NuvolaOauth2Client* self, const gchar* data, const gchar* hmac) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (data != NULL, FALSE);
	g_return_val_if_fail (hmac != NULL, FALSE);
	_tmp0_ = data;
	_tmp1_ = hmac;
	_tmp2_ = nuvola_oauth2_client_hmac_verify_string (self, G_CHECKSUM_SHA1, _tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


gboolean nuvola_oauth2_client_hmac_verify_string (NuvolaOauth2Client* self, GChecksumType checksum, const gchar* data, const gchar* hmac) {
	gboolean result = FALSE;
	gchar* expected_hmac = NULL;
	GChecksumType _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (data != NULL, FALSE);
	g_return_val_if_fail (hmac != NULL, FALSE);
	_tmp0_ = checksum;
	_tmp1_ = data;
	_tmp2_ = nuvola_oauth2_client_hmac_for_string (self, _tmp0_, _tmp1_);
	expected_hmac = _tmp2_;
	_tmp4_ = expected_hmac;
	if (_tmp4_ != NULL) {
		const gchar* _tmp5_ = NULL;
		guint8* _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		guint8* _tmp7_ = NULL;
		gint _tmp7__length1 = 0;
		const gchar* _tmp8_ = NULL;
		guint8* _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
		guint8* _tmp10_ = NULL;
		gint _tmp10__length1 = 0;
		gboolean _tmp11_ = FALSE;
		_tmp5_ = expected_hmac;
		_tmp6_ = string_get_data (_tmp5_, &_tmp6__length1);
		_tmp7_ = _tmp6_;
		_tmp7__length1 = _tmp6__length1;
		_tmp8_ = hmac;
		_tmp9_ = string_get_data (_tmp8_, &_tmp9__length1);
		_tmp10_ = _tmp9_;
		_tmp10__length1 = _tmp9__length1;
		_tmp11_ = drt_utils_const_time_byte_equal (_tmp7_, _tmp7__length1, _tmp10_, _tmp10__length1);
		_tmp3_ = _tmp11_;
	} else {
		_tmp3_ = FALSE;
	}
	result = _tmp3_;
	_g_free0 (expected_hmac);
	return result;
}


static void nuvola_oauth2_client_send_message_data_free (gpointer _data) {
	NuvolaOauth2ClientSendMessageData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->msg);
	_drt_json_node_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (NuvolaOauth2ClientSendMessageData, _data_);
}


static void nuvola_oauth2_client_send_message (NuvolaOauth2Client* self, SoupMessage* msg, gboolean retry, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaOauth2ClientSendMessageData* _data_;
	NuvolaOauth2Client* _tmp0_ = NULL;
	SoupMessage* _tmp1_ = NULL;
	SoupMessage* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	_data_ = g_slice_new0 (NuvolaOauth2ClientSendMessageData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, nuvola_oauth2_client_send_message);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_oauth2_client_send_message_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = msg;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (_data_->msg);
	_data_->msg = _tmp2_;
	_tmp3_ = retry;
	_data_->retry = _tmp3_;
	nuvola_oauth2_client_send_message_co (_data_);
}


static DrtJsonObject* nuvola_oauth2_client_send_message_finish (NuvolaOauth2Client* self, GAsyncResult* _res_, GError** error) {
	DrtJsonObject* result;
	NuvolaOauth2ClientSendMessageData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return NULL;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	result = _data_->result;
	_data_->result = NULL;
	return result;
}


static Block11Data* block11_data_ref (Block11Data* _data11_) {
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}


static void block11_data_unref (void * _userdata_) {
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		NuvolaOauth2Client* self;
		self = _data11_->self;
		(_data11_->resume_cb_target_destroy_notify == NULL) ? NULL : (_data11_->resume_cb_target_destroy_notify (_data11_->resume_cb_target), NULL);
		_data11_->resume_cb = NULL;
		_data11_->resume_cb_target = NULL;
		_data11_->resume_cb_target_destroy_notify = NULL;
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}


static gboolean _nuvola_oauth2_client_send_message_co_gsource_func (gpointer self) {
	gboolean result;
	result = nuvola_oauth2_client_send_message_co (self);
	return result;
}


static void __lambda28_ (Block11Data* _data11_, SoupSession* s, SoupMessage* m) {
	NuvolaOauth2Client* self;
	GSourceFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GDestroyNotify _tmp0__target_destroy_notify = NULL;
	self = _data11_->self;
	g_return_if_fail (s != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = _data11_->resume_cb;
	_tmp0__target = _data11_->resume_cb_target;
	_tmp0__target_destroy_notify = _data11_->resume_cb_target_destroy_notify;
	_data11_->resume_cb = NULL;
	_data11_->resume_cb_target = NULL;
	_data11_->resume_cb_target_destroy_notify = NULL;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
}


static void ___lambda28__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self) {
	__lambda28_ (self, session, msg);
	block11_data_unref (self);
}


static void nuvola_oauth2_client_send_message_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NuvolaOauth2ClientSendMessageData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	nuvola_oauth2_client_send_message_co (_data_);
}


static gboolean nuvola_oauth2_client_send_message_co (NuvolaOauth2ClientSendMessageData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data11_ = g_slice_new0 (Block11Data);
	_data_->_data11_->_ref_count_ = 1;
	_data_->_data11_->self = g_object_ref (_data_->self);
	_data_->_data11_->_async_data_ = _data_;
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->self->priv->_token;
	if (_data_->_tmp0_ != NULL) {
		_data_->_tmp1_ = NULL;
		_data_->_tmp1_ = _data_->msg;
		_data_->_tmp2_ = NULL;
		_data_->_tmp2_ = _data_->_tmp1_->request_headers;
		_data_->_tmp3_ = NULL;
		_data_->_tmp3_ = _data_->self->priv->_token;
		_data_->_tmp4_ = NULL;
		_data_->_tmp4_ = nuvola_oauth2_token_get_token_type (_data_->_tmp3_);
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = _data_->_tmp4_;
		_data_->_tmp6_ = NULL;
		_data_->_tmp6_ = _data_->self->priv->_token;
		_data_->_tmp7_ = NULL;
		_data_->_tmp7_ = nuvola_oauth2_token_get_access_token (_data_->_tmp6_);
		_data_->_tmp8_ = NULL;
		_data_->_tmp8_ = _data_->_tmp7_;
		_data_->_tmp9_ = NULL;
		_data_->_tmp9_ = g_strdup_printf ("%s %s", _data_->_tmp5_, _data_->_tmp8_);
		_data_->_tmp10_ = NULL;
		_data_->_tmp10_ = _data_->_tmp9_;
		soup_message_headers_replace (_data_->_tmp2_, "Authorization", _data_->_tmp10_);
		_g_free0 (_data_->_tmp10_);
	}
	_data_->_data11_->resume_cb = _nuvola_oauth2_client_send_message_co_gsource_func;
	_data_->_data11_->resume_cb_target = _data_;
	_data_->_data11_->resume_cb_target_destroy_notify = NULL;
	_data_->_tmp11_ = NULL;
	_data_->_tmp11_ = _data_->self->priv->soup;
	_data_->_tmp12_ = NULL;
	_data_->_tmp12_ = _data_->msg;
	_data_->_tmp13_ = NULL;
	_data_->_tmp13_ = _g_object_ref0 (_data_->_tmp12_);
	soup_session_queue_message (_data_->_tmp11_, _data_->_tmp13_, ___lambda28__soup_session_callback, block11_data_ref (_data_->_data11_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp14_ = NULL;
	_data_->_tmp14_ = _data_->msg;
	_data_->_tmp15_ = NULL;
	_data_->_tmp15_ = _data_->_tmp14_->response_body;
	_data_->_tmp16_ = NULL;
	_data_->_tmp16_ = soup_message_body_flatten (_data_->_tmp15_);
	_data_->_tmp17_ = NULL;
	_data_->_tmp17_ = _data_->_tmp16_;
	_data_->_tmp18_ = NULL;
	_data_->_tmp18__length1 = 0;
	_data_->_tmp18_ = _data_->_tmp17_->data;
	_data_->_tmp18__length1 = (gint) _data_->_tmp17_->length;
	_data_->_tmp19_ = NULL;
	_data_->_tmp19_ = (const gchar*) _data_->_tmp18_;
	__vala_SoupBuffer_free0 (_data_->_tmp17_);
	_data_->response_data = _data_->_tmp19_;
	_data_->_tmp21_ = NULL;
	_data_->_tmp21_ = _data_->msg;
	_data_->_tmp22_ = 0U;
	g_object_get (_data_->_tmp21_, "status-code", &_data_->_tmp22_, NULL);
	_data_->_tmp23_ = 0U;
	_data_->_tmp23_ = _data_->_tmp22_;
	if (_data_->_tmp23_ < ((guint) 200)) {
		_data_->_tmp20_ = TRUE;
	} else {
		_data_->_tmp24_ = NULL;
		_data_->_tmp24_ = _data_->msg;
		_data_->_tmp25_ = 0U;
		g_object_get (_data_->_tmp24_, "status-code", &_data_->_tmp25_, NULL);
		_data_->_tmp26_ = 0U;
		_data_->_tmp26_ = _data_->_tmp25_;
		_data_->_tmp20_ = _data_->_tmp26_ >= ((guint) 300);
	}
	if (_data_->_tmp20_) {
		_data_->_tmp27_ = NULL;
		_data_->_tmp27_ = _data_->msg;
		_data_->_tmp28_ = 0U;
		g_object_get (_data_->_tmp27_, "status-code", &_data_->_tmp28_, NULL);
		_data_->_tmp29_ = 0U;
		_data_->_tmp29_ = _data_->_tmp28_;
		_data_->_tmp30_ = NULL;
		_data_->_tmp30_ = _data_->msg;
		_data_->_tmp31_ = 0U;
		g_object_get (_data_->_tmp30_, "status-code", &_data_->_tmp31_, NULL);
		_data_->_tmp32_ = 0U;
		_data_->_tmp32_ = _data_->_tmp31_;
		_data_->_tmp33_ = NULL;
		_data_->_tmp33_ = soup_status_get_phrase (_data_->_tmp32_);
		_data_->_tmp34_ = NULL;
		_data_->_tmp34_ = g_strdup_printf ("%u: %s", _data_->_tmp29_, _data_->_tmp33_);
		_data_->http_error = _data_->_tmp34_;
		_data_->_tmp35_ = NULL;
		_data_->_tmp35_ = _data_->http_error;
		_data_->_tmp36_ = NULL;
		_data_->_tmp36_ = _data_->response_data;
		g_warning ("Oauth2Client.vala:266: Oauth2 Response error. %s.\n%s", _data_->_tmp35_, _data_->_tmp36_);
		_data_->_tmp37_ = NULL;
		_data_->_tmp37_ = _data_->msg;
		_data_->_tmp38_ = 0U;
		g_object_get (_data_->_tmp37_, "status-code", &_data_->_tmp38_, NULL);
		_data_->_tmp39_ = 0U;
		_data_->_tmp39_ = _data_->_tmp38_;
		switch (_data_->_tmp39_) {
			case 401:
			{
				_data_->_tmp40_ = NULL;
				_data_->_tmp40_ = _data_->self->priv->_token;
				_vala_assert (_data_->_tmp40_ != NULL, "token != null");
				_data_->_tmp42_ = NULL;
				_data_->_tmp42_ = _data_->self->priv->_token;
				if (_data_->_tmp42_ != NULL) {
					_data_->_tmp43_ = FALSE;
					_data_->_tmp43_ = _data_->retry;
					_data_->_tmp41_ = _data_->_tmp43_;
				} else {
					_data_->_tmp41_ = FALSE;
				}
				if (_data_->_tmp41_) {
					_data_->_tmp44_ = NULL;
					_data_->_tmp44_ = _data_->http_error;
					g_message ("Oauth2Client.vala:273: Failed to send a message. Will try refreshing t" \
"oken. Reason: %s", _data_->_tmp44_);
					_data_->_state_ = 2;
					nuvola_oauth2_client_refresh_token (_data_->self, nuvola_oauth2_client_send_message_ready, _data_);
					return FALSE;
					_state_2:
					_data_->_tmp46_ = FALSE;
					_data_->_tmp46_ = nuvola_oauth2_client_refresh_token_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
					_data_->_tmp45_ = _data_->_tmp46_;
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
						if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
							g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
							g_error_free (_data_->_inner_error_);
							_g_free0 (_data_->http_error);
							block11_data_unref (_data_->_data11_);
							_data_->_data11_ = NULL;
							if (_data_->_state_ == 0) {
								g_simple_async_result_complete_in_idle (_data_->_async_result);
							} else {
								g_simple_async_result_complete (_data_->_async_result);
							}
							g_object_unref (_data_->_async_result);
							return FALSE;
						} else {
							_g_free0 (_data_->http_error);
							block11_data_unref (_data_->_data11_);
							_data_->_data11_ = NULL;
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
							g_clear_error (&_data_->_inner_error_);
							g_object_unref (_data_->_async_result);
							return FALSE;
						}
					}
					if (_data_->_tmp45_) {
						_data_->_tmp48_ = NULL;
						_data_->_tmp48_ = _data_->msg;
						_data_->_state_ = 3;
						nuvola_oauth2_client_send_message (_data_->self, _data_->_tmp48_, FALSE, nuvola_oauth2_client_send_message_ready, _data_);
						return FALSE;
						_state_3:
						_data_->_tmp49_ = NULL;
						_data_->_tmp49_ = nuvola_oauth2_client_send_message_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
						_data_->_tmp47_ = _data_->_tmp49_;
						if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
							if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
								g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
								g_error_free (_data_->_inner_error_);
								_g_free0 (_data_->http_error);
								block11_data_unref (_data_->_data11_);
								_data_->_data11_ = NULL;
								if (_data_->_state_ == 0) {
									g_simple_async_result_complete_in_idle (_data_->_async_result);
								} else {
									g_simple_async_result_complete (_data_->_async_result);
								}
								g_object_unref (_data_->_async_result);
								return FALSE;
							} else {
								_g_free0 (_data_->http_error);
								block11_data_unref (_data_->_data11_);
								_data_->_data11_ = NULL;
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
								g_clear_error (&_data_->_inner_error_);
								g_object_unref (_data_->_async_result);
								return FALSE;
							}
						}
						_data_->_tmp50_ = NULL;
						_data_->_tmp50_ = _data_->_tmp47_;
						_data_->_tmp47_ = NULL;
						_data_->result = _data_->_tmp50_;
						_drt_json_node_unref0 (_data_->_tmp47_);
						_g_free0 (_data_->http_error);
						block11_data_unref (_data_->_data11_);
						_data_->_data11_ = NULL;
						if (_data_->_state_ == 0) {
							g_simple_async_result_complete_in_idle (_data_->_async_result);
						} else {
							g_simple_async_result_complete (_data_->_async_result);
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
				}
				_data_->_tmp51_ = NULL;
				_data_->_tmp51_ = _data_->http_error;
				_data_->_tmp52_ = NULL;
				_data_->_tmp52_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_HTTP_UNAUTHORIZED, _data_->_tmp51_);
				_data_->_inner_error_ = _data_->_tmp52_;
				if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
					g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
					g_error_free (_data_->_inner_error_);
					_g_free0 (_data_->http_error);
					block11_data_unref (_data_->_data11_);
					_data_->_data11_ = NULL;
					if (_data_->_state_ == 0) {
						g_simple_async_result_complete_in_idle (_data_->_async_result);
					} else {
						g_simple_async_result_complete (_data_->_async_result);
					}
					g_object_unref (_data_->_async_result);
					return FALSE;
				} else {
					_g_free0 (_data_->http_error);
					block11_data_unref (_data_->_data11_);
					_data_->_data11_ = NULL;
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
					g_clear_error (&_data_->_inner_error_);
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
			}
			default:
			{
				_data_->_tmp53_ = NULL;
				_data_->_tmp53_ = _data_->http_error;
				_data_->_tmp54_ = NULL;
				_data_->_tmp54_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_HTTP_ERROR, _data_->_tmp53_);
				_data_->_inner_error_ = _data_->_tmp54_;
				if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
					g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
					g_error_free (_data_->_inner_error_);
					_g_free0 (_data_->http_error);
					block11_data_unref (_data_->_data11_);
					_data_->_data11_ = NULL;
					if (_data_->_state_ == 0) {
						g_simple_async_result_complete_in_idle (_data_->_async_result);
					} else {
						g_simple_async_result_complete (_data_->_async_result);
					}
					g_object_unref (_data_->_async_result);
					return FALSE;
				} else {
					_g_free0 (_data_->http_error);
					block11_data_unref (_data_->_data11_);
					_data_->_data11_ = NULL;
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
					g_clear_error (&_data_->_inner_error_);
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
			}
		}
		_g_free0 (_data_->http_error);
	}
	{
		_data_->_tmp56_ = NULL;
		_data_->_tmp56_ = _data_->response_data;
		_data_->_tmp57_ = NULL;
		_data_->_tmp57_ = drt_json_parser_load_object (_data_->_tmp56_, &_data_->_inner_error_);
		_data_->_tmp55_ = _data_->_tmp57_;
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			goto __catch101_g_error;
		}
		_data_->_tmp58_ = NULL;
		_data_->_tmp58_ = _data_->_tmp55_;
		_data_->_tmp55_ = NULL;
		_data_->result = _data_->_tmp58_;
		_drt_json_node_unref0 (_data_->_tmp55_);
		block11_data_unref (_data_->_data11_);
		_data_->_data11_ = NULL;
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	goto __finally101;
	__catch101_g_error:
	{
		_data_->e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp59_ = NULL;
		_data_->_tmp59_ = _data_->e;
		_data_->_tmp60_ = NULL;
		_data_->_tmp60_ = _data_->_tmp59_->message;
		_data_->_tmp61_ = NULL;
		_data_->_tmp61_ = g_error_new_literal (NUVOLA_OAUTH2_ERROR, NUVOLA_OAUTH2_ERROR_PARSE_ERROR, _data_->_tmp60_);
		_data_->_inner_error_ = _data_->_tmp61_;
		_g_error_free0 (_data_->e);
		goto __finally101;
	}
	__finally101:
	if (_data_->_inner_error_->domain == NUVOLA_OAUTH2_ERROR) {
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
		g_error_free (_data_->_inner_error_);
		block11_data_unref (_data_->_data11_);
		_data_->_data11_ = NULL;
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	} else {
		block11_data_unref (_data_->_data11_);
		_data_->_data11_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	block11_data_unref (_data_->_data11_);
	_data_->_data11_ = NULL;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static gboolean nuvola_oauth2_client_device_code_grant_cb (NuvolaOauth2Client* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	SoupMessage* msg = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	SoupMessage* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	SoupSession* _tmp20_ = NULL;
	SoupMessage* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	const gchar* _tmp23_ = NULL;
	const gchar* response_data = NULL;
	SoupMessage* _tmp25_ = NULL;
	SoupMessageBody* _tmp26_ = NULL;
	SoupBuffer* _tmp27_ = NULL;
	SoupBuffer* _tmp28_ = NULL;
	guint8* _tmp29_ = NULL;
	gint _tmp29__length1 = 0;
	const gchar* _tmp30_ = NULL;
	DrtJsonObject* response = NULL;
	SoupMessage* _tmp38_ = NULL;
	guint _tmp39_ = 0U;
	guint _tmp40_ = 0U;
	gchar* access_token = NULL;
	DrtJsonObject* _tmp52_ = NULL;
	gchar* _tmp53_ = NULL;
	gboolean _tmp54_ = FALSE;
	gchar* refresh_token = NULL;
	DrtJsonObject* _tmp55_ = NULL;
	gchar* _tmp56_ = NULL;
	gchar* token_type = NULL;
	DrtJsonObject* _tmp57_ = NULL;
	gchar* _tmp58_ = NULL;
	gchar* scope = NULL;
	DrtJsonObject* _tmp59_ = NULL;
	gchar* _tmp60_ = NULL;
	const gchar* _tmp61_ = NULL;
	const gchar* _tmp62_ = NULL;
	const gchar* _tmp63_ = NULL;
	const gchar* _tmp64_ = NULL;
	NuvolaOauth2Token* _tmp65_ = NULL;
	NuvolaOauth2Token* _tmp66_ = NULL;
	NuvolaOauth2Token* _tmp67_ = NULL;
	gchar* _tmp68_ = NULL;
	gchar* _tmp69_ = NULL;
	NuvolaOauth2Token* _tmp70_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->device_code_endpoint;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = self->priv->device_code;
		_tmp0_ = _tmp2_ == NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp3_ = self->priv->device_code_endpoint;
	_tmp4_ = self->client_id;
	_tmp5_ = self->priv->device_code;
	_tmp6_ = soup_form_request_new ("POST", _tmp3_, "grant_type", "tiliado_device_code", "client_id", _tmp4_, "code", _tmp5_, NULL);
	msg = _tmp6_;
	_tmp7_ = self->client_secret;
	if (_tmp7_ != NULL) {
		SoupMessage* _tmp8_ = NULL;
		SoupMessageHeaders* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		guint8* _tmp14_ = NULL;
		gint _tmp14__length1 = 0;
		guint8* _tmp15_ = NULL;
		gint _tmp15__length1 = 0;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		_tmp8_ = msg;
		_tmp9_ = _tmp8_->request_headers;
		_tmp10_ = self->client_id;
		_tmp11_ = self->client_secret;
		_tmp12_ = g_strdup_printf ("%s:%s", _tmp10_, _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = string_get_data (_tmp13_, &_tmp14__length1);
		_tmp15_ = _tmp14_;
		_tmp15__length1 = _tmp14__length1;
		_tmp16_ = g_base64_encode (_tmp15_, _tmp15__length1);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strconcat ("Basic ", _tmp17_, NULL);
		_tmp19_ = _tmp18_;
		soup_message_headers_replace (_tmp9_, "Authorization", _tmp19_);
		_g_free0 (_tmp19_);
		_g_free0 (_tmp17_);
		_g_free0 (_tmp13_);
	}
	_tmp20_ = self->priv->soup;
	_tmp21_ = msg;
	soup_session_send_message (_tmp20_, _tmp21_);
	_tmp23_ = self->priv->device_code_endpoint;
	if (_tmp23_ == NULL) {
		_tmp22_ = TRUE;
	} else {
		const gchar* _tmp24_ = NULL;
		_tmp24_ = self->priv->device_code;
		_tmp22_ = _tmp24_ == NULL;
	}
	if (_tmp22_) {
		result = FALSE;
		_g_object_unref0 (msg);
		return result;
	}
	_tmp25_ = msg;
	_tmp26_ = _tmp25_->response_body;
	_tmp27_ = soup_message_body_flatten (_tmp26_);
	_tmp28_ = _tmp27_;
	_tmp29_ = _tmp28_->data;
	_tmp29__length1 = (gint) _tmp28_->length;
	_tmp30_ = (const gchar*) _tmp29_;
	__vala_SoupBuffer_free0 (_tmp28_);
	response_data = _tmp30_;
	{
		DrtJsonObject* _tmp31_ = NULL;
		const gchar* _tmp32_ = NULL;
		DrtJsonObject* _tmp33_ = NULL;
		DrtJsonObject* _tmp34_ = NULL;
		_tmp32_ = response_data;
		_tmp33_ = drt_json_parser_load_object (_tmp32_, &_inner_error_);
		_tmp31_ = _tmp33_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch102_g_error;
		}
		_tmp34_ = _tmp31_;
		_tmp31_ = NULL;
		_drt_json_node_unref0 (response);
		response = _tmp34_;
		_drt_json_node_unref0 (_tmp31_);
	}
	goto __finally102;
	__catch102_g_error:
	{
		GError* e = NULL;
		GError* _tmp35_ = NULL;
		const gchar* _tmp36_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp35_ = e;
		_tmp36_ = _tmp35_->message;
		g_signal_emit_by_name (self, "device-code-grant-error", "parse_error", _tmp36_);
		nuvola_oauth2_client_cancel_device_code_grant (self);
		result = FALSE;
		_g_error_free0 (e);
		_drt_json_node_unref0 (response);
		_g_object_unref0 (msg);
		return result;
	}
	__finally102:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp37_ = FALSE;
		_drt_json_node_unref0 (response);
		_g_object_unref0 (msg);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp37_;
	}
	_tmp38_ = msg;
	g_object_get (_tmp38_, "status-code", &_tmp39_, NULL);
	_tmp40_ = _tmp39_;
	if (_tmp40_ != ((guint) 200)) {
		gchar* error_code = NULL;
		gchar* error_description = NULL;
		DrtJsonObject* _tmp41_ = NULL;
		gchar* _tmp42_ = NULL;
		gchar* _tmp43_ = NULL;
		const gchar* _tmp44_ = NULL;
		const gchar* _tmp45_ = NULL;
		GQuark _tmp47_ = 0U;
		static GQuark _tmp46_label0 = 0;
		static GQuark _tmp46_label1 = 0;
		_tmp41_ = response;
		nuvola_oauth2_client_parse_error (self, _tmp41_, &_tmp42_, &_tmp43_);
		_g_free0 (error_code);
		error_code = _tmp42_;
		_g_free0 (error_description);
		error_description = _tmp43_;
		_tmp44_ = error_code;
		_tmp45_ = _tmp44_;
		_tmp47_ = (NULL == _tmp45_) ? 0 : g_quark_from_string (_tmp45_);
		if ((_tmp47_ == ((0 != _tmp46_label0) ? _tmp46_label0 : (_tmp46_label0 = g_quark_from_static_string ("slow_down")))) || (_tmp47_ == ((0 != _tmp46_label1) ? _tmp46_label1 : (_tmp46_label1 = g_quark_from_static_string ("authorization_pending"))))) {
			switch (0) {
				default:
				{
					const gchar* _tmp48_ = NULL;
					const gchar* _tmp49_ = NULL;
					_tmp48_ = error_code;
					_tmp49_ = error_description;
					g_debug ("Oauth2Client.vala:329: Device code grant error: %s. %s", _tmp48_, _tmp49_);
					result = TRUE;
					_g_free0 (error_description);
					_g_free0 (error_code);
					_drt_json_node_unref0 (response);
					_g_object_unref0 (msg);
					return result;
				}
			}
		} else {
			switch (0) {
				default:
				{
					const gchar* _tmp50_ = NULL;
					const gchar* _tmp51_ = NULL;
					_tmp50_ = error_code;
					_tmp51_ = error_description;
					g_signal_emit_by_name (self, "device-code-grant-error", _tmp50_, _tmp51_);
					nuvola_oauth2_client_cancel_device_code_grant (self);
					result = FALSE;
					_g_free0 (error_description);
					_g_free0 (error_code);
					_drt_json_node_unref0 (response);
					_g_object_unref0 (msg);
					return result;
				}
			}
		}
		_g_free0 (error_description);
		_g_free0 (error_code);
	}
	_tmp52_ = response;
	_tmp54_ = drt_json_object_get_string (_tmp52_, "access_token", &_tmp53_);
	_g_free0 (access_token);
	access_token = _tmp53_;
	if (!_tmp54_) {
		g_signal_emit_by_name (self, "device-code-grant-error", "response_error", "The 'access_token' member is missing.");
		nuvola_oauth2_client_cancel_device_code_grant (self);
		result = FALSE;
		_g_free0 (access_token);
		_drt_json_node_unref0 (response);
		_g_object_unref0 (msg);
		return result;
	}
	_tmp55_ = response;
	_tmp56_ = drt_json_object_get_string_or (_tmp55_, "refresh_token", NULL);
	refresh_token = _tmp56_;
	_tmp57_ = response;
	_tmp58_ = drt_json_object_get_string_or (_tmp57_, "token_type", NULL);
	token_type = _tmp58_;
	_tmp59_ = response;
	_tmp60_ = drt_json_object_get_string_or (_tmp59_, "scope", NULL);
	scope = _tmp60_;
	_tmp61_ = access_token;
	_tmp62_ = refresh_token;
	_tmp63_ = token_type;
	_tmp64_ = scope;
	_tmp65_ = nuvola_oauth2_token_new (_tmp61_, _tmp62_, _tmp63_, _tmp64_);
	_tmp66_ = _tmp65_;
	nuvola_oauth2_client_set_token (self, _tmp66_);
	_nuvola_oauth2_token_unref0 (_tmp66_);
	_tmp67_ = self->priv->_token;
	_tmp68_ = nuvola_oauth2_token_to_string (_tmp67_);
	_tmp69_ = _tmp68_;
	g_debug ("Oauth2Client.vala:349: Device code grant token: %s.", _tmp69_);
	_g_free0 (_tmp69_);
	self->priv->device_code_cb_id = (guint) 0;
	_g_free0 (self->priv->device_code);
	self->priv->device_code = NULL;
	_g_free0 (self->priv->device_code_endpoint);
	self->priv->device_code_endpoint = NULL;
	_tmp70_ = self->priv->_token;
	g_signal_emit_by_name (self, "device-code-grant-finished", _tmp70_);
	result = FALSE;
	_g_free0 (scope);
	_g_free0 (token_type);
	_g_free0 (refresh_token);
	_g_free0 (access_token);
	_drt_json_node_unref0 (response);
	_g_object_unref0 (msg);
	return result;
}


static void nuvola_oauth2_client_parse_error (NuvolaOauth2Client* self, DrtJsonObject* response, gchar** error_code, gchar** error_description) {
	gchar* _vala_error_code = NULL;
	gchar* _vala_error_description = NULL;
	DrtJsonObject* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (response != NULL);
	_tmp0_ = response;
	_tmp2_ = drt_json_object_get_string (_tmp0_, "error", &_tmp1_);
	_g_free0 (_vala_error_code);
	_vala_error_code = _tmp1_;
	if (!_tmp2_) {
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp3_ = g_strdup ("response_error");
		_g_free0 (_vala_error_code);
		_vala_error_code = _tmp3_;
		_tmp4_ = g_strdup ("The 'error' member is missing.");
		_g_free0 (_vala_error_description);
		_vala_error_description = _tmp4_;
	} else {
		DrtJsonObject* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = response;
		_tmp6_ = drt_json_object_get_string_or (_tmp5_, "description", NULL);
		_g_free0 (_vala_error_description);
		_vala_error_description = _tmp6_;
	}
	if (error_code) {
		*error_code = _vala_error_code;
	} else {
		_g_free0 (_vala_error_code);
	}
	if (error_description) {
		*error_description = _vala_error_description;
	} else {
		_g_free0 (_vala_error_description);
	}
}


NuvolaOauth2Token* nuvola_oauth2_client_get_token (NuvolaOauth2Client* self) {
	NuvolaOauth2Token* result;
	NuvolaOauth2Token* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_token;
	result = _tmp0_;
	return result;
}


static gpointer _nuvola_oauth2_token_ref0 (gpointer self) {
	return self ? nuvola_oauth2_token_ref (self) : NULL;
}


void nuvola_oauth2_client_set_token (NuvolaOauth2Client* self, NuvolaOauth2Token* value) {
	NuvolaOauth2Token* _tmp0_ = NULL;
	NuvolaOauth2Token* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _nuvola_oauth2_token_ref0 (_tmp0_);
	_nuvola_oauth2_token_unref0 (self->priv->_token);
	self->priv->_token = _tmp1_;
	g_object_notify ((GObject *) self, "token");
}


static void g_cclosure_user_marshal_VOID__NUVOLA_OAUTH2_TOKEN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__NUVOLA_OAUTH2_TOKEN) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__NUVOLA_OAUTH2_TOKEN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__NUVOLA_OAUTH2_TOKEN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, nuvola_value_get_oauth2_token (param_values + 1), data2);
}


static void nuvola_oauth2_client_real_device_code_grant_started (NuvolaOauth2Client* self, const gchar* verification_uri) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (verification_uri != NULL);
	_tmp0_ = verification_uri;
	g_debug ("Oauth2Client.vala:77: Device code grant verification URI: %s", _tmp0_);
}


static void nuvola_oauth2_client_real_device_code_grant_error (NuvolaOauth2Client* self, const gchar* code, const gchar* description) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (code != NULL);
	_tmp1_ = description;
	_tmp0_ = _tmp1_;
	if (_tmp0_ == NULL) {
		_tmp0_ = "(null)";
	}
	_tmp2_ = code;
	g_warning ("Oauth2Client.vala:82: Device code grant error: %s. %s", _tmp2_, _tmp0_);
}


static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}


static void nuvola_oauth2_client_class_init (NuvolaOauth2ClientClass * klass) {
	const gchar* _tmp0_ = NULL;
	nuvola_oauth2_client_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaOauth2ClientPrivate));
	((NuvolaOauth2ClientClass *) klass)->call = (void (*)(NuvolaOauth2Client*, const gchar*, GHashTable*, GHashTable*, GAsyncReadyCallback, gpointer)) nuvola_oauth2_client_real_call;
	((NuvolaOauth2ClientClass *) klass)->call_finish = (DrtJsonObject* (*)(NuvolaOauth2Client*, GAsyncResult*, GError**)) nuvola_oauth2_client_real_call_finish;
	((NuvolaOauth2ClientClass *) klass)->device_code_grant_started = nuvola_oauth2_client_real_device_code_grant_started;
	((NuvolaOauth2ClientClass *) klass)->device_code_grant_error = nuvola_oauth2_client_real_device_code_grant_error;
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_oauth2_client_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_oauth2_client_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_oauth2_client_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_OAUTH2_CLIENT_TOKEN, nuvola_param_spec_oauth2_token ("token", "token", "token", NUVOLA_TYPE_OAUTH2_TOKEN, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("device_code_grant_cancelled", NUVOLA_TYPE_OAUTH2_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("device_code_grant_finished", NUVOLA_TYPE_OAUTH2_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__NUVOLA_OAUTH2_TOKEN, G_TYPE_NONE, 1, NUVOLA_TYPE_OAUTH2_TOKEN);
	g_signal_new ("device_code_grant_started", NUVOLA_TYPE_OAUTH2_CLIENT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (NuvolaOauth2ClientClass, device_code_grant_started), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("device_code_grant_error", NUVOLA_TYPE_OAUTH2_CLIENT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (NuvolaOauth2ClientClass, device_code_grant_error), NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
	_tmp0_ = g_getenv ("OAUTH2_DEBUG_SOUP");
	nuvola_oauth2_client_debug_soup = g_strcmp0 (_tmp0_, "yes") == 0;
}


static void nuvola_oauth2_client_instance_init (NuvolaOauth2Client * self) {
	self->priv = NUVOLA_OAUTH2_CLIENT_GET_PRIVATE (self);
	self->priv->device_code_endpoint = NULL;
	self->priv->device_code = NULL;
	self->priv->device_code_cb_id = (guint) 0;
}


static void nuvola_oauth2_client_finalize (GObject* obj) {
	NuvolaOauth2Client * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_OAUTH2_CLIENT, NuvolaOauth2Client);
	_g_free0 (self->client_id);
	_g_free0 (self->client_secret);
	_g_free0 (self->api_endpoint);
	_nuvola_oauth2_token_unref0 (self->priv->_token);
	_g_free0 (self->token_endpoint);
	_g_object_unref0 (self->priv->soup);
	_g_free0 (self->priv->device_code_endpoint);
	_g_free0 (self->priv->device_code);
	G_OBJECT_CLASS (nuvola_oauth2_client_parent_class)->finalize (obj);
}


GType nuvola_oauth2_client_get_type (void) {
	static volatile gsize nuvola_oauth2_client_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_oauth2_client_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaOauth2ClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_oauth2_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaOauth2Client), 0, (GInstanceInitFunc) nuvola_oauth2_client_instance_init, NULL };
		GType nuvola_oauth2_client_type_id;
		nuvola_oauth2_client_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaOauth2Client", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_oauth2_client_type_id__volatile, nuvola_oauth2_client_type_id);
	}
	return nuvola_oauth2_client_type_id__volatile;
}


static void _vala_nuvola_oauth2_client_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaOauth2Client * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_OAUTH2_CLIENT, NuvolaOauth2Client);
	switch (property_id) {
		case NUVOLA_OAUTH2_CLIENT_TOKEN:
		nuvola_value_set_oauth2_token (value, nuvola_oauth2_client_get_token (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_oauth2_client_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaOauth2Client * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_OAUTH2_CLIENT, NuvolaOauth2Client);
	switch (property_id) {
		case NUVOLA_OAUTH2_CLIENT_TOKEN:
		nuvola_oauth2_client_set_token (self, nuvola_value_get_oauth2_token (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


NuvolaOauth2Token* nuvola_oauth2_token_construct (GType object_type, const gchar* access_token, const gchar* refresh_token, const gchar* token_type, const gchar* scope) {
	NuvolaOauth2Token* self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	g_return_val_if_fail (access_token != NULL, NULL);
	self = (NuvolaOauth2Token*) g_type_create_instance (object_type);
	_tmp0_ = access_token;
	nuvola_oauth2_token_set_access_token (self, _tmp0_);
	_tmp1_ = refresh_token;
	nuvola_oauth2_token_set_refresh_token (self, _tmp1_);
	_tmp2_ = token_type;
	nuvola_oauth2_token_set_token_type (self, _tmp2_);
	_tmp3_ = scope;
	nuvola_oauth2_token_set_scope (self, _tmp3_);
	return self;
}


NuvolaOauth2Token* nuvola_oauth2_token_new (const gchar* access_token, const gchar* refresh_token, const gchar* token_type, const gchar* scope) {
	return nuvola_oauth2_token_construct (NUVOLA_TYPE_OAUTH2_TOKEN, access_token, refresh_token, token_type, scope);
}


gchar* nuvola_oauth2_token_to_string (NuvolaOauth2Token* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_access_token;
	_tmp1_ = self->priv->_refresh_token;
	_tmp2_ = self->priv->_token_type;
	_tmp3_ = self->priv->_scope;
	_tmp4_ = g_strdup_printf ("access='%s'; refresh='%s';type='%s';scope='%s'", _tmp0_, _tmp1_, _tmp2_, _tmp3_);
	result = _tmp4_;
	return result;
}


const gchar* nuvola_oauth2_token_get_access_token (NuvolaOauth2Token* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_access_token;
	result = _tmp0_;
	return result;
}


static void nuvola_oauth2_token_set_access_token (NuvolaOauth2Token* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_access_token);
	self->priv->_access_token = _tmp1_;
}


const gchar* nuvola_oauth2_token_get_refresh_token (NuvolaOauth2Token* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_refresh_token;
	result = _tmp0_;
	return result;
}


static void nuvola_oauth2_token_set_refresh_token (NuvolaOauth2Token* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_refresh_token);
	self->priv->_refresh_token = _tmp1_;
}


const gchar* nuvola_oauth2_token_get_token_type (NuvolaOauth2Token* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_token_type;
	result = _tmp0_;
	return result;
}


static void nuvola_oauth2_token_set_token_type (NuvolaOauth2Token* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_token_type);
	self->priv->_token_type = _tmp1_;
}


const gchar* nuvola_oauth2_token_get_scope (NuvolaOauth2Token* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_scope;
	result = _tmp0_;
	return result;
}


static void nuvola_oauth2_token_set_scope (NuvolaOauth2Token* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_scope);
	self->priv->_scope = _tmp1_;
}


static void nuvola_value_oauth2_token_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void nuvola_value_oauth2_token_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		nuvola_oauth2_token_unref (value->data[0].v_pointer);
	}
}


static void nuvola_value_oauth2_token_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = nuvola_oauth2_token_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer nuvola_value_oauth2_token_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* nuvola_value_oauth2_token_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		NuvolaOauth2Token* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = nuvola_oauth2_token_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* nuvola_value_oauth2_token_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	NuvolaOauth2Token** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = nuvola_oauth2_token_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* nuvola_param_spec_oauth2_token (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	NuvolaParamSpecOauth2Token* spec;
	g_return_val_if_fail (g_type_is_a (object_type, NUVOLA_TYPE_OAUTH2_TOKEN), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer nuvola_value_get_oauth2_token (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_OAUTH2_TOKEN), NULL);
	return value->data[0].v_pointer;
}


void nuvola_value_set_oauth2_token (GValue* value, gpointer v_object) {
	NuvolaOauth2Token* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_OAUTH2_TOKEN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_OAUTH2_TOKEN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		nuvola_oauth2_token_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_oauth2_token_unref (old);
	}
}


void nuvola_value_take_oauth2_token (GValue* value, gpointer v_object) {
	NuvolaOauth2Token* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_OAUTH2_TOKEN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_OAUTH2_TOKEN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_oauth2_token_unref (old);
	}
}


static void nuvola_oauth2_token_class_init (NuvolaOauth2TokenClass * klass) {
	nuvola_oauth2_token_parent_class = g_type_class_peek_parent (klass);
	((NuvolaOauth2TokenClass *) klass)->finalize = nuvola_oauth2_token_finalize;
	g_type_class_add_private (klass, sizeof (NuvolaOauth2TokenPrivate));
}


static void nuvola_oauth2_token_instance_init (NuvolaOauth2Token * self) {
	self->priv = NUVOLA_OAUTH2_TOKEN_GET_PRIVATE (self);
	self->priv->_refresh_token = NULL;
	self->priv->_token_type = NULL;
	self->priv->_scope = NULL;
	self->ref_count = 1;
}


static void nuvola_oauth2_token_finalize (NuvolaOauth2Token* obj) {
	NuvolaOauth2Token * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_OAUTH2_TOKEN, NuvolaOauth2Token);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_access_token);
	_g_free0 (self->priv->_refresh_token);
	_g_free0 (self->priv->_token_type);
	_g_free0 (self->priv->_scope);
}


GType nuvola_oauth2_token_get_type (void) {
	static volatile gsize nuvola_oauth2_token_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_oauth2_token_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { nuvola_value_oauth2_token_init, nuvola_value_oauth2_token_free_value, nuvola_value_oauth2_token_copy_value, nuvola_value_oauth2_token_peek_pointer, "p", nuvola_value_oauth2_token_collect_value, "p", nuvola_value_oauth2_token_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaOauth2TokenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_oauth2_token_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaOauth2Token), 0, (GInstanceInitFunc) nuvola_oauth2_token_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType nuvola_oauth2_token_type_id;
		nuvola_oauth2_token_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NuvolaOauth2Token", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&nuvola_oauth2_token_type_id__volatile, nuvola_oauth2_token_type_id);
	}
	return nuvola_oauth2_token_type_id__volatile;
}


gpointer nuvola_oauth2_token_ref (gpointer instance) {
	NuvolaOauth2Token* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void nuvola_oauth2_token_unref (gpointer instance) {
	NuvolaOauth2Token* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		NUVOLA_OAUTH2_TOKEN_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



