/* PasswordManager.c generated by valac 0.34.9, the Vala compiler
 * generated from PasswordManager.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libsecret/secret.h>
#include <dioriteglib4.h>
#include <nuvolaruntime-base.h>
#include <webkit2/webkit2.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gobject/gvaluecollector.h>


#define NUVOLA_TYPE_PASSWORD_MANAGER (nuvola_password_manager_get_type ())
#define NUVOLA_PASSWORD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_PASSWORD_MANAGER, NuvolaPasswordManager))
#define NUVOLA_PASSWORD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_PASSWORD_MANAGER, NuvolaPasswordManagerClass))
#define NUVOLA_IS_PASSWORD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_PASSWORD_MANAGER))
#define NUVOLA_IS_PASSWORD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_PASSWORD_MANAGER))
#define NUVOLA_PASSWORD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_PASSWORD_MANAGER, NuvolaPasswordManagerClass))

typedef struct _NuvolaPasswordManager NuvolaPasswordManager;
typedef struct _NuvolaPasswordManagerClass NuvolaPasswordManagerClass;
typedef struct _NuvolaPasswordManagerPrivate NuvolaPasswordManagerPrivate;

#define NUVOLA_TYPE_WEB_ENGINE (nuvola_web_engine_get_type ())
#define NUVOLA_WEB_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_ENGINE, NuvolaWebEngine))
#define NUVOLA_WEB_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_ENGINE, NuvolaWebEngineClass))
#define NUVOLA_IS_WEB_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_ENGINE))
#define NUVOLA_IS_WEB_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_ENGINE))
#define NUVOLA_WEB_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_ENGINE, NuvolaWebEngineClass))

typedef struct _NuvolaWebEngine NuvolaWebEngine;
typedef struct _NuvolaWebEngineClass NuvolaWebEngineClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _nuvola_password_manager_unref0(var) ((var == NULL) ? NULL : (var = (nuvola_password_manager_unref (var), NULL)))
#define _secret_value_unref0(var) ((var == NULL) ? NULL : (var = (secret_value_unref (var), NULL)))
#define _drt_lst_unref0(var) ((var == NULL) ? NULL : (var = (drt_lst_unref (var), NULL)))
#define _nuvola_login_credentials_unref0(var) ((var == NULL) ? NULL : (var = (nuvola_login_credentials_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
typedef struct _NuvolaPasswordManagerFetchPasswordsData NuvolaPasswordManagerFetchPasswordsData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NuvolaPasswordManagerStorePasswordData NuvolaPasswordManagerStorePasswordData;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _NuvolaParamSpecPasswordManager NuvolaParamSpecPasswordManager;

struct _NuvolaPasswordManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NuvolaPasswordManagerPrivate * priv;
};

struct _NuvolaPasswordManagerClass {
	GTypeClass parent_class;
	void (*finalize) (NuvolaPasswordManager *self);
};

struct _NuvolaPasswordManagerPrivate {
	gchar* app_id;
	SecretSchema* secret_schema;
	GHashTable* passwords;
	NuvolaWebEngine* web_engine;
};

struct _NuvolaPasswordManagerFetchPasswordsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaPasswordManager* self;
	SecretCollection* collection;
	SecretCollection* _tmp0_;
	GHashTable* attributes;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	SecretSearchFlags flags;
	GList* items;
	SecretCollection* _tmp8_;
	SecretSchema* _tmp9_;
	GHashTable* _tmp10_;
	SecretSearchFlags _tmp11_;
	GList* _tmp12_;
	GHashTable* credentials;
	GHashFunc _tmp13_;
	GEqualFunc _tmp14_;
	GHashTable* _tmp15_;
	GList* _tmp16_;
	GList* item_collection;
	GList* item_it;
	SecretItem* _tmp17_;
	SecretItem* item;
	SecretItem* _tmp18_;
	GHashTable* _tmp19_;
	gchar* hostname;
	GHashTable* _tmp20_;
	gconstpointer _tmp21_;
	gchar* _tmp22_;
	gchar* username;
	GHashTable* _tmp23_;
	gconstpointer _tmp24_;
	gchar* _tmp25_;
	gchar* password;
	SecretItem* _tmp26_;
	SecretValue* _tmp27_;
	SecretValue* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	DrtLst* entries;
	GHashTable* _tmp32_;
	const gchar* _tmp33_;
	gconstpointer _tmp34_;
	DrtLst* _tmp35_;
	DrtLst* _tmp36_;
	DrtLst* _tmp37_;
	DrtLst* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	NuvolaLoginCredentials* _tmp41_;
	NuvolaLoginCredentials* _tmp42_;
	GHashTable* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	DrtLst* _tmp46_;
	DrtLst* _tmp47_;
	NuvolaLoginCredentials* entry;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	NuvolaLoginCredentials* _tmp50_;
	gint index;
	DrtLst* _tmp51_;
	NuvolaLoginCredentials* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	DrtLst* _tmp55_;
	gint _tmp56_;
	NuvolaLoginCredentials* _tmp57_;
	DrtLst* _tmp58_;
	NuvolaLoginCredentials* _tmp59_;
	GHashTable* _tmp60_;
	GHashTable* _tmp61_;
	GError * _inner_error_;
};

struct _NuvolaPasswordManagerStorePasswordData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NuvolaPasswordManager* self;
	gchar* hostname;
	gchar* username;
	gchar* password;
	GCancellable* cancellable;
	SecretSchema* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	GCancellable* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GError* e;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError * _inner_error_;
};

struct _NuvolaParamSpecPasswordManager {
	GParamSpec parent_instance;
};


static gpointer nuvola_password_manager_parent_class = NULL;

gpointer nuvola_password_manager_ref (gpointer instance);
void nuvola_password_manager_unref (gpointer instance);
GParamSpec* nuvola_param_spec_password_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void nuvola_value_set_password_manager (GValue* value, gpointer v_object);
void nuvola_value_take_password_manager (GValue* value, gpointer v_object);
gpointer nuvola_value_get_password_manager (const GValue* value);
GType nuvola_password_manager_get_type (void) G_GNUC_CONST;
GType nuvola_web_engine_get_type (void) G_GNUC_CONST;
#define NUVOLA_PASSWORD_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_PASSWORD_MANAGER, NuvolaPasswordManagerPrivate))
enum  {
	NUVOLA_PASSWORD_MANAGER_DUMMY_PROPERTY
};
static void nuvola_password_manager_on_context_menu (NuvolaPasswordManager* self, WebKitContextMenu* menu, GdkEvent* event, WebKitHitTestResult* hit_test_result);
static void _nuvola_password_manager_on_context_menu_nuvola_web_engine_context_menu (NuvolaWebEngine* _sender, WebKitContextMenu* menu, GdkEvent* event, WebKitHitTestResult* hit_test_result, gpointer self);
#define NUVOLA_PASSWORD_MANAGER_SCHEMA_ID "eu.tiliado.nuvola.LoginCretentials"
#define NUVOLA_PASSWORD_MANAGER_SCHEMA_APP_ID "app-id"
#define NUVOLA_PASSWORD_MANAGER_SCHEMA_HOSTNAME "hostname"
#define NUVOLA_PASSWORD_MANAGER_SCHEMA_USERNAME "username"
NuvolaPasswordManager* nuvola_password_manager_new (NuvolaWebEngine* web_engine, const gchar* app_id);
NuvolaPasswordManager* nuvola_password_manager_construct (GType object_type, NuvolaWebEngine* web_engine, const gchar* app_id);
GHashTable* nuvola_password_manager_get_passwords (NuvolaPasswordManager* self);
static void nuvola_password_manager_fetch_passwords_data_free (gpointer _data);
void nuvola_password_manager_fetch_passwords (NuvolaPasswordManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void nuvola_password_manager_fetch_passwords_finish (NuvolaPasswordManager* self, GAsyncResult* _res_, GError** error);
static gboolean nuvola_password_manager_fetch_passwords_co (NuvolaPasswordManagerFetchPasswordsData* _data_);
static void nuvola_password_manager_fetch_passwords_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void _g_free0_ (gpointer var);
static void _drt_lst_unref0_ (gpointer var);
static gboolean _nuvola_login_credentials_username_equals_gequal_func (gconstpointer a, gconstpointer b);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
static void nuvola_password_manager_store_password_data_free (gpointer _data);
void nuvola_password_manager_store_password (NuvolaPasswordManager* self, const gchar* hostname, const gchar* username, const gchar* password, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void nuvola_password_manager_store_password_finish (NuvolaPasswordManager* self, GAsyncResult* _res_);
static gboolean nuvola_password_manager_store_password_co (NuvolaPasswordManagerStorePasswordData* _data_);
static void nuvola_password_manager_store_password_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void nuvola_password_manager_on_prefill_menu_item_activated (NuvolaPasswordManager* self, GtkAction* action);
static void _nuvola_password_manager_on_prefill_menu_item_activated_gtk_action_activate (GtkAction* _sender, gpointer self);
static void nuvola_password_manager_finalize (NuvolaPasswordManager* obj);


static void _nuvola_password_manager_on_context_menu_nuvola_web_engine_context_menu (NuvolaWebEngine* _sender, WebKitContextMenu* menu, GdkEvent* event, WebKitHitTestResult* hit_test_result, gpointer self) {
	nuvola_password_manager_on_context_menu ((NuvolaPasswordManager*) self, menu, event, hit_test_result);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


NuvolaPasswordManager* nuvola_password_manager_construct (GType object_type, NuvolaWebEngine* web_engine, const gchar* app_id) {
	NuvolaPasswordManager* self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	SecretSchema* _tmp2_ = NULL;
	NuvolaWebEngine* _tmp3_ = NULL;
	NuvolaWebEngine* _tmp4_ = NULL;
	NuvolaWebEngine* _tmp5_ = NULL;
	g_return_val_if_fail (web_engine != NULL, NULL);
	g_return_val_if_fail (app_id != NULL, NULL);
	self = (NuvolaPasswordManager*) g_type_create_instance (object_type);
	_tmp0_ = app_id;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->app_id);
	self->priv->app_id = _tmp1_;
	_tmp2_ = secret_schema_new (NUVOLA_PASSWORD_MANAGER_SCHEMA_ID, SECRET_SCHEMA_NONE, NUVOLA_PASSWORD_MANAGER_SCHEMA_APP_ID, SECRET_SCHEMA_ATTRIBUTE_STRING, NUVOLA_PASSWORD_MANAGER_SCHEMA_HOSTNAME, SECRET_SCHEMA_ATTRIBUTE_STRING, NUVOLA_PASSWORD_MANAGER_SCHEMA_USERNAME, SECRET_SCHEMA_ATTRIBUTE_STRING, NULL);
	_secret_schema_unref0 (self->priv->secret_schema);
	self->priv->secret_schema = _tmp2_;
	_tmp3_ = web_engine;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (self->priv->web_engine);
	self->priv->web_engine = _tmp4_;
	_tmp5_ = web_engine;
	g_signal_connect (_tmp5_, "context-menu", (GCallback) _nuvola_password_manager_on_context_menu_nuvola_web_engine_context_menu, self);
	return self;
}


NuvolaPasswordManager* nuvola_password_manager_new (NuvolaWebEngine* web_engine, const gchar* app_id) {
	return nuvola_password_manager_construct (NUVOLA_TYPE_PASSWORD_MANAGER, web_engine, app_id);
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


GHashTable* nuvola_password_manager_get_passwords (NuvolaPasswordManager* self) {
	GHashTable* result = NULL;
	GHashTable* _tmp0_ = NULL;
	GHashTable* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->passwords;
	_tmp1_ = _g_hash_table_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


static void nuvola_password_manager_fetch_passwords_data_free (gpointer _data) {
	NuvolaPasswordManagerFetchPasswordsData* _data_;
	_data_ = _data;
	_nuvola_password_manager_unref0 (_data_->self);
	g_slice_free (NuvolaPasswordManagerFetchPasswordsData, _data_);
}


static gpointer _nuvola_password_manager_ref0 (gpointer self) {
	return self ? nuvola_password_manager_ref (self) : NULL;
}


void nuvola_password_manager_fetch_passwords (NuvolaPasswordManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaPasswordManagerFetchPasswordsData* _data_;
	NuvolaPasswordManager* _tmp0_ = NULL;
	_data_ = g_slice_new0 (NuvolaPasswordManagerFetchPasswordsData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, nuvola_password_manager_fetch_passwords);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_password_manager_fetch_passwords_data_free);
	_tmp0_ = _nuvola_password_manager_ref0 (self);
	_data_->self = _tmp0_;
	nuvola_password_manager_fetch_passwords_co (_data_);
}


void nuvola_password_manager_fetch_passwords_finish (NuvolaPasswordManager* self, GAsyncResult* _res_, GError** error) {
	NuvolaPasswordManagerFetchPasswordsData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void nuvola_password_manager_fetch_passwords_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NuvolaPasswordManagerFetchPasswordsData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	nuvola_password_manager_fetch_passwords_co (_data_);
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _drt_lst_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (drt_lst_unref (var), NULL));
}


static gpointer _drt_lst_ref0 (gpointer self) {
	return self ? drt_lst_ref (self) : NULL;
}


static gboolean _nuvola_login_credentials_username_equals_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = nuvola_login_credentials_username_equals (a, (NuvolaLoginCredentials*) b);
	return result;
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


static gboolean nuvola_password_manager_fetch_passwords_co (NuvolaPasswordManagerFetchPasswordsData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_state_ = 1;
	secret_collection_for_alias (NULL, SECRET_COLLECTION_DEFAULT, SECRET_COLLECTION_LOAD_ITEMS, NULL, nuvola_password_manager_fetch_passwords_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = secret_collection_for_alias_finish (_data_->_res_, &_data_->_inner_error_);
	_data_->collection = _data_->_tmp0_;
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
		g_error_free (_data_->_inner_error_);
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = g_str_hash;
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = g_str_equal;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = g_hash_table_new_full (_data_->_tmp1_, _data_->_tmp2_, _g_free0_, _g_free0_);
	_data_->attributes = _data_->_tmp3_;
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _data_->attributes;
	_data_->_tmp5_ = NULL;
	_data_->_tmp5_ = g_strdup (NUVOLA_PASSWORD_MANAGER_SCHEMA_APP_ID);
	_data_->_tmp6_ = NULL;
	_data_->_tmp6_ = _data_->self->priv->app_id;
	_data_->_tmp7_ = NULL;
	_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
	g_hash_table_insert (_data_->_tmp4_, _data_->_tmp5_, _data_->_tmp7_);
	_data_->flags = (SECRET_SEARCH_ALL | SECRET_SEARCH_UNLOCK) | SECRET_SEARCH_LOAD_SECRETS;
	_data_->_tmp8_ = NULL;
	_data_->_tmp8_ = _data_->collection;
	_data_->_tmp9_ = NULL;
	_data_->_tmp9_ = _data_->self->priv->secret_schema;
	_data_->_tmp10_ = NULL;
	_data_->_tmp10_ = _data_->attributes;
	_data_->_tmp11_ = 0;
	_data_->_tmp11_ = _data_->flags;
	_data_->_state_ = 2;
	secret_collection_search (_data_->_tmp8_, _data_->_tmp9_, _data_->_tmp10_, _data_->_tmp11_, NULL, nuvola_password_manager_fetch_passwords_ready, _data_);
	return FALSE;
	_state_2:
	_data_->_tmp12_ = NULL;
	_data_->_tmp12_ = secret_collection_search_finish (_data_->_tmp8_, _data_->_res_, &_data_->_inner_error_);
	_data_->items = _data_->_tmp12_;
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
		g_error_free (_data_->_inner_error_);
		_g_hash_table_unref0 (_data_->attributes);
		_g_object_unref0 (_data_->collection);
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp13_ = NULL;
	_data_->_tmp13_ = g_str_hash;
	_data_->_tmp14_ = NULL;
	_data_->_tmp14_ = g_str_equal;
	_data_->_tmp15_ = NULL;
	_data_->_tmp15_ = g_hash_table_new_full (_data_->_tmp13_, _data_->_tmp14_, _g_free0_, _drt_lst_unref0_);
	_data_->credentials = _data_->_tmp15_;
	_data_->_tmp16_ = NULL;
	_data_->_tmp16_ = _data_->items;
	{
		_data_->item_collection = _data_->_tmp16_;
		for (_data_->item_it = _data_->item_collection; _data_->item_it != NULL; _data_->item_it = _data_->item_it->next) {
			_data_->_tmp17_ = NULL;
			_data_->_tmp17_ = _g_object_ref0 ((SecretItem*) _data_->item_it->data);
			_data_->item = _data_->_tmp17_;
			{
				_data_->_tmp18_ = NULL;
				_data_->_tmp18_ = _data_->item;
				_data_->_tmp19_ = NULL;
				_data_->_tmp19_ = secret_item_get_attributes (_data_->_tmp18_);
				_g_hash_table_unref0 (_data_->attributes);
				_data_->attributes = _data_->_tmp19_;
				_data_->_tmp20_ = NULL;
				_data_->_tmp20_ = _data_->attributes;
				_data_->_tmp21_ = NULL;
				_data_->_tmp21_ = g_hash_table_lookup (_data_->_tmp20_, NUVOLA_PASSWORD_MANAGER_SCHEMA_HOSTNAME);
				_data_->_tmp22_ = NULL;
				_data_->_tmp22_ = g_strdup ((const gchar*) _data_->_tmp21_);
				_data_->hostname = _data_->_tmp22_;
				_data_->_tmp23_ = NULL;
				_data_->_tmp23_ = _data_->attributes;
				_data_->_tmp24_ = NULL;
				_data_->_tmp24_ = g_hash_table_lookup (_data_->_tmp23_, NUVOLA_PASSWORD_MANAGER_SCHEMA_USERNAME);
				_data_->_tmp25_ = NULL;
				_data_->_tmp25_ = g_strdup ((const gchar*) _data_->_tmp24_);
				_data_->username = _data_->_tmp25_;
				_data_->_tmp26_ = NULL;
				_data_->_tmp26_ = _data_->item;
				_data_->_tmp27_ = NULL;
				_data_->_tmp27_ = secret_item_get_secret (_data_->_tmp26_);
				_data_->_tmp28_ = NULL;
				_data_->_tmp28_ = _data_->_tmp27_;
				_data_->_tmp29_ = NULL;
				_data_->_tmp29_ = secret_value_get_text (_data_->_tmp28_);
				_data_->_tmp30_ = NULL;
				_data_->_tmp30_ = g_strdup (_data_->_tmp29_);
				_data_->_tmp31_ = NULL;
				_data_->_tmp31_ = _data_->_tmp30_;
				_secret_value_unref0 (_data_->_tmp28_);
				_data_->password = _data_->_tmp31_;
				_data_->_tmp32_ = NULL;
				_data_->_tmp32_ = _data_->credentials;
				_data_->_tmp33_ = NULL;
				_data_->_tmp33_ = _data_->hostname;
				_data_->_tmp34_ = NULL;
				_data_->_tmp34_ = g_hash_table_lookup (_data_->_tmp32_, _data_->_tmp33_);
				_data_->_tmp35_ = NULL;
				_data_->_tmp35_ = _drt_lst_ref0 ((DrtLst*) _data_->_tmp34_);
				_data_->entries = _data_->_tmp35_;
				_data_->_tmp36_ = NULL;
				_data_->_tmp36_ = _data_->entries;
				if (_data_->_tmp36_ == NULL) {
					_data_->_tmp37_ = NULL;
					_data_->_tmp37_ = drt_lst_new (NUVOLA_TYPE_LOGIN_CREDENTIALS, (GBoxedCopyFunc) nuvola_login_credentials_ref, (GDestroyNotify) nuvola_login_credentials_unref, _nuvola_login_credentials_username_equals_gequal_func);
					_drt_lst_unref0 (_data_->entries);
					_data_->entries = _data_->_tmp37_;
					_data_->_tmp38_ = NULL;
					_data_->_tmp38_ = _data_->entries;
					_data_->_tmp39_ = NULL;
					_data_->_tmp39_ = _data_->username;
					_data_->_tmp40_ = NULL;
					_data_->_tmp40_ = _data_->password;
					_data_->_tmp41_ = NULL;
					_data_->_tmp41_ = nuvola_login_credentials_new (_data_->_tmp39_, _data_->_tmp40_);
					_data_->_tmp42_ = NULL;
					_data_->_tmp42_ = _data_->_tmp41_;
					drt_lst_prepend (_data_->_tmp38_, _data_->_tmp42_);
					_nuvola_login_credentials_unref0 (_data_->_tmp42_);
					_data_->_tmp43_ = NULL;
					_data_->_tmp43_ = _data_->credentials;
					_data_->_tmp44_ = NULL;
					_data_->_tmp44_ = _data_->hostname;
					_data_->_tmp45_ = NULL;
					_data_->_tmp45_ = g_strdup (_data_->_tmp44_);
					_data_->_tmp46_ = NULL;
					_data_->_tmp46_ = _data_->entries;
					_data_->_tmp47_ = NULL;
					_data_->_tmp47_ = _drt_lst_ref0 (_data_->_tmp46_);
					g_hash_table_insert (_data_->_tmp43_, _data_->_tmp45_, _data_->_tmp47_);
				} else {
					_data_->_tmp48_ = NULL;
					_data_->_tmp48_ = _data_->username;
					_data_->_tmp49_ = NULL;
					_data_->_tmp49_ = _data_->password;
					_data_->_tmp50_ = NULL;
					_data_->_tmp50_ = nuvola_login_credentials_new (_data_->_tmp48_, _data_->_tmp49_);
					_data_->entry = _data_->_tmp50_;
					_data_->_tmp51_ = NULL;
					_data_->_tmp51_ = _data_->entries;
					_data_->_tmp52_ = NULL;
					_data_->_tmp52_ = _data_->entry;
					_data_->_tmp53_ = 0;
					_data_->_tmp53_ = drt_lst_index (_data_->_tmp51_, _data_->_tmp52_);
					_data_->index = _data_->_tmp53_;
					_data_->_tmp54_ = 0;
					_data_->_tmp54_ = _data_->index;
					if (_data_->_tmp54_ >= 0) {
						_data_->_tmp55_ = NULL;
						_data_->_tmp55_ = _data_->entries;
						_data_->_tmp56_ = 0;
						_data_->_tmp56_ = _data_->index;
						_data_->_tmp57_ = NULL;
						_data_->_tmp57_ = _data_->entry;
						drt_lst_set (_data_->_tmp55_, _data_->_tmp56_, _data_->_tmp57_);
					} else {
						_data_->_tmp58_ = NULL;
						_data_->_tmp58_ = _data_->entries;
						_data_->_tmp59_ = NULL;
						_data_->_tmp59_ = _data_->entry;
						drt_lst_prepend (_data_->_tmp58_, _data_->_tmp59_);
					}
					_nuvola_login_credentials_unref0 (_data_->entry);
				}
				_drt_lst_unref0 (_data_->entries);
				_g_free0 (_data_->password);
				_g_free0 (_data_->username);
				_g_free0 (_data_->hostname);
				_g_object_unref0 (_data_->item);
			}
		}
	}
	_data_->_tmp60_ = NULL;
	_data_->_tmp60_ = _data_->credentials;
	_data_->_tmp61_ = NULL;
	_data_->_tmp61_ = _g_hash_table_ref0 (_data_->_tmp60_);
	_g_hash_table_unref0 (_data_->self->priv->passwords);
	_data_->self->priv->passwords = _data_->_tmp61_;
	_g_hash_table_unref0 (_data_->credentials);
	__g_list_free__g_object_unref0_0 (_data_->items);
	_g_hash_table_unref0 (_data_->attributes);
	_g_object_unref0 (_data_->collection);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void nuvola_password_manager_store_password_data_free (gpointer _data) {
	NuvolaPasswordManagerStorePasswordData* _data_;
	_data_ = _data;
	_g_free0 (_data_->hostname);
	_g_free0 (_data_->username);
	_g_free0 (_data_->password);
	_g_object_unref0 (_data_->cancellable);
	_nuvola_password_manager_unref0 (_data_->self);
	g_slice_free (NuvolaPasswordManagerStorePasswordData, _data_);
}


void nuvola_password_manager_store_password (NuvolaPasswordManager* self, const gchar* hostname, const gchar* username, const gchar* password, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NuvolaPasswordManagerStorePasswordData* _data_;
	NuvolaPasswordManager* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GCancellable* _tmp7_ = NULL;
	GCancellable* _tmp8_ = NULL;
	_data_ = g_slice_new0 (NuvolaPasswordManagerStorePasswordData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, nuvola_password_manager_store_password);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, nuvola_password_manager_store_password_data_free);
	_tmp0_ = _nuvola_password_manager_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = hostname;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->hostname);
	_data_->hostname = _tmp2_;
	_tmp3_ = username;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_data_->username);
	_data_->username = _tmp4_;
	_tmp5_ = password;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (_data_->password);
	_data_->password = _tmp6_;
	_tmp7_ = cancellable;
	_tmp8_ = _g_object_ref0 (_tmp7_);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp8_;
	nuvola_password_manager_store_password_co (_data_);
}


void nuvola_password_manager_store_password_finish (NuvolaPasswordManager* self, GAsyncResult* _res_) {
	NuvolaPasswordManagerStorePasswordData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void nuvola_password_manager_store_password_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NuvolaPasswordManagerStorePasswordData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	nuvola_password_manager_store_password_co (_data_);
}


static gboolean nuvola_password_manager_store_password_co (NuvolaPasswordManagerStorePasswordData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_tmp0_ = NULL;
		_data_->_tmp0_ = _data_->self->priv->secret_schema;
		_data_->_tmp1_ = NULL;
		_data_->_tmp1_ = nuvola_get_app_name ();
		_data_->_tmp2_ = NULL;
		_data_->_tmp2_ = _data_->_tmp1_;
		_data_->_tmp3_ = NULL;
		_data_->_tmp3_ = _data_->username;
		_data_->_tmp4_ = NULL;
		_data_->_tmp4_ = _data_->hostname;
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = g_strdup_printf ("%s password for '%s' at %s", _data_->_tmp2_, _data_->_tmp3_, _data_->_tmp4_);
		_data_->_tmp6_ = NULL;
		_data_->_tmp6_ = _data_->_tmp5_;
		_data_->_tmp7_ = NULL;
		_data_->_tmp7_ = _data_->password;
		_data_->_tmp8_ = NULL;
		_data_->_tmp8_ = _data_->cancellable;
		_data_->_tmp9_ = NULL;
		_data_->_tmp9_ = _data_->self->priv->app_id;
		_data_->_tmp10_ = NULL;
		_data_->_tmp10_ = _data_->hostname;
		_data_->_tmp11_ = NULL;
		_data_->_tmp11_ = _data_->username;
		_data_->_state_ = 1;
		secret_password_store (_data_->_tmp0_, SECRET_COLLECTION_DEFAULT, _data_->_tmp6_, _data_->_tmp7_, _data_->_tmp8_, nuvola_password_manager_store_password_ready, _data_, NUVOLA_PASSWORD_MANAGER_SCHEMA_APP_ID, _data_->_tmp9_, NUVOLA_PASSWORD_MANAGER_SCHEMA_HOSTNAME, _data_->_tmp10_, NUVOLA_PASSWORD_MANAGER_SCHEMA_USERNAME, _data_->_tmp11_, NULL);
		return FALSE;
		_state_1:
		secret_password_store_finish (_data_->_res_, &_data_->_inner_error_);
		_g_free0 (_data_->_tmp6_);
		_g_free0 (_data_->_tmp2_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			goto __catch50_g_error;
		}
	}
	goto __finally50;
	__catch50_g_error:
	{
		_data_->e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp12_ = NULL;
		_data_->_tmp12_ = _data_->username;
		_data_->_tmp13_ = NULL;
		_data_->_tmp13_ = _data_->hostname;
		_data_->_tmp14_ = NULL;
		_data_->_tmp14_ = _data_->e;
		_data_->_tmp15_ = NULL;
		_data_->_tmp15_ = _data_->_tmp14_->message;
		_data_->_tmp16_ = NULL;
		_data_->_tmp16_ = g_strdup_printf ("Failed to store password for '%s' at %s. %s", _data_->_tmp12_, _data_->_tmp13_, _data_->_tmp15_);
		_data_->_tmp17_ = NULL;
		_data_->_tmp17_ = _data_->_tmp16_;
		g_warning ("PasswordManager.vala:110: %s", _data_->_tmp17_);
		_g_free0 (_data_->_tmp17_);
		_g_error_free0 (_data_->e);
	}
	__finally50:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


static void _nuvola_password_manager_on_prefill_menu_item_activated_gtk_action_activate (GtkAction* _sender, gpointer self) {
	nuvola_password_manager_on_prefill_menu_item_activated ((NuvolaPasswordManager*) self, _sender);
}


static void nuvola_password_manager_on_context_menu (NuvolaPasswordManager* self, WebKitContextMenu* menu, GdkEvent* event, WebKitHitTestResult* hit_test_result) {
	GVariant* data = NULL;
	WebKitContextMenu* _tmp0_ = NULL;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GVariant* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (menu != NULL);
	g_return_if_fail (event != NULL);
	g_return_if_fail (hit_test_result != NULL);
	_tmp0_ = menu;
	_tmp1_ = webkit_context_menu_get_user_data (_tmp0_);
	_tmp2_ = _g_variant_ref0 (_tmp1_);
	data = _tmp2_;
	_tmp4_ = data;
	if (_tmp4_ != NULL) {
		GVariant* _tmp5_ = NULL;
		GVariantType* _tmp6_ = NULL;
		GVariantType* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		_tmp5_ = data;
		_tmp6_ = g_variant_type_new ("(sas)");
		_tmp7_ = _tmp6_;
		_tmp8_ = g_variant_is_of_type (_tmp5_, _tmp7_);
		_tmp3_ = _tmp8_;
		_g_variant_type_free0 (_tmp7_);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gchar* name = NULL;
		GVariantIter* iter = NULL;
		GVariant* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		name = NULL;
		iter = NULL;
		_tmp9_ = data;
		g_variant_get (_tmp9_, "(sas)", &name, &iter, NULL);
		_tmp10_ = name;
		if (g_strcmp0 (_tmp10_, "prefill-password") == 0) {
			WebKitContextMenu* usernames = NULL;
			WebKitContextMenu* _tmp11_ = NULL;
			gchar* username = NULL;
			gint i = 0;
			WebKitContextMenu* _tmp25_ = NULL;
			WebKitContextMenu* _tmp26_ = NULL;
			WebKitContextMenuItem* _tmp27_ = NULL;
			WebKitContextMenuItem* _tmp28_ = NULL;
			_tmp11_ = webkit_context_menu_new ();
			usernames = _tmp11_;
			username = NULL;
			i = 0;
			while (TRUE) {
				GVariantIter* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				GtkAction* action = NULL;
				gint _tmp14_ = 0;
				gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				const gchar* _tmp17_ = NULL;
				GtkAction* _tmp18_ = NULL;
				GtkAction* _tmp19_ = NULL;
				GtkAction* _tmp20_ = NULL;
				WebKitContextMenu* _tmp21_ = NULL;
				GtkAction* _tmp22_ = NULL;
				WebKitContextMenuItem* _tmp23_ = NULL;
				WebKitContextMenuItem* _tmp24_ = NULL;
				_tmp12_ = iter;
				_tmp13_ = g_variant_iter_next (_tmp12_, "s", &username, NULL);
				if (!_tmp13_) {
					break;
				}
				_tmp14_ = i;
				i = _tmp14_ + 1;
				_tmp15_ = g_strdup_printf ("prefill-password-%d", _tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = username;
				_tmp18_ = gtk_action_new (_tmp16_, _tmp17_, NULL, NULL);
				_tmp19_ = _tmp18_;
				_g_free0 (_tmp16_);
				action = _tmp19_;
				_tmp20_ = action;
				g_signal_connect (_tmp20_, "activate", (GCallback) _nuvola_password_manager_on_prefill_menu_item_activated_gtk_action_activate, self);
				_tmp21_ = usernames;
				_tmp22_ = action;
				_tmp23_ = webkit_context_menu_item_new (_tmp22_);
				g_object_ref_sink (_tmp23_);
				_tmp24_ = _tmp23_;
				webkit_context_menu_append (_tmp21_, _tmp24_);
				_g_object_unref0 (_tmp24_);
				_g_object_unref0 (action);
			}
			_tmp25_ = menu;
			_tmp26_ = usernames;
			_tmp27_ = webkit_context_menu_item_new_with_submenu ("Fill Password", _tmp26_);
			g_object_ref_sink (_tmp27_);
			_tmp28_ = _tmp27_;
			webkit_context_menu_append (_tmp25_, _tmp28_);
			_g_object_unref0 (_tmp28_);
			_g_free0 (username);
			_g_object_unref0 (usernames);
		}
		_g_variant_iter_free0 (iter);
		_g_free0 (name);
	}
	_g_variant_unref0 (data);
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_ = 0L;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_ = 0L;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		_tmp3_ = offset;
		_tmp4_ = len;
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
		string_length = _tmp5_;
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp6_ = strlen (self);
		_tmp7_ = _tmp6_;
		string_length = (glong) _tmp7_;
	}
	_tmp8_ = offset;
	if (_tmp8_ < ((glong) 0)) {
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp9_ = string_length;
		_tmp10_ = offset;
		offset = _tmp9_ + _tmp10_;
		_tmp11_ = offset;
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
		_tmp12_ = offset;
		_tmp13_ = string_length;
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
	}
	_tmp14_ = len;
	if (_tmp14_ < ((glong) 0)) {
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
		_tmp15_ = string_length;
		_tmp16_ = offset;
		len = _tmp15_ - _tmp16_;
	}
	_tmp17_ = offset;
	_tmp18_ = len;
	_tmp19_ = string_length;
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
	_tmp20_ = offset;
	_tmp21_ = len;
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
	result = _tmp22_;
	return result;
}


static void nuvola_password_manager_on_prefill_menu_item_activated (NuvolaPasswordManager* self, GtkAction* action) {
	GtkAction* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = action;
	_tmp1_ = gtk_action_get_name (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = string_substring (_tmp2_, (glong) 17, (glong) -1);
	_tmp4_ = _tmp3_;
	_tmp5_ = atoi (_tmp4_);
	g_signal_emit_by_name (self, "prefill-username", _tmp5_);
	_g_free0 (_tmp4_);
}


static void nuvola_value_password_manager_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void nuvola_value_password_manager_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		nuvola_password_manager_unref (value->data[0].v_pointer);
	}
}


static void nuvola_value_password_manager_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = nuvola_password_manager_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer nuvola_value_password_manager_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* nuvola_value_password_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		NuvolaPasswordManager* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = nuvola_password_manager_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* nuvola_value_password_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	NuvolaPasswordManager** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = nuvola_password_manager_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* nuvola_param_spec_password_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	NuvolaParamSpecPasswordManager* spec;
	g_return_val_if_fail (g_type_is_a (object_type, NUVOLA_TYPE_PASSWORD_MANAGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer nuvola_value_get_password_manager (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_PASSWORD_MANAGER), NULL);
	return value->data[0].v_pointer;
}


void nuvola_value_set_password_manager (GValue* value, gpointer v_object) {
	NuvolaPasswordManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_PASSWORD_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_PASSWORD_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		nuvola_password_manager_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_password_manager_unref (old);
	}
}


void nuvola_value_take_password_manager (GValue* value, gpointer v_object) {
	NuvolaPasswordManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NUVOLA_TYPE_PASSWORD_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NUVOLA_TYPE_PASSWORD_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		nuvola_password_manager_unref (old);
	}
}


static void nuvola_password_manager_class_init (NuvolaPasswordManagerClass * klass) {
	nuvola_password_manager_parent_class = g_type_class_peek_parent (klass);
	((NuvolaPasswordManagerClass *) klass)->finalize = nuvola_password_manager_finalize;
	g_type_class_add_private (klass, sizeof (NuvolaPasswordManagerPrivate));
	g_signal_new ("prefill_username", NUVOLA_TYPE_PASSWORD_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
}


static void nuvola_password_manager_instance_init (NuvolaPasswordManager * self) {
	self->priv = NUVOLA_PASSWORD_MANAGER_GET_PRIVATE (self);
	self->priv->passwords = NULL;
	self->ref_count = 1;
}


static void nuvola_password_manager_finalize (NuvolaPasswordManager* obj) {
	NuvolaPasswordManager * self;
	NuvolaWebEngine* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_PASSWORD_MANAGER, NuvolaPasswordManager);
	g_signal_handlers_destroy (self);
	g_debug ("PasswordManager.vala:53: ~PasswordManager");
	_tmp0_ = self->priv->web_engine;
	g_signal_parse_name ("context-menu", NUVOLA_TYPE_WEB_ENGINE, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _nuvola_password_manager_on_context_menu_nuvola_web_engine_context_menu, self);
	_g_free0 (self->priv->app_id);
	_secret_schema_unref0 (self->priv->secret_schema);
	_g_hash_table_unref0 (self->priv->passwords);
	_g_object_unref0 (self->priv->web_engine);
}


GType nuvola_password_manager_get_type (void) {
	static volatile gsize nuvola_password_manager_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_password_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { nuvola_value_password_manager_init, nuvola_value_password_manager_free_value, nuvola_value_password_manager_copy_value, nuvola_value_password_manager_peek_pointer, "p", nuvola_value_password_manager_collect_value, "p", nuvola_value_password_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaPasswordManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_password_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaPasswordManager), 0, (GInstanceInitFunc) nuvola_password_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType nuvola_password_manager_type_id;
		nuvola_password_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NuvolaPasswordManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&nuvola_password_manager_type_id__volatile, nuvola_password_manager_type_id);
	}
	return nuvola_password_manager_type_id__volatile;
}


gpointer nuvola_password_manager_ref (gpointer instance) {
	NuvolaPasswordManager* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void nuvola_password_manager_unref (gpointer instance) {
	NuvolaPasswordManager* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		NUVOLA_PASSWORD_MANAGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



