/* StartupWindow.c generated by valac 0.34.9, the Vala compiler
 * generated from StartupWindow.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <dioritegtk4.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_STARTUP_WINDOW (nuvola_startup_window_get_type ())
#define NUVOLA_STARTUP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_STARTUP_WINDOW, NuvolaStartupWindow))
#define NUVOLA_STARTUP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_STARTUP_WINDOW, NuvolaStartupWindowClass))
#define NUVOLA_IS_STARTUP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_STARTUP_WINDOW))
#define NUVOLA_IS_STARTUP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_STARTUP_WINDOW))
#define NUVOLA_STARTUP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_STARTUP_WINDOW, NuvolaStartupWindowClass))

typedef struct _NuvolaStartupWindow NuvolaStartupWindow;
typedef struct _NuvolaStartupWindowClass NuvolaStartupWindowClass;
typedef struct _NuvolaStartupWindowPrivate NuvolaStartupWindowPrivate;

#define NUVOLA_TYPE_STARTUP_CHECK (nuvola_startup_check_get_type ())
#define NUVOLA_STARTUP_CHECK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_STARTUP_CHECK, NuvolaStartupCheck))
#define NUVOLA_STARTUP_CHECK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_STARTUP_CHECK, NuvolaStartupCheckClass))
#define NUVOLA_IS_STARTUP_CHECK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_STARTUP_CHECK))
#define NUVOLA_IS_STARTUP_CHECK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_STARTUP_CHECK))
#define NUVOLA_STARTUP_CHECK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_STARTUP_CHECK, NuvolaStartupCheckClass))

typedef struct _NuvolaStartupCheck NuvolaStartupCheck;
typedef struct _NuvolaStartupCheckClass NuvolaStartupCheckClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NUVOLA_TYPE_APP_RUNNER_CONTROLLER (nuvola_app_runner_controller_get_type ())
#define NUVOLA_APP_RUNNER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_APP_RUNNER_CONTROLLER, NuvolaAppRunnerController))
#define NUVOLA_APP_RUNNER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_APP_RUNNER_CONTROLLER, NuvolaAppRunnerControllerClass))
#define NUVOLA_IS_APP_RUNNER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_APP_RUNNER_CONTROLLER))
#define NUVOLA_IS_APP_RUNNER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_APP_RUNNER_CONTROLLER))
#define NUVOLA_APP_RUNNER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_APP_RUNNER_CONTROLLER, NuvolaAppRunnerControllerClass))

typedef struct _NuvolaAppRunnerController NuvolaAppRunnerController;
typedef struct _NuvolaAppRunnerControllerClass NuvolaAppRunnerControllerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define NUVOLA_STARTUP_CHECK_TYPE_STATUS (nuvola_startup_check_status_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _NuvolaStartupWindow {
	DrtApplicationWindow parent_instance;
	NuvolaStartupWindowPrivate * priv;
};

struct _NuvolaStartupWindowClass {
	DrtApplicationWindowClass parent_class;
	void (*ready_to_continue) (NuvolaStartupWindow* self);
};

struct _NuvolaStartupWindowPrivate {
	GtkLabel* _xdg_desktop_portal_status;
	GtkLabel* _xdg_desktop_portal_message;
	GtkLabel* _nuvola_service_status;
	GtkLabel* _nuvola_service_message;
	GtkLabel* _opengl_driver_status;
	GtkLabel* _opengl_driver_message;
	GtkLabel* _vaapi_driver_status;
	GtkLabel* _vaapi_driver_message;
	GtkLabel* _vdpau_driver_status;
	GtkLabel* _vdpau_driver_message;
	GtkLabel* _app_requirements_status;
	GtkLabel* _app_requirements_message;
	NuvolaStartupCheck* _model;
	GtkScrolledWindow* scroll;
	GtkGrid* grid;
	GtkLabel* header;
	GtkLabel* label;
	GtkButton* bottom_button;
	gint grid_line;
};

typedef enum  {
	NUVOLA_STARTUP_CHECK_STATUS_UNKNOWN,
	NUVOLA_STARTUP_CHECK_STATUS_NOT_APPLICABLE,
	NUVOLA_STARTUP_CHECK_STATUS_IN_PROGRESS,
	NUVOLA_STARTUP_CHECK_STATUS_OK,
	NUVOLA_STARTUP_CHECK_STATUS_WARNING,
	NUVOLA_STARTUP_CHECK_STATUS_ERROR
} NuvolaStartupCheckStatus;


static gpointer nuvola_startup_window_parent_class = NULL;

GType nuvola_startup_window_get_type (void) G_GNUC_CONST;
GType nuvola_startup_check_get_type (void) G_GNUC_CONST;
#define NUVOLA_STARTUP_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_STARTUP_WINDOW, NuvolaStartupWindowPrivate))
enum  {
	NUVOLA_STARTUP_WINDOW_DUMMY_PROPERTY,
	NUVOLA_STARTUP_WINDOW_XDG_DESKTOP_PORTAL_STATUS,
	NUVOLA_STARTUP_WINDOW_XDG_DESKTOP_PORTAL_MESSAGE,
	NUVOLA_STARTUP_WINDOW_NUVOLA_SERVICE_STATUS,
	NUVOLA_STARTUP_WINDOW_NUVOLA_SERVICE_MESSAGE,
	NUVOLA_STARTUP_WINDOW_OPENGL_DRIVER_STATUS,
	NUVOLA_STARTUP_WINDOW_OPENGL_DRIVER_MESSAGE,
	NUVOLA_STARTUP_WINDOW_VAAPI_DRIVER_STATUS,
	NUVOLA_STARTUP_WINDOW_VAAPI_DRIVER_MESSAGE,
	NUVOLA_STARTUP_WINDOW_VDPAU_DRIVER_STATUS,
	NUVOLA_STARTUP_WINDOW_VDPAU_DRIVER_MESSAGE,
	NUVOLA_STARTUP_WINDOW_APP_REQUIREMENTS_STATUS,
	NUVOLA_STARTUP_WINDOW_APP_REQUIREMENTS_MESSAGE,
	NUVOLA_STARTUP_WINDOW_MODEL
};
GType nuvola_app_runner_controller_get_type (void) G_GNUC_CONST;
NuvolaStartupWindow* nuvola_startup_window_new (NuvolaAppRunnerController* app, NuvolaStartupCheck* startup_check);
NuvolaStartupWindow* nuvola_startup_window_construct (GType object_type, NuvolaAppRunnerController* app, NuvolaStartupCheck* startup_check);
static void nuvola_startup_window_set_model (NuvolaStartupWindow* self, NuvolaStartupCheck* value);
static void nuvola_startup_window_add_line (NuvolaStartupWindow* self, gint* line, const gchar* header, const gchar* name);
NuvolaStartupCheck* nuvola_startup_window_get_model (NuvolaStartupWindow* self);
static void nuvola_startup_window_on_model_changed (NuvolaStartupWindow* self, GObject* model, GParamSpec* param);
static void _nuvola_startup_window_on_model_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
GType nuvola_startup_check_status_get_type (void) G_GNUC_CONST;
static void nuvola_startup_window_on_checks_finished (NuvolaStartupWindow* self, NuvolaStartupCheckStatus final_status);
static void _nuvola_startup_window_on_checks_finished_nuvola_startup_check_finished (NuvolaStartupCheck* _sender, NuvolaStartupCheckStatus final_status, gpointer self);
gchar* nuvola_startup_check_status_get_blurb (NuvolaStartupCheckStatus self);
gchar* nuvola_startup_check_status_get_badge_class (NuvolaStartupCheckStatus self);
NuvolaStartupCheckStatus* nuvola_startup_check_status_all (int* result_length1);
static void nuvola_startup_window_on_button_clicked (NuvolaStartupWindow* self, GtkButton* button);
static void _nuvola_startup_window_on_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
GtkLabel* nuvola_startup_window_get_xdg_desktop_portal_status (NuvolaStartupWindow* self);
void nuvola_startup_window_set_xdg_desktop_portal_status (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_xdg_desktop_portal_message (NuvolaStartupWindow* self);
void nuvola_startup_window_set_xdg_desktop_portal_message (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_nuvola_service_status (NuvolaStartupWindow* self);
void nuvola_startup_window_set_nuvola_service_status (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_nuvola_service_message (NuvolaStartupWindow* self);
void nuvola_startup_window_set_nuvola_service_message (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_opengl_driver_status (NuvolaStartupWindow* self);
void nuvola_startup_window_set_opengl_driver_status (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_opengl_driver_message (NuvolaStartupWindow* self);
void nuvola_startup_window_set_opengl_driver_message (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_vaapi_driver_status (NuvolaStartupWindow* self);
void nuvola_startup_window_set_vaapi_driver_status (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_vaapi_driver_message (NuvolaStartupWindow* self);
void nuvola_startup_window_set_vaapi_driver_message (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_vdpau_driver_status (NuvolaStartupWindow* self);
void nuvola_startup_window_set_vdpau_driver_status (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_vdpau_driver_message (NuvolaStartupWindow* self);
void nuvola_startup_window_set_vdpau_driver_message (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_app_requirements_status (NuvolaStartupWindow* self);
void nuvola_startup_window_set_app_requirements_status (NuvolaStartupWindow* self, GtkLabel* value);
GtkLabel* nuvola_startup_window_get_app_requirements_message (NuvolaStartupWindow* self);
void nuvola_startup_window_set_app_requirements_message (NuvolaStartupWindow* self, GtkLabel* value);
static void nuvola_startup_window_real_ready_to_continue (NuvolaStartupWindow* self);
static void nuvola_startup_window_finalize (GObject* obj);
static void _vala_nuvola_startup_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_startup_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Create new StartupWindow
 * 
 * @param app              The corresponding application.
 * @param startup_check    Startup checks.
 */
static void _nuvola_startup_window_on_model_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	nuvola_startup_window_on_model_changed ((NuvolaStartupWindow*) self, _sender, pspec);
}


static void _nuvola_startup_window_on_checks_finished_nuvola_startup_check_finished (NuvolaStartupCheck* _sender, NuvolaStartupCheckStatus final_status, gpointer self) {
	nuvola_startup_window_on_checks_finished ((NuvolaStartupWindow*) self, final_status);
}


NuvolaStartupWindow* nuvola_startup_window_construct (GType object_type, NuvolaAppRunnerController* app, NuvolaStartupCheck* startup_check) {
	NuvolaStartupWindow * self = NULL;
	NuvolaAppRunnerController* _tmp0_ = NULL;
	NuvolaStartupCheck* _tmp1_ = NULL;
	NuvolaAppRunnerController* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GtkGrid* _tmp13_ = NULL;
	GtkGrid* _tmp14_ = NULL;
	GtkGrid* _tmp15_ = NULL;
	GtkGrid* _tmp16_ = NULL;
	GtkGrid* _tmp17_ = NULL;
	NuvolaStartupCheck* _tmp18_ = NULL;
	GtkScrolledWindow* _tmp19_ = NULL;
	GtkScrolledWindow* _tmp20_ = NULL;
	GtkScrolledWindow* _tmp21_ = NULL;
	GtkScrolledWindow* _tmp22_ = NULL;
	GtkScrolledWindow* _tmp23_ = NULL;
	GtkGrid* _tmp24_ = NULL;
	GtkGrid* _tmp25_ = NULL;
	GtkGrid* _tmp26_ = NULL;
	GtkScrolledWindow* _tmp27_ = NULL;
	GtkGrid* _tmp28_ = NULL;
	GtkScrolledWindow* _tmp29_ = NULL;
	NuvolaStartupCheck* _tmp30_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	g_return_val_if_fail (startup_check != NULL, NULL);
	_tmp0_ = app;
	self = (NuvolaStartupWindow*) drt_application_window_construct (object_type, (DrtApplication*) _tmp0_, FALSE);
	_tmp1_ = startup_check;
	nuvola_startup_window_set_model (self, _tmp1_);
	_tmp2_ = app;
	_tmp3_ = drt_application_get_app_name ((DrtApplication*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat ("Start-up Check for ", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	gtk_window_set_title ((GtkWindow*) self, _tmp6_);
	_g_free0 (_tmp6_);
	{
		GdkPixbuf* _tmp7_ = NULL;
		GtkIconTheme* _tmp8_ = NULL;
		NuvolaAppRunnerController* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		GdkPixbuf* _tmp12_ = NULL;
		_tmp8_ = gtk_icon_theme_get_default ();
		_tmp9_ = app;
		_tmp10_ = drt_application_get_icon ((DrtApplication*) _tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = gtk_icon_theme_load_icon (_tmp8_, _tmp11_, 48, 0, &_inner_error_);
		_tmp7_ = _tmp12_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch97_g_error;
		}
		gtk_window_set_icon ((GtkWindow*) self, _tmp7_);
		_g_object_unref0 (_tmp7_);
	}
	goto __finally97;
	__catch97_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("StartupWindow.vala:87: Unable to load application icon.");
		_g_error_free0 (e);
	}
	__finally97:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	gtk_window_set_default_size ((GtkWindow*) self, 500, 500);
	_tmp13_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp13_;
	_tmp14_ = self->priv->grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp14_, GTK_ORIENTATION_VERTICAL);
	_tmp15_ = self->priv->grid;
	_tmp16_ = self->priv->grid;
	gtk_grid_set_row_spacing (_tmp16_, 10);
	gtk_grid_set_column_spacing (_tmp15_, 10);
	_tmp17_ = self->priv->grid;
	g_object_set ((GtkWidget*) _tmp17_, "margin", 15, NULL);
	nuvola_startup_window_add_line (self, &self->priv->grid_line, "Web App Requirements", "app_requirements");
	nuvola_startup_window_add_line (self, &self->priv->grid_line, "Nuvola Service", "nuvola_service");
	nuvola_startup_window_add_line (self, &self->priv->grid_line, "XDG Desktop Portal", "xdg_desktop_portal");
	nuvola_startup_window_add_line (self, &self->priv->grid_line, "OpenGL Driver", "opengl_driver");
	nuvola_startup_window_add_line (self, &self->priv->grid_line, "VA-API Driver", "vaapi_driver");
	nuvola_startup_window_add_line (self, &self->priv->grid_line, "VDPAU Driver", "vdpau_driver");
	_tmp18_ = self->priv->_model;
	g_signal_connect_object ((GObject*) _tmp18_, "notify", (GCallback) _nuvola_startup_window_on_model_changed_g_object_notify, self, G_CONNECT_AFTER);
	_tmp19_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->scroll);
	self->priv->scroll = _tmp19_;
	_tmp20_ = self->priv->scroll;
	gtk_scrolled_window_set_policy (_tmp20_, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	_tmp21_ = self->priv->scroll;
	_tmp22_ = self->priv->scroll;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp22_, TRUE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp21_, TRUE);
	_tmp23_ = self->priv->scroll;
	_tmp24_ = self->priv->grid;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = drt_application_window_get_top_grid ((DrtApplicationWindow*) self);
	_tmp26_ = _tmp25_;
	_tmp27_ = self->priv->scroll;
	gtk_grid_attach (_tmp26_, (GtkWidget*) _tmp27_, 0, 2, 1, 1);
	_tmp28_ = self->priv->grid;
	gtk_widget_show ((GtkWidget*) _tmp28_);
	_tmp29_ = self->priv->scroll;
	gtk_widget_show ((GtkWidget*) _tmp29_);
	_tmp30_ = self->priv->_model;
	g_signal_connect_object (_tmp30_, "finished", (GCallback) _nuvola_startup_window_on_checks_finished_nuvola_startup_check_finished, self, 0);
	return self;
}


NuvolaStartupWindow* nuvola_startup_window_new (NuvolaAppRunnerController* app, NuvolaStartupCheck* startup_check) {
	return nuvola_startup_window_construct (NUVOLA_TYPE_STARTUP_WINDOW, app, startup_check);
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch98_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch98_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally98;
	__catch98_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally98:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void nuvola_startup_window_add_line (NuvolaStartupWindow* self, gint* line, const gchar* header, const gchar* name) {
	NuvolaStartupCheckStatus status = 0;
	gchar* msg = NULL;
	gchar* prop_status = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* prop_msg = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	NuvolaStartupCheck* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	GtkLabel* label = NULL;
	const gchar* _tmp13_ = NULL;
	GtkLabel* _tmp14_ = NULL;
	GtkLabel* _tmp15_ = NULL;
	GtkLabel* _tmp16_ = NULL;
	GtkGrid* _tmp17_ = NULL;
	GtkLabel* _tmp18_ = NULL;
	gint _tmp19_ = 0;
	NuvolaStartupCheckStatus _tmp20_ = 0;
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	GtkLabel* _tmp23_ = NULL;
	GtkLabel* _tmp24_ = NULL;
	GtkLabel* _tmp25_ = NULL;
	GtkLabel* _tmp26_ = NULL;
	GtkLabel* _tmp27_ = NULL;
	GtkStyleContext* _tmp28_ = NULL;
	NuvolaStartupCheckStatus _tmp29_ = 0;
	gchar* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	GtkLabel* _tmp32_ = NULL;
	GtkGrid* _tmp33_ = NULL;
	GtkLabel* _tmp34_ = NULL;
	gint _tmp35_ = 0;
	const gchar* _tmp36_ = NULL;
	GtkLabel* _tmp37_ = NULL;
	const gchar* _tmp38_ = NULL;
	GtkLabel* _tmp39_ = NULL;
	GtkLabel* _tmp40_ = NULL;
	const gchar* _tmp41_ = NULL;
	GtkGrid* _tmp45_ = NULL;
	GtkLabel* _tmp46_ = NULL;
	gint _tmp47_ = 0;
	const gchar* _tmp48_ = NULL;
	GtkLabel* _tmp49_ = NULL;
	gint _tmp50_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (header != NULL);
	g_return_if_fail (name != NULL);
	status = NUVOLA_STARTUP_CHECK_STATUS_UNKNOWN;
	msg = NULL;
	_tmp0_ = name;
	_tmp1_ = string_replace (_tmp0_, "_", "-");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "-status", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	prop_status = _tmp4_;
	_tmp5_ = name;
	_tmp6_ = string_replace (_tmp5_, "_", "-");
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat (_tmp7_, "-message", NULL);
	_tmp9_ = _tmp8_;
	_g_free0 (_tmp7_);
	prop_msg = _tmp9_;
	_tmp10_ = self->priv->_model;
	_tmp11_ = prop_status;
	_tmp12_ = prop_msg;
	g_object_get ((GObject*) _tmp10_, _tmp11_, &status, _tmp12_, &msg, NULL);
	_tmp13_ = header;
	_tmp14_ = drt_labels_header (_tmp13_);
	label = _tmp14_;
	_tmp15_ = label;
	gtk_widget_show ((GtkWidget*) _tmp15_);
	_tmp16_ = label;
	gtk_label_set_line_wrap (_tmp16_, FALSE);
	_tmp17_ = self->priv->grid;
	_tmp18_ = label;
	_tmp19_ = *line;
	gtk_grid_attach (_tmp17_, (GtkWidget*) _tmp18_, 0, _tmp19_, 1, 1);
	_tmp20_ = status;
	_tmp21_ = nuvola_startup_check_status_get_blurb (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = drt_labels_plain (_tmp22_, FALSE);
	_g_object_unref0 (label);
	label = _tmp23_;
	_g_free0 (_tmp22_);
	_tmp24_ = label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp24_, FALSE);
	_tmp25_ = label;
	_tmp26_ = label;
	gtk_widget_set_valign ((GtkWidget*) _tmp26_, GTK_ALIGN_CENTER);
	gtk_widget_set_halign ((GtkWidget*) _tmp25_, GTK_ALIGN_CENTER);
	_tmp27_ = label;
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) _tmp27_);
	_tmp29_ = status;
	_tmp30_ = nuvola_startup_check_status_get_badge_class (_tmp29_);
	_tmp31_ = _tmp30_;
	gtk_style_context_add_class (_tmp28_, _tmp31_);
	_g_free0 (_tmp31_);
	_tmp32_ = label;
	gtk_widget_show ((GtkWidget*) _tmp32_);
	_tmp33_ = self->priv->grid;
	_tmp34_ = label;
	_tmp35_ = *line;
	gtk_grid_attach (_tmp33_, (GtkWidget*) _tmp34_, 1, _tmp35_, 1, 1);
	_tmp36_ = prop_status;
	_tmp37_ = label;
	g_object_set ((GObject*) self, _tmp36_, _tmp37_, NULL);
	_tmp38_ = msg;
	_tmp39_ = drt_labels_markup (_tmp38_, NULL);
	_g_object_unref0 (label);
	label = _tmp39_;
	_tmp40_ = label;
	gtk_label_set_selectable (_tmp40_, TRUE);
	_tmp41_ = msg;
	if (_tmp41_ != NULL) {
		GtkLabel* _tmp42_ = NULL;
		const gchar* _tmp43_ = NULL;
		const gchar* _tmp44_ = NULL;
		_tmp42_ = label;
		gtk_widget_show ((GtkWidget*) _tmp42_);
		_tmp43_ = name;
		_tmp44_ = msg;
		g_warning ("StartupWindow.vala:158: %s: %s", _tmp43_, _tmp44_);
	}
	_tmp45_ = self->priv->grid;
	_tmp46_ = label;
	_tmp47_ = *line;
	gtk_grid_attach (_tmp45_, (GtkWidget*) _tmp46_, 0, _tmp47_ + 1, 2, 1);
	_tmp48_ = prop_msg;
	_tmp49_ = label;
	g_object_set ((GObject*) self, _tmp48_, _tmp49_, NULL);
	_tmp50_ = *line;
	*line = _tmp50_ + 2;
	_g_object_unref0 (label);
	_g_free0 (prop_msg);
	_g_free0 (prop_status);
	_g_free0 (msg);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void nuvola_startup_window_on_model_changed (NuvolaStartupWindow* self, GObject* model, GParamSpec* param) {
	gboolean _tmp0_ = FALSE;
	GParamSpec* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (param != NULL);
	_tmp1_ = param;
	_tmp2_ = _tmp1_->name;
	_tmp3_ = g_str_has_suffix (_tmp2_, "-status");
	if (_tmp3_) {
		GParamSpec* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		_tmp4_ = param;
		_tmp5_ = _tmp4_->name;
		_tmp0_ = g_strcmp0 (_tmp5_, "final-status") != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		NuvolaStartupCheckStatus status = 0;
		GObject* _tmp6_ = NULL;
		GParamSpec* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		GtkLabel* label = NULL;
		GParamSpec* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		GtkLabel* _tmp11_ = NULL;
		NuvolaStartupCheckStatus _tmp12_ = 0;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		GtkStyleContext* styles = NULL;
		GtkLabel* _tmp15_ = NULL;
		GtkStyleContext* _tmp16_ = NULL;
		GtkStyleContext* _tmp17_ = NULL;
		gint _tmp18_ = 0;
		NuvolaStartupCheckStatus* _tmp19_ = NULL;
		GtkStyleContext* _tmp24_ = NULL;
		NuvolaStartupCheckStatus _tmp25_ = 0;
		gchar* _tmp26_ = NULL;
		gchar* _tmp27_ = NULL;
		status = NUVOLA_STARTUP_CHECK_STATUS_UNKNOWN;
		_tmp6_ = model;
		_tmp7_ = param;
		_tmp8_ = _tmp7_->name;
		g_object_get (_tmp6_, _tmp8_, &status, NULL);
		label = NULL;
		_tmp9_ = param;
		_tmp10_ = _tmp9_->name;
		g_object_get ((GObject*) self, _tmp10_, &label, NULL);
		_tmp11_ = label;
		_tmp12_ = status;
		_tmp13_ = nuvola_startup_check_status_get_blurb (_tmp12_);
		_tmp14_ = _tmp13_;
		gtk_label_set_label (_tmp11_, _tmp14_);
		_g_free0 (_tmp14_);
		_tmp15_ = label;
		_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
		_tmp17_ = _g_object_ref0 (_tmp16_);
		styles = _tmp17_;
		_tmp19_ = nuvola_startup_check_status_all (&_tmp18_);
		{
			NuvolaStartupCheckStatus* item_collection = NULL;
			gint item_collection_length1 = 0;
			gint _item_collection_size_ = 0;
			gint item_it = 0;
			item_collection = _tmp19_;
			item_collection_length1 = _tmp18_;
			for (item_it = 0; item_it < _tmp18_; item_it = item_it + 1) {
				NuvolaStartupCheckStatus item = 0;
				item = item_collection[item_it];
				{
					GtkStyleContext* _tmp20_ = NULL;
					NuvolaStartupCheckStatus _tmp21_ = 0;
					gchar* _tmp22_ = NULL;
					gchar* _tmp23_ = NULL;
					_tmp20_ = styles;
					_tmp21_ = item;
					_tmp22_ = nuvola_startup_check_status_get_badge_class (_tmp21_);
					_tmp23_ = _tmp22_;
					gtk_style_context_remove_class (_tmp20_, _tmp23_);
					_g_free0 (_tmp23_);
				}
			}
			item_collection = (g_free (item_collection), NULL);
		}
		_tmp24_ = styles;
		_tmp25_ = status;
		_tmp26_ = nuvola_startup_check_status_get_badge_class (_tmp25_);
		_tmp27_ = _tmp26_;
		gtk_style_context_add_class (_tmp24_, _tmp27_);
		_g_free0 (_tmp27_);
		_g_object_unref0 (styles);
		_g_object_unref0 (label);
	} else {
		GParamSpec* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		gboolean _tmp30_ = FALSE;
		_tmp28_ = param;
		_tmp29_ = _tmp28_->name;
		_tmp30_ = g_str_has_suffix (_tmp29_, "-message");
		if (_tmp30_) {
			gchar* msg = NULL;
			GObject* _tmp31_ = NULL;
			GParamSpec* _tmp32_ = NULL;
			const gchar* _tmp33_ = NULL;
			GtkLabel* label = NULL;
			GParamSpec* _tmp34_ = NULL;
			const gchar* _tmp35_ = NULL;
			GtkLabel* _tmp36_ = NULL;
			const gchar* _tmp37_ = NULL;
			const gchar* _tmp38_ = NULL;
			msg = NULL;
			_tmp31_ = model;
			_tmp32_ = param;
			_tmp33_ = _tmp32_->name;
			g_object_get (_tmp31_, _tmp33_, &msg, NULL);
			label = NULL;
			_tmp34_ = param;
			_tmp35_ = _tmp34_->name;
			g_object_get ((GObject*) self, _tmp35_, &label, NULL);
			_tmp36_ = label;
			_tmp37_ = msg;
			gtk_label_set_label (_tmp36_, _tmp37_);
			_tmp38_ = msg;
			if (_tmp38_ != NULL) {
				GtkLabel* _tmp39_ = NULL;
				GParamSpec* _tmp40_ = NULL;
				const gchar* _tmp41_ = NULL;
				const gchar* _tmp42_ = NULL;
				_tmp39_ = label;
				gtk_widget_show ((GtkWidget*) _tmp39_);
				_tmp40_ = param;
				_tmp41_ = _tmp40_->name;
				_tmp42_ = msg;
				g_warning ("StartupWindow.vala:189: %s: %s", _tmp41_, _tmp42_);
			} else {
				GtkLabel* _tmp43_ = NULL;
				_tmp43_ = label;
				gtk_widget_hide ((GtkWidget*) _tmp43_);
			}
			_g_object_unref0 (label);
			_g_free0 (msg);
		}
	}
}


static void _nuvola_startup_window_on_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	nuvola_startup_window_on_button_clicked ((NuvolaStartupWindow*) self, _sender);
}


static void nuvola_startup_window_on_button_clicked (NuvolaStartupWindow* self, GtkButton* button) {
	GtkButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	g_signal_emit_by_name (self, "ready-to-continue");
	_tmp0_ = button;
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _nuvola_startup_window_on_button_clicked_gtk_button_clicked, self);
}


static void nuvola_startup_window_on_checks_finished (NuvolaStartupWindow* self, NuvolaStartupCheckStatus final_status) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp4_ = NULL;
	GtkButton* _tmp8_ = NULL;
	GtkButton* button = NULL;
	NuvolaStartupCheckStatus _tmp14_ = 0;
	GtkLabel* _tmp34_ = NULL;
	GtkLabel* _tmp35_ = NULL;
	GtkGrid* _tmp36_ = NULL;
	GtkLabel* _tmp37_ = NULL;
	GtkLabel* _tmp38_ = NULL;
	GtkLabel* _tmp39_ = NULL;
	GtkLabel* _tmp40_ = NULL;
	GtkGrid* _tmp41_ = NULL;
	GtkLabel* _tmp42_ = NULL;
	GtkButton* _tmp43_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->header;
	if (_tmp0_ != NULL) {
		GtkLabel* _tmp1_ = NULL;
		GtkContainer* _tmp2_ = NULL;
		GtkLabel* _tmp3_ = NULL;
		_tmp1_ = self->priv->header;
		_tmp2_ = (GtkContainer*) gtk_widget_get_parent ((GtkWidget*) _tmp1_);
		_tmp3_ = self->priv->header;
		gtk_container_remove (_tmp2_, (GtkWidget*) _tmp3_);
		_g_object_unref0 (self->priv->header);
		self->priv->header = NULL;
	}
	_tmp4_ = self->priv->label;
	if (_tmp4_ != NULL) {
		GtkLabel* _tmp5_ = NULL;
		GtkContainer* _tmp6_ = NULL;
		GtkLabel* _tmp7_ = NULL;
		_tmp5_ = self->priv->label;
		_tmp6_ = (GtkContainer*) gtk_widget_get_parent ((GtkWidget*) _tmp5_);
		_tmp7_ = self->priv->label;
		gtk_container_remove (_tmp6_, (GtkWidget*) _tmp7_);
		_g_object_unref0 (self->priv->label);
		self->priv->label = NULL;
	}
	_tmp8_ = self->priv->bottom_button;
	if (_tmp8_ != NULL) {
		GtkButton* _tmp9_ = NULL;
		GtkContainer* _tmp10_ = NULL;
		GtkButton* _tmp11_ = NULL;
		GtkButton* _tmp12_ = NULL;
		guint _tmp13_ = 0U;
		_tmp9_ = self->priv->bottom_button;
		_tmp10_ = (GtkContainer*) gtk_widget_get_parent ((GtkWidget*) _tmp9_);
		_tmp11_ = self->priv->bottom_button;
		gtk_container_remove (_tmp10_, (GtkWidget*) _tmp11_);
		_tmp12_ = self->priv->bottom_button;
		g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp13_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _nuvola_startup_window_on_button_clicked_gtk_button_clicked, self);
		_g_object_unref0 (self->priv->bottom_button);
		self->priv->bottom_button = NULL;
	}
	button = NULL;
	_tmp14_ = final_status;
	switch (_tmp14_) {
		case NUVOLA_STARTUP_CHECK_STATUS_ERROR:
		{
			DrtApplication* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			const gchar* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_ = NULL;
			GtkLabel* _tmp20_ = NULL;
			GtkLabel* _tmp21_ = NULL;
			GtkButton* _tmp22_ = NULL;
			_tmp15_ = ((DrtApplicationWindow*) self)->app;
			_tmp16_ = drt_application_get_app_name (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = g_strconcat (_tmp17_, " cannot start", NULL);
			_tmp19_ = _tmp18_;
			_tmp20_ = drt_labels_header (_tmp19_);
			_g_object_unref0 (self->priv->header);
			self->priv->header = _tmp20_;
			_g_free0 (_tmp19_);
			_tmp21_ = drt_labels_markup ("<big>Look at the table bellow to find out the reason.</big>", NULL);
			_g_object_unref0 (self->priv->label);
			self->priv->label = _tmp21_;
			_tmp22_ = (GtkButton*) gtk_button_new_with_label ("Quit");
			g_object_ref_sink (_tmp22_);
			_g_object_unref0 (button);
			button = _tmp22_;
			break;
		}
		case NUVOLA_STARTUP_CHECK_STATUS_WARNING:
		{
			GtkLabel* _tmp23_ = NULL;
			DrtApplication* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
			const gchar* _tmp26_ = NULL;
			GtkLabel* _tmp27_ = NULL;
			GtkButton* _tmp28_ = NULL;
			_tmp23_ = drt_labels_header ("There are a few issues");
			_g_object_unref0 (self->priv->header);
			self->priv->header = _tmp23_;
			_tmp24_ = ((DrtApplicationWindow*) self)->app;
			_tmp25_ = drt_application_get_app_name (_tmp24_);
			_tmp26_ = _tmp25_;
			_tmp27_ = drt_labels_markup ("<big>You can continue using %s but take a look at the table bellow fir" \
"st.</big>", _tmp26_, NULL);
			_g_object_unref0 (self->priv->label);
			self->priv->label = _tmp27_;
			_tmp28_ = (GtkButton*) gtk_button_new_with_label ("Continue");
			g_object_ref_sink (_tmp28_);
			_g_object_unref0 (button);
			button = _tmp28_;
			break;
		}
		case NUVOLA_STARTUP_CHECK_STATUS_OK:
		{
			GtkLabel* _tmp29_ = NULL;
			DrtApplication* _tmp30_ = NULL;
			const gchar* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			GtkLabel* _tmp33_ = NULL;
			_tmp29_ = drt_labels_header ("Everything is OK");
			_g_object_unref0 (self->priv->header);
			self->priv->header = _tmp29_;
			_tmp30_ = ((DrtApplicationWindow*) self)->app;
			_tmp31_ = drt_application_get_app_name (_tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = drt_labels_markup ("<big>%s will load in a few seconds.</big>", _tmp32_, NULL);
			_g_object_unref0 (self->priv->label);
			self->priv->label = _tmp33_;
			break;
		}
		default:
		break;
	}
	_tmp34_ = self->priv->header;
	g_object_set ((GtkWidget*) _tmp34_, "margin", 5, NULL);
	_tmp35_ = self->priv->header;
	gtk_widget_show ((GtkWidget*) _tmp35_);
	_tmp36_ = self->priv->grid;
	_tmp37_ = self->priv->header;
	gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, 0, 0, 2, 1);
	_tmp38_ = self->priv->label;
	g_object_set ((GtkWidget*) _tmp38_, "margin", 5, NULL);
	_tmp39_ = self->priv->label;
	gtk_widget_set_halign ((GtkWidget*) _tmp39_, GTK_ALIGN_CENTER);
	_tmp40_ = self->priv->label;
	gtk_widget_show ((GtkWidget*) _tmp40_);
	_tmp41_ = self->priv->grid;
	_tmp42_ = self->priv->label;
	gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp42_, 0, 1, 2, 1);
	_tmp43_ = button;
	if (_tmp43_ != NULL) {
		GtkButton* _tmp44_ = NULL;
		GtkButton* _tmp45_ = NULL;
		GtkButton* _tmp46_ = NULL;
		GtkButton* _tmp47_ = NULL;
		GtkButton* _tmp48_ = NULL;
		GtkButton* _tmp49_ = NULL;
		GtkGrid* _tmp50_ = NULL;
		GtkGrid* _tmp51_ = NULL;
		GtkButton* _tmp52_ = NULL;
		_tmp44_ = button;
		_tmp45_ = _g_object_ref0 (_tmp44_);
		_g_object_unref0 (self->priv->bottom_button);
		self->priv->bottom_button = _tmp45_;
		_tmp46_ = button;
		gtk_widget_show ((GtkWidget*) _tmp46_);
		_tmp47_ = button;
		gtk_widget_set_vexpand ((GtkWidget*) _tmp47_, FALSE);
		_tmp48_ = button;
		gtk_widget_set_hexpand ((GtkWidget*) _tmp48_, TRUE);
		_tmp49_ = button;
		g_signal_connect_object (_tmp49_, "clicked", (GCallback) _nuvola_startup_window_on_button_clicked_gtk_button_clicked, self, 0);
		_tmp50_ = drt_application_window_get_top_grid ((DrtApplicationWindow*) self);
		_tmp51_ = _tmp50_;
		_tmp52_ = button;
		gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, 0, 3, 1, 1);
	} else {
		g_signal_emit_by_name (self, "ready-to-continue");
	}
	_g_object_unref0 (button);
}


GtkLabel* nuvola_startup_window_get_xdg_desktop_portal_status (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_xdg_desktop_portal_status;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_xdg_desktop_portal_status (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_xdg_desktop_portal_status);
	self->priv->_xdg_desktop_portal_status = _tmp1_;
	g_object_notify ((GObject *) self, "xdg-desktop-portal-status");
}


GtkLabel* nuvola_startup_window_get_xdg_desktop_portal_message (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_xdg_desktop_portal_message;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_xdg_desktop_portal_message (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_xdg_desktop_portal_message);
	self->priv->_xdg_desktop_portal_message = _tmp1_;
	g_object_notify ((GObject *) self, "xdg-desktop-portal-message");
}


GtkLabel* nuvola_startup_window_get_nuvola_service_status (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_nuvola_service_status;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_nuvola_service_status (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_nuvola_service_status);
	self->priv->_nuvola_service_status = _tmp1_;
	g_object_notify ((GObject *) self, "nuvola-service-status");
}


GtkLabel* nuvola_startup_window_get_nuvola_service_message (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_nuvola_service_message;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_nuvola_service_message (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_nuvola_service_message);
	self->priv->_nuvola_service_message = _tmp1_;
	g_object_notify ((GObject *) self, "nuvola-service-message");
}


GtkLabel* nuvola_startup_window_get_opengl_driver_status (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_opengl_driver_status;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_opengl_driver_status (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_opengl_driver_status);
	self->priv->_opengl_driver_status = _tmp1_;
	g_object_notify ((GObject *) self, "opengl-driver-status");
}


GtkLabel* nuvola_startup_window_get_opengl_driver_message (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_opengl_driver_message;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_opengl_driver_message (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_opengl_driver_message);
	self->priv->_opengl_driver_message = _tmp1_;
	g_object_notify ((GObject *) self, "opengl-driver-message");
}


GtkLabel* nuvola_startup_window_get_vaapi_driver_status (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_vaapi_driver_status;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_vaapi_driver_status (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_vaapi_driver_status);
	self->priv->_vaapi_driver_status = _tmp1_;
	g_object_notify ((GObject *) self, "vaapi-driver-status");
}


GtkLabel* nuvola_startup_window_get_vaapi_driver_message (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_vaapi_driver_message;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_vaapi_driver_message (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_vaapi_driver_message);
	self->priv->_vaapi_driver_message = _tmp1_;
	g_object_notify ((GObject *) self, "vaapi-driver-message");
}


GtkLabel* nuvola_startup_window_get_vdpau_driver_status (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_vdpau_driver_status;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_vdpau_driver_status (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_vdpau_driver_status);
	self->priv->_vdpau_driver_status = _tmp1_;
	g_object_notify ((GObject *) self, "vdpau-driver-status");
}


GtkLabel* nuvola_startup_window_get_vdpau_driver_message (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_vdpau_driver_message;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_vdpau_driver_message (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_vdpau_driver_message);
	self->priv->_vdpau_driver_message = _tmp1_;
	g_object_notify ((GObject *) self, "vdpau-driver-message");
}


GtkLabel* nuvola_startup_window_get_app_requirements_status (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_requirements_status;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_app_requirements_status (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_app_requirements_status);
	self->priv->_app_requirements_status = _tmp1_;
	g_object_notify ((GObject *) self, "app-requirements-status");
}


GtkLabel* nuvola_startup_window_get_app_requirements_message (NuvolaStartupWindow* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_requirements_message;
	result = _tmp0_;
	return result;
}


void nuvola_startup_window_set_app_requirements_message (NuvolaStartupWindow* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_app_requirements_message);
	self->priv->_app_requirements_message = _tmp1_;
	g_object_notify ((GObject *) self, "app-requirements-message");
}


NuvolaStartupCheck* nuvola_startup_window_get_model (NuvolaStartupWindow* self) {
	NuvolaStartupCheck* result;
	NuvolaStartupCheck* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_model;
	result = _tmp0_;
	return result;
}


static void nuvola_startup_window_set_model (NuvolaStartupWindow* self, NuvolaStartupCheck* value) {
	NuvolaStartupCheck* _tmp0_ = NULL;
	NuvolaStartupCheck* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_model);
	self->priv->_model = _tmp1_;
	g_object_notify ((GObject *) self, "model");
}


static void nuvola_startup_window_real_ready_to_continue (NuvolaStartupWindow* self) {
	gtk_widget_hide ((GtkWidget*) self);
}


static void nuvola_startup_window_class_init (NuvolaStartupWindowClass * klass) {
	nuvola_startup_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaStartupWindowPrivate));
	((NuvolaStartupWindowClass *) klass)->ready_to_continue = nuvola_startup_window_real_ready_to_continue;
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_startup_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_startup_window_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_startup_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_XDG_DESKTOP_PORTAL_STATUS, g_param_spec_object ("xdg-desktop-portal-status", "XDG Desktop Portal status", "XDG Desktop Portal is required for proxy settings and opening URIs.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_XDG_DESKTOP_PORTAL_MESSAGE, g_param_spec_object ("xdg-desktop-portal-message", "XDG Desktop Portal message", "Null unless the check went wrong.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_NUVOLA_SERVICE_STATUS, g_param_spec_object ("nuvola-service-status", "Nuvola Service status", "Status of the connection to Nuvola Service (master process).", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_NUVOLA_SERVICE_MESSAGE, g_param_spec_object ("nuvola-service-message", "Nuvola Service message", "Null unless the check went wrong.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_OPENGL_DRIVER_STATUS, g_param_spec_object ("opengl-driver-status", "OpenGL driver status", "If OpenGL driver is misconfigured, WebKitGTK may crash.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_OPENGL_DRIVER_MESSAGE, g_param_spec_object ("opengl-driver-message", "OpenGL driver message", "Null unless the check went wrong.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_VAAPI_DRIVER_STATUS, g_param_spec_object ("vaapi-driver-status", "VA-API driver status", "One of the two APIs for video acceleration.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_VAAPI_DRIVER_MESSAGE, g_param_spec_object ("vaapi-driver-message", "VA-API driver message", "Null unless the check went wrong.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_VDPAU_DRIVER_STATUS, g_param_spec_object ("vdpau-driver-status", "VDPAU driver status", "One of the two APIs for video acceleration.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_VDPAU_DRIVER_MESSAGE, g_param_spec_object ("vdpau-driver-message", "VDPAU driver message", "Null unless the check went wrong.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_APP_REQUIREMENTS_STATUS, g_param_spec_object ("app-requirements-status", "Web App Requirements status", "A web app may have certain requirements, e.g. Flash plugin, MP3 codec, etc.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_APP_REQUIREMENTS_MESSAGE, g_param_spec_object ("app-requirements-message", "Web App Requirements message", "Null unless the check went wrong.", gtk_label_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_STARTUP_WINDOW_MODEL, g_param_spec_object ("model", "Startup checks", "Model for this window.", NUVOLA_TYPE_STARTUP_CHECK, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * Emitted when StartupWindow has provided an user with all information
	 * and can be closed.
	 */
	g_signal_new ("ready_to_continue", NUVOLA_TYPE_STARTUP_WINDOW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (NuvolaStartupWindowClass, ready_to_continue), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void nuvola_startup_window_instance_init (NuvolaStartupWindow * self) {
	self->priv = NUVOLA_STARTUP_WINDOW_GET_PRIVATE (self);
	self->priv->header = NULL;
	self->priv->label = NULL;
	self->priv->bottom_button = NULL;
	self->priv->grid_line = 2;
}


static void nuvola_startup_window_finalize (GObject* obj) {
	NuvolaStartupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_STARTUP_WINDOW, NuvolaStartupWindow);
	_g_object_unref0 (self->priv->_xdg_desktop_portal_status);
	_g_object_unref0 (self->priv->_xdg_desktop_portal_message);
	_g_object_unref0 (self->priv->_nuvola_service_status);
	_g_object_unref0 (self->priv->_nuvola_service_message);
	_g_object_unref0 (self->priv->_opengl_driver_status);
	_g_object_unref0 (self->priv->_opengl_driver_message);
	_g_object_unref0 (self->priv->_vaapi_driver_status);
	_g_object_unref0 (self->priv->_vaapi_driver_message);
	_g_object_unref0 (self->priv->_vdpau_driver_status);
	_g_object_unref0 (self->priv->_vdpau_driver_message);
	_g_object_unref0 (self->priv->_app_requirements_status);
	_g_object_unref0 (self->priv->_app_requirements_message);
	_g_object_unref0 (self->priv->_model);
	_g_object_unref0 (self->priv->scroll);
	_g_object_unref0 (self->priv->grid);
	_g_object_unref0 (self->priv->header);
	_g_object_unref0 (self->priv->label);
	_g_object_unref0 (self->priv->bottom_button);
	G_OBJECT_CLASS (nuvola_startup_window_parent_class)->finalize (obj);
}


/**
 * Graphical representation of {@link StartupCheck}.
 */
GType nuvola_startup_window_get_type (void) {
	static volatile gsize nuvola_startup_window_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_startup_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaStartupWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_startup_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaStartupWindow), 0, (GInstanceInitFunc) nuvola_startup_window_instance_init, NULL };
		GType nuvola_startup_window_type_id;
		nuvola_startup_window_type_id = g_type_register_static (DRT_TYPE_APPLICATION_WINDOW, "NuvolaStartupWindow", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_startup_window_type_id__volatile, nuvola_startup_window_type_id);
	}
	return nuvola_startup_window_type_id__volatile;
}


static void _vala_nuvola_startup_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaStartupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_STARTUP_WINDOW, NuvolaStartupWindow);
	switch (property_id) {
		case NUVOLA_STARTUP_WINDOW_XDG_DESKTOP_PORTAL_STATUS:
		g_value_set_object (value, nuvola_startup_window_get_xdg_desktop_portal_status (self));
		break;
		case NUVOLA_STARTUP_WINDOW_XDG_DESKTOP_PORTAL_MESSAGE:
		g_value_set_object (value, nuvola_startup_window_get_xdg_desktop_portal_message (self));
		break;
		case NUVOLA_STARTUP_WINDOW_NUVOLA_SERVICE_STATUS:
		g_value_set_object (value, nuvola_startup_window_get_nuvola_service_status (self));
		break;
		case NUVOLA_STARTUP_WINDOW_NUVOLA_SERVICE_MESSAGE:
		g_value_set_object (value, nuvola_startup_window_get_nuvola_service_message (self));
		break;
		case NUVOLA_STARTUP_WINDOW_OPENGL_DRIVER_STATUS:
		g_value_set_object (value, nuvola_startup_window_get_opengl_driver_status (self));
		break;
		case NUVOLA_STARTUP_WINDOW_OPENGL_DRIVER_MESSAGE:
		g_value_set_object (value, nuvola_startup_window_get_opengl_driver_message (self));
		break;
		case NUVOLA_STARTUP_WINDOW_VAAPI_DRIVER_STATUS:
		g_value_set_object (value, nuvola_startup_window_get_vaapi_driver_status (self));
		break;
		case NUVOLA_STARTUP_WINDOW_VAAPI_DRIVER_MESSAGE:
		g_value_set_object (value, nuvola_startup_window_get_vaapi_driver_message (self));
		break;
		case NUVOLA_STARTUP_WINDOW_VDPAU_DRIVER_STATUS:
		g_value_set_object (value, nuvola_startup_window_get_vdpau_driver_status (self));
		break;
		case NUVOLA_STARTUP_WINDOW_VDPAU_DRIVER_MESSAGE:
		g_value_set_object (value, nuvola_startup_window_get_vdpau_driver_message (self));
		break;
		case NUVOLA_STARTUP_WINDOW_APP_REQUIREMENTS_STATUS:
		g_value_set_object (value, nuvola_startup_window_get_app_requirements_status (self));
		break;
		case NUVOLA_STARTUP_WINDOW_APP_REQUIREMENTS_MESSAGE:
		g_value_set_object (value, nuvola_startup_window_get_app_requirements_message (self));
		break;
		case NUVOLA_STARTUP_WINDOW_MODEL:
		g_value_set_object (value, nuvola_startup_window_get_model (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_startup_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaStartupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_STARTUP_WINDOW, NuvolaStartupWindow);
	switch (property_id) {
		case NUVOLA_STARTUP_WINDOW_XDG_DESKTOP_PORTAL_STATUS:
		nuvola_startup_window_set_xdg_desktop_portal_status (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_XDG_DESKTOP_PORTAL_MESSAGE:
		nuvola_startup_window_set_xdg_desktop_portal_message (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_NUVOLA_SERVICE_STATUS:
		nuvola_startup_window_set_nuvola_service_status (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_NUVOLA_SERVICE_MESSAGE:
		nuvola_startup_window_set_nuvola_service_message (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_OPENGL_DRIVER_STATUS:
		nuvola_startup_window_set_opengl_driver_status (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_OPENGL_DRIVER_MESSAGE:
		nuvola_startup_window_set_opengl_driver_message (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_VAAPI_DRIVER_STATUS:
		nuvola_startup_window_set_vaapi_driver_status (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_VAAPI_DRIVER_MESSAGE:
		nuvola_startup_window_set_vaapi_driver_message (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_VDPAU_DRIVER_STATUS:
		nuvola_startup_window_set_vdpau_driver_status (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_VDPAU_DRIVER_MESSAGE:
		nuvola_startup_window_set_vdpau_driver_message (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_APP_REQUIREMENTS_STATUS:
		nuvola_startup_window_set_app_requirements_status (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_APP_REQUIREMENTS_MESSAGE:
		nuvola_startup_window_set_app_requirements_message (self, g_value_get_object (value));
		break;
		case NUVOLA_STARTUP_WINDOW_MODEL:
		nuvola_startup_window_set_model (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



