/* TimePositionButton.c generated by valac 0.34.9, the Vala compiler
 * generated from TimePositionButton.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <dioritegtk4.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_TIME_POSITION_BUTTON (nuvola_time_position_button_get_type ())
#define NUVOLA_TIME_POSITION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton))
#define NUVOLA_TIME_POSITION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButtonClass))
#define NUVOLA_IS_TIME_POSITION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_TIME_POSITION_BUTTON))
#define NUVOLA_IS_TIME_POSITION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_TIME_POSITION_BUTTON))
#define NUVOLA_TIME_POSITION_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButtonClass))

typedef struct _NuvolaTimePositionButton NuvolaTimePositionButton;
typedef struct _NuvolaTimePositionButtonClass NuvolaTimePositionButtonClass;
typedef struct _NuvolaTimePositionButtonPrivate NuvolaTimePositionButtonPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NuvolaTimePositionButton {
	DrtPopoverButton parent_instance;
	NuvolaTimePositionButtonPrivate * priv;
};

struct _NuvolaTimePositionButtonClass {
	DrtPopoverButtonClass parent_class;
};

struct _NuvolaTimePositionButtonPrivate {
	gint _start_sec;
	gint _position_sec;
	gint _end_sec;
	GtkOrientation _orientation;
	GtkScale* scale;
};


static gpointer nuvola_time_position_button_parent_class = NULL;

GType nuvola_time_position_button_get_type (void) G_GNUC_CONST;
#define NUVOLA_TIME_POSITION_BUTTON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButtonPrivate))
enum  {
	NUVOLA_TIME_POSITION_BUTTON_DUMMY_PROPERTY,
	NUVOLA_TIME_POSITION_BUTTON_START_SEC,
	NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC,
	NUVOLA_TIME_POSITION_BUTTON_END_SEC,
	NUVOLA_TIME_POSITION_BUTTON_ORIENTATION
};
static gchar* nuvola_time_position_button_format_time_double (NuvolaTimePositionButton* self, gdouble seconds);
static gchar* _nuvola_time_position_button_format_time_double_gtk_scale_format_value (GtkScale* _sender, gdouble value, gpointer self);
static void nuvola_time_position_button_update_label (NuvolaTimePositionButton* self);
static void _nuvola_time_position_button_update_label_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void nuvola_time_position_button_on_value_changed (NuvolaTimePositionButton* self, GtkRange* scale);
static void _nuvola_time_position_button_on_value_changed_gtk_range_value_changed (GtkRange* _sender, gpointer self);
NuvolaTimePositionButton* nuvola_time_position_button_new (gint start_sec, gint end_sec, gint position_sec, GtkOrientation orientation);
NuvolaTimePositionButton* nuvola_time_position_button_construct (GType object_type, gint start_sec, gint end_sec, gint position_sec, GtkOrientation orientation);
static gchar* nuvola_time_position_button_format_time (NuvolaTimePositionButton* self, gint seconds);
gint nuvola_time_position_button_get_position_sec (NuvolaTimePositionButton* self);
gint nuvola_time_position_button_get_end_sec (NuvolaTimePositionButton* self);
static inline gint nuvola_time_position_button_round_sec (NuvolaTimePositionButton* self, gdouble sec);
void nuvola_time_position_button_set_position_sec (NuvolaTimePositionButton* self, gint value);
gint nuvola_time_position_button_get_start_sec (NuvolaTimePositionButton* self);
void nuvola_time_position_button_set_start_sec (NuvolaTimePositionButton* self, gint value);
void nuvola_time_position_button_set_end_sec (NuvolaTimePositionButton* self, gint value);
GtkOrientation nuvola_time_position_button_get_orientation (NuvolaTimePositionButton* self);
void nuvola_time_position_button_set_orientation (NuvolaTimePositionButton* self, GtkOrientation value);
static GObject * nuvola_time_position_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void nuvola_time_position_button_finalize (GObject* obj);
static void _vala_nuvola_time_position_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_time_position_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gchar* _nuvola_time_position_button_format_time_double_gtk_scale_format_value (GtkScale* _sender, gdouble value, gpointer self) {
	gchar* result;
	result = nuvola_time_position_button_format_time_double ((NuvolaTimePositionButton*) self, value);
	return result;
}


static void _nuvola_time_position_button_update_label_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	nuvola_time_position_button_update_label ((NuvolaTimePositionButton*) self);
}


static void _nuvola_time_position_button_on_value_changed_gtk_range_value_changed (GtkRange* _sender, gpointer self) {
	nuvola_time_position_button_on_value_changed ((NuvolaTimePositionButton*) self, _sender);
}


/**
 * Create new TimePositionButton
 * 
 * @param start_sec         The start time in seconds.
 * @param end_sec           The end time in seconds.
 * @param position_sec      The current time in seconds.
 * @param orientation       The orientation of the slider.
 */
NuvolaTimePositionButton* nuvola_time_position_button_construct (GType object_type, gint start_sec, gint end_sec, gint position_sec, GtkOrientation orientation) {
	NuvolaTimePositionButton * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GtkOrientation _tmp3_ = 0;
	_tmp0_ = start_sec;
	_tmp1_ = end_sec;
	_tmp2_ = position_sec;
	_tmp3_ = orientation;
	self = (NuvolaTimePositionButton*) g_object_new (object_type, "start-sec", _tmp0_, "end-sec", _tmp1_, "position-sec", _tmp2_, "orientation", _tmp3_, NULL);
	return self;
}


NuvolaTimePositionButton* nuvola_time_position_button_new (gint start_sec, gint end_sec, gint position_sec, GtkOrientation orientation) {
	return nuvola_time_position_button_construct (NUVOLA_TYPE_TIME_POSITION_BUTTON, start_sec, end_sec, position_sec, orientation);
}


static void nuvola_time_position_button_update_label (NuvolaTimePositionButton* self) {
	gint _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_position_sec;
	_tmp1_ = nuvola_time_position_button_format_time (self, _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_end_sec;
	_tmp4_ = nuvola_time_position_button_format_time (self, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup_printf ("%s/%s", _tmp2_, _tmp5_);
	_tmp7_ = _tmp6_;
	gtk_button_set_label ((GtkButton*) self, _tmp7_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp2_);
}


static gchar* nuvola_time_position_button_format_time (NuvolaTimePositionButton* self, gint seconds) {
	gchar* result = NULL;
	gint hours = 0;
	gint _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar* _result_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint minutes = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = seconds;
	hours = _tmp0_ / 3600;
	_tmp2_ = hours;
	if (_tmp2_ > 0) {
		gint _tmp3_ = 0;
		gchar* _tmp4_ = NULL;
		_tmp3_ = hours;
		_tmp4_ = g_strdup_printf ("%02d:", _tmp3_);
		_g_free0 (_tmp1_);
		_tmp1_ = _tmp4_;
	} else {
		gchar* _tmp5_ = NULL;
		_tmp5_ = g_strdup ("");
		_g_free0 (_tmp1_);
		_tmp1_ = _tmp5_;
	}
	_tmp6_ = g_strdup (_tmp1_);
	_result_ = _tmp6_;
	_tmp7_ = seconds;
	_tmp8_ = hours;
	seconds = _tmp7_ - (_tmp8_ * 3600);
	_tmp9_ = seconds;
	minutes = _tmp9_ / 60;
	_tmp10_ = seconds;
	seconds = _tmp10_ - (minutes * 60);
	_tmp11_ = seconds;
	_tmp12_ = g_strdup_printf ("%02d:%02d", minutes, _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_result_, _tmp13_, NULL);
	_tmp15_ = _tmp14_;
	_g_free0 (_tmp13_);
	result = _tmp15_;
	_g_free0 (_result_);
	_g_free0 (_tmp1_);
	return result;
}


static gchar* nuvola_time_position_button_format_time_double (NuvolaTimePositionButton* self, gdouble seconds) {
	gchar* result = NULL;
	gdouble _tmp0_ = 0.0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = seconds;
	_tmp1_ = nuvola_time_position_button_round_sec (self, _tmp0_);
	_tmp2_ = nuvola_time_position_button_format_time (self, _tmp1_);
	result = _tmp2_;
	return result;
}


static inline gint nuvola_time_position_button_round_sec (NuvolaTimePositionButton* self, gdouble sec) {
	gint result = 0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = sec;
	_tmp1_ = round (_tmp0_);
	result = (gint) _tmp1_;
	return result;
}


static void nuvola_time_position_button_on_value_changed (NuvolaTimePositionButton* self, GtkRange* scale) {
	gint position = 0;
	GtkRange* _tmp0_ = NULL;
	GtkAdjustment* _tmp1_ = NULL;
	GtkAdjustment* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (scale != NULL);
	_tmp0_ = scale;
	_tmp1_ = gtk_range_get_adjustment (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gtk_adjustment_get_value (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = nuvola_time_position_button_round_sec (self, _tmp4_);
	position = _tmp5_;
	_tmp6_ = self->priv->_position_sec;
	_tmp7_ = position;
	if (_tmp6_ != _tmp7_) {
		gint _tmp8_ = 0;
		_tmp8_ = position;
		nuvola_time_position_button_set_position_sec (self, _tmp8_);
		g_signal_emit_by_name (self, "position-changed");
	}
}


gint nuvola_time_position_button_get_start_sec (NuvolaTimePositionButton* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_start_sec;
	result = _tmp0_;
	return result;
}


void nuvola_time_position_button_set_start_sec (NuvolaTimePositionButton* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_start_sec = _tmp0_;
	g_object_notify ((GObject *) self, "start-sec");
}


gint nuvola_time_position_button_get_position_sec (NuvolaTimePositionButton* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_position_sec;
	result = _tmp0_;
	return result;
}


void nuvola_time_position_button_set_position_sec (NuvolaTimePositionButton* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_position_sec = _tmp0_;
	g_object_notify ((GObject *) self, "position-sec");
}


gint nuvola_time_position_button_get_end_sec (NuvolaTimePositionButton* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_end_sec;
	result = _tmp0_;
	return result;
}


void nuvola_time_position_button_set_end_sec (NuvolaTimePositionButton* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_end_sec = _tmp0_;
	g_object_notify ((GObject *) self, "end-sec");
}


GtkOrientation nuvola_time_position_button_get_orientation (NuvolaTimePositionButton* self) {
	GtkOrientation result;
	GtkOrientation _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_orientation;
	result = _tmp0_;
	return result;
}


void nuvola_time_position_button_set_orientation (NuvolaTimePositionButton* self, GtkOrientation value) {
	GtkOrientation _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_orientation = _tmp0_;
	g_object_notify ((GObject *) self, "orientation");
}


static GObject * nuvola_time_position_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	NuvolaTimePositionButton * self;
	GtkOrientation _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GtkScale* _tmp3_ = NULL;
	GtkPopover* _tmp4_ = NULL;
	GtkPopover* _tmp5_ = NULL;
	GtkScale* _tmp6_ = NULL;
	GtkScale* _tmp7_ = NULL;
	GtkScale* _tmp8_ = NULL;
	GtkScale* _tmp9_ = NULL;
	GtkScale* _tmp10_ = NULL;
	GtkScale* _tmp11_ = NULL;
	GtkScale* _tmp12_ = NULL;
	GtkAdjustment* _tmp13_ = NULL;
	GtkAdjustment* _tmp14_ = NULL;
	GtkScale* _tmp15_ = NULL;
	GtkAdjustment* _tmp16_ = NULL;
	GtkAdjustment* _tmp17_ = NULL;
	GtkScale* _tmp18_ = NULL;
	GtkAdjustment* _tmp19_ = NULL;
	GtkAdjustment* _tmp20_ = NULL;
	GtkScale* _tmp21_ = NULL;
	parent_class = G_OBJECT_CLASS (nuvola_time_position_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton);
	nuvola_time_position_button_update_label (self);
	_tmp0_ = self->priv->_orientation;
	_tmp1_ = self->priv->_start_sec;
	_tmp2_ = self->priv->_end_sec;
	_tmp3_ = (GtkScale*) gtk_scale_new_with_range (_tmp0_, _tmp1_ * 1.0, _tmp2_ * 1.0, 1.0);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->scale);
	self->priv->scale = _tmp3_;
	_tmp4_ = drt_popover_button_get_popover ((DrtPopoverButton*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->priv->scale;
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = self->priv->scale;
	gtk_widget_set_size_request ((GtkWidget*) _tmp7_, 200, -1);
	_tmp8_ = self->priv->scale;
	g_signal_connect_object (_tmp8_, "format-value", (GCallback) _nuvola_time_position_button_format_time_double_gtk_scale_format_value, self, 0);
	_tmp9_ = self->priv->scale;
	g_object_set ((GtkWidget*) _tmp9_, "margin", 20, NULL);
	_tmp10_ = self->priv->scale;
	gtk_widget_show ((GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->scale;
	g_object_bind_property_with_closures ((GObject*) self, "orientation", (GObject*) _tmp11_, "orientation", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp12_ = self->priv->scale;
	_tmp13_ = gtk_range_get_adjustment ((GtkRange*) _tmp12_);
	_tmp14_ = _tmp13_;
	g_object_bind_property_with_closures ((GObject*) self, "start-sec", (GObject*) _tmp14_, "lower", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp15_ = self->priv->scale;
	_tmp16_ = gtk_range_get_adjustment ((GtkRange*) _tmp15_);
	_tmp17_ = _tmp16_;
	g_object_bind_property_with_closures ((GObject*) self, "end-sec", (GObject*) _tmp17_, "upper", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp18_ = self->priv->scale;
	_tmp19_ = gtk_range_get_adjustment ((GtkRange*) _tmp18_);
	_tmp20_ = _tmp19_;
	g_object_bind_property_with_closures ((GObject*) self, "position-sec", (GObject*) _tmp20_, "value", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_signal_connect_object ((GObject*) self, "notify::position-sec", (GCallback) _nuvola_time_position_button_update_label_g_object_notify, self, G_CONNECT_AFTER);
	g_signal_connect_object ((GObject*) self, "notify::end-sec", (GCallback) _nuvola_time_position_button_update_label_g_object_notify, self, G_CONNECT_AFTER);
	_tmp21_ = self->priv->scale;
	g_signal_connect_object ((GtkRange*) _tmp21_, "value-changed", (GCallback) _nuvola_time_position_button_on_value_changed_gtk_range_value_changed, self, G_CONNECT_AFTER);
	return obj;
}


static void nuvola_time_position_button_class_init (NuvolaTimePositionButtonClass * klass) {
	nuvola_time_position_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaTimePositionButtonPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_time_position_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_time_position_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = nuvola_time_position_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = nuvola_time_position_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_TIME_POSITION_BUTTON_START_SEC, g_param_spec_int ("start-sec", "start-sec", "start-sec", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC, g_param_spec_int ("position-sec", "position-sec", "position-sec", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_TIME_POSITION_BUTTON_END_SEC, g_param_spec_int ("end-sec", "end-sec", "end-sec", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_TIME_POSITION_BUTTON_ORIENTATION, g_param_spec_enum ("orientation", "orientation", "orientation", GTK_TYPE_ORIENTATION, GTK_ORIENTATION_HORIZONTAL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Emitted when position is changed as a result of user action.
	 */
	g_signal_new ("position_changed", NUVOLA_TYPE_TIME_POSITION_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void nuvola_time_position_button_instance_init (NuvolaTimePositionButton * self) {
	self->priv = NUVOLA_TIME_POSITION_BUTTON_GET_PRIVATE (self);
	self->priv->_start_sec = 0;
	self->priv->_position_sec = 0;
	self->priv->_end_sec = 1;
	self->priv->_orientation = GTK_ORIENTATION_HORIZONTAL;
}


static void nuvola_time_position_button_finalize (GObject* obj) {
	NuvolaTimePositionButton * self;
	GtkScale* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	GQuark _tmp3_ = 0U;
	guint _tmp4_ = 0U;
	GQuark _tmp5_ = 0U;
	GtkScale* _tmp6_ = NULL;
	guint _tmp7_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton);
	_tmp0_ = self->priv->scale;
	g_signal_parse_name ("format-value", gtk_scale_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _nuvola_time_position_button_format_time_double_gtk_scale_format_value, self);
	g_signal_parse_name ("notify::position-sec", G_TYPE_OBJECT, &_tmp2_, &_tmp3_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, _tmp3_, NULL, (GCallback) _nuvola_time_position_button_update_label_g_object_notify, self);
	g_signal_parse_name ("notify::end-sec", G_TYPE_OBJECT, &_tmp4_, &_tmp5_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, _tmp5_, NULL, (GCallback) _nuvola_time_position_button_update_label_g_object_notify, self);
	_tmp6_ = self->priv->scale;
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GtkRange*) _tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _nuvola_time_position_button_on_value_changed_gtk_range_value_changed, self);
	_g_object_unref0 (self->priv->scale);
	G_OBJECT_CLASS (nuvola_time_position_button_parent_class)->finalize (obj);
}


/**
 * Button which shows position inside a time interval and a popover with a slider
 * is shown when the button is clicked.
 */
GType nuvola_time_position_button_get_type (void) {
	static volatile gsize nuvola_time_position_button_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_time_position_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaTimePositionButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_time_position_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaTimePositionButton), 0, (GInstanceInitFunc) nuvola_time_position_button_instance_init, NULL };
		GType nuvola_time_position_button_type_id;
		nuvola_time_position_button_type_id = g_type_register_static (DRT_TYPE_POPOVER_BUTTON, "NuvolaTimePositionButton", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_time_position_button_type_id__volatile, nuvola_time_position_button_type_id);
	}
	return nuvola_time_position_button_type_id__volatile;
}


static void _vala_nuvola_time_position_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaTimePositionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton);
	switch (property_id) {
		case NUVOLA_TIME_POSITION_BUTTON_START_SEC:
		g_value_set_int (value, nuvola_time_position_button_get_start_sec (self));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC:
		g_value_set_int (value, nuvola_time_position_button_get_position_sec (self));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_END_SEC:
		g_value_set_int (value, nuvola_time_position_button_get_end_sec (self));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_ORIENTATION:
		g_value_set_enum (value, nuvola_time_position_button_get_orientation (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_time_position_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaTimePositionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_TIME_POSITION_BUTTON, NuvolaTimePositionButton);
	switch (property_id) {
		case NUVOLA_TIME_POSITION_BUTTON_START_SEC:
		nuvola_time_position_button_set_start_sec (self, g_value_get_int (value));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_POSITION_SEC:
		nuvola_time_position_button_set_position_sec (self, g_value_get_int (value));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_END_SEC:
		nuvola_time_position_button_set_end_sec (self, g_value_get_int (value));
		break;
		case NUVOLA_TIME_POSITION_BUTTON_ORIENTATION:
		nuvola_time_position_button_set_orientation (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



