/* WebAppRegistry.c generated by valac 0.34.9, the Vala compiler
 * generated from WebAppRegistry.vala, do not modify */

/*
 * Copyright 2011-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_WEB_APP_REGISTRY (nuvola_web_app_registry_get_type ())
#define NUVOLA_WEB_APP_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistry))
#define NUVOLA_WEB_APP_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistryClass))
#define NUVOLA_IS_WEB_APP_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_APP_REGISTRY))
#define NUVOLA_IS_WEB_APP_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_APP_REGISTRY))
#define NUVOLA_WEB_APP_REGISTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistryClass))

typedef struct _NuvolaWebAppRegistry NuvolaWebAppRegistry;
typedef struct _NuvolaWebAppRegistryClass NuvolaWebAppRegistryClass;
typedef struct _NuvolaWebAppRegistryPrivate NuvolaWebAppRegistryPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NUVOLA_TYPE_WEB_APP (nuvola_web_app_get_type ())
#define NUVOLA_WEB_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_APP, NuvolaWebApp))
#define NUVOLA_WEB_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_APP, NuvolaWebAppClass))
#define NUVOLA_IS_WEB_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_APP))
#define NUVOLA_IS_WEB_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_APP))
#define NUVOLA_WEB_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_APP, NuvolaWebAppClass))

typedef struct _NuvolaWebApp NuvolaWebApp;
typedef struct _NuvolaWebAppClass NuvolaWebAppClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NuvolaWebAppRegistry {
	GObject parent_instance;
	NuvolaWebAppRegistryPrivate * priv;
};

struct _NuvolaWebAppRegistryClass {
	GObjectClass parent_class;
};

struct _NuvolaWebAppRegistryPrivate {
	GFile* user_storage;
	GFile** system_storage;
	gint system_storage_length1;
	gint _system_storage_size_;
};

typedef enum  {
	NUVOLA_WEB_APP_ERROR_INVALID_METADATA,
	NUVOLA_WEB_APP_ERROR_LOADING_FAILED,
	NUVOLA_WEB_APP_ERROR_COMMAND_FAILED,
	NUVOLA_WEB_APP_ERROR_INVALID_FILE,
	NUVOLA_WEB_APP_ERROR_IOERROR,
	NUVOLA_WEB_APP_ERROR_NOT_ALLOWED,
	NUVOLA_WEB_APP_ERROR_SERVER_ERROR,
	NUVOLA_WEB_APP_ERROR_SERVER_ERROR_MESSAGE,
	NUVOLA_WEB_APP_ERROR_EXTRACT_ERROR
} NuvolaWebAppError;
#define NUVOLA_WEB_APP_ERROR nuvola_web_app_error_quark ()

static gpointer nuvola_web_app_registry_parent_class = NULL;

GType nuvola_web_app_registry_get_type (void) G_GNUC_CONST;
#define NUVOLA_WEB_APP_REGISTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistryPrivate))
enum  {
	NUVOLA_WEB_APP_REGISTRY_DUMMY_PROPERTY
};
NuvolaWebAppRegistry* nuvola_web_app_registry_new (GFile* user_storage, GFile** system_storage, int system_storage_length1);
NuvolaWebAppRegistry* nuvola_web_app_registry_construct (GType object_type, GFile* user_storage, GFile** system_storage, int system_storage_length1);
static GFile** _vala_array_dup4 (GFile** self, int length);
GType nuvola_web_app_get_type (void) G_GNUC_CONST;
NuvolaWebApp* nuvola_web_app_registry_get_app_meta (NuvolaWebAppRegistry* self, const gchar* id);
gboolean nuvola_web_app_validate_id (const gchar* id);
GHashTable* nuvola_web_app_registry_list_web_apps (NuvolaWebAppRegistry* self, const gchar* filter_id);
GFile* nuvola_web_app_get_data_dir (NuvolaWebApp* self);
const gchar* nuvola_web_app_get_name (NuvolaWebApp* self);
gint nuvola_web_app_get_version_major (NuvolaWebApp* self);
gint nuvola_web_app_get_version_minor (NuvolaWebApp* self);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void nuvola_web_app_registry_find_apps (NuvolaWebAppRegistry* self, GFile* directory, const gchar* filter_id, GHashTable* _result_);
GQuark nuvola_web_app_error_quark (void);
NuvolaWebApp* nuvola_web_app_new_from_dir (GFile* dir, GError** error);
NuvolaWebApp* nuvola_web_app_construct_from_dir (GType object_type, GFile* dir, GError** error);
const gchar* nuvola_web_app_get_id (NuvolaWebApp* self);
static void nuvola_web_app_registry_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
 * Creates new web app registry
 * 
 * @param user_storage        user-specific directory with service integrations
 * @param system_storage      system-wide directories with service integrations
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GFile** _vala_array_dup4 (GFile** self, int length) {
	GFile** result;
	int i;
	result = g_new0 (GFile*, length + 1);
	for (i = 0; i < length; i++) {
		GFile* _tmp0_ = NULL;
		_tmp0_ = _g_object_ref0 (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


NuvolaWebAppRegistry* nuvola_web_app_registry_construct (GType object_type, GFile* user_storage, GFile** system_storage, int system_storage_length1) {
	NuvolaWebAppRegistry * self = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	GFile** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	g_return_val_if_fail (user_storage != NULL, NULL);
	self = (NuvolaWebAppRegistry*) g_object_new (object_type, NULL);
	_tmp0_ = user_storage;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->user_storage);
	self->priv->user_storage = _tmp1_;
	_tmp2_ = system_storage;
	_tmp2__length1 = system_storage_length1;
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup4 (_tmp2_, _tmp2__length1) : ((gpointer) _tmp2_);
	_tmp3__length1 = _tmp2__length1;
	self->priv->system_storage = (_vala_array_free (self->priv->system_storage, self->priv->system_storage_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->system_storage = _tmp3_;
	self->priv->system_storage_length1 = _tmp3__length1;
	self->priv->_system_storage_size_ = self->priv->system_storage_length1;
	return self;
}


NuvolaWebAppRegistry* nuvola_web_app_registry_new (GFile* user_storage, GFile** system_storage, int system_storage_length1) {
	return nuvola_web_app_registry_construct (NUVOLA_TYPE_WEB_APP_REGISTRY, user_storage, system_storage, system_storage_length1);
}


/**
 * Return web app by id.
 */
NuvolaWebApp* nuvola_web_app_registry_get_app_meta (NuvolaWebAppRegistry* self, const gchar* id) {
	NuvolaWebApp* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GHashTable* apps = NULL;
	const gchar* _tmp3_ = NULL;
	GHashTable* _tmp4_ = NULL;
	NuvolaWebApp* app = NULL;
	GHashTable* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gconstpointer _tmp7_ = NULL;
	NuvolaWebApp* _tmp8_ = NULL;
	NuvolaWebApp* _tmp9_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = id;
	_tmp1_ = nuvola_web_app_validate_id (_tmp0_);
	if (!_tmp1_) {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = id;
		g_warning ("WebAppRegistry.vala:55: Service id '%s' is invalid.", _tmp2_);
		result = NULL;
		return result;
	}
	_tmp3_ = id;
	_tmp4_ = nuvola_web_app_registry_list_web_apps (self, _tmp3_);
	apps = _tmp4_;
	_tmp5_ = apps;
	_tmp6_ = id;
	_tmp7_ = g_hash_table_lookup (_tmp5_, _tmp6_);
	_tmp8_ = _g_object_ref0 ((NuvolaWebApp*) _tmp7_);
	app = _tmp8_;
	_tmp9_ = app;
	if (_tmp9_ != NULL) {
		gchar* _tmp10_ = NULL;
		NuvolaWebApp* _tmp11_ = NULL;
		GFile* _tmp12_ = NULL;
		GFile* _tmp13_ = NULL;
		NuvolaWebApp* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		NuvolaWebApp* _tmp22_ = NULL;
		gint _tmp23_ = 0;
		gint _tmp24_ = 0;
		NuvolaWebApp* _tmp25_ = NULL;
		gint _tmp26_ = 0;
		gint _tmp27_ = 0;
		_tmp11_ = app;
		_tmp12_ = nuvola_web_app_get_data_dir (_tmp11_);
		_tmp13_ = _tmp12_;
		if (_tmp13_ == NULL) {
			gchar* _tmp14_ = NULL;
			_tmp14_ = g_strdup ("(null)");
			_g_free0 (_tmp10_);
			_tmp10_ = _tmp14_;
		} else {
			NuvolaWebApp* _tmp15_ = NULL;
			GFile* _tmp16_ = NULL;
			GFile* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
			_tmp15_ = app;
			_tmp16_ = nuvola_web_app_get_data_dir (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = g_file_get_path (_tmp17_);
			_g_free0 (_tmp10_);
			_tmp10_ = _tmp18_;
		}
		_tmp19_ = app;
		_tmp20_ = nuvola_web_app_get_name (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = app;
		_tmp23_ = nuvola_web_app_get_version_major (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = app;
		_tmp26_ = nuvola_web_app_get_version_minor (_tmp25_);
		_tmp27_ = _tmp26_;
		g_message ("WebAppRegistry.vala:63: Using web app %s, version %u.%u, data dir %s", _tmp21_, (guint) _tmp24_, (guint) _tmp27_, _tmp10_);
		_g_free0 (_tmp10_);
	} else {
		const gchar* _tmp28_ = NULL;
		_tmp28_ = id;
		g_message ("WebAppRegistry.vala:66: Web App %s not found.", _tmp28_);
	}
	result = app;
	_g_hash_table_unref0 (apps);
	return result;
}


/**
 * Lists available web apps
 * 
 * @param filter_id    if not null, filter apps by id
 * @return hash table of web app id - metadata pairs
 */
static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


GHashTable* nuvola_web_app_registry_list_web_apps (NuvolaWebAppRegistry* self, const gchar* filter_id) {
	GHashTable* result = NULL;
	GHashTable* _result_ = NULL;
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	GHashTable* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GHashTable* _tmp5_ = NULL;
	GFile** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
	_result_ = _tmp2_;
	_tmp3_ = self->priv->user_storage;
	_tmp4_ = filter_id;
	_tmp5_ = _result_;
	nuvola_web_app_registry_find_apps (self, _tmp3_, _tmp4_, _tmp5_);
	_tmp6_ = self->priv->system_storage;
	_tmp6__length1 = self->priv->system_storage_length1;
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
		dir_collection = _tmp6_;
		dir_collection_length1 = _tmp6__length1;
		for (dir_it = 0; dir_it < _tmp6__length1; dir_it = dir_it + 1) {
			GFile* _tmp7_ = NULL;
			GFile* dir = NULL;
			_tmp7_ = _g_object_ref0 (dir_collection[dir_it]);
			dir = _tmp7_;
			{
				GFile* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				GHashTable* _tmp10_ = NULL;
				_tmp8_ = dir;
				_tmp9_ = filter_id;
				_tmp10_ = _result_;
				nuvola_web_app_registry_find_apps (self, _tmp8_, _tmp9_, _tmp10_);
				_g_object_unref0 (dir);
			}
		}
	}
	result = _result_;
	return result;
}


static void nuvola_web_app_registry_find_apps (NuvolaWebAppRegistry* self, GFile* directory, const gchar* filter_id, GHashTable* _result_) {
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (directory != NULL);
	g_return_if_fail (_result_ != NULL);
	_tmp0_ = directory;
	_tmp1_ = g_file_query_exists (_tmp0_, NULL);
	if (_tmp1_) {
		{
			GFileInfo* file_info = NULL;
			GFileEnumerator* enumerator = NULL;
			GFile* _tmp2_ = NULL;
			GFileEnumerator* _tmp3_ = NULL;
			_tmp2_ = directory;
			_tmp3_ = g_file_enumerate_children (_tmp2_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
			enumerator = _tmp3_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (file_info);
				goto __catch70_g_error;
			}
			while (TRUE) {
				GFileInfo* _tmp4_ = NULL;
				GFileEnumerator* _tmp5_ = NULL;
				GFileInfo* _tmp6_ = NULL;
				GFileInfo* _tmp7_ = NULL;
				GFileInfo* _tmp8_ = NULL;
				gchar* dirname = NULL;
				GFileInfo* _tmp9_ = NULL;
				const gchar* _tmp10_ = NULL;
				gchar* _tmp11_ = NULL;
				GFile* app_dir = NULL;
				GFile* _tmp12_ = NULL;
				const gchar* _tmp13_ = NULL;
				GFile* _tmp14_ = NULL;
				GFile* _tmp15_ = NULL;
				GFileType _tmp16_ = 0;
				_tmp5_ = enumerator;
				_tmp6_ = g_file_enumerator_next_file (_tmp5_, NULL, &_inner_error_);
				_tmp4_ = _tmp6_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (enumerator);
					_g_object_unref0 (file_info);
					goto __catch70_g_error;
				}
				_tmp7_ = _tmp4_;
				_tmp4_ = NULL;
				_g_object_unref0 (file_info);
				file_info = _tmp7_;
				_tmp8_ = file_info;
				if (!(_tmp8_ != NULL)) {
					_g_object_unref0 (_tmp4_);
					break;
				}
				_tmp9_ = file_info;
				_tmp10_ = g_file_info_get_name (_tmp9_);
				_tmp11_ = g_strdup (_tmp10_);
				dirname = _tmp11_;
				_tmp12_ = directory;
				_tmp13_ = dirname;
				_tmp14_ = g_file_get_child (_tmp12_, _tmp13_);
				app_dir = _tmp14_;
				_tmp15_ = app_dir;
				_tmp16_ = g_file_query_file_type (_tmp15_, 0, NULL);
				if (_tmp16_ != G_FILE_TYPE_DIRECTORY) {
					_g_object_unref0 (app_dir);
					_g_free0 (dirname);
					_g_object_unref0 (_tmp4_);
					continue;
				}
				{
					NuvolaWebApp* app = NULL;
					GFile* _tmp17_ = NULL;
					NuvolaWebApp* _tmp18_ = NULL;
					gchar* id = NULL;
					NuvolaWebApp* _tmp19_ = NULL;
					const gchar* _tmp20_ = NULL;
					const gchar* _tmp21_ = NULL;
					gchar* _tmp22_ = NULL;
					NuvolaWebApp* _tmp23_ = NULL;
					const gchar* _tmp24_ = NULL;
					const gchar* _tmp25_ = NULL;
					GFile* _tmp26_ = NULL;
					gchar* _tmp27_ = NULL;
					gchar* _tmp28_ = NULL;
					NuvolaWebApp* _tmp29_ = NULL;
					gint _tmp30_ = 0;
					gint _tmp31_ = 0;
					NuvolaWebApp* _tmp32_ = NULL;
					gint _tmp33_ = 0;
					gint _tmp34_ = 0;
					gboolean _tmp35_ = FALSE;
					const gchar* _tmp36_ = NULL;
					_tmp17_ = app_dir;
					_tmp18_ = nuvola_web_app_new_from_dir (_tmp17_, &_inner_error_);
					app = _tmp18_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == NUVOLA_WEB_APP_ERROR) {
							goto __catch71_nuvola_web_app_error;
						}
						_g_object_unref0 (app_dir);
						_g_free0 (dirname);
						_g_object_unref0 (_tmp4_);
						_g_object_unref0 (enumerator);
						_g_object_unref0 (file_info);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					_tmp19_ = app;
					_tmp20_ = nuvola_web_app_get_id (_tmp19_);
					_tmp21_ = _tmp20_;
					_tmp22_ = g_strdup (_tmp21_);
					id = _tmp22_;
					_tmp23_ = app;
					_tmp24_ = nuvola_web_app_get_name (_tmp23_);
					_tmp25_ = _tmp24_;
					_tmp26_ = app_dir;
					_tmp27_ = g_file_get_path (_tmp26_);
					_tmp28_ = _tmp27_;
					_tmp29_ = app;
					_tmp30_ = nuvola_web_app_get_version_major (_tmp29_);
					_tmp31_ = _tmp30_;
					_tmp32_ = app;
					_tmp33_ = nuvola_web_app_get_version_minor (_tmp32_);
					_tmp34_ = _tmp33_;
					g_debug ("WebAppRegistry.vala:105: Found web app %s at %s, version %u.%u", _tmp25_, _tmp28_, (guint) _tmp31_, (guint) _tmp34_);
					_g_free0 (_tmp28_);
					_tmp36_ = filter_id;
					if (_tmp36_ == NULL) {
						_tmp35_ = TRUE;
					} else {
						const gchar* _tmp37_ = NULL;
						const gchar* _tmp38_ = NULL;
						_tmp37_ = filter_id;
						_tmp38_ = id;
						_tmp35_ = g_strcmp0 (_tmp37_, _tmp38_) == 0;
					}
					if (_tmp35_) {
						NuvolaWebApp* prev_app = NULL;
						GHashTable* _tmp39_ = NULL;
						const gchar* _tmp40_ = NULL;
						gconstpointer _tmp41_ = NULL;
						gboolean _tmp42_ = FALSE;
						gboolean _tmp43_ = FALSE;
						NuvolaWebApp* _tmp44_ = NULL;
						_tmp39_ = _result_;
						_tmp40_ = id;
						_tmp41_ = g_hash_table_lookup (_tmp39_, _tmp40_);
						prev_app = (NuvolaWebApp*) _tmp41_;
						_tmp44_ = prev_app;
						if (_tmp44_ == NULL) {
							_tmp43_ = TRUE;
						} else {
							NuvolaWebApp* _tmp45_ = NULL;
							gint _tmp46_ = 0;
							gint _tmp47_ = 0;
							NuvolaWebApp* _tmp48_ = NULL;
							gint _tmp49_ = 0;
							gint _tmp50_ = 0;
							_tmp45_ = app;
							_tmp46_ = nuvola_web_app_get_version_major (_tmp45_);
							_tmp47_ = _tmp46_;
							_tmp48_ = prev_app;
							_tmp49_ = nuvola_web_app_get_version_major (_tmp48_);
							_tmp50_ = _tmp49_;
							_tmp43_ = _tmp47_ > _tmp50_;
						}
						if (_tmp43_) {
							_tmp42_ = TRUE;
						} else {
							gboolean _tmp51_ = FALSE;
							NuvolaWebApp* _tmp52_ = NULL;
							gint _tmp53_ = 0;
							gint _tmp54_ = 0;
							NuvolaWebApp* _tmp55_ = NULL;
							gint _tmp56_ = 0;
							gint _tmp57_ = 0;
							_tmp52_ = app;
							_tmp53_ = nuvola_web_app_get_version_major (_tmp52_);
							_tmp54_ = _tmp53_;
							_tmp55_ = prev_app;
							_tmp56_ = nuvola_web_app_get_version_major (_tmp55_);
							_tmp57_ = _tmp56_;
							if (_tmp54_ == _tmp57_) {
								NuvolaWebApp* _tmp58_ = NULL;
								gint _tmp59_ = 0;
								gint _tmp60_ = 0;
								NuvolaWebApp* _tmp61_ = NULL;
								gint _tmp62_ = 0;
								gint _tmp63_ = 0;
								_tmp58_ = app;
								_tmp59_ = nuvola_web_app_get_version_minor (_tmp58_);
								_tmp60_ = _tmp59_;
								_tmp61_ = prev_app;
								_tmp62_ = nuvola_web_app_get_version_minor (_tmp61_);
								_tmp63_ = _tmp62_;
								_tmp51_ = _tmp60_ > _tmp63_;
							} else {
								_tmp51_ = FALSE;
							}
							_tmp42_ = _tmp51_;
						}
						if (_tmp42_) {
							GHashTable* _tmp64_ = NULL;
							const gchar* _tmp65_ = NULL;
							gchar* _tmp66_ = NULL;
							NuvolaWebApp* _tmp67_ = NULL;
							NuvolaWebApp* _tmp68_ = NULL;
							_tmp64_ = _result_;
							_tmp65_ = id;
							_tmp66_ = g_strdup (_tmp65_);
							_tmp67_ = app;
							_tmp68_ = _g_object_ref0 (_tmp67_);
							g_hash_table_insert (_tmp64_, _tmp66_, _tmp68_);
						}
					}
					_g_free0 (id);
					_g_object_unref0 (app);
				}
				goto __finally71;
				__catch71_nuvola_web_app_error:
				{
					GError* e = NULL;
					GFile* _tmp69_ = NULL;
					gchar* _tmp70_ = NULL;
					gchar* _tmp71_ = NULL;
					GError* _tmp72_ = NULL;
					const gchar* _tmp73_ = NULL;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp69_ = app_dir;
					_tmp70_ = g_file_get_path (_tmp69_);
					_tmp71_ = _tmp70_;
					_tmp72_ = e;
					_tmp73_ = _tmp72_->message;
					g_warning ("WebAppRegistry.vala:122: Unable to load app from %s: %s", _tmp71_, _tmp73_);
					_g_free0 (_tmp71_);
					_g_error_free0 (e);
				}
				__finally71:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (app_dir);
					_g_free0 (dirname);
					_g_object_unref0 (_tmp4_);
					_g_object_unref0 (enumerator);
					_g_object_unref0 (file_info);
					goto __catch70_g_error;
				}
				_g_object_unref0 (app_dir);
				_g_free0 (dirname);
				_g_object_unref0 (_tmp4_);
			}
			_g_object_unref0 (enumerator);
			_g_object_unref0 (file_info);
		}
		goto __finally70;
		__catch70_g_error:
		{
			GError* e = NULL;
			GError* _tmp74_ = NULL;
			const gchar* _tmp75_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp74_ = e;
			_tmp75_ = _tmp74_->message;
			g_warning ("WebAppRegistry.vala:128: Filesystem error: %s", _tmp75_);
			_g_error_free0 (e);
		}
		__finally70:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void nuvola_web_app_registry_class_init (NuvolaWebAppRegistryClass * klass) {
	nuvola_web_app_registry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaWebAppRegistryPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_web_app_registry_finalize;
}


static void nuvola_web_app_registry_instance_init (NuvolaWebAppRegistry * self) {
	self->priv = NUVOLA_WEB_APP_REGISTRY_GET_PRIVATE (self);
}


static void nuvola_web_app_registry_finalize (GObject* obj) {
	NuvolaWebAppRegistry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_WEB_APP_REGISTRY, NuvolaWebAppRegistry);
	_g_object_unref0 (self->priv->user_storage);
	self->priv->system_storage = (_vala_array_free (self->priv->system_storage, self->priv->system_storage_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (nuvola_web_app_registry_parent_class)->finalize (obj);
}


/**
 *  WebAppRegistry deals with management and loading of web apps from filesystem.
 */
GType nuvola_web_app_registry_get_type (void) {
	static volatile gsize nuvola_web_app_registry_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_web_app_registry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaWebAppRegistryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_web_app_registry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaWebAppRegistry), 0, (GInstanceInitFunc) nuvola_web_app_registry_instance_init, NULL };
		GType nuvola_web_app_registry_type_id;
		nuvola_web_app_registry_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaWebAppRegistry", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_web_app_registry_type_id__volatile, nuvola_web_app_registry_type_id);
	}
	return nuvola_web_app_registry_type_id__volatile;
}


GQuark nuvola_web_app_error_quark (void) {
	return g_quark_from_static_string ("nuvola_web_app_error-quark");
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



