/* WebAppStorage.c generated by valac 0.34.9, the Vala compiler
 * generated from WebAppStorage.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <dioriteglib4.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_WEB_APP_STORAGE (nuvola_web_app_storage_get_type ())
#define NUVOLA_WEB_APP_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_APP_STORAGE, NuvolaWebAppStorage))
#define NUVOLA_WEB_APP_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_APP_STORAGE, NuvolaWebAppStorageClass))
#define NUVOLA_IS_WEB_APP_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_APP_STORAGE))
#define NUVOLA_IS_WEB_APP_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_APP_STORAGE))
#define NUVOLA_WEB_APP_STORAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_APP_STORAGE, NuvolaWebAppStorageClass))

typedef struct _NuvolaWebAppStorage NuvolaWebAppStorage;
typedef struct _NuvolaWebAppStorageClass NuvolaWebAppStorageClass;
typedef struct _NuvolaWebAppStoragePrivate NuvolaWebAppStoragePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NuvolaWebAppStorage {
	GObject parent_instance;
	NuvolaWebAppStoragePrivate * priv;
};

struct _NuvolaWebAppStorageClass {
	GObjectClass parent_class;
};

struct _NuvolaWebAppStoragePrivate {
	GFile* _config_dir;
	GFile* _data_dir;
	GFile* _cache_dir;
};


static gpointer nuvola_web_app_storage_parent_class = NULL;

GType nuvola_web_app_storage_get_type (void) G_GNUC_CONST;
#define NUVOLA_WEB_APP_STORAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_WEB_APP_STORAGE, NuvolaWebAppStoragePrivate))
enum  {
	NUVOLA_WEB_APP_STORAGE_DUMMY_PROPERTY,
	NUVOLA_WEB_APP_STORAGE_CONFIG_DIR,
	NUVOLA_WEB_APP_STORAGE_DATA_DIR,
	NUVOLA_WEB_APP_STORAGE_CACHE_DIR
};
NuvolaWebAppStorage* nuvola_web_app_storage_new (GFile* config_dir, GFile* data_dir, GFile* cache_dir);
NuvolaWebAppStorage* nuvola_web_app_storage_construct (GType object_type, GFile* config_dir, GFile* data_dir, GFile* cache_dir);
GFile* nuvola_web_app_storage_create_cache_subdir (NuvolaWebAppStorage* self, const gchar* path);
GFile* nuvola_web_app_storage_get_cache_dir (NuvolaWebAppStorage* self);
GFile* nuvola_web_app_storage_create_data_subdir (NuvolaWebAppStorage* self, const gchar* path);
GFile* nuvola_web_app_storage_get_data_dir (NuvolaWebAppStorage* self);
GFile* nuvola_web_app_storage_get_config_dir (NuvolaWebAppStorage* self);
static void nuvola_web_app_storage_set_config_dir (NuvolaWebAppStorage* self, GFile* value);
static void nuvola_web_app_storage_set_data_dir (NuvolaWebAppStorage* self, GFile* value);
static void nuvola_web_app_storage_set_cache_dir (NuvolaWebAppStorage* self, GFile* value);
static void nuvola_web_app_storage_finalize (GObject* obj);
static void _vala_nuvola_web_app_storage_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_web_app_storage_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


NuvolaWebAppStorage* nuvola_web_app_storage_construct (GType object_type, GFile* config_dir, GFile* data_dir, GFile* cache_dir) {
	NuvolaWebAppStorage * self = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (config_dir != NULL, NULL);
	g_return_val_if_fail (data_dir != NULL, NULL);
	g_return_val_if_fail (cache_dir != NULL, NULL);
	_tmp0_ = config_dir;
	_tmp1_ = data_dir;
	_tmp2_ = cache_dir;
	self = (NuvolaWebAppStorage*) g_object_new (object_type, "config-dir", _tmp0_, "data-dir", _tmp1_, "cache-dir", _tmp2_, NULL);
	{
		GFile* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		_tmp3_ = config_dir;
		drt_system_make_dirs (_tmp3_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch72_g_error;
		}
		_tmp4_ = data_dir;
		drt_system_make_dirs (_tmp4_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch72_g_error;
		}
		_tmp5_ = cache_dir;
		drt_system_make_dirs (_tmp5_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch72_g_error;
		}
	}
	goto __finally72;
	__catch72_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = e->message;
		g_error ("WebAppStorage.vala:45: Failed to create directory. %s", _tmp6_);
		_g_error_free0 (e);
	}
	__finally72:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


NuvolaWebAppStorage* nuvola_web_app_storage_new (GFile* config_dir, GFile* data_dir, GFile* cache_dir) {
	return nuvola_web_app_storage_construct (NUVOLA_TYPE_WEB_APP_STORAGE, config_dir, data_dir, cache_dir);
}


/**
 * Returns the default path of cache subdir with given name, create it if it doesn't exist.
 * 
 * @param path    Subdirectory path.
 * @return cache subdirectory
 */
GFile* nuvola_web_app_storage_create_cache_subdir (NuvolaWebAppStorage* self, const gchar* path) {
	GFile* result = NULL;
	GFile* dir = NULL;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = self->priv->_cache_dir;
	_tmp1_ = path;
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
	dir = _tmp2_;
	{
		drt_system_make_dirs (dir, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch73_g_error;
		}
	}
	goto __finally73;
	__catch73_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = g_file_get_path (dir);
		_tmp4_ = _tmp3_;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("WebAppStorage.vala:64: Failed to create directory '%s'. %s", _tmp4_, _tmp6_);
		_g_free0 (_tmp4_);
		_g_error_free0 (e);
	}
	__finally73:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = dir;
	return result;
}


/**
 * Returns the default path of data subdir with given name, create it if it doesn't exist.
 * 
 * @param path    Subdirectory path.
 * @return data subdirectory
 */
GFile* nuvola_web_app_storage_create_data_subdir (NuvolaWebAppStorage* self, const gchar* path) {
	GFile* result = NULL;
	GFile* dir = NULL;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = self->priv->_data_dir;
	_tmp1_ = path;
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
	dir = _tmp2_;
	{
		drt_system_make_dirs (dir, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch74_g_error;
		}
	}
	goto __finally74;
	__catch74_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = g_file_get_path (dir);
		_tmp4_ = _tmp3_;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("WebAppStorage.vala:84: Failed to create directory '%s'. %s", _tmp4_, _tmp6_);
		_g_free0 (_tmp4_);
		_g_error_free0 (e);
	}
	__finally74:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = dir;
	return result;
}


GFile* nuvola_web_app_storage_get_config_dir (NuvolaWebAppStorage* self) {
	GFile* result;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_config_dir;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void nuvola_web_app_storage_set_config_dir (NuvolaWebAppStorage* self, GFile* value) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_config_dir);
	self->priv->_config_dir = _tmp1_;
	g_object_notify ((GObject *) self, "config-dir");
}


GFile* nuvola_web_app_storage_get_data_dir (NuvolaWebAppStorage* self) {
	GFile* result;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data_dir;
	result = _tmp0_;
	return result;
}


static void nuvola_web_app_storage_set_data_dir (NuvolaWebAppStorage* self, GFile* value) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_data_dir);
	self->priv->_data_dir = _tmp1_;
	g_object_notify ((GObject *) self, "data-dir");
}


GFile* nuvola_web_app_storage_get_cache_dir (NuvolaWebAppStorage* self) {
	GFile* result;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cache_dir;
	result = _tmp0_;
	return result;
}


static void nuvola_web_app_storage_set_cache_dir (NuvolaWebAppStorage* self, GFile* value) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_cache_dir);
	self->priv->_cache_dir = _tmp1_;
	g_object_notify ((GObject *) self, "cache-dir");
}


static void nuvola_web_app_storage_class_init (NuvolaWebAppStorageClass * klass) {
	nuvola_web_app_storage_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaWebAppStoragePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_web_app_storage_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_web_app_storage_set_property;
	G_OBJECT_CLASS (klass)->finalize = nuvola_web_app_storage_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_WEB_APP_STORAGE_CONFIG_DIR, g_param_spec_object ("config-dir", "config-dir", "config-dir", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_WEB_APP_STORAGE_DATA_DIR, g_param_spec_object ("data-dir", "data-dir", "data-dir", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_WEB_APP_STORAGE_CACHE_DIR, g_param_spec_object ("cache-dir", "cache-dir", "cache-dir", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void nuvola_web_app_storage_instance_init (NuvolaWebAppStorage * self) {
	self->priv = NUVOLA_WEB_APP_STORAGE_GET_PRIVATE (self);
}


static void nuvola_web_app_storage_finalize (GObject* obj) {
	NuvolaWebAppStorage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_WEB_APP_STORAGE, NuvolaWebAppStorage);
	_g_object_unref0 (self->priv->_config_dir);
	_g_object_unref0 (self->priv->_data_dir);
	_g_object_unref0 (self->priv->_cache_dir);
	G_OBJECT_CLASS (nuvola_web_app_storage_parent_class)->finalize (obj);
}


GType nuvola_web_app_storage_get_type (void) {
	static volatile gsize nuvola_web_app_storage_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_web_app_storage_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaWebAppStorageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_web_app_storage_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaWebAppStorage), 0, (GInstanceInitFunc) nuvola_web_app_storage_instance_init, NULL };
		GType nuvola_web_app_storage_type_id;
		nuvola_web_app_storage_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaWebAppStorage", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_web_app_storage_type_id__volatile, nuvola_web_app_storage_type_id);
	}
	return nuvola_web_app_storage_type_id__volatile;
}


static void _vala_nuvola_web_app_storage_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaWebAppStorage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_WEB_APP_STORAGE, NuvolaWebAppStorage);
	switch (property_id) {
		case NUVOLA_WEB_APP_STORAGE_CONFIG_DIR:
		g_value_set_object (value, nuvola_web_app_storage_get_config_dir (self));
		break;
		case NUVOLA_WEB_APP_STORAGE_DATA_DIR:
		g_value_set_object (value, nuvola_web_app_storage_get_data_dir (self));
		break;
		case NUVOLA_WEB_APP_STORAGE_CACHE_DIR:
		g_value_set_object (value, nuvola_web_app_storage_get_cache_dir (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_nuvola_web_app_storage_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaWebAppStorage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_WEB_APP_STORAGE, NuvolaWebAppStorage);
	switch (property_id) {
		case NUVOLA_WEB_APP_STORAGE_CONFIG_DIR:
		nuvola_web_app_storage_set_config_dir (self, g_value_get_object (value));
		break;
		case NUVOLA_WEB_APP_STORAGE_DATA_DIR:
		nuvola_web_app_storage_set_data_dir (self, g_value_get_object (value));
		break;
		case NUVOLA_WEB_APP_STORAGE_CACHE_DIR:
		nuvola_web_app_storage_set_cache_dir (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



