/* WelcomeWindow.c generated by valac 0.34.9, the Vala compiler
 * generated from WelcomeWindow.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <dioritegtk4.h>
#include <webkit2/webkit2.h>
#include <stdlib.h>
#include <string.h>
#include <dioriteglib4.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define NUVOLA_TYPE_WELCOME_SCREEN (nuvola_welcome_screen_get_type ())
#define NUVOLA_WELCOME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreen))
#define NUVOLA_WELCOME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreenClass))
#define NUVOLA_IS_WELCOME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WELCOME_SCREEN))
#define NUVOLA_IS_WELCOME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WELCOME_SCREEN))
#define NUVOLA_WELCOME_SCREEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreenClass))

typedef struct _NuvolaWelcomeScreen NuvolaWelcomeScreen;
typedef struct _NuvolaWelcomeScreenClass NuvolaWelcomeScreenClass;
typedef struct _NuvolaWelcomeScreenPrivate NuvolaWelcomeScreenPrivate;

#define NUVOLA_TYPE_WEB_VIEW (nuvola_web_view_get_type ())
#define NUVOLA_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_VIEW, NuvolaWebView))
#define NUVOLA_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_VIEW, NuvolaWebViewClass))
#define NUVOLA_IS_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_VIEW))
#define NUVOLA_IS_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_VIEW))
#define NUVOLA_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_VIEW, NuvolaWebViewClass))

typedef struct _NuvolaWebView NuvolaWebView;
typedef struct _NuvolaWebViewClass NuvolaWebViewClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _webkit_javascript_result_unref0(var) ((var == NULL) ? NULL : (var = (webkit_javascript_result_unref (var), NULL)))

struct _NuvolaWelcomeScreen {
	GtkGrid parent_instance;
	NuvolaWelcomeScreenPrivate * priv;
};

struct _NuvolaWelcomeScreenClass {
	GtkGridClass parent_class;
};

struct _NuvolaWelcomeScreenPrivate {
	GtkGrid* grid;
	DrtApplication* app;
	NuvolaWebView* web_view;
	DrtRichTextView* welcome_text;
	GtkScrolledWindow* scroll;
};


static gpointer nuvola_welcome_screen_parent_class = NULL;

GType nuvola_welcome_screen_get_type (void) G_GNUC_CONST;
GType nuvola_web_view_get_type (void) G_GNUC_CONST;
#define NUVOLA_WELCOME_SCREEN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreenPrivate))
enum  {
	NUVOLA_WELCOME_SCREEN_DUMMY_PROPERTY
};
#define NUVOLA_WELCOME_SCREEN_PATRONS_BOX_URI "https://tiliado.eu/nuvolaplayer/funding/patrons_list_box/"
NuvolaWelcomeScreen* nuvola_welcome_screen_new (DrtApplication* app, DrtStorage* storage);
NuvolaWelcomeScreen* nuvola_welcome_screen_construct (GType object_type, DrtApplication* app, DrtStorage* storage);
static void nuvola_welcome_screen_show_uri (NuvolaWelcomeScreen* self, const gchar* uri);
static void _nuvola_welcome_screen_show_uri_drt_uri_opener (const gchar* uri, gpointer self);
static gboolean nuvola_welcome_screen_on_motion_notify (NuvolaWelcomeScreen* self, GtkWidget* widget, GdkEventMotion* event);
static gboolean _nuvola_welcome_screen_on_motion_notify_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
WebKitWebContext* nuvola_web_engine_get_web_context (void);
NuvolaWebView* nuvola_web_view_new (WebKitWebContext* context);
NuvolaWebView* nuvola_web_view_construct (GType object_type, WebKitWebContext* context);
static gboolean nuvola_welcome_screen_on_scroll_event (NuvolaWelcomeScreen* self, GdkEventScroll* event);
static gboolean _nuvola_welcome_screen_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender, GdkEventScroll* event, gpointer self);
static void nuvola_welcome_screen_on_load_changed (NuvolaWelcomeScreen* self, WebKitWebView* view, WebKitLoadEvent event);
static void _nuvola_welcome_screen_on_load_changed_webkit_web_view_load_changed (WebKitWebView* _sender, WebKitLoadEvent load_event, gpointer self);
static gboolean nuvola_welcome_screen_on_decide_policy (NuvolaWelcomeScreen* self, WebKitPolicyDecision* decision, WebKitPolicyDecisionType decision_type);
static gboolean _nuvola_welcome_screen_on_decide_policy_webkit_web_view_decide_policy (WebKitWebView* _sender, WebKitPolicyDecision* decision, WebKitPolicyDecisionType type, gpointer self);
static gboolean nuvola_welcome_screen_set_web_view_height (NuvolaWelcomeScreen* self);
static void nuvola_welcome_screen_on_height_retrieved (NuvolaWelcomeScreen* self, GObject* o, GAsyncResult* _result_);
static void _nuvola_welcome_screen_on_height_retrieved_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static gboolean nuvola_welcome_screen_decide_navigation_policy (NuvolaWelcomeScreen* self, gboolean new_window, WebKitNavigationPolicyDecision* decision);
static void nuvola_welcome_screen_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _nuvola_welcome_screen_show_uri_drt_uri_opener (const gchar* uri, gpointer self) {
	nuvola_welcome_screen_show_uri ((NuvolaWelcomeScreen*) self, uri);
}


static gboolean _nuvola_welcome_screen_on_motion_notify_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = nuvola_welcome_screen_on_motion_notify ((NuvolaWelcomeScreen*) self, _sender, event);
	return result;
}


static gboolean _nuvola_welcome_screen_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender, GdkEventScroll* event, gpointer self) {
	gboolean result;
	result = nuvola_welcome_screen_on_scroll_event ((NuvolaWelcomeScreen*) self, event);
	return result;
}


static void _nuvola_welcome_screen_on_load_changed_webkit_web_view_load_changed (WebKitWebView* _sender, WebKitLoadEvent load_event, gpointer self) {
	nuvola_welcome_screen_on_load_changed ((NuvolaWelcomeScreen*) self, _sender, load_event);
}


static gboolean _nuvola_welcome_screen_on_decide_policy_webkit_web_view_decide_policy (WebKitWebView* _sender, WebKitPolicyDecision* decision, WebKitPolicyDecisionType type, gpointer self) {
	gboolean result;
	result = nuvola_welcome_screen_on_decide_policy ((NuvolaWelcomeScreen*) self, decision, type);
	return result;
}


NuvolaWelcomeScreen* nuvola_welcome_screen_construct (GType object_type, DrtApplication* app, DrtStorage* storage) {
	NuvolaWelcomeScreen * self = NULL;
	DrtApplication* _tmp0_ = NULL;
	DrtApplication* _tmp1_ = NULL;
	GtkGrid* _tmp2_ = NULL;
	GtkGrid* _tmp3_ = NULL;
	GdkRGBA _tmp4_ = {0};
	GtkGrid* _tmp5_ = NULL;
	gchar* welcome_xml = NULL;
	GFile* welcome_xml_file = NULL;
	DrtStorage* _tmp6_ = NULL;
	GFile* _tmp7_ = NULL;
	DrtRichTextBuffer* buffer = NULL;
	DrtRichTextBuffer* _tmp14_ = NULL;
	DrtRichTextView* _tmp19_ = NULL;
	DrtRichTextView* _tmp20_ = NULL;
	DrtRichTextView* _tmp21_ = NULL;
	DrtRichTextView* _tmp22_ = NULL;
	DrtRichTextView* _tmp23_ = NULL;
	DrtRichTextView* _tmp24_ = NULL;
	GtkGrid* _tmp25_ = NULL;
	DrtRichTextView* _tmp26_ = NULL;
	WebKitWebContext* _tmp27_ = NULL;
	WebKitWebContext* _tmp28_ = NULL;
	NuvolaWebView* _tmp29_ = NULL;
	NuvolaWebView* _tmp30_ = NULL;
	NuvolaWebView* _tmp31_ = NULL;
	NuvolaWebView* _tmp32_ = NULL;
	NuvolaWebView* _tmp33_ = NULL;
	NuvolaWebView* _tmp34_ = NULL;
	NuvolaWebView* _tmp35_ = NULL;
	NuvolaWebView* _tmp36_ = NULL;
	NuvolaWebView* _tmp37_ = NULL;
	NuvolaWebView* _tmp38_ = NULL;
	NuvolaWebView* _tmp39_ = NULL;
	GtkGrid* _tmp40_ = NULL;
	NuvolaWebView* _tmp41_ = NULL;
	GtkScrolledWindow* _tmp42_ = NULL;
	GtkScrolledWindow* _tmp43_ = NULL;
	GtkGrid* _tmp44_ = NULL;
	GtkScrolledWindow* _tmp45_ = NULL;
	GtkScrolledWindow* _tmp46_ = NULL;
	GtkScrolledWindow* _tmp47_ = NULL;
	GtkScrolledWindow* _tmp48_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	g_return_val_if_fail (storage != NULL, NULL);
	self = (NuvolaWelcomeScreen*) g_object_new (object_type, NULL);
	_tmp0_ = app;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->app);
	self->priv->app = _tmp1_;
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp2_;
	_tmp3_ = self->priv->grid;
	_tmp4_.red = 1.0;
	_tmp4_.green = 1.0;
	_tmp4_.blue = 1.0;
	_tmp4_.alpha = 1.0;
	gtk_widget_override_background_color ((GtkWidget*) _tmp3_, GTK_STATE_FLAG_NORMAL, &_tmp4_);
	_tmp5_ = self->priv->grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp5_, GTK_ORIENTATION_VERTICAL);
	welcome_xml = NULL;
	_tmp6_ = storage;
	_tmp7_ = drt_storage_require_data_file (_tmp6_, "welcome.xml");
	welcome_xml_file = _tmp7_;
	{
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		_tmp9_ = drt_system_read_file (welcome_xml_file, &_inner_error_);
		_tmp8_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch78_g_error;
		}
		_tmp10_ = _tmp8_;
		_tmp8_ = NULL;
		_g_free0 (welcome_xml);
		welcome_xml = _tmp10_;
		_g_free0 (_tmp8_);
	}
	goto __finally78;
	__catch78_g_error:
	{
		GError* e = NULL;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp11_ = g_file_get_path (welcome_xml_file);
		_tmp12_ = _tmp11_;
		_tmp13_ = e->message;
		g_error ("WelcomeWindow.vala:53: Failed to load '%s': %s", _tmp12_, _tmp13_);
		_g_free0 (_tmp12_);
		_g_error_free0 (e);
	}
	__finally78:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (welcome_xml_file);
		_g_free0 (welcome_xml);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp14_ = drt_rich_text_buffer_new ();
	buffer = _tmp14_;
	{
		const gchar* _tmp15_ = NULL;
		_tmp15_ = welcome_xml;
		drt_rich_text_buffer_load (buffer, _tmp15_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_MARKUP_ERROR) {
				goto __catch79_g_markup_error;
			}
			_g_object_unref0 (buffer);
			_g_object_unref0 (welcome_xml_file);
			_g_free0 (welcome_xml);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	goto __finally79;
	__catch79_g_markup_error:
	{
		GError* e = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp16_ = g_file_get_path (welcome_xml_file);
		_tmp17_ = _tmp16_;
		_tmp18_ = e->message;
		g_error ("WelcomeWindow.vala:63: Markup Error in '%s': %s", _tmp17_, _tmp18_);
		_g_free0 (_tmp17_);
		_g_error_free0 (e);
	}
	__finally79:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (buffer);
		_g_object_unref0 (welcome_xml_file);
		_g_free0 (welcome_xml);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp19_ = drt_rich_text_view_new (buffer);
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->welcome_text);
	self->priv->welcome_text = _tmp19_;
	_tmp20_ = self->priv->welcome_text;
	drt_rich_text_view_set_link_opener (_tmp20_, _nuvola_welcome_screen_show_uri_drt_uri_opener, g_object_ref (self), g_object_unref);
	_tmp21_ = self->priv->welcome_text;
	g_object_set ((GtkWidget*) _tmp21_, "margin", 18, NULL);
	_tmp22_ = self->priv->welcome_text;
	_tmp23_ = self->priv->welcome_text;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp23_, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp22_, TRUE);
	_tmp24_ = self->priv->welcome_text;
	g_signal_connect_object ((GtkWidget*) _tmp24_, "motion-notify-event", (GCallback) _nuvola_welcome_screen_on_motion_notify_gtk_widget_motion_notify_event, self, 0);
	_tmp25_ = self->priv->grid;
	_tmp26_ = self->priv->welcome_text;
	gtk_grid_attach (_tmp25_, (GtkWidget*) _tmp26_, 0, 0, 1, 1);
	_tmp27_ = nuvola_web_engine_get_web_context ();
	_tmp28_ = _tmp27_;
	_tmp29_ = nuvola_web_view_new (_tmp28_);
	g_object_ref_sink (_tmp29_);
	_g_object_unref0 (self->priv->web_view);
	self->priv->web_view = _tmp29_;
	_g_object_unref0 (_tmp28_);
	_tmp30_ = self->priv->web_view;
	gtk_widget_add_events ((GtkWidget*) _tmp30_, (gint) GDK_SCROLL_MASK);
	_tmp31_ = self->priv->web_view;
	g_signal_connect_object ((GtkWidget*) _tmp31_, "motion-notify-event", (GCallback) _nuvola_welcome_screen_on_motion_notify_gtk_widget_motion_notify_event, self, 0);
	_tmp32_ = self->priv->web_view;
	g_signal_connect_object ((GtkWidget*) _tmp32_, "scroll-event", (GCallback) _nuvola_welcome_screen_on_scroll_event_gtk_widget_scroll_event, self, 0);
	_tmp33_ = self->priv->web_view;
	g_signal_connect_object ((WebKitWebView*) _tmp33_, "load-changed", (GCallback) _nuvola_welcome_screen_on_load_changed_webkit_web_view_load_changed, self, 0);
	_tmp34_ = self->priv->web_view;
	webkit_web_view_load_uri ((WebKitWebView*) _tmp34_, NUVOLA_WELCOME_SCREEN_PATRONS_BOX_URI);
	_tmp35_ = self->priv->web_view;
	g_object_set ((GtkWidget*) _tmp35_, "margin", 18, NULL);
	_tmp36_ = self->priv->web_view;
	g_signal_connect_object ((WebKitWebView*) _tmp36_, "decide-policy", (GCallback) _nuvola_welcome_screen_on_decide_policy_webkit_web_view_decide_policy, self, 0);
	_tmp37_ = self->priv->web_view;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp37_, FALSE);
	_tmp38_ = self->priv->web_view;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp38_, TRUE);
	_tmp39_ = self->priv->web_view;
	gtk_widget_set_size_request ((GtkWidget*) _tmp39_, 275, -1);
	_tmp40_ = self->priv->grid;
	_tmp41_ = self->priv->web_view;
	gtk_grid_attach (_tmp40_, (GtkWidget*) _tmp41_, 1, 0, 1, 1);
	_tmp42_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp42_);
	_g_object_unref0 (self->priv->scroll);
	self->priv->scroll = _tmp42_;
	_tmp43_ = self->priv->scroll;
	_tmp44_ = self->priv->grid;
	gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
	_tmp45_ = self->priv->scroll;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp45_, TRUE);
	_tmp46_ = self->priv->scroll;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp46_, TRUE);
	_tmp47_ = self->priv->scroll;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp47_);
	_tmp48_ = self->priv->scroll;
	gtk_widget_show_all ((GtkWidget*) _tmp48_);
	_g_object_unref0 (buffer);
	_g_object_unref0 (welcome_xml_file);
	_g_free0 (welcome_xml);
	return self;
}


NuvolaWelcomeScreen* nuvola_welcome_screen_new (DrtApplication* app, DrtStorage* storage) {
	return nuvola_welcome_screen_construct (NUVOLA_TYPE_WELCOME_SCREEN, app, storage);
}


static gboolean nuvola_welcome_screen_on_scroll_event (NuvolaWelcomeScreen* self, GdkEventScroll* event) {
	gboolean result = FALSE;
	GtkScrolledWindow* _tmp0_ = NULL;
	GdkEventScroll* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->scroll;
	_tmp1_ = event;
	g_signal_emit_by_name ((GtkWidget*) _tmp0_, "scroll-event", _tmp1_, &_tmp2_);
	result = TRUE;
	return result;
}


static gboolean nuvola_welcome_screen_on_motion_notify (NuvolaWelcomeScreen* self, GtkWidget* widget, GdkEventMotion* event) {
	gboolean result = FALSE;
	GtkWidget* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = widget;
	g_object_get (_tmp0_, "has-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		GtkAdjustment* adjustment = NULL;
		GtkScrolledWindow* _tmp3_ = NULL;
		GtkAdjustment* _tmp4_ = NULL;
		GtkAdjustment* _tmp5_ = NULL;
		gdouble position = 0.0;
		GtkAdjustment* _tmp6_ = NULL;
		gdouble _tmp7_ = 0.0;
		gdouble _tmp8_ = 0.0;
		GtkWidget* _tmp9_ = NULL;
		GtkAdjustment* _tmp10_ = NULL;
		gdouble _tmp11_ = 0.0;
		_tmp3_ = self->priv->scroll;
		_tmp4_ = gtk_scrolled_window_get_vadjustment (_tmp3_);
		_tmp5_ = _g_object_ref0 (_tmp4_);
		adjustment = _tmp5_;
		_tmp6_ = adjustment;
		_tmp7_ = gtk_adjustment_get_value (_tmp6_);
		_tmp8_ = _tmp7_;
		position = _tmp8_;
		_tmp9_ = widget;
		gtk_widget_grab_focus (_tmp9_);
		_tmp10_ = adjustment;
		_tmp11_ = position;
		gtk_adjustment_set_value (_tmp10_, _tmp11_);
		_g_object_unref0 (adjustment);
	}
	result = FALSE;
	return result;
}


static void nuvola_welcome_screen_on_load_changed (NuvolaWelcomeScreen* self, WebKitWebView* view, WebKitLoadEvent event) {
	WebKitLoadEvent _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	_tmp0_ = event;
	if (_tmp0_ == WEBKIT_LOAD_FINISHED) {
		nuvola_welcome_screen_set_web_view_height (self);
	}
}


static void _nuvola_welcome_screen_on_height_retrieved_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	nuvola_welcome_screen_on_height_retrieved ((NuvolaWelcomeScreen*) self, source_object, res);
	g_object_unref (self);
}


static gboolean nuvola_welcome_screen_set_web_view_height (NuvolaWelcomeScreen* self) {
	gboolean result = FALSE;
	NuvolaWebView* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->web_view;
	webkit_web_view_run_javascript ((WebKitWebView*) _tmp0_, "\n" \
"\t\t\tvar bodyElm = document.body, htmlElm = document.documentElement;" \
"\n" \
"\t\t\tdocument.title = Math.max(\n" \
"\t\t\t\tbodyElm.scrollHeight, bodyElm.offsetHeight, \n" \
"                htmlElm.clientHeight, htmlElm.scrollHeight, htmlElm.of" \
"fsetHeight);\n" \
"\t\t\t", NULL, _nuvola_welcome_screen_on_height_retrieved_gasync_ready_callback, g_object_ref (self));
	result = TRUE;
	return result;
}


static void nuvola_welcome_screen_on_height_retrieved (NuvolaWelcomeScreen* self, GObject* o, GAsyncResult* _result_) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_result_ != NULL);
	{
		NuvolaWebView* _tmp0_ = NULL;
		GAsyncResult* _tmp1_ = NULL;
		WebKitJavascriptResult* _tmp2_ = NULL;
		WebKitJavascriptResult* _tmp3_ = NULL;
		gint page_height = 0;
		NuvolaWebView* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		gint width = 0;
		gint height = 0;
		NuvolaWebView* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		gboolean _tmp11_ = FALSE;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		_tmp0_ = self->priv->web_view;
		_tmp1_ = _result_;
		_tmp2_ = webkit_web_view_run_javascript_finish ((WebKitWebView*) _tmp0_, _tmp1_, &_inner_error_);
		_tmp3_ = _tmp2_;
		_webkit_javascript_result_unref0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch80_g_error;
		}
		_tmp4_ = self->priv->web_view;
		_tmp5_ = webkit_web_view_get_title ((WebKitWebView*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = atoi (_tmp6_);
		page_height = _tmp7_;
		_tmp8_ = self->priv->web_view;
		gtk_widget_get_size_request ((GtkWidget*) _tmp8_, &_tmp9_, &_tmp10_);
		width = _tmp9_;
		height = _tmp10_;
		_tmp12_ = height;
		_tmp13_ = page_height;
		if (_tmp12_ < _tmp13_) {
			gint _tmp14_ = 0;
			_tmp14_ = page_height;
			_tmp11_ = _tmp14_ > 100;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			NuvolaWebView* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gint _tmp17_ = 0;
			_tmp15_ = self->priv->web_view;
			_tmp16_ = width;
			_tmp17_ = page_height;
			gtk_widget_set_size_request ((GtkWidget*) _tmp15_, _tmp16_, _tmp17_);
		}
	}
	goto __finally80;
	__catch80_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp18_ = e;
		_tmp19_ = _tmp18_->message;
		g_debug ("WelcomeWindow.vala:147: JavaScript error: %s", _tmp19_);
		_g_error_free0 (e);
	}
	__finally80:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void nuvola_welcome_screen_show_uri (NuvolaWelcomeScreen* self, const gchar* uri) {
	DrtApplication* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (uri != NULL);
	_tmp0_ = self->priv->app;
	_tmp1_ = uri;
	drt_application_show_uri (_tmp0_, _tmp1_, (guint32) GDK_CURRENT_TIME);
}


static gboolean nuvola_welcome_screen_decide_navigation_policy (NuvolaWelcomeScreen* self, gboolean new_window, WebKitNavigationPolicyDecision* decision) {
	gboolean result = FALSE;
	gchar* uri = NULL;
	WebKitNavigationPolicyDecision* _tmp0_ = NULL;
	WebKitNavigationAction* _tmp1_ = NULL;
	WebKitNavigationAction* _tmp2_ = NULL;
	WebKitURIRequest* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp14_ = NULL;
	WebKitNavigationPolicyDecision* _tmp15_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (decision != NULL, FALSE);
	_tmp0_ = decision;
	_tmp1_ = webkit_navigation_policy_decision_get_navigation_action (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = webkit_navigation_action_get_request (_tmp2_);
	_tmp4_ = webkit_uri_request_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup (_tmp5_);
	uri = _tmp6_;
	_tmp9_ = uri;
	_tmp10_ = g_str_has_prefix (_tmp9_, "http://");
	if (!_tmp10_) {
		const gchar* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		_tmp11_ = uri;
		_tmp12_ = g_str_has_prefix (_tmp11_, "https://");
		_tmp8_ = !_tmp12_;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		const gchar* _tmp13_ = NULL;
		_tmp13_ = uri;
		_tmp7_ = g_strcmp0 (_tmp13_, NUVOLA_WELCOME_SCREEN_PATRONS_BOX_URI) == 0;
	}
	if (_tmp7_) {
		result = FALSE;
		_g_free0 (uri);
		return result;
	}
	_tmp14_ = uri;
	nuvola_welcome_screen_show_uri (self, _tmp14_);
	_tmp15_ = decision;
	webkit_policy_decision_ignore ((WebKitPolicyDecision*) _tmp15_);
	result = TRUE;
	_g_free0 (uri);
	return result;
}


static gboolean nuvola_welcome_screen_on_decide_policy (NuvolaWelcomeScreen* self, WebKitPolicyDecision* decision, WebKitPolicyDecisionType decision_type) {
	gboolean result = FALSE;
	WebKitPolicyDecisionType _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (decision != NULL, FALSE);
	_tmp0_ = decision_type;
	switch (_tmp0_) {
		case WEBKIT_POLICY_DECISION_TYPE_NAVIGATION_ACTION:
		{
			WebKitPolicyDecision* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
			_tmp1_ = decision;
			_tmp2_ = nuvola_welcome_screen_decide_navigation_policy (self, FALSE, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, webkit_navigation_policy_decision_get_type (), WebKitNavigationPolicyDecision));
			result = _tmp2_;
			return result;
		}
		case WEBKIT_POLICY_DECISION_TYPE_NEW_WINDOW_ACTION:
		{
			WebKitPolicyDecision* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			_tmp3_ = decision;
			_tmp4_ = nuvola_welcome_screen_decide_navigation_policy (self, TRUE, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, webkit_navigation_policy_decision_get_type (), WebKitNavigationPolicyDecision));
			result = _tmp4_;
			return result;
		}
		default:
		case WEBKIT_POLICY_DECISION_TYPE_RESPONSE:
		{
			result = FALSE;
			return result;
		}
	}
}


static void nuvola_welcome_screen_class_init (NuvolaWelcomeScreenClass * klass) {
	nuvola_welcome_screen_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NuvolaWelcomeScreenPrivate));
	G_OBJECT_CLASS (klass)->finalize = nuvola_welcome_screen_finalize;
}


static void nuvola_welcome_screen_instance_init (NuvolaWelcomeScreen * self) {
	self->priv = NUVOLA_WELCOME_SCREEN_GET_PRIVATE (self);
}


static void nuvola_welcome_screen_finalize (GObject* obj) {
	NuvolaWelcomeScreen * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_WELCOME_SCREEN, NuvolaWelcomeScreen);
	_g_object_unref0 (self->priv->grid);
	_g_object_unref0 (self->priv->app);
	_g_object_unref0 (self->priv->web_view);
	_g_object_unref0 (self->priv->welcome_text);
	_g_object_unref0 (self->priv->scroll);
	G_OBJECT_CLASS (nuvola_welcome_screen_parent_class)->finalize (obj);
}


GType nuvola_welcome_screen_get_type (void) {
	static volatile gsize nuvola_welcome_screen_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_welcome_screen_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaWelcomeScreenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_welcome_screen_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaWelcomeScreen), 0, (GInstanceInitFunc) nuvola_welcome_screen_instance_init, NULL };
		GType nuvola_welcome_screen_type_id;
		nuvola_welcome_screen_type_id = g_type_register_static (gtk_grid_get_type (), "NuvolaWelcomeScreen", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_welcome_screen_type_id__volatile, nuvola_welcome_screen_type_id);
	}
	return nuvola_welcome_screen_type_id__volatile;
}



